/*
 * Created on 7 .. 2550
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.csc.entity;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Properties;

import com.csc.library.database.FieldManager;
import com.csc.library.database.StaticProperties;
import com.csc.library.report.ReportUDF;
import com.csc.library.session.ConnectProcess;
import com.csc.library.session.Connectable;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp0;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * @author Administrator
 */
public class CSC_Quque extends RecordCmp0 {
	
	private static final long serialVersionUID = 1L;
	HashMap processmsg=new HashMap();
	
	public void startUp() {
		UProfile uf = (UProfile)this.getUProfile().clone();
		uf.setDbName(StaticProperties.serverManager.getDatabaseQuque());
		this.setUProfile(uf);
		this.setDatabaseName(StaticProperties.serverManager.getDatabaseQuque());
	}

	public CSC_Quque(){
		super("csc_quque","csc_quque Table");
	}
	
	public void cancleProcess(String ququeid) {
		if (this.search()==1) {
			this.cancleProcess();
		}
	}
	
	public void cancleProcess() {
		if (this.getString("status").equals("R")) {
			Connectable con = new  ConnectProcess().getProcess(this.getString("server_Name"));
			try {
				con.remove(this.getString("ququeID"));
			} catch (RemoteException e) {
				e.printStackTrace();
			}
		}
		StaticProperties.serverManager.cancleProcess(this.getString("ququeID"));
		this.set("process_status", "C");
		this.set("cancle_by", this.getUProfile().getEmployee());
		this.save();
	}
	
	public boolean preUpdateTrigger() {
		if (this.getString("process_status").equals("C")) {
			this.set("cancle_by", this.getUProfile().getEmployee());
		}
		return true;
	}
	
	public boolean preInsertTrigger() {
		try{
		FieldManager fm=this.getField("parentid");
		if(fm!=null && fm.getString().trim().length()==0)			
			fm.set(this.getString("ququeid"));
		if (!StaticProperties.serverManager.isProduction()) {
			if (this.getString("process_status").equals("W")) {
				this.set("process_status", "T");
				this.set("server_name", StaticProperties.serverManager.getServerName());
			}
		}
		}catch(Exception ex){
			MyLog.error(this,this.getUProfile(),ex);
		}
		return true;
	}
	
	
	
	public void postUpdateTrigger() {
//		if (this.getString("process_status").equals("C")) {
//			Connectable con = new  ConnectProcess().getProcess(this.getString("server_Name"));
//			try {
//				con.remove(this.getString("ququeID"));
//			} catch (RemoteException e) {
//				e.printStackTrace();
//			}
//		}
	}
	
	public CscCalendar getLastAction() {
		Connectable con = new  ConnectProcess().getProcess(this.getString("server_Name"));
		try {
			return con.getLastAction(this.getString("ququeID"));
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public boolean preDeleteTrigger() {
		this.removeConditionFile(this.getString("condition").trim());
		this.removeResultFile(this.getString("ququeID").trim());
		return true;
	}
	
	private void removeConditionFile(String fileName){
		try {
			fileName = new InitialEnvironment("GLOBAL").getValue("temp-dir") + "/process/condition/" + fileName;
			File f=new File(fileName);
			if(f.exists())
				f.delete();
		} catch (Exception ex) {
			MyLog.error(this,  ex);
		}
	}
	
	private void removeResultFile(String fileName){
		try {
			fileName = new InitialEnvironment("GLOBAL").getValue("export-dir") +"/report/"+ fileName+".*";
			File f=new File(fileName);
			if(f.exists())
				f.delete();
		} catch (Exception ex) {
			MyLog.error(this,  ex);
		}
	}



	@Override 
	protected void saveRecord() throws Exception {		
		if(this.param.containsKey("__dellist") && this.param.get("__dellist").toString().length()>0){
			this.deleteProcess();
		}else if(this.param.containsKey("__statuslist") && this.param.get("__statuslist").toString().length()>0){
			this.statusProcess();
		}else if(this.param.containsKey("__cancelprocess") && this.param.get("__cancelprocess").toString().length()>0){
			this.cancelProcess();
		}else{
			if(!this.getString("ququeid").equals("-99999") && !this.getString("ququeid").equals("-9999")){
				super.saveRecord();
			}
		}
	}
	
	@Override
	protected void updateRecord() throws SQLException {
		if(this.param.containsKey("__dellist") && this.param.get("__dellist").toString().length()>0){
			this.deleteProcess();
		}else if(this.param.containsKey("__statuslist") && this.param.get("__statuslist").toString().length()>0){
			this.statusProcess();
		}else if(this.param.containsKey("__cancelprocess") && this.param.get("__cancelprocess").toString().length()>0){
			this.cancelProcess();
		}else{
			if(!this.getString("ququeid").equals("-99999") && !this.getString("ququeid").equals("-9999")){
				super.updateRecord();
			}
		}
	}
	
	private void statusProcess(){
		try{
			DbRecord rec=new InitialRecord(this.getUProfile()).getDbRecord("com.csc.entity.CSC_Quque");
			rec.setColumn("ququeid,companyid,process_status");
			String [] dellist=this.param.get("__statuslist").toString().split(",");
			for(int v=0;v<dellist.length;v++){
				rec.set("ququeid",dellist[v]);
				rec.set("comapnyid",this.getString("companyid"));
				rec.set("process_status", "D");
				rec.save();
			}			
		}catch(Exception ex){ex.printStackTrace();}
	}
	
	private void cancelProcess(){
		try{
			DbRecord rec=new InitialRecord(this.getUProfile()).getDbRecord("com.csc.entity.CSC_Quque");
				rec.setColumn("ququeid,companyid,process_status,cancle_by");
				rec.set("ququeid",this.param.get("__cancelprocess").toString());
				rec.set("comapnyid",this.getString("companyid"));
				rec.set("process_status", "C");
				StaticProperties.serverManager.cancleProcess(this.param.get("__cancelprocess").toString());
				rec.set("cancle_by", this.getUProfile().getEmployee());
				rec.save();				
		}catch(Exception ex){ex.printStackTrace();}
	}	
	
	private void deleteProcess(){
		try{
			DbRecord rec=new InitialRecord(this.getUProfile()).getDbRecord("com.csc.entity.CSC_Quque");
			rec.setColumn("ququeid,companyid");
			String [] dellist=this.param.get("__dellist").toString().split(",");
			for(int v=0;v<dellist.length;v++){
				rec.set("ququeid",dellist[v]);
				rec.set("comapnyid",this.getString("companyid"));
				rec.delete();
			}			
		}catch(Exception ex){ex.printStackTrace();}
	}	
	
	@Override
	public FieldManager getField(String fieldName) {
		FieldManager fm=null;
		if(fieldName.equalsIgnoreCase("jobname")){
			fm = this.initField("String", "Job name", 80, 0, "Job name");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);	
			if(this.getString("ptype").length()>0){
				ReportUDF rf=new ReportUDF();
				fm.set(this.getSystemCode("ptype"));
			}else{
				if(this.getUProfile().get("lang").toString().equalsIgnoreCase("eng"))
					fm.set(this.getString("ename"));
				else
					fm.set(this.getString("tname"));
			}
		}else if(fieldName.equalsIgnoreCase("longtime")){
			fm = this.initField("String", "long time", 80, 0, "long time");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);	
			CscCalendar cs=new CscCalendar();
			String longtime="";
			if(this.getString("start_time").matches("\\w[0123456789. :-]{1,}")){
				String sttime=this.getString("start_time");
				String entime=cs.getYYYYMMDDHHMMSS();
				if(this.getString("end_time").matches("\\w[0123456789. :-]{1,}"))
					entime=this.getString("end_time");
				longtime=cs.longToHHMMSS(cs.countTimeAsLong(sttime, entime));
			}
			fm.set(longtime);
		}else {
			fm= super.getField(fieldName);
			if (fieldName.equalsIgnoreCase("process_msg") && !this.isSaveState()) {
				String msg = fm.getString();
				if (this.getString("process_status").equals("W")) {
					msg = "Please waiting!";
				} else {
					if (this.getString("process_status").equals("R")) {
						String url=null;
						if(this.getString("provider_url").trim().length()>0&&this.getString("http_port").length()>0){
							url=this.getString("provider_url")+":"+this.getString("http_port");
							msg=httpReader(url);
						}else{
							msg="";
						}
//							String servername=this.getString("server_name");
//							String[] tmp=servername.split(":");
//							if(tmp.length==2){
//								try{
//								 InetAddress addr =InetAddress.getByName(tmp[0]) ;
//							        	int port  =80;
//							        	if(tmp[1].length()==tmp[1].replaceAll("[^0123456789]","").length()){
//							        		port=Integer.parseInt(tmp[1]) ;
//							        	}else{
//							        		MyLog.warn(this,this.getUProfile(),"Please config port after servername in payrollweb ext: server < SERVER name=\"servername\" port=\"8080\"... >");
//							        	}
//							        	try{
//								        Socket socket = new Socket(addr,port);
//									        if(socket!=null){
//									        	System.out.println("Connection to "+addr+":"+port+" Complete..........");
//												if(!StaticProperties.serverManager.getServerDead(servername.toUpperCase()))
//													msg = StaticProperties.serverManager.getResult(this.getString("ququeID"));
//									        }
//								        }catch(Exception ex){
//											msg="Failed to connect to server "+servername.toLowerCase();
//											StaticProperties.serverManager.setServerDead(servername.toUpperCase());								        	
//								        }
//
//								}catch(Exception ex){
//									MyLog.warn(this,this.getUProfile(),"Please config port after servername in payrollweb ext: server < SERVER name=\"servername:8080\"... >");
//								}
//							}else{
//								msg="Please config port after servername in payrollweb ext: server < SERVER name=\""+servername+":8080\"... >"+servername.toLowerCase();
//							}
//							Comment by pas nouse EJB 						
//							Connectable con=null;
//							if(!StaticProperties.serverManager.getServerDead(servername.toUpperCase()))
//								con= new  ConnectProcess().getProcess(servername);
//								if(con!=null){
//							msg = con.getResult(this.getString("ququeID"));
//								}else{
//									msg="Failed to connect to server "+servername.toLowerCase();
//									StaticProperties.serverManager.setServerDead(servername.toUpperCase());
//								}
							
					}
				}
				fm.set(msg);
			}
		} 
		return fm;
	}
	
	public void setNextTime() {
		/*		 M : Minute
				 H : Hour
				 D : Day
				 W : Day of Week
				 T : Day of Month
		*/
		if (this.getString("process_type").equals("R")) {
				CscCalendar d =new CscCalendar();
				if("DTW".indexOf(this.getString("interval_type"))>-1){
						try{
								String s = this.getString("next_time");
								if (s.trim().length()>0) {
									d.setCscCalendar(s);
								}
							}catch(Exception ex){
								MyLog.warn(this, this.getUProfile(),"Wrong format next_time in csc_quque where ququeid="+this.getString("ququeid")+" next_time="+this.getString("next_time"));
								d=new CscCalendar();
						}
				}
				if (this.getInt("interval") > 0) {
					if (this.getString("interval_type").equals("M")) {
						d.incMinute(this.getInt("interval"));
					}else if(this.getString("interval_type").equals("H")) {
						d.incHour(this.getInt("interval"));
					}else if(this.getString("interval_type").equals("D")) {
						d.incDate(this.getInt("interval"));
					}else if(this.getString("interval_type").equals("W")) {
						d.incDate(7);
					}else if (this.getString("interval_type").equals("T")) {
						d.incMonth(this.getInt("interval"));
					}
				}else d.incYear(10);
				if(StaticProperties.serverManager.isProduction())
					this.set("process_status", "W");
				else
					this.set("process_status", "T");
				this.set("next_time", d.getYYYYMMDDHHMMSS());
		}else {
			if(this.getString("process_status").equalsIgnoreCase("T")||this.getString("process_status").equalsIgnoreCase("W")||this.getString("process_status").equalsIgnoreCase("R"))
				this.set("process_status", "F");
			else
				this.set("process_status",this.getString("process_status"));
		}
	}

	
	public DbRecord cloneRecord(boolean isSave) {
		DbRecord db = null;
		try {
			if (isSave)
				db = new InitialRecord(this.userPro).getDbRecord("com.csc.entity.CSC_Quque");
			else
				db = new InitialRecord(this.userPro).getDbRecord("com.csc.entity.CSC_Quque", 'i');
			db.loadHelp(true);
			db.setColumn(this.getArrayFieldList());
			for (int i = 0; i < this.aField.size(); i++) {
				String fieldName = this.aField.get(i).toString();
				String data = this.getString(fieldName);
				db.set(fieldName, data);
			}
			db.setRelationInfo(this.getRelationInfo());
			db.setChildTable(this.getChildClone());
			db.setParam(this.getParam());
		} catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
		}
		return db;
	}

	
	private Hashtable getChildClone() {
		Hashtable child = new Hashtable();
		Enumeration em = this.getChildTable().keys();
		while (em.hasMoreElements()) {
			String key = (String) em.nextElement();
			Object ch = this.getChildTable().get(key);
			if (ch instanceof DbRecord) {
				DbRecord db;
				try {
					db = (DbRecord) ((DbRecord) ch).cloneRecord(true);
					child.put(key, db);
				} catch (Exception e) {
					child.put(key, ch);
				}

			} else {
				child.put(key, ch);
			}
		}
		return child;
	}
	
	public String httpReader(String url) {
		HashMap<String, String> msg=new HashMap<String, String>();
		if(!processmsg.containsKey(url)){			
			try {		        
			        URL url1 = new URL("http://"+url+"/hr/PROCESSMSG.jsp");
			        URLConnection conn = url1.openConnection();
			        conn.setReadTimeout(500);
					Properties prop= new Properties();
					prop.load(conn.getInputStream());
					msg=new HashMap(prop);
					String key="";
					Iterator it=msg.keySet().iterator();
					while(it.hasNext()){
						key=(String)it.next();
						MyLog.debug(this,key+":"+msg.get(key));
					}
			        processmsg.put(url,msg);
			} catch (IOException e) {
				return " ";
			}
		}
			
			msg=(HashMap)processmsg.get(url);
				if(msg!=null&&msg.containsKey(this.getString("ququeid"))){
					return (String)msg.get(this.getString("ququeid"));
				}else{
					return "Failed to connect to server "+this.getString("server_name");
				}
	}	
}
