package com.csc.entity;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.rmi.RemoteException;
import java.sql.Blob;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Collections;
import java.util.HashMap;
import java.util.Vector;

import oracle.jdbc.OracleResultSet;

import com.csc.library.database.ConnectionPools;
import com.csc.library.database.CscConnection;
import com.csc.library.database.FieldManager;
import com.csc.library.database.PropertyRec;
import com.csc.library.database.StaticProperties;
import com.csc.library.log.EventLog;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.Base64Decoder;
import com.csc.library.utilities.CscIndexTable;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;


public class DataBMPBean {
	private HashMap					dbField = new HashMap();
	private Vector					keyList;
	private Vector					keyField=new Vector();	
	private String					tableName;
	private String 					oldWhere="";
	private UProfile				upf=null;
	private DbRecord 		db = null;
    // fieldtype for PrepareStatement
    private HashMap fieldType = new HashMap();
    private PropertyRec mf = null;
    private Vector updateFieldExclude = new Vector();
    private Vector updateList=new Vector();
    private HashMap dataBlob=new HashMap();
    private EventLog ev=new EventLog();
    
    private transient SQLExceptionManager oSQLExceptionManager = new SQLExceptionManager();
	
	public DataBMPBean() {
		this.updateFieldExclude.add("create_date");
		this.updateFieldExclude.add("create_time");
		this.updateFieldExclude.add("create_by");
		this.updateFieldExclude.add("actorid");
		this.updateFieldExclude.add("runno");
	}

	public void setDbRecord(DbRecord db) {
		try {
			this.db = db;
			this.tableName = db.getTableName();
			this.upf = db.getUProfile();
			this.mf = this.db.getPropertyRec();			
			dataBlob.clear();
			this.ev.setRecord(db);
			this.initField();
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	}
	
	public void setUProfile(UProfile upf) {
		this.upf = upf;
	}
	public synchronized boolean create() throws Exception {
		CscConnection connection = null;
		PreparedStatement statement = null;
		ev.clearObject();
		StringBuffer bf=new StringBuffer();
		boolean ok=true;
		boolean create=true;
		try {
			if (!this.db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.db.getDataBaseName(), this.upf);				
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(), this.upf); 
			}
			connection.setAutoCommit(false);
			connection.setClassName(this.db.getActualName()+">DataBMPBean.create");
			String sql = this.getCreateSqlScript(connection.isJdbc(),connection.getVendor());
			connection.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);
			statement = connection.prepareStatement(sql, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
            MyLog.info(this, this.upf, "   >> "+sql);
            
            bf.append("SQL create =").append(sql).append("\n");
            
            String key="",value="";
            int countkey=0;
          
			String fieldName,fieldValue;
			FieldManager fm;
			int j=1;
			for (int i = 0; i < this.db.getArrayFieldList().size();i++) {
				fieldName = (String)this.db.getArrayFieldList().get(i);
				fm = this.db.getField(fieldName);
				if (fm.isKey()=='0') {
					if(fm.isLog()){
						fieldValue=fm.getString();
						if(fieldValue.trim().length()>0){
							ev.setNew_value(fieldName, fieldValue);
							if(!fm.isEncrypt())
								ev.setOld_value(fieldName, fm.getOriginalData());
							else{
								if(fm.getOriginalData().trim().length()>1){
									try{
										ev.setOld_value(fieldName, new Base64Decoder(fm.getOriginalData()).processString());
									}catch(Exception ex){
										ev.setOld_value(fieldName, fm.getOriginalData());
									}
								}else{
									ev.setOld_value(fieldName, fm.getOriginalData());
								}
							}
							ev.setField_desc(fieldName,fm.getDescriptionThai());
						}
						bf.append(fieldName).append("=").append(fieldValue).append(" # ");						
					}											
					if (fm.getType().equals("Blob")) {
						String data;
						data = (String) fm.getSaveString();
						if(connection.getVendor().equalsIgnoreCase("ORACLE")&&connection.isJdbc()){
							this.setjdbcBlob(data,fieldName);
						}else if(connection.isJdbc()){
							statement.setString(j++, (String) fm.getSaveString());
						}else{
							this.setOdbcBlob(data,statement,j++);
						}
						bf.append(fieldName).append("=").append(data).append(" # ");
					} else {
						statement.setString(j++, (String) fm.getSaveString());
						bf.append(fieldName).append("=").append(fm.getSaveString()).append(" # ");
					}
				}else{
					countkey++;
					value=fm.getString();				
					statement.setString(j++,  value);
					key+=fieldName+"="+value;
					if(countkey<this.keyList.size()-1)
						key+=" and ";			
//					bf.append("[K]").append(fieldName).append("=").append(value).append(" # ");
					bf.append("'").append(value).append("',");
				}
    		}
			ev.setKey_field(key);
					try {						
						statement.executeUpdate();
						ev.create();
		                connection.setLasttime(System.currentTimeMillis());
		                connection.commit();
						ok=false;
						create=true;
					} catch (SQLException e) {
						connection.rollback();
						create=false;
						MyLog.error(this,this.upf,bf.toString());
						if(e.getSQLState().equals("23000")){ // integrity constraint violation Դ case  价ӡ update
							ok=true;
							this.update(true);
						}else{
						oSQLExceptionManager.checkProplem(this.upf,  connection, this.tableName, e, sql, this.db, this.mf);
						StaticProperties.myConnection.rollback(this.upf, this);
						}
					}
		} catch (Exception e) {
			create=false;
			MyLog.error(this, this.upf, this.tableName + e.toString());
			MyLog.error(this, this.upf, e);
			StaticProperties.myConnection.rollback(this.upf, this);
		} finally {
			closeConnection(connection, statement);
		}
		if(!ok){
			if(this.db.getFieldBlob().size()>0){
				this.updateDataToBlob(0);
			}
		}
		return create;
	}
	

	private String getWhereString() throws RemoteException {
		String buff = "";
		for (int i = 0; i < this.keyList.size(); i++) {
//			buff += this.keyList.get(i).toString() + (String) this.dbField.get(this.keyList.elementAt(i));
			buff += this.keyList.get(i).toString() + this.db.getField(this.keyList.elementAt(i).toString()).getSaveString();
		}
		return buff;
	}
    
	public boolean isNewWhereString() throws RemoteException {
		boolean flag = true;
		if (this.oldWhere.equals(this.getWhereString())) flag = false;
		return flag;
	}
	
    public  boolean findByPrimaryKey() throws Exception {
        CscConnection connection = null;
        PreparedStatement statement = null;
        ResultSet resultSet = null;
        String sql = this.getFindByPrimarySqlScript();
        this.oldWhere = "";
        boolean ok=true;
        try {
			if (!db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(db.getDataBaseName(),this.upf);				
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(),this.upf); 
			}
			connection.setClassName(this.db.getActualName()+">DataBMPBean.findByPrimaryKey");
            statement = connection.prepareStatement(sql, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_READ_ONLY);
            for (int i = 0; i < this.keyList.size(); i++) {
              statement.setString(i + 1, this.db.getField(this.keyList.elementAt(i).toString()).getSaveString());
            }
            int error=0;
			for(;ok;){
		            try {
		                resultSet = statement.executeQuery();
		                connection.setLasttime(System.currentTimeMillis());
		                connection.commit();
		                ok=false;
		            } catch(SQLException ex) {
		            	connection.rollback();
		            	error++;
						oSQLExceptionManager.checkProplem(this.upf, connection, tableName, ex, sql, this.db, this.mf);
						StaticProperties.myConnection.rollback(this.upf, this);
						if(error>5)
							return false;
		            }
			}
            if (resultSet == null || !resultSet.next()) {
                resultSet.close();
                return false;
            } else {
                String field;
                FieldManager fm;
                this.dbField.clear();
                for (int i = 0; i < this.db.getArrayFieldList().size(); i++) {
                    field = this.db.getArrayFieldList().elementAt(i).toString();
                    fm = this.db.getField(field);
                    field = fm.getName();
                    String type = fm.getType();
                    String data; // Warning for null Value in DB
                	if (type.equals("Blob")) {
                		if(connection.getVendor().equals("ORACLE")&& connection.isJdbc()){
                    		Blob blob = resultSet.getBlob(i+1);
                    		connection.addOpenblob();
                    		if(blob!=null)
                    			data= new String(blob.getBytes(1,(int)blob.length()));
                    		else
                    			data="";
                		}else if(connection.isJdbc()){
                			data = resultSet.getString(i+1);
                		}else
                		  data = new String(resultSet.getBytes(i+1));                		
                	} else {
                		data = resultSet.getString(i+1);
                	}
                	
                	if (data != null) {
            			fm.setOriginalData(data);
            			fm.setOriginal(data);
            		} else {
            			data=fm.getDefault();
            			fm.setDefault();
            			fm.setOriginalData("");
            		}
               		this.dbField.put(field, data);
               		this.oldWhere = this.getWhereString();
                    // -------------------
                }
                resultSet.close();
            }
        } catch (Exception e) {
        	MyLog.error(this,this.upf,e);
            return false;
        } finally {
        	try{
        		if(resultSet!=null)
        			resultSet.close();
        	}catch(Exception ex){}
            closeConnection(connection, statement);
        }
        return true;
    }
    
	public boolean isDuplicate() throws Exception {
		CscConnection connection = null;
		PreparedStatement statement = null;
		ResultSet resultSet = null;
		String sql = this.getIsDuplicateSqlScript();
		this.oldWhere = "";
		StringBuffer bf = new StringBuffer();

		boolean ok = true;
		try {
			if (!db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(db.getDataBaseName(), this.upf);
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(), this.upf);
			}
			connection.setClassName(this.db.getActualName()+ ">DataBMPBean.isDuplicate");
			statement = connection.prepareStatement(sql,java.sql.ResultSet.TYPE_FORWARD_ONLY,java.sql.ResultSet.CONCUR_READ_ONLY);
			bf.append("SQL isDuplicate =").append(sql).append("\n");
			FieldManager fm;
			for (int i = 0; i < this.keyList.size(); i++) {
				fm = ((FieldManager) this.keyField.get(i));
				statement.setString(i + 1, fm.getSaveString());
				bf.append(" [K]").append(fm.getName()).append("=").append(fm.getSaveString());
			}
			int error = 0;
			for (;ok;) {
				try {
					resultSet = statement.executeQuery();
					connection.setLasttime(System.currentTimeMillis());
					connection.commit();
					ok = false;
				} catch (SQLException ex) {
					error++;
					connection.rollback();
					oSQLExceptionManager.checkProplem(this.upf, connection,tableName, ex, sql, this.db, this.mf);
					StaticProperties.myConnection.rollback(this.upf, this);
					if (error > 5){
						return false;
					}
				}
			}
			if (resultSet == null || !resultSet.next()) {
				MyLog.debug(this, this.upf, bf.toString());
				resultSet.close();
				return false;
			} else {
				String field = "";
				try {
					this.dbField.clear();
					for (int i = 0; i < this.db.getArrayFieldList().size(); i++) {
						field = (String) this.db.getArrayFieldList().get(i);
						fm = this.db.getField(field);
						field = fm.getName();
						String type = fm.getType();
						String data; // Warning for null Value in DB
						if (type.equals("Blob")) {
							if(connection.getVendor().equals("ORACLE")&& connection.isJdbc()) {
								Blob blob = resultSet.getBlob(i + 1);
								if (blob != null){
									data = new String(blob.getBytes(1,(int) blob.length()));
								}else{
									data = "";
								}
							}else if (connection.isJdbc()) {
								data = resultSet.getString(i + 1);
							}else{
								data = new String(resultSet.getBytes(i + 1));
							}
						}else{
							data = resultSet.getString(i + 1);
						}
						if (data != null) {
							fm.setOriginalData(data);
						} else {
							data = fm.getDefault();
							fm.setOriginalData("");
						}
						this.dbField.put(field, data);
					}
				} catch (Exception ex) {
					MyLog.error(this,this.upf,"Exception on field "+field+" >>>"+ex);
					MyLog.error(this,this.upf,ex);
					return true;
				}
				return true;
			}
		} catch (Exception e) {
			e.printStackTrace();
			MyLog.error(this,this.upf,e); 
			return false;
		} finally {
			try {
				if (resultSet != null)
					resultSet.close();
			}catch (Exception ex) {}
			closeConnection(connection, statement);
		}
	}
    
	public void remove() throws Exception {
        CscConnection connection = null;
		PreparedStatement statement = null;
		String sql = this.getRemoveSqlScript();
		ev.clearObject();
		this.printSql(sql);
		boolean ok=true;
		try {
			if (!db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(db.getDataBaseName(), this.upf);				
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(), this.upf); 
			}
			connection.setClassName(this.db.getActualName()+">DataBMPBean.remove");
			connection.setAutoCommit(false);
			connection.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);
//			connection.getMetaData().supportsResultSetConcurrency(java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
			statement = connection.prepareStatement(sql, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
			
			 String key="",value="";
			 FieldManager fm;
				for (int i = 0; i < this.keyList.size(); i++) {
					fm=(FieldManager)keyField.get(i);
					value=fm.getString();							
					statement.setString(i + 1, value);
					key+=fm.getName()+"="+value;
					if(i<this.keyList.size()-1)
						key+=" and ";
				}
				ev.setKey_field(key);	
			
					try {
						statement.executeUpdate();
		                connection.setLasttime(System.currentTimeMillis());
		                connection.commit();
		                ok=false;
					} catch (SQLException e) {
						connection.rollback();
						oSQLExceptionManager.checkProplem(this.upf, connection, this.tableName, e, sql, this.db, this.mf);
						StaticProperties.myConnection.rollback(this.upf, this);
					}
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
			StaticProperties.myConnection.rollback(this.upf, this);
		} finally {
			closeConnection(connection, statement);
		}
		ev.delete();
	}
	
	public String getString(String field) throws RemoteException {
		String data = "";
		if (this.dbField.containsKey(field)) {
			data = (String)this.dbField.get(field);
			if (data == null) {
				data = " ";
			}
		}
		return data.trim();
	}

	 public boolean update(boolean afterSave) throws Exception {
        CscConnection connection = null;
		PreparedStatement statement = null;
		boolean ok=true;
		boolean update=true;
		ev.clearObject();
		StringBuffer bf=new StringBuffer();
		try {
			if (!this.db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.db.getDataBaseName(), this.upf);				
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(), this.upf); 
			}
//			connection.getMetaData().supportsResultSetConcurrency(java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
			connection.setAutoCommit(false);
			connection.setClassName(this.db.getActualName()+">DataBMPBean.update");
			String sql = this.getStoreSqlScript(connection.isJdbc(),connection.getVendor());
			if(sql.trim().length()>0){
			
			bf.append("SQL update =").append(sql).append("\n");
			
			connection.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);
			statement = connection.prepareStatement(sql, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
            String fieldName;
            FieldManager fm;
            String key="",value="";
            int c=1;            
            for (int i = 0; i < this.db.getArrayFieldList().size(); i++) {
                fieldName = this.db.getArrayFieldList().elementAt(i).toString();
                fm = this.db.getField(fieldName);
                fieldName = fm.getName();
            	
                if (!this.updateFieldExclude.contains(fieldName)) {
                	
					if(fm.isEdit() && fm.isKey()=='0'&& (!fm.getSaveString().equals(fm.getOriginalData())||fm.getType().equals("Blob"))){
						String data =  fm.getSaveString();
						if(fm.isLog()){
							ev.setNew_value(fieldName, fm.getString());
							if(!fm.isEncrypt())
								ev.setOld_value(fieldName, fm.getOriginalData());
							else{
								if(fm.getOriginalData().trim().length()>1){
									try{
										ev.setOld_value(fieldName, new Base64Decoder(fm.getOriginalData()).processString());
									}catch(Exception ex){
										ev.setOld_value(fieldName, fm.getOriginalData());
									}
								}else
									ev.setOld_value(fieldName, fm.getOriginalData());
							}
							ev.setField_desc(fieldName,fm.getDescriptionThai());
						}						
						if (fm.getType().equals("Blob")) {
							if(connection.getVendor().equalsIgnoreCase("ORACLE")&&connection.isJdbc()){
								this.setjdbcBlob(data,fieldName);
							}else if(connection.isJdbc()){
								statement.setString(c++, data);
							}else{
								this.setOdbcBlob(data,statement,c++);
							}
						} else {
							statement.setString(c++, data);
						}
						bf.append(fieldName).append("=").append(data).append(" # ");
					}	
				}
			}
			for (int i = 0; i < this.keyList.size(); i++) {
				fm=(FieldManager)this.keyField.get(i);
				value=fm.getSaveString();
				statement.setString(c++, value);
				key+=fm.getName()+"="+value;
				if(i<this.keyList.size()-1)
					key+=" and ";
				
				bf.append("[K]").append(fm.getName()).append("=").append(value).append(" # ");				
				
				}
			ev.setKey_field(key);

			int updaterow = 0;
			boolean tryOneTime = false;
			for(;ok && ! tryOneTime;){
				try {
					updaterow = statement.executeUpdate();					
	                connection.setLasttime(System.currentTimeMillis());
	                connection.commit();
	                ok=false;
	                update=true;
				} catch (SQLException e) {
					connection.rollback();
					update=false;
					MyLog.debug(this,this.upf,bf.toString());
					oSQLExceptionManager.checkProplem(this.upf, connection,  this.tableName, e, sql, this.db, this.mf);
					StaticProperties.myConnection.rollback(this.upf, this);
					break;
				} catch (Exception e) {
					connection.rollback();
					update=false;
	    			MyLog.error(this, this.upf, e);
	            	tryOneTime = true;
	            	break;
				}
			}
			if (updaterow < 1) {
//				throw new Exception("Row does not exist");
				MyLog.error(this,this.upf,"Row does not exist =>"+bf.toString());
				if(!afterSave){//ҨҡԴ exception ӧҹ 					
					return this.create();
				}else{
					MyLog.error(this,this.upf,"Row does not exist =>"+bf.toString());
					return false;
				}
			}else{
				ev.update();
			}
		  }
		} catch (SQLException e) {
			MyLog.error(this, this.upf, e);
		} finally {
			closeConnection(connection, statement);
		}
		if(!ok){
			if(this.dataBlob.size()>0){
				this.updateDataToBlob(0);
			}						                	                			
		}
		return update;
	}
	  
		private String getCreateSqlScript(boolean isJdbc,String vendor) throws RemoteException {
			String sql = "", field = "", value = "";
			String fieldName;
			FieldManager fm;
			for (int i = 0; i < this.db.getArrayFieldList().size(); i++) {
				fieldName = this.db.getArrayFieldList().get(i).toString();
				fm = this.db.getField(fieldName);
				if(i!=0){
					field += ",";
					value += ",";
				}
				fieldName = fm.getName();				
				if (fm.isKey()=='0') {
					if (field.length() == 0) {
						field += fieldName;
						if(this.db.getFieldBlob().contains(fieldName)&&isJdbc&&vendor.equalsIgnoreCase("ORACLE"))
							value += "empty_blob()";					
						else
							value += "?";
					} else {
						field +=  fieldName;						
						if(this.db.getFieldBlob().contains(fieldName)&&isJdbc&&vendor.equalsIgnoreCase("ORACLE"))
							value += "empty_blob()";					
						else
							value += "?";
					}
				}else{
					field +=  fieldName;
					value += "?";					
				}
			}
			sql = "INSERT INTO " + this.tableName + " (" + field + ") VALUES(" + value + ")";
			return sql.toString();
		}
	
	private String getFindByPrimarySqlScript() {
		String sql = "", field = "";
		try {
			field=db.getArrayFieldList().toString();
			field=field.replace("[", "");
			field=field.replace("]", "");
			sql = "SELECT " + field + " FROM " + this.tableName + "  " + this.getWhereSqlScript(true);
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return sql;
	}
	
	private String getIsDuplicateSqlScript() {
		String sql = "", field = "";
		try {
			field=db.getArrayFieldList().toString();
			field=field.replace("[", "");
			field=field.replace("]", "");
			sql = "SELECT " + field + " FROM " + this.tableName + "  " + this.getWhereSqlScript(false);
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return sql;
	}
	
	private String getStoreSqlScript(boolean isJdbc,String vendor) throws RemoteException {
        String fieldName;
        FieldManager fm;
		String sql = "", field = "";
		int editcheck=0;
        for (int i = 0; i < this.db.getArrayFieldList().size(); i++) {
        	fieldName=(String)this.db.getArrayFieldList().get(i);
            fm = this.db.getField(fieldName);
            fieldName = fm.getName();
            if (!this.updateFieldExclude.contains(fieldName)) {
				if(fm.isEdit() && fm.isKey()=='0'&& (!fm.getSaveString().equals(fm.getOriginalData())||fm.getType().equals("Blob"))){	
					if (field.length() == 0){
							if(this.db.getFieldBlob().contains(fieldName)&&isJdbc&&vendor.equals("ORACLE"))
								field +=  fieldName + " = empty_blob() ";
							else
								field +=  fieldName + " = ? ";					
					}else{						
						if(this.db.getFieldBlob().contains(fieldName)&&isJdbc&&vendor.equals("ORACLE"))
							field += "," + fieldName + " = empty_blob() ";
						else
							field += "," + fieldName + " = ? ";
					}
					editcheck++;	
				}
        	}
		}
        if(editcheck>0)
        	sql = "UPDATE " + this.tableName + " SET " + field + " " + this.getWhereSqlScript(true);
		return sql.toString();
	}
	
	private String getRemoveSqlScript() {
		String sql = "";
		sql = "DELETE FROM " + this.tableName + " " + this.getWhereSqlScript(true);
		return sql.toString();
	}
	
	/**
	 * @modify by pas  parameter security ͡˹ case ˹ͧ security 㹡 seach
	 *         óշ繡 search,update,delete еͧ set security on
	 *         繡óշ search for save еͧӡ set security off ж set Դ case duplicate key  
	 * @param securityOn
	 * @return filter
	 */
	private String getWhereSqlScript(boolean securityOn) {
		String value = "WHERE ";
		try{
				for (int i = 0; i < this.keyList.size(); i++) {
					value += (String) keyList.get(i) + " = ? ";
					if (i + 1 < this.keyList.size())
						value += " AND ";
				}
				
				if(securityOn&&this.db.getSecurity()!=null){
					String se=this.db.getSecurity().inquiryBefor(this.db);
					if(se.trim().length()>0){
						value+=" AND "+se;	
					}
				}
				
		        /*
		         * Start -*****-check column to user from app to cscindextable
		         */
		        
		        if(StaticProperties.checkIndextable){
		                CscIndexTable ci=new CscIndexTable(this.upf,this.tableName,value);
		                ci.save("W_REC");
		        }        
		        /*
		         * End -****-check column to user from app to cscindextable
		         */     
			}catch(Exception ex){
				MyLog.error(this,this.upf,ex);
			}
		return value;
	}
	private void initField() {
		try {
			this.keyList = this.db.getAllKey();
			this.keyField.clear();
			String keyname="";
			for(int c=0;c<this.keyList.size();c++){
				keyname=(String)this.keyList.get(c);				
				this.keyField.add(this.db.getField(keyname));
			}

		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	}
	
	private void setDataBaseInfor() {
		try {
			this.tableName = this.db.getTableName();
		} catch (Exception e) {
		}
	}
	private void closeConnection(CscConnection connection, PreparedStatement statement) {
		try {
			if(statement!=null){
				statement.close();
			}
			if(connection!=null){
				connection.close();
			}
		} catch (SQLException e) {	}
	}
	
	private void printSql(String sql) {
		MyLog.info(this, this.upf, "SQL IN TABLE " + this.tableName + "   : ****************************************");
		MyLog.info(this, this.upf,":" + sql);
	}
	
 
    /************************************
     * CREATE BY ERICAVA
     * check Region and Return eng year
     ***********************************/
    private int checkRegion(int years){
        int th=2443, eng=1900;
        int tmp=years;
        if(years>2443){
            tmp-=2443;
        }else{
            tmp-=1900;
        }
        tmp+=1900;
        return tmp;
    } 
    
    public Vector getKeyList() {
    	return this.keyList;
    }
    
    public  boolean checkDataBeforeSave() throws Exception {
        this.setDataBaseInfor();
        CscConnection connection = null;
        String sql = this.checkRecordValidate();
        Statement stm = null;
        ResultSet rs=null;
        this.oldWhere = "";
        boolean foundError = false;
        boolean ok=true;
        if (sql.length()>0) {
			if (!this.db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.db.getDataBaseName(),this.upf);				
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(),this.upf); 
			}
			connection.setClassName(this.db.getActualName()+">DataBMPBean.checkDataBeforeSave");
	        for(;ok;) {
                try {
                    stm = connection.createStatement(java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_READ_ONLY);
                    MyLog.info(this, upf, "REFRESH  " + sql);
                    rs = stm.executeQuery(sql);
                    if (rs != null && rs.next()) {
                        //this.fetch();
                        foundError = true;
                    } else {
                        foundError =  false;
                    }
                    connection.setLasttime(System.currentTimeMillis());
                    ok = false;
                } catch (SQLException e) {     
                	this.oSQLExceptionManager.checkProplem(upf, connection,this.tableName, e, sql);
                	if(connection.isReconnect(e)){
                		connection=connection.checkConnectionClose();
                	}	    			
                	continue;
                }catch(Exception ex){
                	 /** nuball edit  10-10-49 **/
                	 MyLog.info(this, upf,"Exception  Error In DataSet.initConnection() "+ex.toString());
                	/********************/
                 	if(connection.isReconnect(ex)){
                		connection=connection.checkConnectionClose();
                	}	    			
                	continue;
                 }finally{
                	 if(rs!=null)
                		 rs.close();
                	 if(stm!=null)
                		 stm.close();
     	        	connection.close();
     	        }
	        }
        }
        return !foundError;
    }
  
	private String checkRecordValidate() throws RemoteException {
		String andCond = "";
		String orCond = "";
		String allCond = "";
		String fieldName = "";
		DbRecord dbRecord = this.db;
		if (dbRecord.getConditionAND().size()>0 || dbRecord.getConditionOR().size()>0) {
			
			// KEY FIELD ( NOT( KEYFIELD1='XXXXXX' AND KEYFIELD2='XXXXXX' ))
			fieldName = this.getKeyList().get(0).toString();
			allCond += "( not (" + dbRecord.getField(fieldName).getCompareString();
			for (int i = 1; i < this.getKeyList().size();i++) {
				fieldName = this.getKeyList().get(i).toString();
				allCond += " and " + dbRecord.getField(fieldName).getCompareString();
			}
			allCond += "))";
			
			// ANDFIELD  ( ANDFIELD1='XXXXXX' AND ANDFIELD2='XXXXXX' ))
			if (dbRecord.getConditionAND().size()>0) {
				andCond = "(" +  dbRecord.getField(dbRecord.getConditionAND().get(0).toString()).getCompareString();
				for (int i = 1; i < dbRecord.getConditionAND().size();i++) {
					fieldName = dbRecord.getConditionAND().get(i).toString();
					if (!this.getKeyList().contains(fieldName)) {
						if (this.mf.containsKey(fieldName)) {
							andCond += " and " + dbRecord.getField(fieldName).getCompareString();
						}
					}
				}
				andCond += ")";
				allCond += " and "+andCond; 
			}
			
			// ORFIELD  (ORFIELD1='XXXXXX' AND ORFIELD2='XXXXXX' ))
			if (dbRecord.getConditionOR().size()>0) {
				orCond = "(" + dbRecord.getField(dbRecord.getConditionOR().get(0).toString()).getCompareString();
				for (int i = 1; i < dbRecord.getConditionOR().size();i++) {
					fieldName = dbRecord.getConditionAND().get(i).toString();
					if (!this.getKeyList().contains(fieldName)) {
						if (this.mf.containsKey(fieldName)) {
							orCond += " or "+dbRecord.getField(fieldName).getCompareString();
						}
					}
				}
				orCond += ")";
				allCond += "and "+orCond; 
			}
			
			allCond = "select "+dbRecord.getFieldList()+" from "+this.tableName+" where "+allCond;
		} 
		return allCond;
	}	
	
	public void clearOldWhere(){
		this.oldWhere="";
	}

	private void setOdbcBlob(String data, PreparedStatement statement,int position) {			
		try {
			InputStream is = new ByteArrayInputStream(data.getBytes());
			statement.setBinaryStream(position, is, is.available());
		} catch (Exception e) {
			e.printStackTrace();
		}			
	}
    
	private void setjdbcBlob(String data,String fieldName) {
		try {
				dataBlob.put(fieldName.toUpperCase(),data);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	private void updateDataToBlob(int num){			
		ResultSet result=null;
		String blobList="";
		CscConnection con = null;
		Statement stm=null;
		try{
			Thread.sleep(500);
			if(!this.db.getDataBaseName().equals("")){
				ConnectionPools cp = (ConnectionPools) StaticProperties.connectionMap.get(this.db.getDataBaseName().toLowerCase());
				con = cp.createConnection();
			}else{
				ConnectionPools cp = (ConnectionPools) StaticProperties.connectionMap.get(this.upf.getDbName().toLowerCase());
				con = cp.createConnection();
			}	
		if(con!=null){
			if(con.isJdbc()&&con.getVendor().equals("ORACLE")){
				con.setClassName(this.db.getActualName()+">DataBMPBean.updateDataToBlob");
						con.setAutoCommit(false);
						stm=con.createStatement();					
						for(int v=0;v<this.db.getFieldBlob().size();v++){
							blobList+=(String)this.db.getFieldBlob().get(v);
							if(v!=this.db.getFieldBlob().size()-1)
								blobList+=",";
						}
						String keyValue="";
						for (int i = 0; i < this.keyList.size(); i++) {
							keyValue+=this.keyList.elementAt(i).toString()+"='"+this.db.getString((String)this.keyList.elementAt(i))+"'";
							if(i!=keyList.size()-1)
								keyValue+=" AND ";
						}
						
						String sql="SELECT "+blobList+" FROM "+this.tableName.toUpperCase()+" WHERE "+keyValue+" for update nowait";
						result=stm.executeQuery(sql);
						if(result.next()){
						String field="";						
						try{							
								for(int c=0;c<this.db.getFieldBlob().size();c++){
									oracle.sql.BLOB oracleBlob =((OracleResultSet)result).getBLOB(c+1);
									field=(String)this.db.getFieldBlob().get(c);
								    OutputStream outputStream = oracleBlob.setBinaryStream(0L);
								    synchronized (outputStream) {										
									    InputStream inputStream = new ByteArrayInputStream(((String)dataBlob.get(field.toUpperCase())).getBytes());
									    byte[] buffer = new byte[oracleBlob.getBufferSize()];
									    int byteread = 0;
									    while ((byteread = inputStream.read(buffer)) != -1) {
									        outputStream.write(buffer, 0, byteread);
									    }
									    outputStream.close();
									    inputStream.close();
								     }
								 }
							}catch(Exception ex){
								result.close();
								stm.close();
								con.commit();
								num++;
								MyLog.error(this,this.db.getUProfile()," Error Exception :Can't update Oracle Blob (-_-\"), please wait...");
								if(num<20){
									this.updateDataToBlob(num);
									MyLog.error(this,this.db.getUProfile()," Continue  update Oracle Blob ");
								}else{
									MyLog.error(this,this.db.getUProfile()," Error Exception :Can't update Oracle Blob "+ex.getMessage());
									ex.printStackTrace();
								}								
							}
						}
						result.close();
						stm.close();
						con.commit();
						MyLog.debug(this,this.db.getUProfile()," Update Oracle Blob Complete (^__^) ");
			}
		 }else{
			 MyLog.error(this,this.db.getUProfile()," Can't update Oracle Blob .Connection is null ");
		 }
		}catch(Exception ex){
			ex.printStackTrace();
		}
		finally {
			try{
				if(result!=null)
					result.close();
				if(stm!=null)
					stm.close();
				if(con!=null)
					con.endProcess();
			}catch(Exception ex){}
			
		}
	}	

	private String getQueryMove(DbRecord target,String condition,boolean sort){
		StringBuffer insert=new StringBuffer();
		StringBuffer select=new StringBuffer();
		try{
			insert.append(" insert into ").append(target.getTableName()).append(" (");
			select.append("( select ");
			Vector<String> vsource=(Vector <String>)this.db.getArrayFieldList().clone();
			Vector<String> vtarget=(Vector<String>)target.getArrayFieldList().clone();
			if(sort){
				Collections.sort(vsource);
				Collections.sort(vtarget);
			}
			for(int i=0;i<vsource.size();i++){
				insert.append((String)vsource.get(i));
				select.append((String)vtarget.get(i));
				if(i==vsource.size()-1){
					insert.append(")");
				}else{
					insert.append(",");
					select.append(",");
				}
			}
			select.append(" from ").append(this.db.getTableName());
			if(condition.trim().length()>0){
				select.append(" where ").append(condition);
			}
			select.append(")");
			insert.append(select);
		}catch(Exception ex){
			MyLog.error(this,this.db.getUProfile(),ex);
		}		
		return insert.toString();
	}
	
	public int moveToTable(DbRecord target,String condition,boolean sort){
		try{
			String sql=getQueryMove(target,condition,sort);
			return this.moveToTable(sql);
		}catch(Exception ex){
			MyLog.error(this,this.db.getUProfile(),ex);
			return 1;
		}
	}

	public int moveToTable(String sql){
		CscConnection connection = null;
		Statement statement = null;
		try{
			if (!this.db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.db.getDataBaseName(),this.upf);				
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(),this.upf); 
			}
			connection.setClassName(this.db.getActualName()+">DataBMPBean.moveToTable(String)");
			statement = connection.createStatement();
			statement.executeUpdate(sql);
		}catch(Exception ex){
			MyLog.error(this,this.db.getUProfile(),"can't move table sql["+sql+"] exception="+ex);
			return 1;
		}finally{
			try{
				if(statement!=null)
					statement.close();
				if(connection!=null)
					connection.close();
			}catch(Exception ex){
				MyLog.error(this,this.db.getUProfile(),ex);
			}
		}		
		return 0;
	}
	
	public int deleteTable(String deleteSql){
		CscConnection connection = null;
		Statement statement = null;
		try{
			if (!this.db.getDataBaseName().equals("")) {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.db.getDataBaseName(),this.upf);				
			} else {
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.getDbName(),this.upf); 
			}
			connection.setClassName(this.db.getActualName()+">DataBMPBean.deleteTable(String)");
			statement = connection.createStatement();
			statement.executeUpdate(deleteSql);
		}catch(Exception ex){
			MyLog.error(this,this.db.getUProfile(),"cloud n't delete table sql["+deleteSql+"] exception="+ex);
			return 1;
		}finally{
			try{
				if(statement!=null)
					statement.close();
				if(connection!=null)
					connection.close();
			}catch(Exception ex){
				MyLog.error(this,this.db.getUProfile(),ex);
			}
		}		
		return 0;
	}
 }

