package com.csc.library.components;

import java.io.Serializable;
import java.util.StringTokenizer;

import com.csc.library.database.FieldDate;
import com.csc.library.database.GenCompareString;
import com.csc.library.database.SystemCode;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.DbXml;
import com.csc.library.utilities.FileString;
import com.csc.library.utilities.MyFont;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.StrReplace;
import com.csc.library.utilities.UProfile;

public class MyTag implements TagManager, Serializable {
	private static final long serialVersionUID = 1L;
	
	protected String tlabel_read="[*Է繢]";
	protected String elabel_read="[*No permission]";
	protected String tlabel_edit="[*Է䢢]";
	protected String elabel_edit="[*Can't Edit]";
	protected boolean useValidCode = false;

	protected MyFont labelFont, inputFont;
	
	protected String name = "",
                value = "",
                label = "",
                help = "",
                font = "",
                type = "",
                point = "",
                onChange = "",
                onClick = "",
                require = "",
                filter = "",
                onMouseOver = "",
                onMouseOut = "",
                disable = "",
                readonly="",
                onKeyPress = "",
                onKeyUp="",
                onBlur="",
        		onFocus="",
        		css="";
        		
        protected boolean key = false;

        static String sign = "__";
        String[][] sysCode = { { "", "" }
        };

        /********ball edit 23-09-03***********/
        String helpReturn = "";
        /**************/

        protected ComponentManager com;
        // ball edit 09-09-03
        UProfile uPro;

        public MyTag() {}
        
        public MyTag(ComponentManager com) {
            this.com = com;
            this.uPro = com.getUProfile();
            this.set();
        }
        
        @Deprecated
        public MyTag(ComponentManager com, MyFont laFont, MyFont inFont) {
                this(com);
                this.setLabelFont(laFont);
                this.setInputFont(inFont);

        }

        private void set() {
                this.setonChange(com.getProperty("onchange"));
                this.setName(com.getName());
                this.setType(com.getComType());
                this.setonClick(com.getProperty("onclick"));
                // ball edit 09-09-03
                this.setKey( String.valueOf(com.isKey()));
                /*********************/

                this.setDisable(com.getProperty("disable"));
//                this.setValue(com.getProperty("value"));
                this.setValue(com.getDataFormat());
                this.setPonitLabel(com.getProperty("pointlabel"));
                if(!com.getProperty("help").equals(""))
                	this.setHelp(com.getProperty("help"));
                else
                	this.setHelp(com.getHelp());
               
                /********ball edit 30-09-03***********/
                this.setRequire(com.getProperty("require"));

                /*******************/
                this.setonChange(com.getProperty("onchange"));
                this.setToolTip(com.getAlt());
                if(com.getProperty("help_return_field").equalsIgnoreCase(("true"))||(com.getHELP_RETURN_FIELD()))
                	this.setHelpReturn("true");
                else
                	this.setHelpReturn("");

                this.setReadonly(com.getProperty("readonly"));
                this.setonKeyPress(com.getProperty("onKeyPress"));
                this.setonKeyup(com.getProperty("onKeyUp"));
            	this.setLabel(com.getDescription());
            	if(!com.isRead()){
                	this.setLabel(com.getDescription()+this.getReadDescription());
                	this.setDisable("true");
                }else{
                	this.setLabel(com.getDescription());
                	this.setDisable("false");                	
                }
            	if(!com.isEdit()){
                  	this.setLabel(com.getDescription()+this.getEditDescription());
                   	this.setDisable("true");
                }else{
                  	this.setLabel(com.getDescription());
                   	this.setDisable("false");                	
                }
                this.setonBlur(com.getProperty("onBlur"));
                this.setonFocus(com.getProperty("onFocus"));
                //wut edit 06/02/04
        this.setCSS(com.getProperty("css"));        
        }

        public void setDisable(String disble) {
                this.disable = disble;
        }
//wut edit 06/02/04
public void setReadonly(String readonly){
        this.readonly=readonly;
}
        public void setValidCode(String validCode) {
                // ball edit 17-11-03
                if ((!validCode.equals("")) && (this.uPro != null)) {
                        /*********************/
                        sysCode = SystemCode.getContent(validCode.trim());
                        this.useValidCode = true;
                        
                        // ball edit 11-03-05
                   /*     for (int point = 0; point < sysCode.length; point++) {
                                if (sysCode[point][1].indexOf(",") > 0) {
                                        // ball edit 09-09-03
                                        if (this.uPro.get("lang").equalsIgnoreCase("eng")) {
                                                /*********************/
                   /*                             sysCode[point][1] = sysCode[point][1].substring(0, sysCode[point][1].indexOf(","));
                                        } else {
                                                sysCode[point][1] = sysCode[point][1].substring(sysCode[point][1].indexOf(",") + 1);
                                        }

                                }
                        }*/
                }
        }

        protected void setTable(String condition) { // condition = nameTable,fieldValue,fieldLabel,filter,orderby,lang
                if (!condition.equals("")) {
                        StringTokenizer token = new StringTokenizer(condition, ",");
                        String dbXml, fieldValue, fieldLabel, filter, orderBy,lang;
                        dbXml = fieldValue = fieldLabel = filter = orderBy =lang= "";
                        if (token.hasMoreTokens()) { // nameTable
                                dbXml = token.nextToken();
                        }
                        if (token.hasMoreTokens()) { // fieldValue
                                fieldValue = token.nextToken();
                        }
                        if (token.hasMoreTokens()) { // fieldLabel
                                fieldLabel = token.nextToken();
                        }
                        if (token.hasMoreTokens()) { // fileter
                                filter = token.nextToken();
                        }
                        if (token.hasMoreTokens()) { // orderby
                                orderBy = token.nextToken();
                        }
                        if (token.hasMoreTokens()) { // lang
                            lang = token.nextToken();
                    }
                        this.setTable(dbXml, fieldValue, fieldLabel, filter, orderBy,lang);
                }
        }

        /**
         *  Use Data From Table set Component
         * @param dbXml
         * @param fieldValue
         * @param fieldLabel
         * @param filter
         * @param orderby
         */
        public void setTable(String dbXml, String fieldValue, String fieldLabel, String filter, String orderby,String lang) {
                        int count = 0;
                        try {
                                sysCode = new String[500][2];
                                DbInquiry inq = new DbXml(this.uPro, dbXml, "", "", "").getInquiry();
                                if ((filter.length() > 0) && (filter != null)) {
                                        try {
                                                FileString fs = new FileString();
                                                fs.setData(filter);
                                                fs.replaceAll("$L", "<");
                                                fs.replaceAll("$G", ">");
                                                //filter=	 fs.getData();
                                                inq.setFilter(fs.getData());
                                        } catch (RuntimeException e) {
                                                MyLog.error(this, e);
                                        }
                                }
                                inq.setOrderBy(orderby);
                                inq.refresh();
                                for (; inq.next();) {
                                        DbRecord rec = inq.getCurrentDbRecord();
                                        //	rec.setUProfile(com.getUProfile());
                                        if(lang.equalsIgnoreCase("langoff")){
                                            rec.referLangOff();
                                        }else{
                                            rec.referLangOn();
                                        }
                                        sysCode[count][0] = rec.getString(fieldValue);
                                        StringTokenizer st=new StringTokenizer(fieldLabel,"|");
                                        String label="";
                                        while(st.hasMoreTokens()){
                                                String temp=st.nextToken();
                                                String value="";
                                                if(temp.indexOf("FIX#")!=-1){
                                                        value=temp.substring(temp.indexOf("#")+1,temp.length());
                                                }else{
                                                        value=rec.getString(temp);
                                                }
                                                if(label.length()==0){
                                                        label+=value;
                                                }else{
                                                        label+=" "+value;
                                                }
                                        }
                                        sysCode[count][1] = label;
                                        rec.referLangOff();
                                        count++;
                                }
                        } catch (Exception e) {
                            MyLog.error(this, e);
                        }
                }
        
        public String spilltLang(String value){
        	if((value!=null)&&(value.indexOf(",")>0)){
			 if (this.uPro.get("lang").equalsIgnoreCase("eng")) {                    
			 	return value.substring(0, value.indexOf(","));				 	
			 } else {         
			 	
			 	return  value.substring(value.indexOf(",") + 1);
			 }				
        	}
			 return value;
        }
/*
        public void setTable(String dbXml, String fieldValue, String fieldLabel, String filter, String orderby) {
                int count = 0;
                try {

                        sysCode = new String[100][2];
                        DbInquiry inq =      new DbXml(this.uPro,dbXml,"","","").getInquiry();
                        //inq.setDataSource(new InitialEnvironment(com.getUProfile().getDbName()).getValue("datasource-name"));
                        //inq.setSchemaName(com.getUProfile().getSchemaName());
                        //inq.initMyTable(dbXml, filter, orderby);
                        //inq.setColumn("*");
                        if ((filter.length()>0) && (filter !=null)){
                                try {
                                        FileString fs=new FileString();
                                        fs.setData(filter);
                                        fs.replaceAll("$L","<");
                                        fs.replaceAll("$G",">");
                                        //filter=	 fs.getData();
                                        inq.setFilter(fs.getData());
                                       // System.out.println("-----------------------------------++++++++++++++++++++:"+fs.getData());
                                } catch (RuntimeException e) {
                                        e.printStackTrace();
                                }
                        }
                        inq.setOrderBy(orderby);
                        inq.refresh();
        //	System.out.println("---------------------------------------"+com.getUProfile());
                        for (; inq.next();) {
                                DbRecord rec =			inq.getCurrentDbRecord();
                        //	rec.setUProfile(com.getUProfile());
                                rec.referLangOn();
                                sysCode[count][0] = rec.getString(fieldValue);
                		System.out.println("---------"+fieldLabel+"-----<"+rec.getString(fieldLabel)+">------"+rec.getString(fieldValue));
                                sysCode[count][1] = rec.getString(fieldLabel);
                                rec.referLangOff();
                                count++;
                        }
        //	System.out.println("---------------------------------------");
                } catch (Exception e) {
                        e.printStackTrace();
                }
        }
 */
        // ball edit 09-09-03
//	private DbInquiry getInquiry() {
//		return new InitialInquiry(this.uPro).getDbInquiry();
//	}
        /****************/
        // ball edit 09-09-03
        public String tagHelp(String helpCode, String fieldName, String Show) {

                if (this.helpReturn != null && !this.helpReturn.equals("")) {
                        return "&nbsp;<a href=\"javascript:goHelp('"
                                + helpCode
                                + "','"
                                + fieldName
                                + "');\"  "
                                + "onMouseOut=\"MM_swapImgRestore()\" onMouseOver=\"MM_swapImage('"
                                + this.name
                                + "_image"
             
                                + "','','../IMAGES/BUTTON/SWAP/SEARCH_SWAP20.gif',1)\"><img src=\"../IMAGES/BUTTON/MAIN/SEARCH20.gif\" alt=\"SEARCH\" name=\""
                                /*************/
                                + this.name
                                + "_image"
                                + "\" width=\"20\" height=\"20\" border=\"0\" align=\"absmiddle\"  ></a> ";
                } else {
                        return "&nbsp;<a href=\"javascript:linkHelp('"
                                + helpCode
                                + "','"
                                + fieldName
                                + "');\"  "
                                + "onMouseOut=\"MM_swapImgRestore()\" onMouseOver=\"MM_swapImage('"
                                + this.name
                                + "_image"                  
                                + "','','../IMAGES/BUTTON/SWAP/SEARCH_SWAP20.gif',1)\"><img src=\"../IMAGES/BUTTON/MAIN/SEARCH20.gif\" alt=\"SEARCH\" name=\""
                                + this.name
                                + "_image"
                                + "\" width=\"20\" height=\"20\" border=\"0\" align=\"absmiddle\"  ></a> ";
                }
        }
        /****************/
        public void setName(String name) {
                this.name = sign + name;
        }

        public void setLabel(String lable) {
        	if (this.key) {
                this.label = "<label class=\"key\"><b>" + lable + "</b></label>";
            } else {
                 this.label = "<label>" +lable + "<span class=\"require\">" +this.require +"</span></label>";
            }
        }

        public void setHelp(String help) {
                this.help = help;
        }

        public void setValue(String value) {
                /*************ball edit  15 03 01*****************/
        	if(this.com instanceof FieldDate){
        		GenCompareString genCom = new GenCompareString();
                this.value = genCom.dateString(new CscCalendar(value));
            }else {
            	this.value = this.charForSet(value);
            }
        }
        public String charForSet(String data) {
                String buff = data;
                // ball edit 17-10-03
                String tmpV, tmpL;
                if ((buff != null) && (!buff.equals(""))) {
                        StrReplace replace = new StrReplace();
                        //SystemCode code = new SystemCode();
                        String[][] sysCode = SystemCode.getContent("charsave");
                        for (int point = 0; point < sysCode.length; point++) {
                                tmpV = sysCode[point][0];
                                tmpL = sysCode[point][1];
                                buff = replace.replaceAll(buff, tmpV, tmpL);
                        }
                }
                return buff;
        }

        public void setLabelFont(MyFont label) {
	            this.labelFont = label;
	    }
	
	    public void setInputFont(MyFont input) {
	            this.inputFont = input;
	    }
    
    public void setType(String type) {
                this.type = type;
        }

        public void setPonitLabel(String point) {
                this.point = point;
        }

        public void setonClick(String action) {
                this.onClick = action;
        }

        public void setonChange(String action) {
                this.onChange = action;
        }

        public void setonBlur(String action) {
                this.onBlur = action;
        }
        public void setonFocus(String action) {
            this.onFocus = action;
    }
        public void setKey(String majority) {
                if (majority != null) {
                        // ball edit 09-09-03
                        if (!majority.equalsIgnoreCase("0")) {
                                //key = "&nbsp;*";
                                this.key = true;
/*				this.setRequire("false");
                        } else {
                                this.key = false;
                                this.setRequire("true");*/
                        }
                }
        }

        public void setonMouseOver(String script) {
                this.onMouseOver = script;
        }

        public void setonMouseOut(String script) {
                this.onMouseOut = script;
        }

        //pae edit 10-11-2546
        public void setonKeyPress(String script) {
                this.onKeyPress = script;
        }

        //pae edit 10-11-2546
        public void setonKeyup(String script) {
                this.onKeyUp = script;
        }

        // ball edit 09-09-03
        public void setUProfile(UProfile uPr) {
                this.uPro = uPr;
        }

        public void setToolTip(String alt) {

        	if((alt!=null)&& (!alt.equals(""))) {
        		this.onMouseOver = "toolTip('" + alt.trim() + "')";
        		this.onMouseOut = "toolTip()";
            }

        }

        public void setSpace(int space) {}
        public String getInput() {
                return "";
        }

        public String process() {
                return "";
        }
        /********ball edit 23-09-03***********/
        public void setHelpReturn(String helpReturn) {
                this.helpReturn = helpReturn;
        }
        /********************************/

        /********ball edit 30-09-03***********/
        public void setRequire(String req) {

        	if (req.equalsIgnoreCase("true")){
        		this.require = "&nbsp;*";
        	} else {
        		this.require = "";
        	}
      }
    
        public String getLabel() {
        	return this.label;
        }
        public void ini(){}
        public void setCSS(String css){
            this.css = css;
        }
        
        private String getReadDescription(){
        	return (this.uPro.get("lang").equalsIgnoreCase("tha")?tlabel_read:elabel_read);
        }

        private String getEditDescription(){
        	return (this.uPro.get("lang").equalsIgnoreCase("tha")?tlabel_edit:elabel_edit);
        }
}
