package com.csc.library.components;

import java.util.StringTokenizer;

import com.csc.library.database.FieldAutoNumber;
import com.csc.library.database.FieldBigDecimal;
import com.csc.library.database.FieldDate;
import com.csc.library.database.FieldDouble;
import com.csc.library.database.FieldFloat;
import com.csc.library.database.FieldInteger;
import com.csc.library.database.FieldTime;
import com.csc.library.utilities.CscCalendar;

public class Text extends MyTag {
	private static final long serialVersionUID = 1L;
	String charsize = "";
	String maxsize = "";
	String tagInput = "";
	String hspace = "";
	String dir = "";
	
	private boolean autonumber = false;

	public Text() {
		this.type = "text";
	}

	public Text(ComponentManager cm) {
		super(cm);
		
		if (cm.getProperty("size").equals("")) {
			this.setSize(cm.getStringWidth());
		} else {
			this.setSize(cm.getProperty("size"));
		}
		
		this.setMax(cm.getProperty("maxsize"));
		this.setDir(cm.getProperty("dir"));
		if (cm.getProperty("dir") != null && !cm.getProperty("dir").equals("")) {
			dir = "rtl";
		}

		if (cm instanceof FieldDate) {
			if (this.value.equalsIgnoreCase("01-01-1900")){//||this.value.equalsIgnoreCase("31-12-2100")) {
				if (cm.getProperty("default").equalsIgnoreCase("new")) {
					this.value = new CscCalendar().getDDMMYYYY();
				} else {
					this.value = "";
				}

			}
			if (this.onKeyUp.equals("") && this.onBlur.equals("") && this.onKeyPress.equals("")) {
				this.setonKeyup("formatDate(this);");
				this.setonBlur("chkInputDate(this);");
				this.setonKeyPress("chkIntegerOfDate(this.value,event);");
				this.setToolTip(cm.getAlt() + "(DDMMYYYY)");
			}
			this.setMax("10");

		} else if ((cm instanceof FieldFloat) || (cm instanceof FieldDouble) || (cm instanceof FieldBigDecimal)) {
			if (this.onKeyUp.equals("") && this.onBlur.equals("") && this.onKeyPress.equals("") && this.onFocus.equals("")) {
				this.setonKeyup("checkComma(this,2);");
				this.setonBlur("checkNumFloat(this,0,900000000);");
				this.setonKeyPress("checkWordNumber(this.value,event);");
				this.setonFocus("callDelComma(this);");
			}
			dir = "";
			this.setCSS("numeric");

		} else if (cm instanceof FieldTime) {
			if (this.onKeyUp.equals("")) {
				this.setonKeyup("isValidTime(this.value);");
			}

		} else if (cm instanceof FieldInteger) {
			if (this.onBlur.equals("") && this.onKeyPress.equals("") && this.onFocus.equals("")) {
				this.setonBlur("checkNumInt(this,0,900000000);");
				this.setonKeyPress("chkInteger(event);");
				this.setonFocus("callDelComma(this);");
			}
			dir = "";
			this.setCSS("numeric");
			
		} else if( cm instanceof FieldAutoNumber) {
			autonumber = true;
			
		} else {
			if (cm.getProperty("isvalid").equals("") || cm.getProperty("isvalid").equals("true") || this.key) { //edit by pas óշ key ͧ ѡþ java script function chkSpecialStr
				this.onBlur = "trimValue(this);" + this.onBlur;
				if(this.key){					
					this.onKeyPress = "chkSpecialKey(event);" + this.onKeyPress;
				}else{
					this.onKeyPress = "chkSpecialStr(event);" + this.onKeyPress;
				}
			}
		}

		if (this.onFocus.equals("")) {
			this.onFocus = "this.select();";
		}
		if ((cm.getLang() == 'E') || (cm.getLang() == 'e')) {
			this.onKeyPress = "chkNotThaiChaOnly(event);" + this.onKeyPress;
		}
		this.ini();
		if (this.maxsize.length() < 1)
			this.maxsize = this.charsize;

		if ((this.help != null) && (this.help.length() > 0)) {
			if ((cm instanceof FieldFloat) || (cm instanceof FieldDouble) || (cm instanceof FieldBigDecimal) || (cm instanceof FieldInteger)) {
				if (this.value.equals("")) {
					this.setValue("0");
				}
			} else {
				if (this.value.equals("")) {
					this.setValue("NONE");
				}
			}
		}

	}

	public void setSpace(int space) {
		for (int i = 0; i < space; i++) {
			hspace = hspace + "&nbsp;";
		}
	}

	public void ini() {
		String label2;
		label2 = "";

		// this.logger.info("text help "+this.help+" "+this.help.length());
		if ((this.help != null) && (this.help.length() > 0)) {

			label2 = "help";
			label2 = this.tagHelp(this.help, this.name, label2);
		}
		
		/*
        tagInput =
            "<INPUT TYPE='"
                    + this.type
                    + "'"
                    + " Name='"
                    + this.name
                    + "'"
                    + " SIZE='"
                    + this.charsize
                    + "'"
                    + " MAXLENGTH='"
                    + this.maxsize
                    + "'"
                    + " VALUE='"
                    + this.value
                    + "'"
                    + ((this.disable.equalsIgnoreCase("true")) ? " DISABLED" : "")
                    +" "
                    + ((this.readonly.equalsIgnoreCase("true")) ? " READONLY " : "")
                    + " onClick=\""
                    + onClick
                    + "\""
                    + " onChange=\""
                    + onChange
                    + "\""
                    + " onMouseOver=\""
                    + this.onMouseOver
                    + "\""
                    + " onMouseOut=\""
                    + this.onMouseOut
                    + "\""
                    + " onKeyPress=\""
                    + this.onKeyPress
                    + "\""
                    + " onKeyUp=\""
                    + "sysIsEdit();" + this.onKeyUp
                    + "\""
                    + " dir=\""+dir+"\""
                    + " onBlur=\""+this.onBlur+"\""
                    +" onFocus=\""+this.onFocus+"\""
                    +" class=\""+this.css+"\""
                   
                    +" alt=\""+((com!=null)?com.getAlt():"")+"\""
                    + "  >"
                    + label2;
                    */
		
		StringBuilder tag = new StringBuilder();
		tag.append("<input type=\"").append(type).append("\" ");
		tag.append("name=\"").append( name ).append("\" ");
		tag.append("size=\"").append( charsize ).append("\" ");
		tag.append("maxlength=\"").append( maxsize ).append("\" ");
		tag.append("value=\"").append( value ).append("\" ");
			
		if(autonumber) {
			tag.append("autonumber ");
		}
			
		if("true".equalsIgnoreCase( disable )) {
			tag.append("disabled ");
		}
		if("true".equalsIgnoreCase( readonly  )) {
			tag.append("readonly ");
		}
	
		if( !"".equalsIgnoreCase( css  )) {
			tag.append("class=\"").append( css ).append("\" ");
		}
		if( !"".equalsIgnoreCase( onClick  )) {
			tag.append("onclick=\"").append( onClick ).append("\" ");
		}
		if( !"".equalsIgnoreCase( onChange  )) {
			tag.append("onchange=\"").append( onChange ).append("\" ");
		}
		if( !"".equalsIgnoreCase( onKeyPress  )) {
			tag.append("onkeypress=\"").append( onKeyPress ).append("\" ");
		}
		if( !"".equalsIgnoreCase( onKeyUp  )) {
			tag.append("onkeyup=\"sysIsEdit();").append( onKeyUp ).append("\" ");
		}else{
			tag.append("onkeyup=\"sysIsEdit();").append("\" ");
		}
		if( !"".equalsIgnoreCase( onBlur  )) {
			tag.append("onblur=\"").append( onBlur ).append("\" ");
		}
		if( !"".equalsIgnoreCase( onFocus  )) {
			tag.append("onfocus=\"").append( onFocus ).append("\" ");
		}
		if( !"".equalsIgnoreCase( dir )) {
			tag.append("dir=\"").append( dir ).append("\" ");
		}
		if( com != null ) {
			tag.append("alt=\"").append( com.getAlt() ).append("\" ");
		}
		if( !"".equalsIgnoreCase( onMouseOver  )) {
			tag.append("onmousemver=\"").append( onMouseOver ).append("\" ");
		}
		if( !"".equalsIgnoreCase( onMouseOut  )) {
			tag.append("onmouseout=\"").append( onMouseOut ).append("\" ");
		}
		
		tag.append(" />");
		tag.append( label2 );
		tagInput = tag.toString();

	}

	public void setDir(String type) {
		if ((type.equalsIgnoreCase("BigDecimal")) || (type.equalsIgnoreCase("Double")) || (type.equalsIgnoreCase("Integer")) || (type.equalsIgnoreCase("Float"))) {
			dir = "rtl";
		}
	}

	public void setSize(String size) {
		this.charsize = size;
	}

	public void setMax(String max) {
		this.maxsize = max;
	}

	public String process() {
		this.ini();
		if ((this.point != null) && (this.point.equalsIgnoreCase("l"))) {
			return this.tagInput + this.hspace + this.label;
		} else {
			return this.label + this.hspace + this.tagInput;
		}
	}

	public String getInput() {
		return this.tagInput;
	}

	public void setonKeyPress(String script) {
		if ((script.indexOf(";") < 0) && (script.indexOf("()") > 0)) {
			script = script.substring(0, script.length() - 1) + "event)";
		} else {
			String temp = "";
			String temp1 = "";
			StringTokenizer token = new StringTokenizer(script, ";");
			while (token.hasMoreTokens()) {
				temp = token.nextToken();
				if (temp.indexOf("()") > 0) {
					temp1 += temp.substring(0, temp.length() - 1) + "event)";
				} else {

					if (temp.substring(temp.indexOf("(")).toLowerCase()
							.indexOf("event") < 0) {
						temp1 += temp.substring(0, temp.length() - 1)
								+ ",event)";
					} else {
						temp1 += temp;
					}
				}
				temp1 += ";";
			}
			script = temp1;
		}
		this.onKeyPress = script;
	}
}
