package com.csc.library.cscexport;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import org.jdom.Attribute;
import org.jdom.Element;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

/**
 * <PRE>
 * Cls 红 xml ͧ Export
 *  Cls CscExport ¡ҹдǡ
 * </PRE>
 * 
 * @author @SoCooL@
 */
public class ExportXml {
	//root element 
	Element						root;
	// attribute in root element
	private String				xmlName;
	private String				fileOut;
	private String				processType;
	private String				fileType;
	private String 				requiryFound;
	private String				separateRec;
	// element INIT HEAD FOOT
	private String				initData;
	private Vector				head;
	private Vector				foot;
	private Vector				data;
	private Vector				configData;
	private Vector				configHead;
	private Vector				configFoot;
	private HashMap				attrData;
	private HashMap				attrHead;
	private HashMap				attrFoot;
	/**
	 * <PRE>
	 * Constructor 㹡ҹҨҡ xml 
	 * 絤ҵ Cls ҹ
	 * </PRE>
	 * @param xmlName  xml ͧ Export
	 */
	public ExportXml(String xmlName) {
		this.xmlName = xmlName;
		data = new Vector();
		head = new Vector();
		foot = new Vector();
		configData = new Vector();
		configHead = new Vector();
		configFoot = new Vector();
		attrData = new HashMap();
		attrHead = new HashMap();
		attrFoot = new HashMap();
		this.process();
	}
	/**
	 * ֧ config ͧ
	 * @param configNo  
	 * 			-    1   config ͧ tag data
	 * 			-    2   config ͧ tag head
	 * 			-    3   config ͧ tag foot
	 * @return Vector  Ѿ config  Vector 
	 * 		¨纤 Key Value ͧ Property ͧ Tag ͧ
	 */
	public Vector getConfig(int configNo) {
		if (configNo == 0) {
			return this.configData;
		} else if (configNo == 1) {
			return this.configHead;
		} else if (configNo == 2) {
			return this.configFoot;
		} else
			return null;
	}
	/**
	 * ֧ property ͧ tag data ӴѺͧ
	 * @param no  ӴѺͧ property ͧ
	 * @return HashMap  [key,value] ͧ tag data
	 */
	public HashMap getConfigData(int no) {
		return (HashMap) this.configData.get(no);
	}
	/**
	 * ֧ property ͧ tag head ӴѺͧ
	 * @param no  ӴѺͧ property ͧ
	 * @return HashMap  [key,value] ͧ tag head
	 */
	public HashMap getConfigHead(int no) {
		return (HashMap) this.configHead.get(no);
	}
	/**
	 * ֧ property ͧ tag foot ӴѺͧ
	 * @param no  ӴѺͧ property ͧ
	 * @return HashMap  [key,value] ͧ tag foot
	 */
	public HashMap getConfigFoot(int no) {
		return (HashMap) this.configFoot.get(no);
	}
	/**
	 * ֧Ըա㹡÷ӧҹ Export
	 * @return String  Ըա㹡 export
	 */
	public String getProcessType() {
		return processType;
	}
	/**
	 * ֧ ͧӡ¡ record 
	 * @return String
	 */
	public String getSeparateRec() {
		return separateRec;
	}
	/**
	 * 觤 Vector  tag data Ѻ
	 * @return Vector
	 */
	public Vector getData() {
		return data;
	}
	/**
	 * 觤 Vector  tag foot Ѻ
	 * @return Vector
	 */
	public Vector getFoot() {
		return foot;
	}
	/**
	 * 觤 Vector  tag head Ѻ
	 * @return Vector
	 */
	public Vector getHead() {
		return head;
	}
	/**
	 * 觤 export  c:/test.txt
	 * @return String
	 */
	public String getFileOut() {
		return fileOut;
	}
	/**
	 * 觤ҪԴͧ export  txt , xml
	 * @return String
	 */
	public String getFileType() {
		return fileType;
	}
	public String getRequiryFound(){
		return this.requiryFound;
	}
	/**
	 * 觤 tag Init data Ѻ
	 * @return String
	 */
	public String getInitData() {
		return initData;
	}
	/**
	 * 觤Ҫ xml Ѻ
	 * @return String
	 */
	public String getXmlName() {
		return xmlName;
	}
	/**
	 * 絤 export  c:/test.txt
	 * @param fileOut The fileOut to set
	 */
	public void setFileOut(String fileOut) {
		this.fileOut = fileOut;
	}
	/**
	 *  fetch Ũҡ node 
	 * @param nodeData  note ͧ fetch 
	 * @param data  Vector 红Ţͧ tag ͧ
	 * @param config  Vector  property ͧ tag 
	 */
	private void fetchValue(String nodeData, Vector data, Vector config) {
		HashMap h = new HashMap();
		Element e = null;
		List list = null, dataList = null;
		Iterator it = null, dataIterate = null;
		Attribute at = null;
		int dataSize = 0;
		if (root.getChild(nodeData)!=null) {
			dataList = root.getChild(nodeData).getChildren();
			dataIterate = dataList.listIterator();
			while (dataIterate.hasNext()) {
				e = (Element) dataIterate.next();
				data.add(e.getText());
				list = e.getAttributes();
				it = list.listIterator();
				while (it.hasNext()) {
					at = (Attribute) it.next();
					h.put(at.getName().trim(), at.getValue().trim());
				}
				config.add(dataSize, h.clone());
				h.clear();
				dataSize++;
			}
		}
	}
	protected boolean process() {
		ReadXml r = new ReadXml(this.xmlName);
		try {
			// necessary
			root = r.getRootElement();
			// attribute in root element  is   name  fileout  filetype processtype   separaterec
			this.xmlName = r.getAttrValue(r.getRootElement(), "name").trim();
			this.fileOut = r.getAttrValue(r.getRootElement(), "fileout").trim();
			this.fileType = r.getAttrValue(r.getRootElement(), "filetype").trim();
			this.processType = r.getAttrValue(r.getRootElement(), "processtype").trim();
			this.initData = r.getString("INIT");
			this.fetchValue("DATA", this.data, this.configData);
			this.fetchValue("HEAD", this.head, this.configHead);
			this.fetchValue("FOOT", this.foot, this.configFoot);
			if (root.getChild("DATA")!=null) this.attrData = r.getHashMapAttr(root.getChild("DATA"));
			if (root.getChild("HEAD")!=null) this.attrHead = r.getHashMapAttr(root.getChild("HEAD"));
			if (root.getChild("FOOT")!=null) this.attrFoot = r.getHashMapAttr(root.getChild("FOOT"));
			if (r.getAttrValue(r.getRootElement(),"requiryfound")!=null) this.requiryFound = r.getAttrValue(r.getRootElement(),"requiryfound").trim();
			return true;
		} catch (Exception e) {
            MyLog.error(this, e);
			return false;
		}
	}
	/**
	 * Returns the atrbData.
	 * @return HashMap
	 */
	public String getAttrData(String key) {
		return attrData.get(key).toString();
	}
	/**
	 * Returns the atrbFoot.
	 * @return HashMap
	 */
	public String getAttrFoot(String key) {
		return attrFoot.get(key).toString();
	}
	/**
	 * Returns the atrbHead.
	 * @return HashMap
	 */
	public String getAttrHead(String key) {
		return attrHead.get(key).toString();
	}
	public static void main(String[] args) {
		ExportXml exp = new ExportXml("c:/export");
	}
}
