package com.csc.library.database;

import java.sql.Connection;

import javax.naming.Context;
import javax.sql.DataSource;

import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.MyContext;
import com.csc.library.utilities.MyLog;

public class ConnectionPoolManager {

    /**
     * Method Pool create a new connection pool
     */
    public ConnectionPoolManager() {
        System.err.println("DBUtil instance created.");
    }

    /**
     * Method getConnection.
     * @return Connection New connection from the pool
     */



    public  Connection getConnection(String dbName) {
        Connection conn = null;
        String dsName = new InitialEnvironment(dbName).getValue("datasource-name");
        try {
   			Context ic = new MyContext().getInitialContext();
			DataSource ds = (DataSource) ic.lookup(dsName);
			conn=ds.getConnection();

        }
        catch (Exception e) {
        	MyLog.error(this, e);
        }
        return conn;
    }


}
