package com.csc.library.database;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class ConnectionPools {

	private String dbName;

	private int incmx = 0;//ӹǹ connection ٧ش
	
	private int reConnect=0;
	/*
	 * create connection pools 
	 */
	private InitialEnvironment inv;

	private String dbURL = "";

	private String userName = "";

	private String password = "";

	private String databaseName = "";

	private String driverName = "";

	private Vector<CscConnection> connectionsUsed; //connection ١ҹ

	private Vector<CscConnection> connectionsFree; //connection ҹ
	
	private String dbVendor = ""; //ͧ database {MSSQL,ORALCE,MYSQL}
	
	private boolean isJdbc = false;//ͧ connection {true=JDBC , false=ODBC}
	
	private boolean ok = true; 
	
	private long lastclear = 0;
	
	public static boolean traceOn = true; //Ѻ trace connection
	
	public static HashMap<String,CscConnection> connectionProcess= new HashMap<String,CscConnection>();
	
	final String timehold="900000";//  (1  =3600000) Timeout 㹡öͤͧ connection
							
	
//	private ConnectionReaper reaper;

	/**
	 * @author NOVAVIVA
	 * @param dbName
	 * ӡҧ consturcture Ѻ Database Name 㹡ҧ Environment 
	 *  ҧ Connection  HashTable Ѻ֧ connection к  
	 */
	public ConnectionPools(String dbName) {
		this.dbName = dbName;
		try {
			inv = new InitialEnvironment(dbName);
			initEnv();
			this.setParameters();
//		    reaper = new ConnectionReaper(this);
//		    reaper.start();
		} catch (Exception e) {
        	MyLog.error(this, "Can' t connect to database :----------------------------> "+dbName);
        	MyLog.error(this, e);
        	this.ok = false;
		}
	}
	
	public ConnectionPools(Properties prop,String dbName) {
		this.dbName = dbName;
		try {
			inv = new InitialEnvironment(dbName);
			initProperties(prop);
			this.setParameters();
		} catch (Exception e) {
        	MyLog.error(this, "Can' t connect to database :----------------------------> "+dbName);
        	MyLog.error(this, e);
        	this.ok = false;
		}
	}	
	
	public boolean isWorking() {
		return ok;
	}

	/**
	 * 
	 * @throws SQLException
	 * @throws ClassNotFoundException
	 *  ҧ Connection  HashTable Ѻ֧ connection к  ¨ҧ Connection
	 *   tag datasource-max  payrollweb
	 */
	public void setParameters() throws SQLException, ClassNotFoundException {
		Class.forName(driverName);
		connectionsFree = new Vector<CscConnection>();
		connectionsUsed = new Vector<CscConnection>();
		MyLog.info(this, "Start init Connection ....");
		for (int i = 0; i < incmx; i++) {
			connectionsFree.add(this.createConnection());
		}
		MyLog.info(this, "End init Connection ....");
	}

	/**
	 * @author NOVAVIVA
	 * @return CscConnection
	 * ѺǨͺʶҹТͧ connection  ҧ
	 * ¨ 2 hashtable ¡ connection ҹ 
	 *  connectionҹ
	 * ҡ hashconnection ҧ  connection 
	 * кеͺ connection  ҧҹԧ ҡ hash ҧ
	 * ҡ connection ҧ¨ҧ connectionա  tag datasource-inc
	 * ҡ connection ١ҹԹ ˹(٨ҡ tag datasource-timeover) 
	 * кж connectionҧ
	 */

	private CscConnection getConnections() {
		boolean flag = false;
		CscConnection con = null;
		if(connectionsFree.size()>0){			
			try {
				//connection д֧ connection á  get ͡ remove ͡ѹ ͻͧѹ ֧
//				synchronized(connectionsFree) {
					try{
						con = (CscConnection) connectionsFree.firstElement();
						if((con.getCscTransaction()!=null)){//óչͧԴͧҡ transaction § 1 connection : 1 transaction
							addConnectionUsed(con,0);
							con=null;
							con=this.getConnections();
						}else{
							connectionsFree.remove(0);
						}
					}catch(Exception ex){
						MyLog.error(this, "Can't get firstElement : "+ex.getMessage());
					}					
					//ҡ connection 㴷ӡäͧҹԹ˹ (1  =3600000)кзӡ remove ͡ close connection  ШТ connection 
					long timeOver = Long.parseLong(new CheckNull().chkNullString(inv.getValue("datasource-timehold"),timehold));
					if(con.getOverTime()>Integer.parseInt(new CheckNull().chkNullString(inv.getValue("datasource-overtime"),"2"))){ //ҧ next close ͷӡõǨͺҤ駵仵ͧԴ connection 㴺ҧ еͧԴ connection ջѭ
						ConnectionPools.writeLog(Thread.currentThread().getStackTrace(),con,"CloseAll-Over time hold[getConnections]");
						con.closeAll();						
						con=null;
						con = this.getConnections();
					}else if(con.isUses()&&con.getInittime()>0&&System.currentTimeMillis()-con.getInittime()>timeOver){
						//繡óշաҹҹԹҷк˹ кзӡset
						MyLog.warn(this,"datasource-timehold="+inv.getValue("datasource-timehold")+" result="+(System.currentTimeMillis()-con.getInittime()));
						con.setOverTime();						
						connectionsFree.add(con);
						con=null;
						con=this.getConnections();
					}
					//close connection öҹ
					if(con==null){
						con=this.getConnections();
					}else{ 
						if (!con.isClosed()&& con.validate()) {
							//move connection öҹ connectionsUsed
							long sttime=System.currentTimeMillis();
							con.setUses(true);
							con.setStarttime(sttime);
//							con.setLasttime(sttime);
							addConnectionUsed(con,-1);
							flag = true; 
						}else{
							if(!con.validate()){
								con.closeAll();
								con=null;
							}
							con=this.getConnections();
						}
					  }
//					}
			} catch (Exception ex) {
	        	MyLog.error(this, ex);
			}
		 }
		if (flag) {
			try {
				con.setAutoCommit(true);
			} catch (SQLException e) {
            	if(con.isReconnect(e)){
            		con=con.checkConnectionClose();
            	}	    			
			}			
			return con;
		} else {
			return null;
		}
	}
	/**
	 * 
	 * @return Connection
	 * @throws SQLException
	 *   ѺǨͺʶҹТͧ connection  ҧ
	 */
	public synchronized Connection getConnection() throws SQLException {
		Connection con = null;
		long current=System.currentTimeMillis();
		con = this.getConnections();
		// clear connection ء 30 ҷ ͻͧѹ connection ҧҹԹ ¨ close connection 鹷
			if(lastclear==0){
				this.lastclear=System.currentTimeMillis();
			}else if((current-lastclear)>Long.parseLong(new CheckNull().chkNullString(inv.getValue("datasource-clear"),timehold))){
				this.checkConnection();
				this.clearConnectionUsed();
				this.lastclear=System.currentTimeMillis();
			}
			if (con == null) {
				this.reConnect++;
				Runtime.getRuntime().gc();
				this.checkConnection();
					if(this.connectionsFree.size()==0){
						this.clearConnectionUsed();
					}
				if(this.reConnect<30)
					con = this.getConnection();
			}else{
				this.reConnect=0;
			}
		return con;
	}

	public void setConnectionPools() {
		StaticProperties.connectionMap = new HashMap<String,ConnectionPools>();
		String dbList = new InitialEnvironment("GLOBAL")	.getValue("dblist-name");
		StringTokenizer st = new StringTokenizer(dbList, ",");
		while (st.hasMoreTokens()) {
			String dbName = st.nextToken();
			String url = new InitialEnvironment(dbName).getValue("datasource-url");
			ConnectionPools con = new ConnectionPools(dbName);
			StaticProperties.connectionMap.put(url.toLowerCase(), con);
		}
		MyLog.info(this, "Commit Set Connection   "	+ StaticProperties.connectionMap);
	}


	public int checkConnection() {
		CscConnection con = null;
		int cisUser = 0;
		
		try {
			/**
			 * ҡա Hold Connection ҹԹӡ close Connection 
			 */
			for(int i=0;i<this.connectionsFree.size();i++){
				con = (CscConnection) connectionsFree.get(i);
				if(con!=null){
					long now = System.currentTimeMillis();
					long timein = con.getLasttime();
					long timeOver = Long.parseLong(new CheckNull().chkNullString(inv.getValue("datasource-timehold"),timehold));
					if ((now - timein) > timeOver || con.getOpenblob()>0) {
						con.setOverTime();
					}
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return cisUser;
	}
	
	@SuppressWarnings("unchecked")
	public void clearConnectionUsed() {
		CscConnection con = null;
		try {
//			Vector<CscConnection> conused = (Vector<CscConnection>)this.connectionsUsed.clone();
			Vector<CscConnection> conused = this.connectionsUsed;
			long current = System.currentTimeMillis(); 
			for(int i=0;i<conused.size();i++){
				con = (CscConnection) conused.get(i);
				if(con!=null){
					long timeBegin = con.getStarttime();
					long timeEnd = con.getLasttime();
					if(timeEnd<timeBegin){//edbit by pas 2011-11-24  starttime=lasttime ҹԹ timehold ʴա connection Ǩ֧ set current time ͷӡ clear connection 鹷
						timeEnd= current; 
					}
					long timeOver = Long.parseLong(new CheckNull().chkNullString(inv.getValue("datasource-clear"),timehold));
					if (((current-timeEnd)>timeOver)||((timeEnd-timeBegin) > timeOver)) {
							con.commit();
							ConnectionPools.writeLog(Thread.currentThread().getStackTrace(),con,"CloseAll-Over time hold[getConnections]");
							con.closeAll();						
					}
				}
			}
			conused=null;
			if(this.connectionsFree.size()==0){
				this.incConnection();
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
	}	

	public CscConnection createConnection() {
		CscConnection con=null;
		try {
			con = this.createConnection(dbURL, databaseName,userName, password, this.driverName);
			if(con!=null){
				con.initTime();
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return con;
	}

	private CscConnection createConnection(String dbURL,	String databaseName, String userName, String password, String driverName) throws Exception {
		CscConnection con = new CscConnection();
		if (con.initConnection(dbURL, databaseName, userName, password, this.driverName)) {
			con.setVendor(this.dbVendor);	
			con.setJdbc(isJdbc);
			con.setPoolManager(this);
		} else {
        	MyLog.error(this, "Can' t connect to database :----------------------------> "+dbName);
			this.ok = false;
		}
		return con;
	}
	
	private boolean incConnection() {
		int incConn = Integer.parseInt(new CheckNull().chkNullString(inv.getValue("datasource-inc"), "10"));
		boolean chkcon = false;
			CscConnection con = null;
			MyLog.info(this, "start  to  increase connection ....");
			for (int i = 0; i < incConn; i++) {
				con = this.createConnection();
				if (con != null) {
					connectionsFree.add(con);
					chkcon = true;
				}
			}
			MyLog.info(this, "Size of Connection Free : " + connectionsFree.size());
			MyLog.info(this, "Size of Connection Used : " + connectionsUsed.size());
		return chkcon;
	}

	/**
	 * @author NOVAVIVA
	 * ҧ Enverionment ҷͧ ҧͺ
	 *
	 */
	private void initEnv() {
		dbURL = inv.getValue("datasource-url");
		userName = inv.getValue("datasource-username");
		password = inv.getValue("datasource-password");
		databaseName = inv.getValue("datasource-dbname");
		dbVendor = inv.getValue("datasource-dbtype");
//		schema = inv.getValue("schema-name");
		driverName = inv.getValue("datasource-driver");
		incmx = Integer.parseInt(inv.getValue("datasource-max"));
//		incr = Integer.parseInt(inv.getValue("datasource-min"));
		
		if(dbURL.indexOf("jdbc:odbc:")>-1){
			this.isJdbc = false;
		}else{
			this.isJdbc = true;
		}
	}

	private void initProperties(Properties prop) {
		dbURL = prop.getProperty("datasource-url");
		userName = prop.getProperty("datasource-username");
		password = prop.getProperty("datasource-password");
		databaseName = prop.getProperty("datasource-dbname");
		dbVendor = prop.getProperty("datasource-dbtype");
//		schema = prop.getProperty("schema-name");
		driverName = prop.getProperty("datasource-driver");
		incmx = Integer.parseInt(prop.getProperty("datasource-max"));
//		incr = Integer.parseInt(prop.getProperty("datasource-min"));
		
		if(dbURL.indexOf("jdbc:odbc:")>-1){
			this.isJdbc = false;
		}else{
			this.isJdbc = true;
		}
	}	
	public void returnConnection(CscConnection cn) {		
		try{
		if(cn!=null && cn.isUses()&&cn.getProcessid().length()==0 && cn.getCscTransaction()==null &&!cn.isClosed()){
			this.removeConnetions(cn);
			cn.setUses(false);
			if(!this.connectionsFree.contains(cn)){
				this.connectionsFree.add(cn);
			}
		}else{
			try{
				if(cn.isClosed()&&!cn.validate()){//Դѭ connection close  зӡ remove ͡ҡ connectionpools
					this.removeConnetions(cn);
				} 
			}catch(Exception ex){
				MyLog.debug(this,"connection is null =>"+cn);
				}		
			}
		}catch(Exception ex){}
	}

	/**
	 * @return the connectionsused
	 */
	public Vector<CscConnection> getConnectionsused() {
		return connectionsUsed;
	}

	
	/**
	 * @param connectionsused the connectionsused to set
	 */
	public void setConnectionsused(Vector<CscConnection> connectionsused) {
		this.connectionsUsed = connectionsused;
	}

	/**
	 * @param connections the connections to set
	 */
	public void setConnections(Vector<CscConnection> connections) {
		this.connectionsFree = connections;
	}
	
	/**
	 * @return the connectionsused
	 */
	public Vector<CscConnection> getConnectionsnoused() {
		return connectionsFree;
	}
	
	public void removeConnetions(CscConnection cn){
		if(cn!=null&& this.connectionsFree.size()>0){
			this.connectionsFree.remove(cn);
		}
		if(cn!=null&& this.connectionsUsed.size()>0){
			this.connectionsUsed.remove(cn);
		}
	}

	public void removeConnetionsUsed(CscConnection cn){
		if(cn!=null&& this.connectionsUsed.size()>0){
				this.connectionsUsed.remove(cn);
		}
	}
	
	public void reConnection(CscConnection cn) {
		if(cn!=null){
			synchronized (connectionsFree) {
				cn.setUses(false);
				this.connectionsFree.add(cn);
		  }
		}
	}
	
	public static void writeLog(StackTraceElement[] stackem,CscConnection con,String action){
		try{
			if(ConnectionPools.traceOn){
				CscCalendar cs=new CscCalendar();
				String fileName="connection-"+cs.getYYYYMMDD()+"-00.log";
				if(cs.getHour()>12){
					fileName="connection-"+cs.getYYYYMMDD()+"-12.log";
				}
				FileWriter fstream = new FileWriter(System.getProperty("jboss.server.log.dir")+"\\"+fileName,true);
	 		    BufferedWriter writer = new BufferedWriter(fstream);
	            writer.write(action+"-------"+cs.getYYMMDDHHMMSS()+"-----------------");
	            writer.newLine();
	            writer.write(con.toString());
	            writer.newLine();
	            for(int i=0;i<stackem.length;i++){
	            	writer.write(stackem[i].toString());
	            	writer.newLine();
	            }
	        	writer.write("---getConnectionTrace---");
            	writer.write(con.getStackTrace());
            	writer.newLine();
	        	writer.write("------------------------------------");
	           	writer.newLine();
	            writer.close();
	            fstream.close();

	            FileWriter fstream2 = new FileWriter(System.getProperty("jboss.server.log.dir")+"\\access-connection-"+cs.getYYYYMMDD()+".log",true);
	 		    BufferedWriter writer2 = new BufferedWriter(fstream2);
	            writer2.write(con+"-------"+action+"-------"+cs.getYYMMDDHHMMSS()+"-----------------");
	           	writer2.newLine();
	            writer2.close();
	            fstream2.close();	            
			}
		}catch(Exception ex){
			System.out.println("Cann't create connection file..........");
		}
	}
	
	   public synchronized void reapConnections() {
			  clearConnectionUsed();
		   }
	   
	   public void removeConnectionProcess(String pid){
		   if(connectionProcess.containsKey(pid)){
			   CscConnection conn =(CscConnection)connectionProcess.get(pid);
			   conn.endProcess();
			   connectionProcess.remove(pid);
		   }
	   }
	   
	   private void addConnectionUsed(CscConnection con,int index){
			if(!connectionsUsed.contains(con)){
				connectionsUsed.addElement(con);
			}
			if(connectionsFree.size()>0&&index!=-1){
				connectionsFree.remove(index);
			}
	   }
}
