package com.csc.library.database;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.CallableStatement;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.Date;
import java.sql.NClob;
import java.sql.ParameterMetaData;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.RowId;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.SQLXML;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Map;

public class CscCallableStatement implements CallableStatement{
	private CallableStatement call;
	private CscConnection conn=null;
	private boolean close=false; 	
	private ArrayList<ResultSet> resultset=new ArrayList<ResultSet>();
	private long createTime=0;
	public CscCallableStatement(CallableStatement call,long createtime) {
		this.call=call;
		this.createTime=createtime;
//		this.close=false;
	}
	

	public Array getArray(int i) throws SQLException {
		return this.call.getArray(i);
	}

	public Array getArray(String parameterName) throws SQLException {
		return this.call.getArray(parameterName);
	}

	public BigDecimal getBigDecimal(int parameterIndex) throws SQLException {
		return this.call.getBigDecimal(parameterIndex);
	}

	public BigDecimal getBigDecimal(String parameterName) throws SQLException {
		return this.call.getBigDecimal(parameterName);
	}

	@Deprecated
	public BigDecimal getBigDecimal(int parameterIndex, int scale)
			throws SQLException {
		return this.call.getBigDecimal(parameterIndex, scale);
	}

	public Blob getBlob(int i) throws SQLException {
		return this.call.getBlob(i);
	}

	public Blob getBlob(String parameterName) throws SQLException {
		return this.call.getBlob(parameterName);
	}

	public boolean getBoolean(int parameterIndex) throws SQLException {
		return this.call.getBoolean(parameterIndex);
	}

	public boolean getBoolean(String parameterName) throws SQLException {
		return this.call.getBoolean(parameterName);
	}

	public byte getByte(int parameterIndex) throws SQLException {
		return this.call.getByte(parameterIndex);
	}

	public byte getByte(String parameterName) throws SQLException {
		return this.call.getByte(parameterName);
	}

	public byte[] getBytes(int parameterIndex) throws SQLException {
		return this.call.getBytes(parameterIndex);
	}

	public byte[] getBytes(String parameterName) throws SQLException {
		return this.call.getBytes(parameterName);
	}

	public Clob getClob(int i) throws SQLException {
		return this.call.getClob(i);
	}

	public Clob getClob(String parameterName) throws SQLException {
		return this.call.getClob(parameterName);
	}

	public Date getDate(int parameterIndex) throws SQLException {
		return this.call.getDate(parameterIndex);
	}

	public Date getDate(String parameterName) throws SQLException {
		return this.call.getDate(parameterName);
	}

	public Date getDate(int parameterIndex, Calendar cal) throws SQLException {
		return this.call.getDate(parameterIndex, cal);
	}

	public Date getDate(String parameterName, Calendar cal) throws SQLException {
		return this.call.getDate(parameterName, cal);
	}

	public double getDouble(int parameterIndex) throws SQLException {
		return this.call.getDouble(parameterIndex);
	}

	public double getDouble(String parameterName) throws SQLException {
		return this.call.getDouble(parameterName);
	}

	public float getFloat(int parameterIndex) throws SQLException {
		return this.call.getFloat(parameterIndex);
	}

	public float getFloat(String parameterName) throws SQLException {
		return this.call.getFloat(parameterName);
	}

	public int getInt(int parameterIndex) throws SQLException {
		return this.call.getInt(parameterIndex);
	}

	public int getInt(String parameterName) throws SQLException {
		return this.call.getInt(parameterName);
	}

	public long getLong(int parameterIndex) throws SQLException {
		return this.call.getLong(parameterIndex);
	}

	public long getLong(String parameterName) throws SQLException {
		return this.call.getLong(parameterName);
	}

	public Object getObject(int parameterIndex) throws SQLException {
		return this.call.getObject(parameterIndex);
	}

	public Object getObject(String parameterName) throws SQLException {
		return this.call.getObject(parameterName);
	}

	public Object getObject(int i, Map<String, Class<?>> map)
			throws SQLException {
		return this.call.getObject(i, map);
	}

	public Object getObject(String parameterName, Map<String, Class<?>> map)
			throws SQLException {
		return this.call.getObject(parameterName, map);
	}

	public Ref getRef(int i) throws SQLException {
		return this.call.getRef(i);
	}

	public Ref getRef(String parameterName) throws SQLException {
		return this.call.getRef(parameterName);
	}

	public short getShort(int parameterIndex) throws SQLException {
		return this.call.getShort(parameterIndex);
	}

	public short getShort(String parameterName) throws SQLException {
		return this.call.getShort(parameterName);
	}

	public String getString(int parameterIndex) throws SQLException {
		return this.call.getString(parameterIndex);
	}

	public String getString(String parameterName) throws SQLException {
		return this.call.getString(parameterName);
	}

	public Time getTime(int parameterIndex) throws SQLException {
		return this.call.getTime(parameterIndex);
	}

	public Time getTime(String parameterName) throws SQLException {
		return this.call.getTime(parameterName);
	}

	public Time getTime(int parameterIndex, Calendar cal) throws SQLException {
		return this.call.getTime(parameterIndex,cal);
	}

	public Time getTime(String parameterName, Calendar cal) throws SQLException {
		return this.call.getTime(parameterName, cal);
	}

	public Timestamp getTimestamp(int parameterIndex) throws SQLException {
		return this.call.getTimestamp(parameterIndex);
	}

	public Timestamp getTimestamp(String parameterName) throws SQLException {
		return this.call.getTimestamp(parameterName);
	}

	public Timestamp getTimestamp(int parameterIndex, Calendar cal)
			throws SQLException {
		return this.call.getTimestamp(parameterIndex, cal);
	}

	public Timestamp getTimestamp(String parameterName, Calendar cal)
			throws SQLException {
		return this.call.getTimestamp(parameterName, cal);
	}

	public URL getURL(int parameterIndex) throws SQLException {
		return this.call.getURL(parameterIndex);
	}

	public URL getURL(String parameterName) throws SQLException {
		return this.call.getURL(parameterName);
	}

	public void registerOutParameter(int parameterIndex, int sqlType)
			throws SQLException {
		this.call.registerOutParameter(parameterIndex, sqlType);
	}

	public void registerOutParameter(String parameterName, int sqlType)
			throws SQLException {
		this.call.registerOutParameter(parameterName, sqlType);
	}

	public void registerOutParameter(int parameterIndex, int sqlType, int scale)
			throws SQLException {
		this.call.registerOutParameter(parameterIndex, sqlType, scale);
	}

	public void registerOutParameter(int paramIndex, int sqlType,
			String typeName) throws SQLException {
		this.call.registerOutParameter(paramIndex, sqlType, typeName);
	}

	public void registerOutParameter(String parameterName, int sqlType,
			int scale) throws SQLException {
		this.call.registerOutParameter(parameterName, sqlType, scale);
	}

	public void registerOutParameter(String parameterName, int sqlType,
			String typeName) throws SQLException {
		this.call.registerOutParameter(parameterName, sqlType, typeName);
	}

	public void setAsciiStream(String parameterName, InputStream x, int length)
			throws SQLException {
		this.call.setAsciiStream(parameterName, x, length);
	}

	public void setBigDecimal(String parameterName, BigDecimal x)
			throws SQLException {
		this.call.setBigDecimal(parameterName, x);
	}

	public void setBinaryStream(String parameterName, InputStream x, int length)
			throws SQLException {
		this.call.setBinaryStream(parameterName, x, length);
		
	}

	public void setBoolean(String parameterName, boolean x) throws SQLException {
		this.call.setBoolean(parameterName, x);		
	}

	public void setByte(String parameterName, byte x) throws SQLException {
		this.call.setByte(parameterName, x);		
	}

	public void setBytes(String parameterName, byte[] x) throws SQLException {
		this.call.setBytes(parameterName, x);		
	}

	public void setCharacterStream(String parameterName, Reader reader,
			int length) throws SQLException {
		this.call.setCharacterStream(parameterName, reader, length);		
	}

	public void setDate(String parameterName, Date x) throws SQLException {
		this.call.setDate(parameterName, x);		
	}

	public void setDate(String parameterName, Date x, Calendar cal)
			throws SQLException {
		this.call.setDate(parameterName, x, cal);
	}

	public void setDouble(String parameterName, double x) throws SQLException {
		this.call.setDouble(parameterName, x);
	}

	public void setFloat(String parameterName, float x) throws SQLException {
		this.call.setFloat(parameterName, x);
	}

	public void setInt(String parameterName, int x) throws SQLException {
		this.call.setInt(parameterName, x);
	}

	public void setLong(String parameterName, long x) throws SQLException {
		this.call.setLong(parameterName, x);
	}

	public void setNull(String parameterName, int sqlType) throws SQLException {
		this.call.setNull(parameterName, sqlType);
	}

	public void setNull(String parameterName, int sqlType, String typeName)
			throws SQLException {
		this.call.setNull(parameterName, sqlType, typeName);
	}

	public void setObject(String parameterName, Object x) throws SQLException {
		this.call.setObject(parameterName,x);
	}

	public void setObject(String parameterName, Object x, int targetSqlType)
			throws SQLException {
		this.call.setObject(parameterName, x,targetSqlType);
	}

	public void setObject(String parameterName, Object x, int targetSqlType,
			int scale) throws SQLException {
		this.call.setObject(parameterName,x,targetSqlType);
	}

	public void setShort(String parameterName, short x) throws SQLException {
		this.call.setShort(parameterName, x);
	}

	public void setString(String parameterName, String x) throws SQLException {
		this.call.setString(parameterName, x);
	}

	public void setTime(String parameterName, Time x) throws SQLException {
		this.call.setTime(parameterName, x);
	}

	public void setTime(String parameterName, Time x, Calendar cal)
			throws SQLException {
		this.call.setTime(parameterName, x, cal);
	}

	public void setTimestamp(String parameterName, Timestamp x)
			throws SQLException {
		this.call.setTimestamp(parameterName, x);
	}

	public void setTimestamp(String parameterName, Timestamp x, Calendar cal)
			throws SQLException {
		this.call.setTimestamp(parameterName, x, cal);
	}

	public void setURL(String parameterName, URL val) throws SQLException {
		this.call.setURL(parameterName, val);
	}

	public boolean wasNull() throws SQLException {
		return this.call.wasNull();
	}

	public void addBatch() throws SQLException {
		this.call.addBatch();
	}

	public void clearParameters() throws SQLException {
		this.call.clearParameters();
	}

	public boolean execute() throws SQLException {
		return this.call.execute();
	}

	public ResultSet executeQuery() throws SQLException {
		ResultSet rs=this.call.executeQuery();
		this.resultset.add(rs);
		return rs;
	}

	public int executeUpdate() throws SQLException {
		return this.call.executeUpdate();
	}

	public ResultSetMetaData getMetaData() throws SQLException {
		return this.call.getMetaData();
	}

	public ParameterMetaData getParameterMetaData() throws SQLException {
		return this.call.getParameterMetaData();
	}

	public void setArray(int i, Array x) throws SQLException {
		this.call.setArray(i, x);
	}

	public void setAsciiStream(int parameterIndex, InputStream x, int length)
			throws SQLException {
		this.call.setAsciiStream(parameterIndex, x, length);
	}

	public void setBigDecimal(int parameterIndex, BigDecimal x)
			throws SQLException {
		this.call.setBigDecimal(parameterIndex, x);
	}

	public void setBinaryStream(int parameterIndex, InputStream x, int length)
			throws SQLException {
		this.call.setBinaryStream(parameterIndex, x, length);
	}

	public void setBlob(int i, Blob x) throws SQLException {
		this.call.setBlob(i, x);
	}

	public void setBoolean(int parameterIndex, boolean x) throws SQLException {
		this.call.setBoolean(parameterIndex, x);
	}

	public void setByte(int parameterIndex, byte x) throws SQLException {
		this.call.setByte(parameterIndex, x);
	}

	public void setBytes(int parameterIndex, byte[] x) throws SQLException {
		this.call.setBytes(parameterIndex, x);
	}

	public void setCharacterStream(int parameterIndex, Reader reader, int length)
			throws SQLException {
		this.call.setCharacterStream(parameterIndex, reader, length);
	}

	public void setClob(int i, Clob x) throws SQLException {
		this.call.setClob(i, x);		
	}

	public void setDate(int parameterIndex, Date x) throws SQLException {
		this.call.setDate(parameterIndex, x);
	}

	public void setDate(int parameterIndex, Date x, Calendar cal)
			throws SQLException {
		this.call.setDate(parameterIndex, x, cal);
	}

	public void setDouble(int parameterIndex, double x) throws SQLException {
		this.call.setDouble(parameterIndex, x);
	}

	public void setFloat(int parameterIndex, float x) throws SQLException {
		this.call.setFloat(parameterIndex, x);
	}

	public void setInt(int parameterIndex, int x) throws SQLException {
		this.call.setInt(parameterIndex, x);
	}

	public void setLong(int parameterIndex, long x) throws SQLException {
		this.call.setLong(parameterIndex, x);
	}

	public void setNull(int parameterIndex, int sqlType) throws SQLException {
		this.call.setNull(parameterIndex, sqlType);
	}

	public void setNull(int paramIndex, int sqlType, String typeName)
			throws SQLException {
		this.call.setNull(paramIndex, sqlType, typeName);		
	}

	public void setObject(int parameterIndex, Object x) throws SQLException {
		this.call.setObject(parameterIndex, x);
	}

	public void setObject(int parameterIndex, Object x, int targetSqlType)
			throws SQLException {
		this.call.setObject(parameterIndex, x, targetSqlType);
	}

	public void setObject(int parameterIndex, Object x, int targetSqlType,
			int scale) throws SQLException {
		this.call.setObject(parameterIndex, x, targetSqlType, scale);		
	}

	public void setRef(int i, Ref x) throws SQLException {
		this.call.setRef(i, x);		
	}

	public void setShort(int parameterIndex, short x) throws SQLException {
		this.call.setShort(parameterIndex, x);
	}

	public void setString(int parameterIndex, String x) throws SQLException {
		this.call.setString(parameterIndex, x);
	}

	public void setTime(int parameterIndex, Time x) throws SQLException {
		this.call.setTime(parameterIndex, x);		
	}

	public void setTime(int parameterIndex, Time x, Calendar cal)
			throws SQLException {
		this.call.setTime(parameterIndex, x, cal);
	}

	public void setTimestamp(int parameterIndex, Timestamp x)
			throws SQLException {
		this.call.setTimestamp(parameterIndex, x);		
	}

	public void setTimestamp(int parameterIndex, Timestamp x, Calendar cal)
			throws SQLException {
		this.call.setTimestamp(parameterIndex, x, cal);
	}

	public void setURL(int parameterIndex, URL x) throws SQLException {
		this.call.setURL(parameterIndex, x);
	}
	@Deprecated
	public void setUnicodeStream(int parameterIndex, InputStream x, int length)
			throws SQLException {
		this.call.setUnicodeStream(parameterIndex, x, length);
	}

	public void addBatch(String sql) throws SQLException {
		this.call.addBatch(sql);
	}

	public void cancel() throws SQLException {
		this.call.cancel();
	}

	public void clearBatch() throws SQLException {
		this.call.clearBatch();
	}

	public void clearWarnings() throws SQLException {
		this.call.clearWarnings();
	}

	public void close() throws SQLException {
		if(this.call!=null){
			this.setClose(true);
			this.closeResultSet();
			this.call.close();			
			this.call=null;
			if(conn!=null){
				this.conn.getCallstm().remove(this);
			}
		}
	}

	public boolean execute(String sql) throws SQLException {
		return this.call.execute(sql);
	}

	public boolean execute(String sql, int autoGeneratedKeys)
			throws SQLException {
		return this.call.execute(sql, autoGeneratedKeys);
	}

	public boolean execute(String sql, int[] columnIndexes) throws SQLException {
		return this.call.execute(sql, columnIndexes);
	}

	public boolean execute(String sql, String[] columnNames)
			throws SQLException {
		return this.call.execute(sql, columnNames);
	}

	public int[] executeBatch() throws SQLException {
		return this.call.executeBatch();
	}

	public ResultSet executeQuery(String sql) throws SQLException {
		ResultSet rs=this.call.executeQuery(sql);
		this.resultset.add(rs);
		return rs;
	}

	public int executeUpdate(String sql) throws SQLException {
		return this.call.executeUpdate(sql);
	}

	public int executeUpdate(String sql, int autoGeneratedKeys)
			throws SQLException {
		return this.call.executeUpdate(sql, autoGeneratedKeys);
	}

	public int executeUpdate(String sql, int[] columnIndexes)
			throws SQLException {
		return this.call.executeUpdate(sql, columnIndexes);
	}

	public int executeUpdate(String sql, String[] columnNames)
			throws SQLException {
		return this.call.executeUpdate(sql, columnNames);
	}

	public Connection getConnection() throws SQLException {
		return this.call.getConnection();
	}

	public int getFetchDirection() throws SQLException {
		return this.call.getFetchDirection();
	}

	public int getFetchSize() throws SQLException {
		return this.call.getFetchSize();
	}

	public ResultSet getGeneratedKeys() throws SQLException {
		ResultSet rs=this.call.getGeneratedKeys();
		this.resultset.add(rs);
		return rs; 
	}

	public int getMaxFieldSize() throws SQLException {
		return this.call.getMaxFieldSize();
	}

	public int getMaxRows() throws SQLException {
		return this.call.getMaxRows();
	}

	public boolean getMoreResults() throws SQLException {
		return this.call.getMoreResults();
	}

	public boolean getMoreResults(int current) throws SQLException {
		return this.call.getMoreResults(current);
	}

	public int getQueryTimeout() throws SQLException {
		return this.call.getQueryTimeout();
	}

	public ResultSet getResultSet() throws SQLException {
		ResultSet rs= this.call.getResultSet();
		this.resultset.add(rs);
		return rs;
	}

	public int getResultSetConcurrency() throws SQLException {
		return this.call.getResultSetConcurrency();
	}

	public int getResultSetHoldability() throws SQLException {
		return this.call.getResultSetHoldability();
	}

	public int getResultSetType() throws SQLException {
		return this.call.getResultSetType();
	}

	public int getUpdateCount() throws SQLException {
		return this.call.getUpdateCount();
	}

	public SQLWarning getWarnings() throws SQLException {
		return this.call.getWarnings();
	}

	public void setCursorName(String name) throws SQLException {
		this.call.setCursorName(name);
	}

	public void setEscapeProcessing(boolean enable) throws SQLException {
		this.call.setEscapeProcessing(enable);
	}

	public void setFetchDirection(int direction) throws SQLException {
		this.call.setFetchDirection(direction);
	}

	public void setFetchSize(int rows) throws SQLException {
		this.call.setFetchSize(rows);
	}

	public void setMaxFieldSize(int max) throws SQLException {
		this.call.setMaxFieldSize(max);
	}

	public void setMaxRows(int max) throws SQLException {
		this.call.setMaxRows(max);
	}

	public void setQueryTimeout(int seconds) throws SQLException {
		this.call.setQueryTimeout(seconds);
	}


	public boolean isClose() {
		return close;
	}


	public void setClose(boolean close) {
		this.close = close;
	}
	
	private void closeResultSet(){
		try{
		if(this.resultset.size()>0){
			for(int i=0;i<this.resultset.size();i++){
				ResultSet rs=(ResultSet) this.resultset.get(i);
				if(rs!=null){					
					rs.close();
					this.resultset.remove(rs);
				}
			}
		}
		}catch(Exception ex){}
	}

	@Override
	protected void finalize() throws Throwable {
		this.close();
	}

	public boolean isBefore(long starttime){
		if((starttime==0||this.createTime==starttime)&&this.conn.getStarttime()!=this.conn.getLasttime()){
		//if((starttime==0||this.createTime<starttime)&&this.conn.getStarttime()!=this.conn.getLasttime()){
			return true;
		}
		return false;
	}

	public CscConnection getCscConnection() {
		return conn;
	}

	public void setCscConnection(CscConnection conn) {
		this.conn = conn;
	}


	public void setRowId(int parameterIndex, RowId x) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNString(int parameterIndex, String value)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNCharacterStream(int parameterIndex, Reader value,
			long length) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNClob(int parameterIndex, NClob value) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setClob(int parameterIndex, Reader reader, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBlob(int parameterIndex, InputStream inputStream, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNClob(int parameterIndex, Reader reader, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setSQLXML(int parameterIndex, SQLXML xmlObject)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setAsciiStream(int parameterIndex, InputStream x, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBinaryStream(int parameterIndex, InputStream x, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setCharacterStream(int parameterIndex, Reader reader,
			long length) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setAsciiStream(int parameterIndex, InputStream x)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBinaryStream(int parameterIndex, InputStream x)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setCharacterStream(int parameterIndex, Reader reader)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNCharacterStream(int parameterIndex, Reader value)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setClob(int parameterIndex, Reader reader) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBlob(int parameterIndex, InputStream inputStream)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNClob(int parameterIndex, Reader reader) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public boolean isClosed() throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}


	public void setPoolable(boolean poolable) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public boolean isPoolable() throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}


	public <T> T unwrap(Class<T> iface) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public boolean isWrapperFor(Class<?> iface) throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}


	public RowId getRowId(int parameterIndex) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public RowId getRowId(String parameterName) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public void setRowId(String parameterName, RowId x) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNString(String parameterName, String value)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNCharacterStream(String parameterName, Reader value,
			long length) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNClob(String parameterName, NClob value) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setClob(String parameterName, Reader reader, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBlob(String parameterName, InputStream inputStream,
			long length) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNClob(String parameterName, Reader reader, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public NClob getNClob(int parameterIndex) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public NClob getNClob(String parameterName) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public void setSQLXML(String parameterName, SQLXML xmlObject)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public SQLXML getSQLXML(int parameterIndex) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public SQLXML getSQLXML(String parameterName) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public String getNString(int parameterIndex) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public String getNString(String parameterName) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public Reader getNCharacterStream(int parameterIndex) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public Reader getNCharacterStream(String parameterName) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public Reader getCharacterStream(int parameterIndex) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public Reader getCharacterStream(String parameterName) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}


	public void setBlob(String parameterName, Blob x) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setClob(String parameterName, Clob x) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setAsciiStream(String parameterName, InputStream x, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBinaryStream(String parameterName, InputStream x, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setCharacterStream(String parameterName, Reader reader,
			long length) throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setAsciiStream(String parameterName, InputStream x)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBinaryStream(String parameterName, InputStream x)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setCharacterStream(String parameterName, Reader reader)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNCharacterStream(String parameterName, Reader value)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setClob(String parameterName, Reader reader)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setBlob(String parameterName, InputStream inputStream)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}


	public void setNClob(String parameterName, Reader reader)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}
}
