package com.csc.library.database;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.Date;
import java.sql.NClob;
import java.sql.ParameterMetaData;
import java.sql.PreparedStatement;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.RowId;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.SQLXML;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Vector;

public class CscPreparedStatement implements PreparedStatement{
	private PreparedStatement prepare;
	private CscConnection conn=null;
	private boolean close=false;
	private ArrayList<ResultSet> resultset=new ArrayList<ResultSet>();
	private long createTime=0;
	 public CscPreparedStatement(PreparedStatement pre,long createtime) {
			 this.prepare=pre;
			 this.createTime=createtime;			 
//			 this.close=false;
	}

	public void addBatch() throws SQLException {
		this.prepare.addBatch();
		
	}

	public void clearParameters() throws SQLException {
		this.prepare.clearParameters();
		
	}

	public boolean execute() throws SQLException {
		return this.prepare.execute();
	}

	public ResultSet executeQuery() throws SQLException {
		ResultSet rs=this.prepare.executeQuery();
		this.resultset.add(rs);
		return rs;
	}

	public int executeUpdate() throws SQLException {
		return this.prepare.executeUpdate();
	}

	public ResultSetMetaData getMetaData() throws SQLException {
		return this.prepare.getMetaData();
	}

	public ParameterMetaData getParameterMetaData() throws SQLException {
		return this.prepare.getParameterMetaData();
	}

	public void setArray(int i, Array x) throws SQLException {
		this.prepare.setArray(i, x);
	}

	public void setAsciiStream(int parameterIndex, InputStream x, int length)
			throws SQLException {
		this.prepare.setAsciiStream(parameterIndex, x, length);
	}

	public void setBigDecimal(int parameterIndex, BigDecimal x)
			throws SQLException {
		this.prepare.setBigDecimal(parameterIndex, x);
	}

	public void setBinaryStream(int parameterIndex, InputStream x, int length)
			throws SQLException {
		this.prepare.setBinaryStream(parameterIndex, x, length);
	}

	public void setBlob(int i, Blob x) throws SQLException {
		this.prepare.setBlob(i, x);
	}

	public void setBoolean(int parameterIndex, boolean x) throws SQLException {
		this.prepare.setBoolean(parameterIndex, x);
	}

	public void setByte(int parameterIndex, byte x) throws SQLException {
		this.prepare.setByte(parameterIndex, x);
	}

	public void setBytes(int parameterIndex, byte[] x) throws SQLException {
		this.prepare.setBytes(parameterIndex, x);
	}

	public void setCharacterStream(int parameterIndex, Reader reader, int length)
			throws SQLException {
		this.prepare.setCharacterStream(parameterIndex, reader, length);
	}

	public void setClob(int i, Clob x) throws SQLException {
		this.prepare.setClob(i, x);
	}

	public void setDate(int parameterIndex, Date x) throws SQLException {
		this.prepare.setDate(parameterIndex, x);	
	}

	public void setDate(int parameterIndex, Date x, Calendar cal)
			throws SQLException {
		this.prepare.setDate(parameterIndex, x, cal);
	}

	public void setDouble(int parameterIndex, double x) throws SQLException {
		this.prepare.setDouble(parameterIndex, x);
	}

	public void setFloat(int parameterIndex, float x) throws SQLException {
		this.prepare.setFloat(parameterIndex, x);
	}

	public void setInt(int parameterIndex, int x) throws SQLException {
		this.prepare.setInt(parameterIndex, x);
	}

	public void setLong(int parameterIndex, long x) throws SQLException {
		this.prepare.setLong(parameterIndex, x);
	}

	public void setNull(int parameterIndex, int sqlType) throws SQLException {
		this.prepare.setNull(parameterIndex, sqlType);
	}

	public void setNull(int paramIndex, int sqlType, String typeName)
			throws SQLException {
		this.prepare.setNull(paramIndex, sqlType, typeName);
	}

	public void setObject(int parameterIndex, Object x) throws SQLException {
		this.prepare.setObject(parameterIndex, x);
	}

	public void setObject(int parameterIndex, Object x, int targetSqlType)
			throws SQLException {
		this.prepare.setObject(parameterIndex, x, targetSqlType);
	}

	public void setObject(int parameterIndex, Object x, int targetSqlType,
			int scale) throws SQLException {
		this.prepare.setObject(parameterIndex, x, targetSqlType, scale);
	}

	public void setRef(int i, Ref x) throws SQLException {
		this.prepare.setRef(i, x);		
	}

	public void setShort(int parameterIndex, short x) throws SQLException {
		this.prepare.setShort(parameterIndex, x);
	}

	public void setString(int parameterIndex, String x) throws SQLException {
		this.prepare.setString(parameterIndex, x);
	}

	public void setTime(int parameterIndex, Time x) throws SQLException {
		this.prepare.setTime(parameterIndex, x);
	}

	public void setTime(int parameterIndex, Time x, Calendar cal)
			throws SQLException {
		this.prepare.setTime(parameterIndex, x, cal);
	}

	public void setTimestamp(int parameterIndex, Timestamp x)
			throws SQLException {
		this.prepare.setTimestamp(parameterIndex, x);
	}

	public void setTimestamp(int parameterIndex, Timestamp x, Calendar cal)
			throws SQLException {
		this.prepare.setTimestamp(parameterIndex, x, cal);
	}

	public void setURL(int parameterIndex, URL x) throws SQLException {
		this.prepare.setURL(parameterIndex, x);
	}
	
	@Deprecated
	public void setUnicodeStream(int parameterIndex, InputStream x, int length)
			throws SQLException {
		this.prepare.setUnicodeStream(parameterIndex, x, length);
	}

	public void addBatch(String sql) throws SQLException {
		this.prepare.addBatch(sql);
	}

	public void cancel() throws SQLException {
		this.prepare.cancel();
	}

	public void clearBatch() throws SQLException {
		this.prepare.clearBatch();
	}

	public void clearWarnings() throws SQLException {
		this.prepare.clearWarnings();		
	}

	public void close() throws SQLException {
		if(this.prepare!=null){
			this.setClose(true);
			this.closeResultSet();
			this.prepare.close();
			this.prepare=null;
			if(conn!=null){
				this.conn.getPrepare().remove(this);
			}
		}
	}

	public boolean execute(String sql) throws SQLException {
		return this.prepare.execute(sql);
	}

	public boolean execute(String sql, int autoGeneratedKeys)
			throws SQLException {
		return this.prepare.execute(sql, autoGeneratedKeys);
	}

	public boolean execute(String sql, int[] columnIndexes) throws SQLException {
		return this.prepare.execute(sql, columnIndexes);
	}

	public boolean execute(String sql, String[] columnNames)
			throws SQLException {
		return this.prepare.execute(sql, columnNames);
	}

	public int[] executeBatch() throws SQLException {
		return this.prepare.executeBatch();
	}

	public ResultSet executeQuery(String sql) throws SQLException {
		ResultSet rs=this.prepare.executeQuery(sql);
		this.resultset.add(rs);
		return rs;
	}

	public int executeUpdate(String sql) throws SQLException {
		return this.prepare.executeUpdate(sql);
	}

	public int executeUpdate(String sql, int autoGeneratedKeys)
			throws SQLException {
		return this.prepare.executeUpdate(sql, autoGeneratedKeys);
	}

	public int executeUpdate(String sql, int[] columnIndexes)
			throws SQLException {
		return this.prepare.executeUpdate(sql, columnIndexes);
	}

	public int executeUpdate(String sql, String[] columnNames)
			throws SQLException {
		return this.prepare.executeUpdate(sql, columnNames);
	}

	public Connection getConnection() throws SQLException {
		return this.prepare.getConnection();
	}

	public int getFetchDirection() throws SQLException {
		return this.prepare.getFetchDirection();
	}

	public int getFetchSize() throws SQLException {
		return this.prepare.getFetchSize();
	}

	public ResultSet getGeneratedKeys() throws SQLException {
		ResultSet rs=this.prepare.getGeneratedKeys();
		this.resultset.add(rs);
		return rs;
	}

	public int getMaxFieldSize() throws SQLException {
		return this.prepare.getMaxFieldSize();
	}

	public int getMaxRows() throws SQLException {
		return this.prepare.getMaxRows();
	}

	public boolean getMoreResults() throws SQLException {
		return this.prepare.getMoreResults();
	}

	public boolean getMoreResults(int current) throws SQLException {
		return this.prepare.getMoreResults(current);
	}

	public int getQueryTimeout() throws SQLException {
		return this.prepare.getQueryTimeout();
	}

	public ResultSet getResultSet() throws SQLException {
		ResultSet rs=this.prepare.getResultSet();
		this.resultset.add(rs);
		return rs;
	}

	public int getResultSetConcurrency() throws SQLException {
		return this.prepare.getResultSetConcurrency();
	}

	public int getResultSetHoldability() throws SQLException {
		return this.prepare.getResultSetHoldability();
	}

	public int getResultSetType() throws SQLException {
		return this.prepare.getResultSetType();
	}

	public int getUpdateCount() throws SQLException {
		return this.prepare.getUpdateCount();
	}

	public SQLWarning getWarnings() throws SQLException {
		return this.prepare.getWarnings();
	}

	public void setCursorName(String name) throws SQLException {
		this.prepare.setCursorName(name);
	}

	public void setEscapeProcessing(boolean enable) throws SQLException {
		this.prepare.setEscapeProcessing(enable);
	}

	public void setFetchDirection(int direction) throws SQLException {
		this.prepare.setFetchDirection(direction);
	}

	public void setFetchSize(int rows) throws SQLException {
		this.prepare.setFetchSize(rows);
	}

	public void setMaxFieldSize(int max) throws SQLException {
		this.prepare.setMaxFieldSize(max);
	}

	public void setMaxRows(int max) throws SQLException {
		this.prepare.setMaxRows(max);
	}

	public void setQueryTimeout(int seconds) throws SQLException {
		this.prepare.setQueryTimeout(seconds);
	}

	public boolean isClose(){
		return close;
	}

	public void setClose(boolean close) {
		this.close = close;
	}

	private void closeResultSet(){
		try{
		if(this.resultset.size()>0){
			for(int i=0;i<this.resultset.size();i++){
				ResultSet rs=(ResultSet) this.resultset.get(i);
				if(rs!=null){
					rs.close();
					this.resultset.remove(rs);
				}
			}
		}
		}catch(Exception ex){}
	}
	
	@Override
	protected void finalize() throws Throwable {
		this.close();
	}

	public boolean isBefore(long starttime){
		//if((starttime==0||this.createTime==starttime)&&this.conn.getStarttime()!=this.conn.getLasttime()){
		if((starttime==0||this.createTime<starttime)&&this.conn.getStarttime()!=this.conn.getLasttime()){
			return true;
		}
		return false;
	}

	public CscConnection getCscConnection() {
		return conn;
	}

	public void setCscConnection(CscConnection conn) {
		this.conn = conn;
	}

	public boolean isClosed() throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}

	public void setPoolable(boolean poolable) throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public boolean isPoolable() throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}

	public <T> T unwrap(Class<T> iface) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isWrapperFor(Class<?> iface) throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}

	public void setRowId(int parameterIndex, RowId x) throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setNString(int parameterIndex, String value)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setNCharacterStream(int parameterIndex, Reader value,
			long length) throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setNClob(int parameterIndex, NClob value) throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setClob(int parameterIndex, Reader reader, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setBlob(int parameterIndex, InputStream inputStream, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setNClob(int parameterIndex, Reader reader, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setSQLXML(int parameterIndex, SQLXML xmlObject)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setAsciiStream(int parameterIndex, InputStream x, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setBinaryStream(int parameterIndex, InputStream x, long length)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setCharacterStream(int parameterIndex, Reader reader,
			long length) throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setAsciiStream(int parameterIndex, InputStream x)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setBinaryStream(int parameterIndex, InputStream x)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setCharacterStream(int parameterIndex, Reader reader)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setNCharacterStream(int parameterIndex, Reader value)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setClob(int parameterIndex, Reader reader) throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setBlob(int parameterIndex, InputStream inputStream)
			throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public void setNClob(int parameterIndex, Reader reader) throws SQLException {
		// TODO Auto-generated method stub
		
	}
	
	
}
