package com.csc.library.database;
import java.io.Serializable;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Vector;

import com.csc.entity.SQLExceptionManager;
import com.csc.library.factor.Factorable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class DataSet implements Serializable {
    private transient CscConnection con;
    private transient Statement stm;
    private transient ResultSet rs;
    private transient ResultSetMetaData rm;
    private HashMap record = null;
    private HashMap tmp1   = null;
    private HashMap tmp2   = null;
    private String sql, dbName,dbType;
    private boolean end = false;
    private boolean isFetch = false;
    private Vector data = new Vector();
    private int reCount = 0;
    private boolean requireTransaction = false;
    private Vector groupByVector = new Vector();
    private String tableName = null;
    private boolean isError=false;
    private String msgError="";
    private Vector vfield=new Vector();
    private Vector vvalue=new Vector();
    private Vector tmpvalue1=new Vector();
    private Vector tmpvalue2=new Vector();
    private String class_name="";
    private transient HashMap mField=new LinkedHashMap();
    private UProfile up =null;    
    
    private transient SQLExceptionManager oSQLExceptionManager = new SQLExceptionManager();

    private HashMap fetch()throws Exception {
            HashMap hdata = this.getHashData();
            return hdata;
    }
    
    public DataSet() {
    }
    
    public DataSet(String sql, String dbName, String tableName ) {
        this.sql = sql;
        this.dbName = dbName;
        this.tableName=tableName;
        this.dbType=new InitialEnvironment(this.dbName).getValue("datasource-dbtype");
    }
    
    public String getClassName() {
		return class_name;
	}

	public void setClassName(String className) {
		class_name = className;
	}

	public void setInfo(String sql, String dbName, String tableName) {
        this.sql = sql;
        this.dbName = dbName;
        this.tableName = tableName;
        this.dbType=new InitialEnvironment(this.dbName).getValue("datasource-dbtype");
    }
    
   
    public void finalize() {
//    	System.out.println("== CONNECTION CLOSE BY DATASET.finalize() ="+this.con);
//    	if(this.getUPofile()!=null && this.getUPofile().getProcessid().length()==0){
//    		this.closeConnection();
//    	}
    }
    
    public void initField() throws Exception {
        record.putAll(this.getHashData());
    }  
    
   
    public void initConnection(UProfile	upf) throws SQLException, RemoteException {
    	boolean ok = true;
    	this.end = false;
    	this.isError=false;
    	msgError="";
    	this.closeConnection();
//		closeResultSet(); //close resultSet ͹ҹ
//		closeStatement(); //close closeStatement ͹ҹ
    	tmp1=null;
    	tmp2=null;
    	record=null;
    	vvalue.clear();
    	tmpvalue1.clear();
    	tmpvalue2.clear();
        int error=0;
        this.up=upf;
        for(;ok;) {
                try {
               		con = (CscConnection) StaticProperties.myConnection.getConnection(this.dbName,upf);
                    con.setClassName(this.getClassName()+">DataSet.initConnection");
                    con.setTransactionIsolation(con.TRANSACTION_READ_UNCOMMITTED);
                    this.dbType=new InitialEnvironment(this.dbName).getValue("datasource-dbtype");
                    stm = con.createStatement(java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_READ_ONLY);
                    MyLog.debug(this, upf, "REFRESH  " + sql);
                    rs = stm.executeQuery(this.sql);
                    con.setLasttime(System.currentTimeMillis());
                    this.splitField();
                    if (!this.isFetch) {
                        this.fetchForClose();
                    } else {
                        this.fetchAll();
                        this.closeConnection();
                    }                    
                    ok = false;
                } catch (SQLException e) { 
                	error++;
                	this.isError=true;
                	this.msgError=e.getMessage();                
                	if(!e.getSQLState().equals("HY010")&&!e.getSQLState().equals("99999")){
                			this.oSQLExceptionManager.checkProplem(upf, con,this.tableName, e, this.sql);
                		}else{
                			MyLog.error(this, " Reconnection because=>"+msgError);
                	}                	
                	this.closeConnection();//close ͧҡ cursor ҧк
                	if(error<5){
                		continue;
                	}else{
                		MyLog.error(this, " SQLState="+e.getSQLState()+" errorCode="+e.getErrorCode()+" message="+msgError);
                		this.closeConnection();
                		break;                		
                	}
                }catch(Exception ex){
                	error++;
                	this.isError=true;
                	msgError=ex.getMessage(); 
                	 /** nuball edit  10-10-49 **/
                	 MyLog.info(this, upf,ex);
                	/********************/
                	 this.closeConnection();//close ͧҡ cursor ҧк
                	if(error<5)
                		continue;
                	else{
                		this.closeConnection();
                		break;
                	}
                 }
        }
    }
    
    private void fetchAll() throws Exception{
//        try {
            while (this.rs!=null && this.rs.next()) {
                this.data.addElement(this.getHashData());
            }
//        } catch (Exception e) {
//        	 MyLog.error(this, e);
//        	 e.printStackTrace();
//        }finally{
//        	 this.closeConnection();
//        }
    }
    private void fetchForClose()throws Exception {
        if (this.nexts()) {
            this.tmp1 = this.fetch();
            this.tmpvalue1=(Vector)tmpvalue2.clone();
            if (this.nexts()) {
                this.tmp2 = this.fetch();
            }else
                this.closeConnection();
        } else
            this.closeConnection();
    }
    public void initConnection(String rsName, String filter, String order) {
    	this.isError=false;
    	msgError="";
    	this.closeConnection();
    	this.end = false;
    	tmp1=null;
    	tmp2=null;
    	record=null;
        try {
            Factorable factor = (Factorable) Class.forName("com.csc.library.factor." + this.conversField(rsName)).newInstance();
            if (filter != null && !filter.equals(""))
                factor.setFilter(filter);
            if (order != null && !order.equals(""))
                factor.setOrder(order);
            factor.Refresh();
            con = (CscConnection)factor.getConnection();
            stm = factor.getStatement();
            rs = factor.getResultSet();
            if (!this.isFetch) {
                this.fetchForClose();
            } else {
                this.fetchAll();
            }            
        } catch (Exception ex) {
        	this.isError=true;
        	msgError=ex.getMessage();
        	MyLog.error(this, ex);
        }
    }
    private String conversField(String field) {
        field = field.substring(0, 1).toUpperCase() + field.substring(1, field.length()).toLowerCase();
        return field;
    }
    private boolean nextRecord() throws Exception {
        this.record = this.tmp1;
        this.vvalue=this.tmpvalue1; 
        this.tmpvalue1=(Vector)this.tmpvalue2.clone();
        this.tmp1 = tmp2;
        if (this.nexts()) {
            this.tmp2 = this.fetch();
        } else{
            this.tmp2 = null;
            this.closeConnection();
        }    
        if (this.record == null) {
            this.end = true;
            return false;
        } else
            return true;
    }
    private boolean nextAll() {
        if (this.reCount < this.data.size()) {
            this.record = (HashMap) this.data.elementAt(this.reCount++);
            if (this.reCount < this.data.size()) {
            	this.tmp1 = (HashMap) this.data.elementAt(this.reCount);
            } else {
            	this.tmp1 = null;
            }
            return true;
        } else {
            this.end = true;
            return false;
        }
    }
    public boolean next() {
     try{
    	if(con!=null)
    		con.setLasttime(System.currentTimeMillis()); // 
        if (!this.isFetch) {
            return this.nextRecord();
        } else {
            return this.nextAll();
        }
     }catch(Exception ex){
    	 closeConnection();
    	 return false;
     }
    }
    private boolean nexts() {
        try {
            if (rs != null && rs.next()) {
                return true;
            } else {
//                this.closeConnection();
                return false;
            }
        } catch (SQLException e) {
//        	this.closeConnection();
            return false;
        }
    }
   
  
    
    public String getString(String field) {
    	String data="";
    	if(this.record.containsKey(field)){
    		data = (String) this.record.get(field);
    	}
        return data;
    }
    
    public String getString(int index) {
    	String data="";
    	if(this.vvalue!=null &&index<this.vvalue.size()){
    		data=(String)this.vvalue.get(index);
    	}
        return data;
    }
    
    public void closeConnection() {
    	// ź͡ա Close ӫ͹кҨ Close Դ Exception      	    	
        try {
        	if(rs!=null){
        		rs.close();
        		rs=null;
        	}
        } catch (Exception e) {
//       	 	MyLog.error(this, e);
       	 }
        try {
        	if(stm!=null){
        		stm.close();
        		stm=null;
        	}
        } catch (Exception e) {
//       	 	MyLog.error(this, e);
        }
        try {
        	if(con!=null){
        		con.close();
        		con=null;
        	}
        } catch (Exception e) {
//       	 	MyLog.error(this, e);
        }
    }
    
    private void closeResultSet() {
        try {
        	if(rs!=null){
        		rs.close();
        		rs=null;
        	}
        } catch (Exception e) {
       	 }
    }
    
    private void closeStatement() {
        try {
        	if(stm!=null){
        		stm.close();
        		stm=null;
        	}
        } catch (Exception e) {
        }
    }

    public boolean isEmpty() {
        //return this.record.isEmpty();
        return this.end;
    }
    public void setFetchAll(boolean fetchAll) {
        this.isFetch = fetchAll;
    }
    public void setConnection(Connection connection) {
    	this.con = (CscConnection)connection;
    }
    public void setRequireTransaction(boolean requireTransaction) {
    	this.requireTransaction = requireTransaction;
    }
    public int getGroupChange() {
    	int change = -1;
		Object key;
		if (this.groupByVector.size() == 0)
			return change;
		if (tmp1 == null)
			return 0;
		for (int i = 0; i < this.groupByVector.size() && change == -1; i++) {
			key = this.groupByVector.elementAt(i);
			if (!this.record.get(key).equals(this.tmp1.get(key))) {
				change = i;
			}
		}
		return change;
    }    
    
    public void setGroupBy(Vector vf) {
        this.groupByVector = vf;
    }
    
    public void go(int recno) {
    	
    	if (this.data.size()+1 >= recno && this.isFetch) {
	    	this.reCount = recno-1;
	        this.end = false;
    	}
    }
    public boolean hasEror(){
    	return isError;
    }
    
    public String msgError(){
    	return this.msgError;
    }

	/**
	 * @return the sql
	 */
	public String getSql() {
		return sql;
	}

	/**
	 * @param sql the sql to set
	 */
	public void setSql(String sql) {
		this.sql = sql;
	}

	/**
	 * @return the dbName
	 */
	public String getDbName() {
		return dbName;
	}

	/**
	 * @param dbName the dbName to set
	 */
	public void setDbName(String dbName) {
		this.dbName = dbName;
	}

	/**
	 * @return the dbType
	 */
	public String getDbType() {
		return dbType;
	}

	/**
	 * @param dbType the dbType to set
	 */
	public void setDbType(String dbType) {
		this.dbType = dbType;
	}

	/**
	 * @return the tableName
	 */
	public String getTableName() {
		return tableName;
	}

	/**
	 * @param tableName the tableName to set
	 */
	public void setTableName(String tableName) {
		this.tableName = tableName;
	}
    
	private void splitField()throws Exception{
	        	if(rs!=null){
		        	mField =new LinkedHashMap();
	        		rm = rs.getMetaData();
		            int i = rm.getColumnCount();
		            vfield=new Vector();
		            String field = "";
		            for (int j = 1; j < i + 1; j++) {
		                field = rm.getColumnName(j).toLowerCase();  
		                if(dbType.equalsIgnoreCase("ORACLE")&&tableName!=null&&StaticProperties.blobField.contains(this.tableName.toLowerCase()+"."+field.toLowerCase())){
		                	mField.put(field,"B");
		                }else{
		                	mField.put(field,"V");
		                }
		                vfield.add(field);
		            }
	        	}
	}

	public void first() throws Exception{
		try {
	    	tmp1=null;
	    	tmp2=null;
	    	record=null;	    	
			rs.beforeFirst();
			if (!this.isFetch) {
	            this.fetchForClose();
	        } else {
	            this.fetchAll();
	        }
		} catch (SQLException e) {
			MyLog.error(this, e);
		}
	}
	
	private HashMap getHashData()throws Exception{
		HashMap hdata=new HashMap();
		String field="";
		String value="";
		byte[] data=null;
		tmpvalue2.clear();
		int j =0;
        for (;j < vfield.size(); j++) {
        	field =(String)vfield.get(j);
        	if(((String)mField.get(field)).equals("B")){
        		data=rs.getBytes(j+1);
        		if(data!=null)
            		value=new String(data);
            	hdata.put(field, value);
            	tmpvalue2.add(value);
            	this.con.addOpenblob();
        	}else{
        		value=rs.getString(j+1);
        		hdata.put(field, value);
        		tmpvalue2.add(value);
        	}
        }    	
		return hdata;
		
	}


	public Vector getFieldList() {
		return vfield;
	}

	
	
	public UProfile getUPofile() {
		return up;
	}

	public void setUPofile(UProfile up) {
		this.up = up;
	}

	public String getObjectTrace() {
		StringBuilder build=new StringBuilder();
		/**
		 * 
		 * comment by pas  
		 * comment ͷͺ memory
		 * 
		 * 		
		build.append("====DataSet.toString()=").append(getClass().getName() + "@" + Integer.toHexString(hashCode()));
		build.append("record(current record)=").append(record).append("\n");
		build.append("tmp1 =").append(tmp1).append("\n");
		build.append("tmp2 =").append(tmp2).append("\n");
		build.append("sql =").append(sql).append("\n");
		build.append("dbName =").append(dbName).append("\n");
		build.append("dbType =").append(dbType).append("\n");
		build.append("isFetch =").append(isFetch).append("\n");
		build.append("data =").append(data).append("\n");
		build.append("recCount =").append(reCount).append("\n");
		build.append("groupByVector =").append(groupByVector).append("\n");
		build.append("tableName =").append(tableName).append("\n");
	    build.append("isError =").append(isError).append("\n");
	    build.append("msgError =").append(msgError).append("\n");
	    build.append("vfield =").append(vfield).append("\n");
	    build.append("vvalue =").append(vvalue).append("\n");
	    build.append("tmpvalue1 =").append(tmpvalue1).append("\n");
	    build.append("tmpvalue2 =").append(tmpvalue2).append("\n");
	    build.append("class_name =").append(class_name).append("\n");
	    build.append("mField =").append(mField).append("\n");
	    build.append("=====================");
	    **/
		return build.toString();	
	}
	
	public boolean excuteUpdate(UProfile upf) {
		CscConnection connection = null;
		Statement statement = null;
		boolean create=true;
		try {
			if(this.sql.trim().toLowerCase().startsWith("delete ")){
				if(this.sql.toLowerCase().indexOf(" where ")==-1){
					MyLog.error(this, upf, this.tableName +" if used delete command ,please set where condition");
					return false;
				}
			}
				connection = (CscConnection) StaticProperties.myConnection.getConnection(this.dbName,upf); 
				connection.setClassName(">DataSet.excuteUpdate");
				statement = connection.createStatement(java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);			
				statement.executeUpdate(this.sql);
		} catch (Exception e) {
			create=false;
			MyLog.error(this, upf, this.tableName + e.toString());
		} finally {
			this.closeConnection(connection, statement);
		}
		return create;
	}	
	
	public boolean excuteUpdate(UProfile upf,String[] arrString){
		CscConnection connection = null;
		PreparedStatement statement = null;
		boolean create=true;
		if(arrString==null ||(arrString!=null &&arrString.length==0)){
			MyLog.error(this, upf, this.tableName + "arrString is null or not value");
		}
		if(this.sql.trim().toLowerCase().startsWith("delete ")){
			if(this.sql.toLowerCase().indexOf(" where ")==-1){
				MyLog.error(this, upf, this.tableName +" if used delete command ,please set where condition");
				return false;
			}
		}
		try {
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.dbName,upf); 
			connection.setClassName(">DataSet.excuteUpdate-prepared");
			statement = connection.prepareStatement(sql, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
			for(int i=0;i<arrString.length;i++){
				statement.setString(i+1,arrString[i+1]);
			}
			statement.executeUpdate();
		} catch (Exception e) {
			create=false;
			MyLog.error(this, upf, this.tableName + e.toString());
		} finally {
			this.closeConnection(connection, statement);
		}
		return create;
	}		
	
	private void closeConnection(CscConnection connection, Statement statement) {
		try {
			if(statement!=null)
				statement.close();
			if(connection!=null)
				connection.close();
		} catch (SQLException e) {
			MyLog.error(this, e);
		}
	}	
}
