package com.csc.library.database;

import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Time;
import java.sql.Timestamp;

import com.csc.library.components.ComponentManager;
import com.csc.library.session.DbRecord;
import com.csc.library.summary.Calculation;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.UProfile;

public interface FieldManager extends ComponentManager, Serializable, Cloneable{
	public void setDefault(String defaultValue);
	public void setNone(boolean none);
	public void setModified(boolean mod);
	public void setCaption(String caption);
	public void setDescription(String description);
	public void setKey(char key);
	public void setWorking(boolean working);
	public void setRelation(String parentTable);
	public String getRelation();
	public String getDescription();
	public boolean checkCondition();
	public boolean checkAll();
	public boolean checkValid();
	public String get();
	public String getValue();
	public boolean getBoolean();
	public byte getByte();
	public String getString();
	public char[] getChars();
	public char getChar();
	public short getShort();
	public int getInt();
	public long getLong();
	public float getFloat();
	public double getDouble();
	public Timestamp getTimestamp();
	public java.sql.Date getDate();
	public Time getTime();
	public BigDecimal getBigDecimal();
	public CscCalendar getcscCalendar();
	public String getRefValue();
	public boolean set(boolean x);
	public boolean set(byte x);
	public boolean set(String x);
	public boolean set(char[] x);
	public boolean set(char x);
	public boolean set(short x);
	public boolean set(int x);
	public boolean set(long x);
	public boolean set(float x);
	public boolean set(double x);
	public boolean set(Timestamp x);
	public boolean set(java.sql.Date x);
	public boolean set(BigDecimal x);
	public boolean set(Time x);
	public boolean set(CscCalendar d);
	public void restoreValue();
	public void setOriginal(String x);
	public void setDefault();
	public void setName(String name);
	public String getBufferValue();
	public String getDefault();
	public int undo();
	public int getWidth();
	public String getName();
	public int getDecimal();
	public String getType();
	public char getUsedFor();
	public void setUsedFor(char usedFor);
	public boolean isModified();
	public boolean isWorking();
	public char isKey();
	public String getCompareString();
	public String getValueString();
	public void setRecord(Object x);
	public void putEffectField(FieldManager ofield);
	public void removeEffectField(String fieldName);
	public void refresh();
	public void refreshEffectField();
	public void setCalMethod(Calculation cal);
	public Calculation getCalMethod();
	public String getStringWidth();
	public String getStringDecimal();
	public String getProperty(String code);
	public void setProperty(PropertyField property);
	public void setProperty(String code, String data);
	public String getValidCode();
	public void setValidCode(String code);
	public String getFieldCreate();
	public void setSecurity(boolean set);
	public void setSecurity(FSecurityManager sf);
	public void setCondition(FConditionManager cf);
	public boolean getSecurity();
	public void setUProfile(UProfile uPro);
	public UProfile getUProfile();
	public void setErrmess(String mess);
	public void rollback();
	public String encryption();
	//public String decryption();
	public void setEncrypt(boolean status);
	public PropertyField getProperty();
	public String getOldValue();
	public boolean isEncrypt();
	public String encryption(String data);
	public boolean isLog();
	public DbRecord getParent();
	public String getDefaultCode();
	public void loadSecurity();
	public String getSaveString();
	public String insAutoNumber();
	public void formatOn(); 
	public void formatOff();
	public boolean getFormatFlag();
	public String decryption(String encryption);
	
	public void setLog(boolean log );
	public void setVerify(boolean verify);
	public void setLang(char lang);
	public void setWidth(int  width);
	public void setDescriptionThai(String desc);
	public void setDescriptionEng(String desc);
	public void  setAlt(String alt);
	public void setAltEng(String desc);
	public void setAltThai(String desc);
	public void setComType(String comtype);
	public void setHelp(String help);
	public void setHELP_RETURN_FIELD(boolean check);
	public void setDecimal(int decimal);
	public void setType(String type);
	public boolean isVerify();
	public void setOldValue(String oldvalue);

	
	public void setProperty(Object cfield);
	public void setProperty(String code,Object cfield);
	
	public void setFormat(String format);
	public String getFormat();
	public boolean isEdit();
	public boolean isRead();
	public Object clone(UProfile upf);
	public Object clone();
	public void initField(UProfile upf);
	
	public String get_DEFAULT_ALT_ENG();
	public void set_DEFAULT_ALT_ENG(String _default_alt_eng) ;
	public String get_DEFAULT_ALT_THAI();
	public void set_DEFAULT_ALT_THAI(String _default_alt_thai) ;
	public String get_DEFAULT_COMTYPE() ;
	public void set_DEFAULT_COMTYPE(String _default_comtype) ;
	public String get_DEFAULT_DEFAULTVALUE() ;
	public void set_DEFAULT_DEFAULTVALUE(String _default_defaultvalue) ;
	public String get_DEFAULT_DESC_ENG() ;
	public void set_DEFAULT_DESC_ENG(String _default_desc_eng) ;
	public String get_DEFAULT_DESC_THAI() ;
	public void set_DEFAULT_DESC_THAI(String _default_desc_thai) ;
	public String getOriginalData();
	public void setEdit(boolean isedit);
	public void setRead(boolean isread);
	public boolean get_DEFAULT_HELP_RETURN_FIELD();
	public void set_DEFAULT_HELP_RETURN_FIELD(boolean _default_help_return_field) ;
	public void setOriginalData(String x);
}