package com.csc.library.database;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;
import org.jdom.Attribute;
import org.jdom.Element;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class LoadProTable {
	private HashMap				fieldPro	= new HashMap();
	private HashMap				relation	= new HashMap();
	private HashMap				fieldGroup	= new HashMap();
	private String				descEng, descThai, editcheck = "false";
	private String				fileName;
	private String				verify, verifyGroup;
	//private String mainHelp,referHelp,mainKey,securityClass;
	private String				mainHelp, referHelp, mainKey;
	boolean						loadCompo	= false;
	private String				wfactive	= "false";
	private String				wfkey		= "";
	private String				documentno 	= "";
	private String				security;
	private String				systemField	= "";
	// depend on all table
	private String 				tdbintegrity = "false";
	public String getSecurity() {
		return this.security;
	}
	public HashMap getProperties() {
		return fieldPro;
	}
	public void setTableName(String table) {
		this.fileName = table;
	}
	private String getPath() {
		String path = "";
		try {
			path = new InitialEnvironment("GLOBAL").getValue("xmlpath-protable");
			//path="X:/PRPEAP/XML/PROTABLEXML/";
		} catch (Exception ex) {
        	MyLog.error(this, "Can not get path to load config server file.");
		}
		return path;
	}
	public void process() {
		try {
			ReadXml read = new ReadXml();
			read.setDataManager(this.getPath() + this.fileName);
			Element root = read.getRootElement();
			this.security = root.getAttributeValue("security");
			descThai = root.getAttributeValue("desc_thai").trim();
			descEng = root.getAttributeValue("desc_eng").trim();
			this.mainHelp = root.getAttributeValue("mainhelp");
			String wfactive = root.getAttributeValue("wfactive");
			if (wfactive != null && wfactive.equals("true")) {
				this.wfactive = "true";
			} else
				this.wfactive = "false";
			this.wfkey = root.getAttributeValue("wfkey");
			if (this.wfkey == null)
				this.wfkey = "";
			this.documentno = root.getAttributeValue("documentno");
			if (this.documentno == null) 
				this.documentno = "";
			// load systemfield
			this.systemField = root.getAttributeValue("fieldsystem");
			if (this.systemField == null)
				this.systemField = "*";
			// set table depend 
			if (root.getAttributeValue("dependlevel") != null)
				this.tdbintegrity = root.getAttributeValue("dependlevel");
			this.referHelp = root.getAttributeValue("referhelp");
			this.mainKey = root.getAttributeValue("mainkey");
			this.editcheck = root.getAttributeValue("editcheck").trim();
			if (root.getAttributeValue("verify_type") != null) {
				this.verifyGroup = root.getAttributeValue("verify_type").trim();
			} else
				this.verifyGroup = "0";
			verify = root.getAttributeValue("verify").trim();
			List list = root.getChild("FIELD").getChildren();
			this.setRelation(root.getChild("RELATION"));
			Iterator it = list.iterator();
			String fieldName = "";
			while (it.hasNext()) {
				Element obj = (Element) it.next();
				if (obj != null) {
					fieldName = obj.getName();
					if ((fieldName != null) && (!fieldName.equals(""))) {
						fieldName = fieldName.toLowerCase();
					}
					if (!fieldName.equalsIgnoreCase("edit_date") && 
							!fieldName.equalsIgnoreCase("edit_time") && 
							!fieldName.equalsIgnoreCase("edit_by") && 
							!fieldName.equalsIgnoreCase("create_date") && 
							!fieldName.equalsIgnoreCase("create_time") &&
							!fieldName.equalsIgnoreCase("create_by") && 
							!fieldName.equalsIgnoreCase("runno") && 
							!fieldName.equalsIgnoreCase("wf_status") &&
							!fieldName.equalsIgnoreCase("approve") && 
							!fieldName.equalsIgnoreCase("verified") &&
							!fieldName.equalsIgnoreCase("actorid"))
					this.fieldPro.put(fieldName, this.getProField(obj));
					fieldName = "";
				}
			}
		} catch (Exception e) {
        	MyLog.error(this, e);
		}
	}
	private void setRelation(Element objRela) {
		List list = objRela.getChildren();
		Iterator it = list.iterator();
		Element rela, subRela;
		Iterator itChild;
		List listChild;
		Vector child, parent;
		HashMap hRela;
		String re = "", ch = "", pa = "";
		while (it.hasNext()) {
			rela = (Element) it.next();
			listChild = rela.getChildren();
			itChild = listChild.iterator();
			parent = new Vector();
			child = new Vector();
			hRela = new HashMap();
			while (itChild.hasNext()) {
				subRela = (Element) itChild.next();
				if (subRela.getName().equalsIgnoreCase("PARENT")) {
					pa = subRela.getText();
					pa = pa.trim().toLowerCase();
					parent.add(pa);
				} else {
					if (subRela.getName().equalsIgnoreCase("CHILD")) {
						ch = subRela.getText();
						ch = ch.trim().toLowerCase();
						child.add(ch);
					}
				}
			}
			hRela.put("PARENT", parent);
			hRela.put("CHILD", child);
			String iLevel = StaticProperties.defaultInsertRelatoinLevel;
			String dLevel = StaticProperties.defaultDeleteRelatoinLevel;
			if (rela.getAttributeValue("insertlevel") != null)
				iLevel = rela.getAttributeValue("insertlevel");
			if (rela.getAttributeValue("deletelevel") != null)
				dLevel = rela.getAttributeValue("deletelevel");
			// get depend from relation to set in relation property
			// -----------------------------
			String delevel = rela.getAttributeValue("dependlevel");
			if (delevel != null && delevel.equals("true"))
				hRela.put("DEPENDLEVEL",delevel);
			else 
				hRela.put("DEPENDLEVEL",this.tdbintegrity);
			String relaTablename = rela.getAttributeValue("rtablename");
			if (relaTablename != null) 
				hRela.put("RTABLENAME",relaTablename);
			else 
				hRela.put("RTABLENAME",rela.getName());
			// ------------------------------
			hRela.put("INSERTLEVEL", iLevel);
			hRela.put("DELETELEVEL", dLevel);
			String moduledelete = "";
			if (rela.getAttributeValue("moduledelete") != null)
				moduledelete = rela.getAttributeValue("moduledelete");
			hRela.put("MODULEDELETE",moduledelete);
			re = rela.getName();
			re = re.trim().toLowerCase();
			this.relation.put(re, hRela);
		}
	}
	// ball edit 09-09-03
	private HashMap getProField(Element objField) {
		HashMap hashField = new HashMap();
		String fieldName = "";
		fieldName = objField.getName();
		if ((fieldName != null) && (!fieldName.equals(""))) {
			fieldName = fieldName.trim().toLowerCase();
		}
		hashField.put("NAME", fieldName);
		Iterator it = objField.getAttributes().iterator();
		Attribute att;
		while (it.hasNext()) {
			att = (Attribute) it.next();
			//		this.logger.debug("att name -->"+att.getName()+"<-- value-->"+att.getValue()+"<----");
			hashField.put(att.getName().toUpperCase(), att.getValue());
		}
		List list = objField.getChildren();
		it = list.iterator();
		Element subE = null;
		while (it.hasNext()) {
			subE = (Element) it.next();
			hashField.put(subE.getName(), subE.getText());
		}
//		if (this.loadCompo) {
		if (this.loadCompo) {
			Element com = objField.getChild("COMPONENT");
			hashField.put("COMTYPE", com.getAttributeValue("type").trim());
			list = com.getChildren();
			it = list.iterator();
			Element subCom;
			while (it.hasNext()) {
				subCom = (Element) it.next();
				hashField.put(subCom.getName(), subCom.getText().trim());
			}
		}
		Element gField = objField.getChild("GROUP");
		if (gField != null) {
			this.setGroupField(fieldName, gField.getText());
		}
		/*
		 if(this.fieldGroup.containsKey("all")){
		 String tmp=(String)this.fieldGroup.get("all");
		 tmp+=","+fieldName;
		 this.fieldGroup.put("all",tmp);
		 }else{
		 this.fieldGroup.put("all",fieldName);
		 }*/
		this.fieldGroup.put("all", "*");
		return hashField;
	}
	private void setGroupField(String fName, String gField) {
		StringTokenizer st = new StringTokenizer(gField, ",");
		while (st.hasMoreTokens()) {
			String gName = st.nextToken().toLowerCase();
			if (this.fieldGroup.containsKey(gName)) {
				String tmp = (String) this.fieldGroup.get(gName);
				tmp += "," + fName;
				this.fieldGroup.put(gName, tmp);
			} else {
				this.fieldGroup.put(gName.toLowerCase(), fName);
			}
		}
	}
	public String getDescThai() {
		return this.descThai;
	}
	public HashMap getFieldGroup() {
		return this.fieldGroup;
	}
	public String getDescEng() {
		return this.descEng;
	}
	public String getEditCheck() {
		return this.editcheck;
	}
	public String getVerify() {
		return this.verify;
	}
	public String getVerifyGroup() {
		return this.verifyGroup;
	}
	public void setLoadComponent(boolean load) {
		this.loadCompo = load;
	}
	public HashMap getRelation() {
		return this.relation;
	}
	public String getMainHelp() {
		return this.mainHelp;
	}
	public String getReferHelp() {
		return this.referHelp;
	}
	public String getMainkey() {
		return this.mainKey;
	}
	public String getWfActive() {
		return this.wfactive;
	}
	public String getWfKey() {
		return this.wfkey;
	}
	public String getDocumentno() {
		return this.documentno;
	}
	public String getSystemField() {
		return this.systemField;
	}
	/*
	 public String getSecurity() {
	 return this.securityClass;
	 }
	 */
}
