package com.csc.library.database;

import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import org.jdom.Element;

import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;
import com.csc.library.utilities.UProfile;

/**
 * @author developer11
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class LoadSimXml {
	MyHashMap hTable = new MyHashMap();	
	String fileName;	
	InitialEnvironment env;
	private UProfile upf = null;
	
	public void initEnv(String dbName) {
		try {
			env = new InitialEnvironment("GLOBAL");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void initEnv(UProfile up) {
		try {
			this.upf = up;
			env = new InitialEnvironment("GLOBAL");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	private String getPath() {
		String path = "";
		try {
			path = env.getValue("xmlpath-simxml");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return path;
	}
	
	public MyHashMap getSimXmlHash() { //Load SimXml New				
		MyHashMap myHash = new MyHashMap();	//MyHashTable FieldName		
		FieldManager fieldProp;		
		Element objTable,objField,objEleField,eleAttCom,objComField;
		String tableName,fieldName,attFieldName,attSub;
		MyRecord fieldRec;
		List listField;
		Iterator iField,iAttField,iEleField,iComField;
		
		fieldRec = new MyRecord("","");
		fieldRec.setUProfile(this.upf);
		ReadXml read = new ReadXml(this.getPath() + this.fileName,true);
		Element root = read.getRootElement();		
		Iterator iTable = root.getChildren().iterator();	
	
		while (iTable.hasNext()) {
			objTable = (Element) iTable.next();
			if (objTable != null) {
				tableName = objTable.getName();								
				//System.out.println("tableName = "+tableName);	
				
				listField = root.getChild(tableName).getChildren();
				iField = root.getChild(tableName).getChildren().iterator();
				while (iField.hasNext()){
					objField = (Element) iField.next();
					if (objField != null){
						fieldName = objField.getName();
						//System.out.println("fileldName = "+fieldName);
						fieldProp = fieldRec.initField(objField.getAttributeValue("type"),fieldName,0,0,""); //Inital Field						
						//Set Attribute Field
						iAttField = objField.getAttributes().iterator();
						while (iAttField.hasNext()){														
							attFieldName = iAttField.next().toString();
							attSub = attFieldName.substring(12,attFieldName.indexOf("="));
//							MyLog.debug(this, "-------------->"+attSub+" = "+objField.getAttributeValue(attSub));
							if(attSub.equalsIgnoreCase("key"))
								fieldProp.setKey(objField.getAttributeValue(attSub).charAt(0));
							else if(attSub.equalsIgnoreCase("ENCRYPT"))		
								fieldProp.setEncrypt( new Boolean((String)objField.getAttributeValue(attSub).trim()).booleanValue());
							else if(attSub.equalsIgnoreCase("LOG"))		
								fieldProp.setLog( new Boolean((String)objField.getAttributeValue(attSub).trim()).booleanValue());
							else if(attSub.equalsIgnoreCase("LANG"))	
								fieldProp.setLang(objField.getAttributeValue(attSub).charAt(0));
/*							
							else if(attSub.equalsIgnoreCase("DEFAULTVALUE"))
								fieldProp.setDefault(objField.getAttributeValue(attSub).trim());
							else if(attSub.equalsIgnoreCase("RELATION"))
								fieldProp.setRelation(objField.getAttributeValue(attSub).trim());
							else if(attSub.equalsIgnoreCase("DESC_ENG"))								
									fieldProp.setDescriptionEng(objField.getAttributeValue(attSub).trim());
							else if(attSub.equalsIgnoreCase("DESC_THAI"))								
								fieldProp.setDescriptionThai(objField.getAttributeValue(attSub).trim());	
							else if(attSub.equalsIgnoreCase("ALT_ENG"))								
									fieldProp.setAltEng(objField.getAttributeValue(attSub).trim());
							else if(attSub.equalsIgnoreCase("ALT_THAI"))								
								fieldProp.setAltThai(objField.getAttributeValue(attSub).trim()); */	
							else
							fieldProp.setProperty(attSub,objField.getAttributeValue(attSub).trim());
						}//End while (iAttField.hasNext())
						
						//Set Field Element						
						iEleField = objField.getChildren().iterator();
						while (iEleField.hasNext()){
							objEleField = (Element) iEleField.next();
							if (objEleField != null){								
								if (!objEleField.getName().equals("COMPONENT")){
//									MyLog.debug(this, "eleField = "+objEleField.getName()+"   value ="+objEleField.getText());
									String elementSub = objEleField.getName();
									fieldProp.setProperty(objEleField.getName(),objEleField.getText().trim());
									if(elementSub.equalsIgnoreCase("DEFAULTVALUE"))
										fieldProp.setDefault(objEleField.getText().trim());
									else if(elementSub.equalsIgnoreCase("RELATION"))
										fieldProp.setRelation(objEleField.getText().trim());
									else if(elementSub.equalsIgnoreCase("DESC_ENG"))								
										fieldProp.setDescriptionEng(objEleField.getText().trim());
									else if(elementSub.equalsIgnoreCase("DESC_THAI"))								
										fieldProp.setDescriptionThai(objEleField.getText().trim());	
									else if(elementSub.equalsIgnoreCase("ALT_ENG"))								
										fieldProp.setAltEng(objEleField.getText().trim());
									else if(elementSub.equalsIgnoreCase("ALT_THAI"))								
										fieldProp.setAltThai(objEleField.getText().trim());
									
								}
							}
						}//End while (iEleField.hasNext()){
						
						//Set Attribute Component				
						eleAttCom = objField.getChild("COMPONENT");
						//System.out.println("Attribute Value = "+eleAttCom.getAttributeValue("type"));
						fieldProp.setComType(eleAttCom.getAttributeValue("type").trim());
						
						//Set Field COMPANENT Element
						iComField = objField.getChild("COMPONENT").getChildren().iterator();							
						while (iComField.hasNext()){							
							objComField = (Element) iComField.next();								
							if (objComField != null){								
								//System.out.println("componentName = "+objComField.getName()+" ,Value = "+objComField.getText().trim());
								fieldProp.setProperty(objComField.getName(),objComField.getText().trim());								
							}
						}//End while (iComField.hasNext()
						//myHash.put(fieldName.toLowerCase(),fieldProp);			
						fieldProp.setDescription(fieldProp.getProperty("desc"));
						myHash.put(fieldName.toLowerCase(),fieldProp);			
						//System.out.println("-------- END RECORD ---------");	
					}//End if (objChild != null)
				}//End while (itChild.hasNext())
			}//End if (obj != null) 
		}//while (it.hasNext()) 					
		return myHash;
	}
	
	public MyHashMap getSimHash() { //Load SimXml Old
		MyHashMap hRecNo = new MyHashMap();	//MyHashTable RecNo
		MyHashMap hField = new MyHashMap();	//MyHashTable FieldName
		
		StringTokenizer st;
		DbRecord rec;
		String keyField, fieldName, comName;
		List listChild, listCom;
		Iterator itChild, itCom;
		FieldManager fieldProp,tmpField;
		Element eleCom, objCom;
		
		ReadXml read = new ReadXml(this.getPath() + this.fileName,true);		
//		read.setDataManager(this.getPath() + this.fileName);
		Element root = read.getRootElement(); 		
		List list = root.getChildren(); 		
		Iterator it = list.iterator();
		String tableName = "";
		while (it.hasNext()) {
			Element obj = (Element) it.next();
			if (obj != null) {
				tableName = obj.getName();												
				rec = new InitialRecord().getDbRecord(tableName);	
				
				try {
					rec.setProperties(true);					
					//Check Key Field
					rec.getListKey(); 					
					st = new StringTokenizer(rec.getListKey(),",");
        			while (st.hasMoreTokens()){
			         	keyField = st.nextToken();			         				          	
			          	tmpField = rec.getField(keyField.toLowerCase());
			          	tmpField.setName(rec.getTableName().toLowerCase()+"$"+keyField.toLowerCase());			          	
			          	hField.put(keyField.toLowerCase(),tmpField);			          	
        			}  
        			
					listChild = root.getChild(tableName).getChildren();					
					itChild = listChild.iterator();					
					while (itChild.hasNext()){
						Element objChild = (Element) itChild.next();
						if (objChild != null){
							fieldName = objChild.getName();							
							fieldProp = rec.getField(fieldName);
							
							eleCom = objChild.getChild("COMPONENT");							
							fieldProp.setProperty("comtype",eleCom.getAttributeValue("type"));
							listCom = objChild.getChild("COMPONENT").getChildren();							
							itCom = listCom.iterator();
							while (itCom.hasNext()){
								objCom = (Element) itCom.next();
								if (objCom != null){
									comName = objCom.getName();		
									if(comName.equalsIgnoreCase("key"))
										fieldProp.setKey(objCom.getAttributeValue(comName).charAt(0));
									else if(comName.equalsIgnoreCase("ENCRYPT"))		
										fieldProp.setEncrypt( new Boolean((String)objCom.getAttributeValue(comName).trim()).booleanValue());
									else if(comName.equalsIgnoreCase("LOG"))		
										fieldProp.setLog( new Boolean((String)objCom.getAttributeValue(comName).trim()).booleanValue());
									else if(comName.equalsIgnoreCase("LANG"))	
										fieldProp.setLang(objCom.getAttributeValue(comName).charAt(0));
									else if(comName.equalsIgnoreCase("DEFAULTVALUE"))
										fieldProp.setDefault(objCom.getAttributeValue(comName).trim());
									else if(comName.equalsIgnoreCase("RELATION"))
										fieldProp.setRelation(objCom.getAttributeValue(comName).trim());
									
									else if(comName.equalsIgnoreCase("DESC_ENG"))								
											fieldProp.setProperty("DESC_ENG",objCom.getAttributeValue(comName).trim());
									else if(comName.equalsIgnoreCase("DESC_THAI"))								
										fieldProp.setProperty("DESC_THAI",objCom.getAttributeValue(comName).trim());	
									else if(comName.equalsIgnoreCase("ALT_ENG"))								
											fieldProp.setAltEng(objCom.getAttributeValue(comName).trim());
									else if(comName.equalsIgnoreCase("ALT_THAI"))								
										fieldProp.setAltThai(objCom.getAttributeValue(comName).trim());	
									else
									fieldProp.setProperty(comName,objCom.getAttributeValue(comName).trim());

									
								}
							} //End itCom.hasNext()							
							
							tmpField = rec.getField(fieldName.toLowerCase());
							tmpField.setName(rec.getTableName().toLowerCase()+"$"+fieldName.toLowerCase());							
							hField.put(fieldName.toLowerCase(),tmpField);						
						} //End if (objChild != null)												
						hRecNo.put("0",hField);
					} //End itChild.hasNext()
					hTable.put(tableName.toLowerCase(),hRecNo);
				} catch (RemoteException e) { 
		        	MyLog.error(this, e);
		        }				
			} //End if (obj != null)					
		} //End it.hasNext()		
		return hTable;		
	}
	
}
