package com.csc.library.database;

import java.io.Serializable;
import java.math.BigDecimal;
import java.rmi.RemoteException;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;

import com.csc.library.components.ComponentManager;
import com.csc.library.session.DbRecord;
import com.csc.library.summary.Calculation;
import com.csc.library.utilities.Base64Decoder;
import com.csc.library.utilities.Base64Encoder;
import com.csc.library.utilities.ConvertHTML;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public abstract class MyField implements Serializable, ComponentManager, FieldManager {
	protected String						oValue		= "0.00";		
	protected DbRecord					parent;
	protected PropertyField				property	= new PropertyField();
	protected Hashtable					effectField	= new Hashtable();
	protected ComponentField			cfield=new ComponentField();
	transient protected Calculation		calMethod	= null;
	protected UProfile					user		= null;
	transient  FSecurityManager	sf			= null;
	transient private FConditionManager	cf			= null;
	protected boolean					isFormat	= false;
	String name="";
	boolean encrypt = false;
	boolean verify = false;
	boolean log = false;
	char key  = '0';
	char lang  = 'A';
	int  width = 0;
	String desc_thai="";
	String desc_eng="";
	String desc="";
	String comtype = "";
	String alt="";
	String alt_eng="";
	String alt_thai="";
	boolean working =false;
	String value = "";
	String buffvalue = "";
	String defaultvalue="";
	String type = "";
	String help ="";
	boolean help_return=false;
	boolean modified=false;
	String relation = "";
	String format="";
	int decimal=0;
	boolean security=false;	
	
	boolean isedit=true;
	boolean isread=true;
//	boolean ischange=false;
	
	protected String _DEFAULT_DESC_ENG="";
	protected String _DEFAULT_DESC_THAI="";
	protected String _DEFAULT_ALT_ENG="";
	protected String _DEFAULT_ALT_THAI="";
	protected String _DEFAULT_COMTYPE="";
	protected String _DEFAULT_DEFAULTVALUE="";
	protected boolean _DEFAULT_HELP_RETURN_FIELD=false;
	
	protected String OriginalData = "";
	
	//Begin Constructor
	public MyField(String name) {
		this.setName(name);
		// this.name = name.toLowerCase();
	}
	public MyField(String name, String description) {
		this.setName(name);
		this.setDescription(description);
		/*
		 * this.name = name.toLowerCase(); this.description = description;
		 */
	}
	public MyField(String name, int width, String description) {
		this.setName(name);
		this.setWidth(width);
		this.setDescription(description);	
		/*
		 * this.name = name.toLowerCase(); this.width = width; this.description =
		 * description;
		 */
	}
	public MyField(String name, int width, int decimal, String description) {
		this.setName(name);
		this.setWidth(width);
		this.setDecimal(decimal);
		this.setDescription(description);	
		/*
		 * this.name = name.toLowerCase(); this.width = width; this.decimal=
		 * decimal; this.description = description;
		 */
	}
	// End Constructor
	public void setDefault(String defaultValue) {		
		this.defaultvalue=defaultValue;
		// this.defaultValue = defaultValue;
	}
	public void setNone(boolean none) {
		this.setProperty("none", String.valueOf(none));
		// this.none = none;
	}
	public void setName(String name) {
		this.name=name;
	}
	public void setModified(boolean mod) {
		this.setProperty("mod", String.valueOf(mod));
		// this.modified = mod;
	}
	public void setCaption(String caption) {
		this.setProperty("caption", caption);
		// this.caption = caption;
	}
	public void setDescription(String description) {
		 this.desc = description;	
	}
	public void setKey(char key) {
		this.key=key;
		if (key != '0') {
			this.setWorking(true);
		}
	}
	public void setWorking(boolean working) {
		this.working=working;
//		if(working)
//			this.ischange=false;
	}
	public void setRelation(String parentTable) {
		this.relation=parentTable;
	}
	public String getRelation() {
		return this.relation;
	}
	public String getDescription() {
		return this.desc;
	}
	// Begin of Get Value method
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public boolean getBoolean() {
		Boolean buff = null;
		try {
			// if (this.value.equals("true") && checkCondition() &&
			// this.checkType() && this.isWorking()){
			if (this.getValueProperties().equals("true") && checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {	
					this.setRead(this.isread);
					return this.isRead();					
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
					return this.isRead();				}
			} else {
				return false;
			}
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = new Boolean(this.getDefault());		
			return buff.booleanValue();
		}
	}
	public byte getByte() {
		Byte buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf != null) && (this.sf.get(this))) {
					// buff = Byte.valueOf(this.value);
					buff = Byte.valueOf(this.getValueProperties());
					this.setRead(this.isread);				
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
				// } else buff = Byte.valueOf(this.value);
			} else {
				buff = Byte.valueOf(this.getValueProperties());
			}
			return buff.byteValue();
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = new Byte(this.getDefault());
			return buff.byteValue();
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public String getString() {
		String buff = "";
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = this.value;
					buff = this.getValueProperties();
					this.setRead(this.isread);				
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = this.defaultValue;
				buff = this.getDefault();
				// this.logger.info("$$$$$$$$$$ BUFF "+buff) ;
			}
			return buff;
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = this.getDefault();
			return buff;
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public char[] getChars() {
		char buff[] = null;
		if (checkCondition() && this.checkType() && this.isWorking()) {
			if ((this.sf == null) || (this.sf.get(this))) {
				// buff = this.value.toCharArray();
				buff = this.getValueProperties().toCharArray();
				this.setRead(this.isread);
			} else {
				this.setErrmess("You don't have permission to get Value.");
				this.setRead(false);
			}
		} else {
			// buff = String.valueOf("?").toCharArray();
			buff = this.getDefault().toCharArray();
		}
		return buff;
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public char getChar() {
		char buff = ' ';
		if (checkCondition() && this.checkType() && this.isWorking()) {
			if ((this.sf == null) || (this.sf.get(this))) {
				// buff = this.value.charAt(0);
				String tmp = this.getValueProperties();
				if (tmp.trim().length() > 0)
					buff = tmp.charAt(0);
				this.setRead(this.isread);
			} else {
				this.setErrmess("You don't have permission to get Value.");
				this.setRead(false);
			}
		} else {
			// buff = '?';
			buff = this.getDefault().charAt(0);
		}
		return buff;
	}
	public short getShort() {
		Short buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = new Short(this.value.trim());
					buff = new Short(this.getValueProperties().trim());
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new Short("0");
				buff = new Short(this.getDefault());
			}
			return buff.shortValue();
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = new Short(this.getDefault());
			return buff.shortValue();
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public int getInt() {
		Integer buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = new Integer(this.value.trim());
					buff = new Integer(this.getValueProperties().replace(",", ""));
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new Integer("0");
				buff = new Integer(this.getDefault());
			}
			return buff.intValue();
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = new Integer(this.getDefault());
			return buff.intValue();
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public long getLong() {
		Long buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = new Long(this.value.trim());
					buff = new Long(this.getValueProperties().replace(",", ""));
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new Long("0");
				buff = new Long(this.getDefault());
			}
			return buff.longValue();
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = new Long(this.getDefault());
			return buff.longValue();
		}
	}
	public float getFloat() {
		Float buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = new Float(this.value.trim());
					buff = new Float(this.getValueProperties().replace(",", ""));
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new Float("0");
				buff = new Float(this.getDefault());
			}
			return buff.floatValue();
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = new Float(this.getDefault());
			return buff.floatValue();
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public double getDouble() {
		Double buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = new Double(this.value.trim());
					buff = new Double(this.getValueProperties().replace(",", ""));
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new Double("0");
				buff = new Double(this.getDefault());
			}
			return buff.doubleValue();
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			return 0.0;
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public Timestamp getTimestamp() {
		Timestamp buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = Timestamp.valueOf(value);
					buff = Timestamp.valueOf(this.getValueProperties());
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new Timestamp(1);
				buff = Timestamp.valueOf(this.getDefault());
			}
			return buff;
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = Timestamp.valueOf(this.getDefault());
			return buff;
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public BigDecimal getBigDecimal() {
		BigDecimal buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = new BigDecimal(this.value.trim());
					buff = new BigDecimal(this.getValueProperties());
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new BigDecimal("0");
				buff = new BigDecimal(this.getDefault());
			}
			return buff;
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = new BigDecimal(this.getDefault());
			return buff;
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 */
	public java.sql.Date getDate() {
		java.sql.Date buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = java.sql.Date.valueOf(value);
					buff = java.sql.Date.valueOf(this.getValueProperties());
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new java.sql.Date(1);
				buff = java.sql.Date.valueOf(this.getDefault());
			}
			return buff;
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> IllegalArgument Exception [value is blank setdefault by system]");
        	if(this.getDefault().trim().length()>0){        		
        		buff = java.sql.Date.valueOf(new CscCalendar(this.getDefault()).getYYYYMMDD());
        	}
			return buff;
		}
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.get(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to get Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold get (return
	 * true))
	 * <p>
	 * else Print Error Message
	 * 
	 * @return Time set
	 */
	public Time getTime() {
		Time buff = null;
		try {
			if (checkCondition() && this.checkType() && this.isWorking()) {
				if ((this.sf == null) || (this.sf.get(this))) {
					// buff = Time.valueOf(value);
					buff = Time.valueOf(this.getValueProperties());
					this.setRead(this.isread);
				} else {
					this.setErrmess("You don't have permission to get Value.");
					this.setRead(false);
				}
			} else {
				// buff = new Time(1);
				buff = Time.valueOf(this.getDefault());
			}
			return buff;
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			buff = Time.valueOf(this.getDefault());
			return buff;
		}
	}
	public CscCalendar getcscCalendar() {
		CscCalendar d = null;
		d = new CscCalendar(this.buffvalue);
		return d;
	}
	public String get() {
		return this.getString();
	}
	public String getValue() {
		return this.getString();
	}
	// End of Get Value method
	// Begin of Set Value method. Need to uses Throw Exception Concept to slove
	// it
	public boolean set(boolean x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(byte x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(String x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(char[] x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(char x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(short x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(int x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(long x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(float x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(Timestamp x) {
		return setValue(x.toString());
	}
	public boolean set(Time x) {
		return setValue(x.toString());
	}
	public boolean set(java.sql.Date x) {
		return setValue(x.toString());
	}
	public boolean set(BigDecimal x) {
		return setValue(x.toString());
	}
	public boolean set(double x) {
		return setValue(String.valueOf(x));
	}
	public boolean set(CscCalendar d) {
		return true;
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if((this.sf==null)||(this.sf.set(this))){
	 * <p>
	 * }else{
	 * <p>
	 * this.setErrmess("You don't have permission to set Value.");
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * IF(Security Field == null) or( Security Field call methold set (return
	 * true))
	 * <p>
	 * else Print Error Message
	 * 
	 * @param x
	 */
	protected boolean setValue(String x) {
//		ischange=true;
		boolean check = false;
		String tmpx = null;
		if (x != null){ 
			x=x.trim();
			tmpx = new String(x);
			} else tmpx = "";
		String oldData = this.getOldValue();
		if (this instanceof FieldDouble || this instanceof FieldBigDecimal) {
			if (tmpx == null || tmpx.equals("")) tmpx = "0";
			boolean haveFormat = false;
			String format = this.getFormat();
			if (tmpx.indexOf(",") > 0||format.length()>0){
				haveFormat = true;	
			}
			if (haveFormat) {
				if (format == null || format.equals("") || format.equals("null")) {
					format = this.user.get("formatnumber");
				}
				tmpx = this.getParseValue(format,tmpx);
			}else{
				tmpx = this.getFormatValue("0.0###",tmpx);
			}
		}
//		if (this.isFormat) {
//			String format = this.property.getString("format");
//			if (format == null || format.equals("") || format.equals("null")) {
//				if (this.getProperty("type").equalsIgnoreCase("Date")) {
//					format = this.user.get("formatdate");
//				} else if (this.getProperty("type").equalsIgnoreCase("Double")) {
//					format = this.user.get("formatnumber");
//				}
//			}
//			if (format != null && !format.equals("") && !format.equals("null")) {
//				x = this.getParseValue(format, x);
//			}
//		}
		//if (this.isWorking() && !oldData.equals(tmpx) && this.checkValid()) { Ball Edit
		if (this.isWorking() && this.checkValid()) { 
			if ((this.sf == null) || (this.sf.set(this))) {
				this.oValue=this.value;
				this.value= tmpx;				
				if (!this.getValue().equals(this.getOriginalData())) {
					this.modified = true;
				} else {
					this.modified = false;
				}
				this.refreshEffectField();
				check = this.isedit;
				this.setEdit(check);
			} else {
				this.setErrmess("You don't have permission to set up Value.");
				this.setEdit(false);
			}
			// this.parent.refreshEffectTable(this.getName());
		}
		return check;
	}
	public void restoreValue() {
		String temp;
		temp = this.getValueProperties();
		this.value= this.oValue;
		this.oValue = temp;
	}
	/**
	 * <p>
	 * <b>BALL Edit </b>
	 * <p>
	 * if(this.encrypt){
	 * <p>
	 * x=this.decryption(x);
	 * <p>}
	 * <p>
	 * <b>Explain </b>
	 * <p>
	 * Decrypt Data (Data in Database) to x
	 * 
	 * @param x
	 */
	public void setOriginal(String x) {
		if ((this.sf == null) || (this.sf.set(this)))
			this.setEdit(true);
	    else
	    	this.setEdit(false);
		x = this.charForSet(x);
		if (this.isEncrypt()) {
			x = this.decryption(x);
		}
		this.modified = false;
		this.OriginalData = x;
		this.oValue=x;
		this.value=x;
		this.buffvalue=x;
		this.refreshEffectField();
	}
	public void setDefault() {
		//this.loadDefault();
		this.oValue=this.getDefault();
		this.value=this.getDefault();
		this.buffvalue=this.getDefault();		
		this.modified = false;
		this.OriginalData = this.getDefault();
		this.refreshEffectField();
	}
	private void loadDefault() {
//		DbInquiry inq = null;
//		try {
//			if ((!this.getDefaultCode().equalsIgnoreCase("")) /* &&(this.parent!=null) */
//					&& (this.getUProfile() != null)) {
//				String data = "";
//				// myInuriy
//				inq = new InitialInquiry(this.user).getDbInquiry();
//				inq.setDataSource(new InitialEnvironment(this.getUProfile().getDbName()).getValue("datasource-name"));
//				inq.setSchemaName(this.getUProfile().getSchemaName());
//				inq.initMyTable("defaulttable", "", "");
//				inq.setColumn("*");
//				String fieldS = this.parent.getNameKey(String.valueOf(this.parent.getSizeKey()));
//				inq.setFilter(fieldS + "='" + this.parent.getString(fieldS) + "' and DEFAULTID='" + this.getDefaultCode() + "'");
//				inq.refresh();
//				if (inq.next()) {
//					if (inq.getString("dtype").equalsIgnoreCase("I")) {
//						this.defaultTypeI(inq.getString("refer"), inq.getString("defaultdata"));
//					} else {
//						if ((inq.getString("dtype").equalsIgnoreCase("S"))) {
//						} else {
//							data = inq.getString("defaultdata");
//						}
//					}
//					this.setDefault(data);
//				}
//				inq.closeConnection();
//			}
//		} catch (Exception ex) {
//        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+ex);
//        	MyLog.warn(this, this.getUProfile(), ex);
//			try {
//				inq.closeConnection();
//			} catch (RemoteException e) {
//	        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
//	        	MyLog.warn(this, this.getUProfile(), e);
//			}
//		}
	}
	private String defaultTypeI(String refer, String key) {
		return "";
		/*
		 * String table,field; table= refer.substring(0,refer.indexOf(".")-1);
		 * field= refer.substring(refer.indexOf("."),refer.length());
		 * if(this.parent.getChild(table)!=null){ }else{ }
		 */
	}
	public String getDefaultCode() {
		return this.getProperty("defaultcode");
	}
	// End of Set Value method
	public String getBufferValue() {
		// return this.bufferValue;
		return this.buffvalue;
	}
	public String getDefault() {
		// return this.defaultValue;
		return this.defaultvalue;
	}
	public boolean checkValid() {
		return true;
	}
	public boolean checkAll() {
		if (this.checkValid() && this.checkValidCode()) {
			return true;
		} else {
			return false;
		}
	}
	public boolean checkCondition() {
		if (cf != null) {
			return cf.check(this);
		} else {
			return true;
		}
	}
	public boolean checkValidCode() {
		boolean ok = false;
		/*
		 * if (!this.validCode.equals("")) { ok = new
		 * MyCode().code.serach(this.validCode, this.value);
		 */
		if (!this.getProperty("validcode").equals("")) {
			ok = SystemCode.search(this.getProperty("validcode"), this.getValue());
		} else {
			ok = true;
		}
		return ok;
	}
	public boolean checkType() {
		return true;
	}
	public int undo() {
		return 1;
	}
	public int getWidth() {
		// return this.width;
		return this.width;
	}
	public String getName() {
		// return this.name;
		return this.name.toLowerCase();
	}
	public int getDecimal() {
		// return this.decimal;
		return this.decimal;
	}
	public String getType() {
		// return this.type;
		return this.type;
	}
	public char getUsedFor() {
		// return this.usedFor;
		if (this.getProperty("usedfor").trim().equals("")) {
			return '1';
		}
		return this.getProperty("usedfor").trim().charAt(0);
	}
	public void setUsedFor(char usedFor) {
		// this.usedFor = usedFor;
		this.setProperty("usedfor", String.valueOf(usedFor));
	}
	public boolean isModified() {
		return this.modified;
	}
	public boolean isWorking() {
		return this.working;
	}
	public char isKey() {
		return this.key;
	}
	public void setRecord(Object x) {
		this.parent = (DbRecord) x;
	}
	public String getRefValue() {
		return this.getString();
	}
	/*
	 * public String getName() { return this.name; }
	 */
	abstract public String getCompareString();
	abstract public String getValueString();
	public void putEffectField(FieldManager ofield) {
		this.effectField.put(ofield.getName(), ofield);
	}
	public void removeEffectField(String fieldName) {
		this.effectField.remove(fieldName);
	}
	public void setCalMethod(Calculation cal) {
		this.calMethod = cal;
	}
	public Calculation getCalMethod() {
		return this.calMethod;
	}
	public void refresh() {
		if (this.calMethod != null) {
			this.set(this.calMethod.calculate());
		}
	}
	public void refreshEffectField() {
		String buff = "";
		FieldManager fm;
		for (Enumeration enums = this.effectField.keys(); enums.hasMoreElements();) {
			fm = (FieldManager) this.effectField.get((String) enums.nextElement());
			fm.refresh();
		}
	}
	public String getStringWidth() { // getWidth
		return String.valueOf(this.width);
	}
	public String getStringDecimal() { // getDecimal
		return String.valueOf(this.decimal);
	}
	/**
	 * @param code
	 * @see getProperties(String code)
	 * 
	 */
	public String getProperty(String code) { // getProperty
		String appname=(this.user!=null)?((String)this.user.get("appname")).toUpperCase():"";
//		String _postFix=(this.user!=null&& this.user.get("lang").toString().equalsIgnoreCase("THA"))?code.toUpperCase()+"_THAI":code.toUpperCase()+"_ENG";
		String buff = "";
		if (code.equalsIgnoreCase("isupdate") && !this.checkCondition()) {
			return "false";
		}else{
			if(cfield!=null&&cfield.getComField(appname)!=null){	
				if(!cfield.getAppName().equals(appname))
					cfield.setAppName(appname);	
				buff=cfield.getComFieldValue(code.toUpperCase());
				if(buff==null)							
						buff = this.getProperties(code);
			}else
				buff= this.getProperties(code);			
		}
		return buff;
	}
	
	// public void setProperty(Hashtable property) { //setProperty
	public void setProperty(PropertyField property) {
		this.property = property;
	}
	public void setProperty(String code, String data) { // getDecimal
		this.property.put(code.toLowerCase(), data);
	}
	public String getValidCode() { // new
		// return this.validCode;
		return this.getProperty("validcode");
	}
	public void setValidCode(String code) { // new
		// this.validCode = code;
		this.setProperty("validcode", code);
	}
	public String getOldValue() {
		//return this.oValue;
		if(this.parent !=null){
			String x = this.parent.getOriginalValue(this.name);
			if (this.isEncrypt()) {
				x = this.decryption(x);
			}
			return x;
		}else
			return this.oValue;
	}
	/**
	 * 
	 * @param set
	 *                       Use Security (true/false)
	 */
	public void setSecurity(boolean set) {
		// this.security=set;
		this.security=set;
	}
	/**
	 * It's has Security. It's return true.
     * edit 10/11/2005 
     * */
    public boolean getSecurity() {
    	return this.security;	}
	/**
	 * Set User Profile
	 * 
	 * @param uPro
	 */
	public void setUProfile(UProfile uPro) {
		this.user = uPro;
		this.property.setUProfile(this.user);
	}
	/**
	 * Get User Profile
	 * 
	 * @return UProfile
	 */
	public UProfile getUProfile() {
		return this.user;
	}
	/**
	 * set Field Security Manager
	 * 
	 * @param sf
	 */
	public void setSecurity(FSecurityManager sf) {
		this.sf = sf;
	}
	/**
	 * Set Calss Field Condition Manager . Sometime Field have condition range,
	 * It's must put range data into HashTable and get it from property methold
	 * 
	 * @param cf
	 */
	public void setCondition(FConditionManager cf) {
		this.cf = cf;
	}
	/**
	 * Show Error Message
	 * 
	 * @param mess
	 * @throws RemoteException 
	 */
	public void setErrmess(String mess) {
    	try {
			MyLog.debug(this, this.getUProfile(), mess+"    "+this.parent.getActualName()+"---"+this.getName());
		} catch (RemoteException e) {
	    	MyLog.info(this, this.getUProfile(), e);
		}
	}
	/**
	 * Rollback (It's set value data = oldValue data)
	 */
	public void rollback() {
		// this.value=this.oldValue;
		this.setValue(this.getOldValue());
	}
	/**
	 * my Record Call this methold
	 * 
	 * @return String to encrypt
	 */
	public String encryption() {
		if(this.encrypt){
			return this.encryption(this.getString());
		} else {
			return this.charForSave(this.getString());
		}
	}
	/**
	 * true = use Encrypt false = don't use Default = false
	 * 
	 * @param status
	 *                       true/false
	 */
	public void setEncrypt(boolean status) {
		 this.encrypt=status;
		//this.encrypt=false;
	}
	public String charForSave(String data) {
		return data;
	}
	public String charForSet(String data) {
		return data;
	}
	public boolean containsKey(String key) {
		return this.property.containsKey(key);
	}
	public PropertyField getProperty() {
		return this.property;
	}
	public boolean isEncrypt() {
		return this.encrypt;
	}
	public boolean isLog() {
		return this.log;
	}
	private void checkSum() {
	}
	private void checkLenght() {
	}
	private void setSum() {
	}
	private void setLenght() {
	}
	public void loadSecurity() {
        /****************nuball edit 08-01-07***********************/   
        if(!((this.user.get("fsecurity")!=null)&&(this.user.get("fsecurity").equalsIgnoreCase("1")))){
        
        /***************************************/        
		if (!this.getProperty("security").equals("")) {
			try {
				if (this.getProperty("security").equals("SalaryEmpSecurity")) {
					if(StaticProperties.mySecurity!=null){
						this.sf = (FSecurityManager) StaticProperties.mySecurity;
				}else{
						this.sf = (FSecurityManager) Class.forName("com.csc.library.security." + this.getProperty("security")).newInstance();
						StaticProperties.mySecurity=sf;
					}
				} else {
					this.sf = (FSecurityManager) Class.forName("com.csc.library.security." + this.getProperty("security")).newInstance();
				}
			} catch (Exception ex) {
	        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+ex);
	        	MyLog.warn(this, this.getUProfile(), ex);
			}
		}
      }
	}
	public DbRecord getParent() {
		return this.parent;
	}
	protected String setMaxChar(String data) {
		HashMap hashCounter = new HashMap();
		String point, maxChar = "";
		String counter = new String();
		for (int i = 0; i < data.length(); i++) {
			point = String.valueOf(data.charAt(i));
			if (hashCounter.containsKey(point)) {
				counter = (String) hashCounter.get(point);
				counter = String.valueOf(Integer.valueOf(counter).intValue() + 1);
				hashCounter.put(point, counter);
			} else {
				hashCounter.put(point, "1");
			}
		}
		int max = 0;
		for (Iterator it = hashCounter.keySet().iterator(); it.hasNext();) {
			point = (String) it.next();
			counter = (String) hashCounter.get(point);
			if (max < Integer.valueOf(counter).intValue()) {
				maxChar = point;
				max = Integer.valueOf(counter).intValue();
			}
		}
		// data Return charMax:value;
		return maxChar + String.valueOf(max) + ":" + data;
	}
	protected boolean checkMaxChar(String data) {
		try {
			String check = "";
			check = this.setMaxChar(data.substring(data.indexOf(":"), data.length()));
			if (data.equals(check))
				return true;
			else
				return false;
		} catch (Exception e) {
		}
		return false;
	}
	/** ************************************** */
	/*
	 * ball edit 25-09-03
	 */
	public String decryption(String encryption) {
		try {
			if(this.getDefault().equals(encryption)){//óշ ҡѺ default value ͧ
				return encryption;
			}else if (encryption.trim().length()>0) {
				Base64Decoder b = new Base64Decoder(encryption.trim(),this.getParent().getTableName()+this.getName());
				return b.processString();
			} else { 
				String ftype = this.getType();
				if (ftype.equalsIgnoreCase("double") || 
						ftype.equalsIgnoreCase("integer") || 
						ftype.equalsIgnoreCase("float") || 
						ftype.equalsIgnoreCase("long")) {
					return this.getDefault();
				}else {
					return encryption;
				}
			}
		} catch (Exception e) {
			try {
	        	MyLog.warn(this, "Table : " + this.getParent().getTableName() +" Field : " + this.getName() + " Encrypt Data : " + encryption);
	        	MyLog.warn(this, this.getUProfile(), e);	        	
			} catch (RemoteException e1) {
	        	MyLog.warn(this, this.getUProfile(), e);
			}
			return this.getDefault();
		}
		
	}
	public String getSaveString() {
		String data =this.getString().trim();
		String ovalue=this.getOldValue();
//		data=(this.ischange||ovalue.trim().length()==0)?data:this.getOldValue();
		if (this.isEncrypt()) {
			data = this.encryption(data);
			return data;
		} else {				
			if (data.length() > this.width) {
				data = data.substring(0,this.width);
			}
			return data;
		}
	}
	/**
	 * 
	 * @param encryption
	 *                       Data from Database
	 * @return String is Decrypt
	 */
	public String encryption(String value) {
		// System.out.println("=============================:" + encryption +
		// ":-----------------------------");
		Base64Encoder b64ec = new Base64Encoder(value);
		return b64ec.processString();
	}
	public String insAutoNumber() {
		return "";
	}
	
	public void formatOn() {
		isFormat = true;
	}
	public void formatOff() {
		isFormat = false;
	}
	private String getValueProperties() {
		String value = this.value;
		try {
			if ((value==null)||(value.equals("null"))) {
				return "";
			}
			if (this.isFormat) {
				String format = this.getFormat();
				if (format == null || format.equals("")) {
					if (this.getType().equalsIgnoreCase("Date")) {
						format = this.user.get("formatdate");
					} else if (this.getType().equalsIgnoreCase("Double")) {
						format = this.user.get("formatnumber");
					}
				}
				if (format != null && !format.equals("")) {
					String type = this.getType();
					value = this.getFormatValue(format, value);
				}
			}
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
		}		
		return value;
	}
	private String getParseValueProperties(String value) {
		try {
			if (this.isFormat) {
				String format = this.getFormat();
				if (format != null && !format.equals("")) {
					Class c = MyField.class;
					value = this.getParseValue(format, value);
				}
			}
		} catch (Exception e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
		}
		return value;
	}
	protected String getFormatValue(String format, String value) {
		return "";
	}
	protected String getParseValue(String format, String value) {
		return "";
	}
	public boolean getFormatFlag() {
		return this.isFormat;
	}
	public String getDataFormat() {
		if (!this.isFormat) {
			String temp = "";
			if ( this instanceof FieldDate) {
				if (this.getFormat() != null && !this.getFormat().equals("")) {
					temp = this.getFormatValue((String) this.getFormat(),this.getString());
				} else if (this.user.get("formatdate") != null && !this.user.get("formatdate").equals("")) {
					temp = this.getFormatValue(this.user.get("formatdate"),this.getString());
				} else {
					temp = this.getString();
				}
			} else if ( this instanceof FieldDouble) {
				String data = this.getString();
				if (data == null || data.equals(""))
					data = "0";
				if (this.getFormat() != null && !this.getFormat().equals("")) {
					temp = this.getFormatValue((String) this.getFormat(),data);
				} else if (this.user.get("formatnumber") != null && !this.user.get("formatnumber").equals("")) {
					temp = this.getFormatValue(this.user.get("formatnumber"),data);
				} else {
					temp = this.getString();
				}
			}  else if ( this instanceof FieldInteger) {
				String data = this.getString();
				if (data == null || data.equals(""))
					data = "0";
				if(this.getFormat().length()>0){
					temp = this.getFormatValue(this.getFormat(),data);
				}else{
					temp = this.getString();
				}
			}else {
				temp = this.getString();
			}
			return temp;
		}
		return this.getString();
	}
	public void  setLog(boolean log) {
		this.log= log;	
	}
	public void  setVerify(boolean verify) {
		this.verify= verify;	
	}
	public void  setLang(char lang) {
		this.lang= lang;
	}	
	public void  setWidth(int width) {
		this.width= width;	
	}	
	public void setDescriptionThai(String desc){
			this.desc_thai = desc;		
	}
	public void setDescriptionEng(String desc){
		this.desc_eng = desc;
	}
	public String getDescriptionThai(){
		return this.desc_thai;
		
	}
	public String  getDescriptionEng(){
		return this.desc_eng;
	}
	public void setAlt(String desc){
		this.alt = desc;
	}
	public String getAlt(){
		return this.alt;
	}
	public void setAltEng(String desc){
		this.alt_eng = desc;
	}
	public String getAltEng(){
		return this.alt_eng;
	}
	public void setAltThai(String desc){
		this.alt_thai = desc;
	}
	public String getAltThai(){
		return this.alt_thai;
	}
	public void setComType(String comtype){
		this.comtype=comtype;		
	}
	public String getComType(){
		return this.comtype;
	}
	public void setHelp(String help){
		this.help=help;
	}
	public String getHelp(){
		return this.help;
	}
	public void setHELP_RETURN_FIELD(boolean check){
		this.help_return=check;
	}
	public boolean getHELP_RETURN_FIELD(){
		return this.help_return;
	}
	public void setFormat(String format){
		this.format=format;
	}
	public String getFormat(){
		return this.format;
	}	
	public void setType(String type){
		this.type=type;
	}	
	public boolean isVerify(){
		return this.verify;
	}
	public void setOldValue(String oldvalue){
		this.oValue = oldvalue;
	}
	public void setDecimal(int decimal){
		this.decimal=decimal;
	}	
	public char getLang(){
		return this.lang;
	}	
	public String getStringHTML() {
		
		
		return ConvertHTML.convert(this.getDataFormat());
	}
	
	public void setProperty(Object cfield) {
		this.cfield = (ComponentField)cfield;
	}	
	
	public ComponentField getComponentField(){
		return cfield;
	}	
	
	public void setProperty(String code,Object cfield) {
		property.put("cfield",(ComponentField)cfield);
		setProperty(cfield);
	}	
	
	public boolean isEdit(){
		return this.isedit;
	}
	
	public boolean isRead(){
		return this.isread;
	}
	
	public void setEdit(boolean edit){
		this.isedit=edit;
	}
	
	public void setRead(boolean read){
		this.isread=read;
	}	

	public void initField(UProfile upf){
		this.initField(upf, false);
	}
	
	public void initField(UProfile upf,boolean copyvalue){
		try{
			String appname=upf.get("appname");
			if(appname!=null&&appname.trim().length()>0&&cfield!=null&&cfield.getComField(appname)!=null){ 
				PropertyField propertyField=(PropertyField)this.getProperty().clone();
				this.setProperty(propertyField);
				cfield.setAppName(appname);					
				if(upf.get("lang").equalsIgnoreCase("ENG"))			
					this.setDescription(cfield.getComFieldValue("DESC_ENG"));
				else
					this.setDescription(cfield.getComFieldValue("DESC_THAI"));
				this.setDescriptionThai(cfield.getComFieldValue("DESC_THAI"));
				this.setDescriptionEng(cfield.getComFieldValue("DESC_ENG"));
				
				if(upf.get("lang").equalsIgnoreCase("ENG"))
					this.setAlt(cfield.getComFieldValue("ALT_ENG"));
				else
					this.setAlt(cfield.getComFieldValue("ALT_THAI"));
				this.setAltEng(cfield.getComFieldValue("ALT_ENG"));
				this.setAltThai(cfield.getComFieldValue("ALT_THAI"));
				this.setComType(cfield.getComFieldValue("COMTYPE"));		
				if(cfield.getComFieldValue("DEFAULTVALUE")!=null && cfield.getComFieldValue("DEFAULTVALUE").length()>0)
					this.setDefault(cfield.getComFieldValue("DEFAULTVALUE"));
				else {
					this.setDefault(this.get_DEFAULT_DEFAULTVALUE());
				}
				if(cfield.getComFieldValue("HELP_RETURN_FIELD")!=null && cfield.getComFieldValue("HELP_RETURN_FIELD").equalsIgnoreCase("true"))
					this.setHELP_RETURN_FIELD(true);
				else
					this.setHELP_RETURN_FIELD(false);
				this.setProperty("HELP_RETURN_FIELD", String.valueOf(cfield.getComFieldValue("HELP_RETURN_FIELD")));				
			}else{
				if(upf.get("lang").equalsIgnoreCase("ENG"))		
					this.setDescription(this.get_DEFAULT_DESC_ENG());
				else
					this.setDescription(this.get_DEFAULT_DESC_THAI());
				this.setDescriptionThai(this.get_DEFAULT_DESC_THAI());
				this.setDescriptionEng(this.get_DEFAULT_DESC_ENG());
				if(upf.get("lang").equalsIgnoreCase("ENG"))
					this.setAlt(this.get_DEFAULT_ALT_ENG());
				else
					this.setAlt(this.get_DEFAULT_ALT_THAI());
				this.setAltEng(this.get_DEFAULT_ALT_ENG());
				this.setAltThai(this.get_DEFAULT_ALT_THAI());
				this.setComType(this.get_DEFAULT_COMTYPE());
				this.setDefault(this.get_DEFAULT_DEFAULTVALUE());
				this.setHELP_RETURN_FIELD(this.get_DEFAULT_HELP_RETURN_FIELD());
				this.setProperty("HELP_RETURN_FIELD", String.valueOf(this.get_DEFAULT_HELP_RETURN_FIELD()));
			}
			if(!copyvalue){
				this.value=this.get_DEFAULT_DEFAULTVALUE();
			}
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	public Object clone(UProfile upf) {
			this.initField(upf,true);
			return this.clone();
	}
	
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	/**
	 * @return Returns the _DEFAULT_ALT_ENG.
	 */
	public String get_DEFAULT_ALT_ENG() {
		return _DEFAULT_ALT_ENG;
	}
	/**
	 * @param _default_alt_eng The _DEFAULT_ALT_ENG to set.
	 */
	public void set_DEFAULT_ALT_ENG(String _default_alt_eng) {
		_DEFAULT_ALT_ENG = _default_alt_eng;
	}
	/**
	 * @return Returns the _DEFAULT_ALT_THAI.
	 */
	public String get_DEFAULT_ALT_THAI() {
		return _DEFAULT_ALT_THAI;
	}
	/**
	 * @param _default_alt_thai The _DEFAULT_ALT_THAI to set.
	 */
	public void set_DEFAULT_ALT_THAI(String _default_alt_thai) {
		_DEFAULT_ALT_THAI = _default_alt_thai;
	}
	/**
	 * @return Returns the _DEFAULT_COMTYPE.
	 */
	public String get_DEFAULT_COMTYPE() {
		return _DEFAULT_COMTYPE;
	}
	/**
	 * @param _default_comtype The _DEFAULT_COMTYPE to set.
	 */
	public void set_DEFAULT_COMTYPE(String _default_comtype) {
		_DEFAULT_COMTYPE = _default_comtype;
	}
	/**
	 * @return Returns the _DEFAULT_DEFAULTVALUE.
	 */
	public String get_DEFAULT_DEFAULTVALUE() {
		return _DEFAULT_DEFAULTVALUE;
	}
	/**
	 * @param _default_defaultvalue The _DEFAULT_DEFAULTVALUE to set.
	 */
	public void set_DEFAULT_DEFAULTVALUE(String _default_defaultvalue) {
		if(_default_defaultvalue!=null)
			_DEFAULT_DEFAULTVALUE = _default_defaultvalue;
	}
	/**
	 * @return Returns the _DEFAULT_DESC_ENG.
	 */
	public String get_DEFAULT_DESC_ENG() {
		return _DEFAULT_DESC_ENG;
	}
	/**
	 * @param _default_desc_eng The _DEFAULT_DESC_ENG to set.
	 */
	public void set_DEFAULT_DESC_ENG(String _default_desc_eng) {
		_DEFAULT_DESC_ENG = _default_desc_eng;
	}
	/**
	 * @return Returns the _DEFAULT_DESC_THAI.
	 */
	public String get_DEFAULT_DESC_THAI() {
		return _DEFAULT_DESC_THAI;
	}
	/**
	 * @param _default_desc_thai The _DEFAULT_DESC_THAI to set.
	 */
	public void set_DEFAULT_DESC_THAI(String _default_desc_thai) {
		_DEFAULT_DESC_THAI = _default_desc_thai;
	}
	
	public String getOriginalData() {
		return this.OriginalData;
	}
	/**
	 * 
	 * @param code
	 * @return
	 * <pre>
	 * 		͹˹ҹա set ءҧŧ  PropertyField  primative ᷹  field ѧ
	 *  	desc_eng			
	 *		desc_thai			
	 *		alt_eng			
	 *		alt_thai			
	 *		defaultvalue			
	 *		comtype		
	 *      óշ cfield դ Ҥ default ʴ	
     *
	 * </pre>
	 */
	
	private String getProperties(String code){
		String prop="";
		code = code.toLowerCase().trim();
		prop = (String) property.get(code);
		
		if(prop!=null&&prop.length()==0){
			if(code.equals("desc_eng"))			
				prop=this._DEFAULT_DESC_ENG;
			else if(code.equals("desc_thai"))			
				prop=this._DEFAULT_DESC_THAI;
			else if(code.equals("alt_eng"))			
				prop=this._DEFAULT_ALT_ENG;
			else if(code.equals("alt_thai"))			
				prop=this._DEFAULT_ALT_THAI;
			else if(code.equals("defaultvalue"))			
				prop=this.defaultvalue;
			else if(code.equals("comtype"))			
				prop=this._DEFAULT_COMTYPE;
		}
		if(prop==null)prop="";
		return prop;
	}
	public boolean get_DEFAULT_HELP_RETURN_FIELD(){
		return this._DEFAULT_HELP_RETURN_FIELD;
	}
	
	public void set_DEFAULT_HELP_RETURN_FIELD(boolean _default_help_return_field){
		this._DEFAULT_HELP_RETURN_FIELD=_default_help_return_field;
	}

	public void setOriginalData(String x) {
		this.OriginalData = x;
	}
	
}
