package com.csc.library.database;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.TreeMap;

import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;

/**
 * @author SoCool
 *
 * Class ??? extend HashMap ??????????????????????????????
 */
public class MyHashMap extends LinkedHashMap {
	private static final long	serialVersionUID	= 1L;
	private UProfile			user				= null;
	private boolean				autoLower			= false;
	private MyTreeMap keySort = null;
	private TreeMap tree = new TreeMap();
	private transient CheckNull chk=new CheckNull();
	
	public MyHashMap() {
		super();
	}
	public MyHashMap(boolean autoLow) {
		super();
		this.autoLower = autoLow;
	}
	public void setUProfile(UProfile up) {
		this.user = up;
	}
	public UProfile getUProfile() {
		return user;
	}
	/**
	 * <PRE>
	 * ???????? put ??????????? HashMap ????????????????????????
	 * ???? double ???????????????????????????????
	 * </PRE>
	 * @param key ??? ????????????????????
	 * @param value ??? ????????????????????
	 * @return
	 */
	public Object putToSum(Object key, double value) {
		
		if (this.containsKey(key)) {
			
			double tmpDouble = this.parseDouble(this.get(key).toString()) + value;
			tree.put(key, new Double(tmpDouble));
			return this.put(key, new Double(tmpDouble));
		} else {
			
			tree.put(key, new Double(value));
			return this.put(key, new Double(value));
		}
	}
	
	
	/**
	 * <PRE>
	 * ???????? put ??????????? HashMap ????????????????????????
	 * ???? double ???????????????????????????????
	 * </PRE>
	 * @param key ??? ????????????????????
	 * @param value ??? ????????????????????
	 * @return
	 */
	public Object putToSum(Object key, int value) {
		if (this.containsKey(key)) {
			int tmpInt = this.parseInt(this.get(key).toString()) + value;
			tree.put(key, new Integer(tmpInt));
			return this.put(key, new Integer(tmpInt));
		} else {
			tree.put(key, new Integer(value));
			return this.put(key, new Integer(value));
		}
	}
	/**
	 * <PRE>
	 * ???????? put ??????????? HashMap ????????????????????????
	 * ???? double ???????????????????????????????
	 * </PRE>
	 * @param key ??? ????????????????????
	 * @param value ??? ????????????????????
	 * @return
	 */
	public Object putToSum(Object key, float value) {
		if (this.containsKey(key)) {
			float tmpFloat = this.parseFloat(this.get(key).toString()) + value;
			tree.put(key, new Float(tmpFloat));
			return this.put(key, new Float(tmpFloat));
		} else {
			tree.put(key, new Float(value));
			return this.put(key, new Float(value));
		}
	}
	/**
	 * ???????? Merge Map ?????? Hash
	 * @param map ??? Map ?????????? Merge
	 * @return
	 */
	protected boolean mergeMap(Map map) {
		if (map == null || map.isEmpty())
			return false;
		Iterator it = map.keySet().iterator();
		try {
			while (it.hasNext()) {
				String key = it.next().toString().trim();
				Object value = map.get(key);
				if (value instanceof Double) {
					this.putToSum(key, this.parseDouble(value.toString()));
				} else if (value instanceof Integer) {
					this.putToSum(key, this.parseInt(value.toString()));
				} else if (value instanceof Float) {
					this.putToSum(key, this.parseDouble(value.toString()));
				} else {
					this.put(key, value);
				}
			}
			return true;
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return false;
		}
	}
	/**
	 * ???????? put ??? Map ?????????????????? Hash
	 * @param map ??? Map ?????????? put 
	 * @return
	 */
	protected boolean putMap(Map map) {
		if (map == null || map.isEmpty())
			return false;
		Iterator it = map.keySet().iterator();
		try {
			while (it.hasNext()) {
				String key = it.next().toString().trim();
				Object value = map.get(key);
				if (value instanceof Double) {
					this.put(key, this.parseDouble(value.toString()));
				} else if (value instanceof Integer) {
					this.put(key, this.parseInt(value.toString()));
				} else if (value instanceof Float) {
					this.put(key, this.parseDouble(value.toString()));
				} else {
					this.put(key, value);
				}
			}
			return true;
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return false;
		}
	}
	/**
	 * <PRE>
	 * ???????? Merge HashMap ????????????
	 * </PRE>
	 * @param hm ??? HashMap ?????????? Merge
	 * @return flag success
	 */
	public boolean mergeHash(HashMap hm) {
		return this.mergeMap(hm);
	}
	/**
	 * <PRE>
	 * ???????? Merge HashMap ????????????
	 * </PRE>
	 * @param hm ??? HashMap ?????????? Merge
	 * @return flag success
	 */
	public boolean mergeHash(MyHashMap hm) {
		return this.mergeMap(hm);
	}
	/**
	 * ???????? Merge MyTreeMap ??????? Hash
	 * */
	public boolean mergeHash(MyTreeMap tmap) {
		return this.mergeMap(tmap);
	}
	/**
	 *  @param key is key in myhash map which store MyTreeamap to sum
	 *  @param tmap is MyTreeMap for sum
	 * */
	public void mergeHash(Object key, MyTreeMap tmap) {
		if (this.containsKey(key)) {
			this.mergeMap((MyTreeMap) this.get(key));
		} else {
			this.put(key, tmap);
		}
	}
	/**
	 * <PRE>
	 * ?????????????????????? Hash ????????????????????????
	 * String ??????????????????????????
	 * </PRE>
	 * @param key ??? ?????????????????
	 * @return ???????????? Hash
	 */
	public String getString(Object key) {
		return String.valueOf(this.get(key));
	}
	/**
	 * <PRE>
	 * ?????????????????????? Hash ????????????????????????
	 * Boolean ??????????????????????????
	 * </PRE>
	 * @param key ??? ?????????????????
	 * @return ???????????? Hash
	 */
	public boolean getBoolean(Object key) {
		return Boolean.valueOf(this.getString(key)).booleanValue();
	}
	/**
	 * <PRE>
	 * ?????????????????????? Hash ????????????????????????
	 * Double ??????????????????????????
	 * </PRE>
	 * @param key ??? ?????????????????
	 * @return ???????????? Hash
	 */
	public double getDouble(Object key) {
		try {
			if (key instanceof String) {
				if (this.autoLower) {
					key = key.toString().toLowerCase();
				}
			} 	
			if (this.containsKey(key)) {
				return Double.parseDouble(chk.chkNullString(this.get(key).toString(),"0"));
			} else {
				return 0;
			}
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return 0;
		}
	}
	
	//Pae Edit 1-11-2005 
	public float getFloat(Object key) {
		try {
			if (key instanceof String) {
				if (this.autoLower) {
					key = key.toString().toLowerCase();
				}
			} 	
			if (this.containsKey(key)) {
				return Float.parseFloat(chk.chkNullString(this.get(key).toString(),"0"));
			} else {
				return 0;
			}
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return 0;
		}
	}
	/**
	 * <PRE>
	 * ?????????????????????? Hash ????????????????????????
	 * Int ??????????????????????????
	 * </PRE>
	 * @param key ??? ?????????????????
	 * @return ???????????? Hash
	 */
	public int getInt(Object key) {
		try {
			if (key instanceof String) {
				if (this.autoLower) {
					key = key.toString().toLowerCase();
				}
			} 	
			if (this.containsKey(key)) {
				return (int)this.getDouble(key);
			} else {
				return 0;
			}
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return 0;
		}
	}
	/**
	 * <PRE>
	 * ??? put ????? Hash
	 * </PRE>
	 * @param key ??? ????????????????? put ??????
	 * @param value ??? ????????????? put ???????? Hash
	 * @return
	 */
	public Object put(Object key, Object value) {
		if (key instanceof String) {
			if (this.autoLower) {
				tree.put(key.toString().toLowerCase(), value);
				return super.put(key.toString().toLowerCase(), value);
			} else {
				tree.put(key.toString(), value);
				return super.put(key.toString(), value);
			}
		} else {
			tree.put(key, value);
			return super.put(key, value);
		}
	}
	/**
	 * <PRE>
	 * ??? put ????? Hash
	 * </PRE>
	 * @param key ??? ????????????????? put ??????
	 * @param value ??? Hash ?????????? put ???????? Hash
	 * @return
	 */
	public void putHash(MyHashMap value) {
		this.putMap(value);
		tree.putAll(value);
	}
	/**
	 * <PRE>
	 * ??? put ????? Hash ??????????? Hash ?????????? Double Integer Float
	 * ??????? ??????????????????????????????? Hash
	 * </PRE>
	 * @param key ??? ????????????????? put ??????
	 * @param value ??? ????????????? put ???????? Hash
	 * @return
	 */
	protected Object putSummary(Object key, Object value) {
		if (value instanceof Double) {
			this.putToSum(key, ((Double) value).doubleValue());
			return null;
		} else if (value instanceof Integer) {
			this.putToSum(key, ((Integer) value).intValue());
			return null;
		} else if (value instanceof Float) {
			this.putToSum(key, ((Float) value).floatValue());
			return null;
		} else {
			tree.put(key, value);
			this.put(key, value);
		}
		return null;
	}
	/**
	 * <PRE>
	 * ???????? put ??????????? HashMap ????????????????????????
	 * ???? ?????? ???????????????????????????????
	 * </PRE>
	 * @param key ??? ????????????????????
	 * @param value ??? ????????????????????
	 * @return
	 */
	public Object putToSum(Object key, Object value) {
		if (key instanceof String) {
			if (this.autoLower) {
				tree.put(key.toString().toLowerCase(), value);
				return super.put(key.toString().toLowerCase(), value);
			} else {
				tree.put((String) key, value);
				return super.put((String) key, value);
			}
		} else {
			return this.putSummary(key, value);
		}
	}
	/**
	 * <PRE>
	 * ??? put ????? Hash
	 * </PRE>
	 * @param key ??? ????????????????? put ??????
	 * @param value ??? ????????????? put ???????? Hash
	 * @return
	 */
	public Object put(Object key, double value) {
		if (key instanceof String) {
			if (this.autoLower) {
				tree.put(key.toString().toLowerCase(), new Double(value));
				return super.put(key.toString().toLowerCase(), new Double(value));
			}else{
				tree.put((String) key, new Double(value));
				return super.put((String) key, new Double(value));
			}
		} else {
			tree.put(key, new Double(value));
			return super.put(key, new Double(value));
		}
	}
	/**
	 * <PRE>
	 * ??? put ????? Hash
	 * </PRE>
	 * @param key ??? ????????????????? put ??????
	 * @param value ??? ????????????? put ???????? Hash
	 * @return
	 */
	public Object put(Object key, int value) {
		if (key instanceof String) {
			if (this.autoLower) {
				tree.put(key.toString().toLowerCase(), new Integer(value));
				return super.put(key.toString().toLowerCase(), new Integer(value));
			} else {
				tree.put((String) key, new Integer(value));
				return super.put((String) key, new Integer(value));
			}
		} else {
			tree.put(key, new Integer(value));
			return super.put(key, new Integer(value));
		}
	}
	/**
	 * Method ??????????? remove ????????? Hash
	 * @param key ??? ??????? ?????????? remove
	 */
	public Object remove(Object key) {
		if (key instanceof String) {
			if (this.autoLower) { 
				tree.remove(key.toString().toLowerCase());
				return super.remove(key.toString().toLowerCase());
			} else {
				tree.remove(key);
				return super.remove(key);
			}
		} else {
			tree.remove(key);
			return super.remove(key);
		}
	}
	/**
	 * <PRE>
	 * ?????????????????????? Hash
	 * </PRE>
	 * @param key ??? ?????????????????
	 * @return ???????????? Hash
	 */
	public Object get(Object key) {
//		if (this.containsKey(key)) {
			if (key instanceof String) {
				if (this.autoLower)
					return super.get(key.toString().toLowerCase());
				else
					if (super.get(key) != null) 
						return super.get(key);
					else if (super.get(((String) key).toLowerCase()) != null)
						return super.get(((String) key).toLowerCase());
					else if (super.get(((String) key).toUpperCase()) != null)
						return super.get(((String) key).toUpperCase());
					else
						return null;
			} else {
				return super.get(key);
			}
//		} else {
			//Log.warn("!!!!!!!!!!!!!!!!! Not Found key [" + key + "] to get value !!!!!!!!!!!!!!!!!");
//			return null;
//		}
	}
	/**
	 * ??????????????????????????????????????????????
	 * @param key ??? ????????????????????????
	 * @return boolean true false
	 */
	public boolean containsKey(Object key) {
		if (key instanceof String) {
			if (this.autoLower)
				return super.containsKey(key.toString().toLowerCase());
			else
				return super.containsKey(key);
		} else {
			return super.containsKey(key);
		}
	}
	/**
	 * ???????? get ??? Iterator ??? key
	 * @return Iterator
	 */
	public Iterator getKeyIterator() {
		return this.keySet().iterator();
	}
	
	public Iterator getKeySortIterator() {
		return tree.keySet().iterator();
	}
	/**
	 * <PRE>
	 * Utility Method ???????? parse ??? Double
	 * ??????????? Parse ???? ??? ??????? Exception 
	 * ????????????????? 0 ????
	 * </PRE>
	 * @param value ??? String ?????????? parse
	 * @return
	 */
	public double parseDouble(String value) {
		try {
			return Double.parseDouble(value);
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return 0;
		}
	}
	/**
	 * <PRE>
	 * Utility Method ???????? parse ??? Double
	 * ??????????? Parse ???? ??? ??????? Exception 
	 * ????????????????? 0 ????
	 * </PRE>
	 * @param value ??? String ?????????? parse
	 * @return
	 */
	public int parseInt(String value) {
		try {
			return Integer.parseInt(value);
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return 0;
		}
	}
	/**
	 * <PRE>
	 * Utility Method ???????? parse ??? Double
	 * ??????????? Parse ???? ??? ??????? Exception 
	 * ????????????????? 0 ????
	 * </PRE>
	 * @param value ??? String ?????????? parse
	 * @return
	 */
	public float parseFloat(String value) {
		try {
			return Float.parseFloat(value);
		} catch (Exception e) {
	    	MyLog.info(this, this.user , e);
			return 0;
		}
	}
	
	public TreeMap getTreeMap() {
		return tree;
	}
	
	public static void main(String[] args) {
		MyHashMap l = new MyHashMap();
		l.put("2", 4);
		l.putToSum("2", 2.5);
		l.putToSum("3", 2.5);
        Iterator it = l.getKeySortIterator();
	    while (it.hasNext()) {
	    	String k = (String)it.next();
			System.out.println(k);
			System.out.println(l.getDouble(k));	
	    }
	}
/*	public MyTreeMap getM?yTreeMap() {
		return 
	}
	
	public void Sorting() {
		MyTreeMap treemap = new MyTreeMap();
		
	}
*/
}
