package com.csc.library.database;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * @author paecsc
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SimColReport implements java.io.Serializable {	
	DbRecord dbPRGroup=null;
	MyHashMap hm_Col;
	String filter="",formulaList="",captionList="",tableGroup="",fieldKeyName="",fieldValueName="";
	UProfile up = new UProfile();
	HashMap param = new HashMap();
	
	public SimColReport(UProfile up, HashMap param, MyHashMap hm_Col){
		this.up=up;
		this.param=param;
		this.hm_Col=hm_Col;
	}
	
	public void setFieldKey(String field){
		this.fieldKeyName = field;
	}
	
	public String getFieldKey(){
		return this.fieldKeyName;
	}
	
	public void setFieldValue(String field){
		this.fieldValueName = field;
	}
	
	public String getFieldValue(){
		return this.fieldValueName;
	}
	
	public void setTableGroup(String table){
		this.tableGroup = table;
	}
	
	public String getTableGroup(){
		return this.tableGroup;
	}
	
	public void setFormulaList(String field){
		this.formulaList = this.setStrCol(field);
	}
	
	public String getFormulaList(){
		return this.formulaList;
	}
	
	public void setCaptionList(String field){
		this.captionList = this.setStrCol(field);	
	}
	
	public String getCaptionList(){
		return this.captionList;
	}
	
	public void setFilterPayrollGroup(String filter){
		this.filter = filter;
	}
	
	public String getFilterPayrollGroup(){
		return this.filter;
	}
	
	public DbRecord getDbPRGroup(){
		return this.dbPRGroup;
	}
		
	public void setPayrollGroupToHash(){		
		try {											
			DbInquiry inq = new InitialInquiry(this.up).getDbInquiry();
			inq.setSchemaName(this.up.getSchemaName());
			inq.initMyTable(this.tableGroup,this.filter,"");
			inq.setColumn("*");				
			inq.setParam(this.param);
			inq.refresh();	
			while (inq.next()){
				 this.dbPRGroup = inq.getCurrentDbRecord();						 
			}			
		} catch (Exception e) {e.printStackTrace();}		
	}
	
	public String setStrCol(String str){
		String formulaStr="";
		for (int i=1;i<=40;i++){
			if (i==1){
				formulaStr = str+"01,";
			} else if (i>1&&i<=9){
				formulaStr = formulaStr+str+"0"+i+",";
			} else {
				formulaStr = formulaStr+str+i+",";
			}
		}
		return formulaStr;
	}
	
	public void setDataToCol(DbRecord rec){	
		StringTokenizer st,stChkFormula,stPyGroup;
		String keyFormula,tmpFormula="",pyGroup;
		try {								
			
			st = new StringTokenizer(rec.getString(this.fieldKeyName),",");					
			while (st.hasMoreTokens()){
				keyFormula = st.nextToken().toString();
				stChkFormula = new StringTokenizer(this.formulaList,",");
				while (stChkFormula.hasMoreTokens()){					
					tmpFormula = stChkFormula.nextToken().toString();							
					stPyGroup = new StringTokenizer(this.dbPRGroup.getString(tmpFormula),",");
					while (stPyGroup.hasMoreTokens()){		
						pyGroup = stPyGroup.nextToken().toString();					
						if (keyFormula.equalsIgnoreCase(pyGroup)){
							if (this.hm_Col.get(tmpFormula)==null){
								this.newData(rec,keyFormula,tmpFormula);
							} else {
								this.plusminusData(rec,keyFormula,tmpFormula);
							}
						}						
					} //End while (stPyGroup.hasMoreTokens()) --> get from PAYROLL_GROUP
				} //End while (stChkFormula.hasMoreTokens()) --> formula01,formula02				
			} //End while (st.hasMoreTokens()) --> OT,WAGE			
		} catch (Exception e) {
			System.out.println("---> ERROR ---> "+tmpFormula);
			e.printStackTrace();
		}
	}
	
	private void newData(DbRecord rec,String keyFormula,String tmpFormula){
		try {
			double value=0;
			if (!rec.getString(this.fieldValueName).equalsIgnoreCase("")){
				value = Double.parseDouble(rec.getString(this.fieldValueName));																		
			}
			this.hm_Col.put(tmpFormula,new Double(value));
		} catch (RemoteException e) {e.printStackTrace();}
	}
	
	private void plusminusData(DbRecord rec,String keyFormula,String tmpFormula){
		try {
			double value=0,oldValue=0;
			if (!rec.getString(this.fieldValueName).equalsIgnoreCase("")){
				value = Double.parseDouble(rec.getString(this.fieldValueName));
			}
			oldValue = ((Double) this.hm_Col.get(tmpFormula)).doubleValue(); 			
			this.hm_Col.put(tmpFormula,new Double(oldValue+value));
		} catch (RemoteException e) {e.printStackTrace();}
	}
	
	public void setDataToColTotal(){
		try {
			String tmpFormula,pyGroup;
			StringTokenizer stChkFormula,stPyGroup;
						
			stChkFormula = new StringTokenizer(this.formulaList,",");
			while (stChkFormula.hasMoreTokens()){			
				tmpFormula = stChkFormula.nextToken().toString();			
				stPyGroup = new StringTokenizer(this.dbPRGroup.getString(tmpFormula),",");			
				while (stPyGroup.hasMoreTokens()){						
					pyGroup = stPyGroup.nextToken().toString();															
					if ((pyGroup.length()==5)&&(pyGroup.substring(0,3)).equalsIgnoreCase("COL")){
						this.setDataColToHash(tmpFormula,pyGroup);
					} 						
				} //End while (stPyGroup.hasMoreTokens())
			} //End while (stChkFormula.hasMoreTokens())
		} catch (Exception e) {e.printStackTrace();}
	}	
	
	public void setDataColToHash(String tmpFormula,String pyGroup){						
		String formula = "formula"+pyGroup.substring(3,5);		
		if (this.hm_Col.get(tmpFormula)==null){						
			this.hm_Col.put(tmpFormula,this.hm_Col.get(formula));				
		} else {
			double oldValue = ((Double) this.hm_Col.get(tmpFormula)).doubleValue();	
			double newValue = 0;
			if (this.hm_Col.get(formula)!=null){
				newValue = ((Double) this.hm_Col.get(formula)).doubleValue(); 				
			}
			this.hm_Col.put(tmpFormula,new Double(oldValue + newValue));
		}		
	}	
	
	public void setCaptionToCol(){	
		try {
			if (this.dbPRGroup==null) return; 
			String tmpCaption;
			StringTokenizer stCaption = new StringTokenizer(this.captionList,",");
			while (stCaption.hasMoreTokens()){					
				tmpCaption = stCaption.nextToken().toString();
				this.hm_Col.put(tmpCaption,this.dbPRGroup.getString(tmpCaption));
			}
		} catch (RemoteException e) {e.printStackTrace();}
	}
	
	public void getColList(){
		Iterator it = this.hm_Col.keySet().iterator();
		while (it.hasNext()){
			String col = it.next().toString();
			MyLog.info(this, this.up, "+++++ col = "+col+" +++++ value = "+this.hm_Col.get(col));
		}
	}	
	
	
}
