package com.csc.library.database;

import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.session.DbRecord;
import com.csc.library.utilities.MyLog;

/**
 * @author developer11
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SimXMLRecord extends SimRecord {
	public String fileXml;	
	public SimXMLRecord(String a, String b){
		super(a,b);
	}
	
	public void setProperties() {
		super.setProperties();
		this.loadSimXmlEnv(fileXml);
	}
	
	public void loadSimXmlEnv(String fileName){ 			
		LoadSimXml lsx = new LoadSimXml();				
		lsx.initEnv(this.getUProfile().getDbName());
		lsx.setFileName(fileName);	
		this.setHTable(lsx.getSimHash());					
	}
	
	public FieldManager getField(String fieldName) {		
		String tName,fName;		
		if (this.mf.get(fieldName)!=null){	
			return (FieldManager) this.mf.get(fieldName);			
		}
		else {						
			if (fieldName.indexOf(".")>0){				
				tName = fieldName.substring(0,fieldName.indexOf(".")).toLowerCase();
				fName = fieldName.substring(fieldName.indexOf(".")+1,fieldName.length()).toLowerCase();
				return this.getSimField(tName,fName);
			}
			else return (FieldManager) this.mf.get(fieldName);	
		}				
	}
	
	private void actRecord(){
		String tableName,fieldName;
		FieldManager fieldM;
		DbRecord simRecord;
		Iterator iField;
		StringTokenizer st;
		int status=0;
		
		Iterator iTable = this.getSimTableAll();
		while (iTable.hasNext()){
			tableName = iTable.next().toString().toLowerCase();
			simRecord = this.initRecord(tableName);
			try {
				String keyList = simRecord.getListKey();
				String keyField; 
				st = new StringTokenizer(simRecord.getListKey(),",");
        		while (st.hasMoreTokens()){
			    	keyField = st.nextToken().toLowerCase();	
			    	fieldM = this.getField(tableName+"."+keyField);
			    	if (fieldM.getString().equals("")) status=1; else status=0;
        		}
        		
        		if (status==1){
        			Hashtable hRela = this.getRelationInfo();		
        			if (hRela!=null){
        				Iterator iRela = hRela.keySet().iterator();
        				while (iRela.hasNext()){	        
        					String iRelaName = iRela.next().toString().toLowerCase();
        					Relation stRela =  this.getRelation(iRelaName);
        					
        					String parentTable = stRela.parentTableName.toLowerCase();
        					DbRecord parentRec = this.initRecord(parentTable);        					
        					Vector vParent = stRela.parentField;
        					Vector vParentValue=new Vector();
        					String parentFieldValue;
        					for (int i=0;i<vParent.size();i++) {
        						String parentField = vParent.elementAt(i).toString().toLowerCase();
        						parentFieldValue = this.getString(parentField);
        						vParentValue.add(parentFieldValue);    						
        					}
        														
        					String childTable = stRela.childTableName.toLowerCase();
        					DbRecord childRec = this.initRecord(childTable);
        					FieldManager childM;
        					Vector vChild = stRela.childField;
	        				for (int i=0;i<vChild.size();i++) {
	        					String childField = vChild.elementAt(i).toString().toLowerCase();     	    					
        						childM = childRec.getField(childField);
        						childRec.set(childField,vParentValue.elementAt(i).toString()); 
        						
        						MyHashMap childHash = this.getSimRecord(childTable);
        						simRecord.getField(childField);
        						simRecord.set(childField,vParentValue.elementAt(i).toString());  
        						
        						childM = this.getField(childTable+"."+childField);
        						this.set(childTable+"."+childField,vParentValue.elementAt(i).toString());     
        						childHash.put(childField,childM);        						        						
	        				}    	    				
        				}//End iRela.hasNext()
        				
					iField = this.getFieldSimListKey(tableName);					
					while (iField.hasNext()){
						fieldName = iField.next().toString().toLowerCase();
						fieldM = this.getField(tableName+"."+fieldName);	
						simRecord.set(fieldName,fieldM.getString());		
					}		
					simRecord.save();		
        			}//End hRela!=null        			
        		}
        		else{
        			//------------------ Code For Save With Not Relation
        			iField = this.getFieldSimListKey(tableName);	
					while (iField.hasNext()){
						fieldName = iField.next().toString().toLowerCase();
						fieldM = this.getField(tableName+"."+fieldName);		
						simRecord.set(fieldName,fieldM.getString());		
					}							
					simRecord.save();
					//----------------- End Code For Save With Not Relation
        		}        		
			} catch (Exception e) {
				MyLog.error(this, e);
			}		
		}
	}
	
	protected void saveRecord() {	
		try {
			super.saveRecord();		
		} catch (Exception e) {}	
		this.actRecord();
	}
		
	protected void updateRecord() {	
		try {
			super.updateRecord();
		} catch (SQLException e) {
			MyLog.error(this, this.getUProfile(), e);
		}		
		this.actRecord();
	}	

}
