package com.csc.library.database;

import java.util.Enumeration;
import java.util.Hashtable;

import com.csc.library.summary.SumManager;
import com.csc.library.utilities.MyLog;

public class SumReport extends Hashtable {

	public float getValue(Object key) {
		float v = 0;
		if (key instanceof String) {
			SumManager s = (SumManager) super.get(key);
			if (s != null) {
				v = s.getAmount();
			} else {
				MyLog.error(this, "Could not find this key!  " + (String) key);
			}
		} else {
			MyLog.error(this, "You have to use String to be key only!");
		}
		return v;
	}

	public float getOldValue(Object key) {
		float v = 0;
		if (key instanceof String) {
			SumManager s = (SumManager) super.get(key);
			if (s != null) {
				v = s.getOldAmount();
			} else {
				MyLog.error(this, "Could not find this key!  " + (String) key);
			}
		} else {
			MyLog.error(this, "You have to use String to be key only!");
		}
		return v;
	}

	public synchronized Object put(Object key, Object value) {
		Object o = null;
		int i = 0;
		if (value instanceof SumManager && key instanceof String) {
			o = super.put(key, value);
		}
		return o;
	}

	public void calculate(MyInquiry q) {
		SumManager s;
		for (Enumeration enums = this.keys(); enums.hasMoreElements();) {
			s = (SumManager) this.get((String) enums.nextElement());
			s.keepAmount();
			if (s.clearCondition(q))
				s.clear();
			if (s.sumCondition(q))
				s.sum(q);
		}
	}

	public void printAmount() {
		SumManager s;
		String key;
		for (Enumeration enums = this.keys(); enums.hasMoreElements();) {
			key = (String) enums.nextElement();
			s = (SumManager) this.get(key);
			MyLog.error(this, key + ":" + String.valueOf(s.getAmount()) + ":");
		}
	}

	public void printOldAmount() {
		SumManager s;
		String key;
		for (Enumeration enums = this.keys(); enums.hasMoreElements();) {
			key = (String) enums.nextElement();
			s = (SumManager) this.get(key);
			MyLog.error(this, key + ":" + String.valueOf(s.getOldAmount()) + ":");
		}
	}

	public void clearAll() {
		SumManager s;
		String key;
		for (Enumeration enums = this.keys(); enums.hasMoreElements();) {
			key = (String) enums.nextElement();
			s = (SumManager) this.get(key);
			s.clear();
		}
	}
}
