package com.csc.library.entry;

import java.util.StringTokenizer;
import com.csc.library.utilities.MyLog;

/**
 * @author James
 * EmvHelpEntry  Employee View
 */
public class EmvHelpEntry extends HelpEntry {

	public EmvHelpEntry() {
		super();
	}
	

    
    public String printTableHTML() {
         this.setTable();
         return this.charCode("point6", this.tableHTML);
     }    
    
    
    public void setTable() {
		try {
			
			StringBuilder contentHTML = new StringBuilder();
			String columnLabel, columnValue;
			String table, field;
			String tableName = "MyTable";
			String returnValue = "";
			int orderField = 0;
			int numField = 0;
			String style = "coumn-text";
			StringTokenizer token1 = new StringTokenizer(this.showList, ",");
			numField = token1.countTokens();
				
			contentHTML.append("<table class=\"table-help-list\"  width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" ");
			contentHTML.append("id=\"").append(tableName).append("\" ");
			contentHTML.append("name=\"").append(tableName).append("\" ");
			contentHTML.append("cols=\"").append((numField + 1)).append("\" >").append( this.nextline );
			

			contentHTML.append("<tr>").append( this.nextline );

			// set header row
			for (; token1.hasMoreTokens();) {
				table = token1.nextToken();
				field = table.substring(table.indexOf(".") + 1);
				table = table.substring(0, table.indexOf("."));
				columnLabel = this.getStringfm(table, field, "desc", false); //column header
				
				contentHTML.append("<td class=\"column-header\" >");
				contentHTML.append( columnLabel );
				contentHTML.append("</td>").append( this.nextline );
				orderField++;
			}
			
			contentHTML.append("</tr>").append( this.nextline ); // close header row 
			
			// for set data 
			
			this.setPeriodRows();
	        
	        inq.first();    
			if (inq.recCount() > 0) {

				while (inq.next()) {
//					if ((inq.recNo() <= (maxLine * Integer.parseInt(goPage))) && (inq.recNo() > (maxLine * (Integer.parseInt(goPage) - 1)))) {

						contentHTML.append("<tr>").append( this.nextline );
						
						for (StringTokenizer token = new StringTokenizer(this.showList, ","); token.hasMoreTokens();) {
							table = token.nextToken();
							field = table.substring(table.indexOf(".") + 1);
							table = table.substring(0, table.indexOf("."));
							columnValue = this.getStringfm(table, field, "value", false);
							
							if (!this.getStringfm(table, field, "type", false).equalsIgnoreCase("String")) {
								style = "column-text-right";
							} else {
								style = "column-text";
							}
													 
							if (this.checkReturn(field)) {
								returnValue = this.returnHelp(table);
								contentHTML.append("<td class=\"").append( style ).append("\" >");
								contentHTML.append( this.getLinkTag(returnValue, columnValue )  );
								contentHTML.append("</td>").append( this.nextline );	
							} else {
								contentHTML.append("<td class=\"").append( style ).append("\" >");
								contentHTML.append( columnValue );
								contentHTML.append("</td>").append( this.nextline );
							}
						}

						contentHTML.append("</tr>").append( this.nextline );
					}
//					if (inq.recNo() > (maxLine * Integer.parseInt(goPage))) {
//						break;
//					}
//				}
			} else { 
				// not found date print empty row
				for (int i = 0; i < numField; i++) {
					contentHTML.append("<td  class=\"column-text\" >&nbsp;</td>").append( this.nextline );
				}
			}
			
			contentHTML.append("</table>");
			this.tableHTML = contentHTML.toString();
			
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
    
    public String getPageTag(){
    	
	    StringBuffer contentHTML = new StringBuffer();
	    
	    int max_page =this.getMaxPage();
	    int current_page = 1;
	    
	    try{
	    	current_page= Integer.parseInt(currentPage.trim());
	    }catch(Exception e){
	    	current_page = 1;	    	
	    }
	    
       	// first page
		if( current_page < 2 ){
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/FIRST.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"First page\"  />" );
		}else {
			contentHTML.append( "<a href=\"javascript:goPage('+1');\">");
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/FIRST.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"First page\"  />");
			contentHTML.append( "</a>");
		}
		
		// previous page
		if ( current_page < 2 ){
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/BACK.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"Previous page\"  />" );
		}else {
			contentHTML.append( "<a href=\"javascript:goPage('+").append( current_page-1 ).append("');\">");
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/BACK.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"Previous page\"  />" );
			contentHTML.append("</a>") ;
		}
		
	    // generate dropdown
	    contentHTML.append( "<select name=\"listpage\" id=\"listpage\" onChange=\"goPage(this.value)\" >").append( this.nextline );
        for( int page = 1 ; page <= max_page ; page++ ){
        	contentHTML.append("<option value=\"+").append( page ).append( "\"" );
        	if( current_page == page ){
        		contentHTML.append(" selected");
        	 }
        	 contentHTML.append( ">" );
        	 contentHTML.append( page );
        	 contentHTML.append("</option>" ).append( this.nextline );
         }
         contentHTML.append("</select>").append( this.nextline );

        // next page
		if( current_page >= max_page ){
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/NEXT.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"Next page\"  />");
		}else {
			contentHTML.append( "<a href=\"javascript:goPage('+").append( current_page+1 ).append("');\">");
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/NEXT.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"Next page\"  />");
			contentHTML.append( "</a>") ;
		}
		
		// last page
		if( current_page >= max_page ) {
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/LAST.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"Last page\"  />" );
		}else{
			contentHTML.append( "<a href=\"javascript:goPage('+").append( max_page) .append("');\">" );
			contentHTML.append( "<img src=\"../IMAGES/MYNOTE/LAST.gif\" width=\"14\" height=\"14\" border=\"0\" align=\"absmiddle\" alt=\"Last page\"  />" );
			contentHTML.append( "</a>" );
		}
						
		return contentHTML.toString();
    }
    
}
