package com.csc.library.entry;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;

import com.csc.library.components.Component;
import com.csc.library.components.ComponentManager;
import com.csc.library.components.TagManager;
import com.csc.library.database.FieldManager;
import com.csc.library.database.RecordManager;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyEnvironment;
import com.csc.library.utilities.MyFont;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ThaiUtilities;
public class MultiLine implements Serializable {
	MyEnvironment env;
	transient CscCalendar cscDate;
	MyFont lFont, iFont;
	String laBox = "";
	RecordManager rec=null;
	DbTable tab;
	int recCount = 0;
	String sign = "__";
	Hashtable boxLine;
	HashMap param;
	public MultiLine(DbTable tableName) {
		this.tab = tableName;
		cscDate = new CscCalendar();
		boxLine = new Hashtable();
	}
	// ball edit
	public void setChannel(HashMap param) throws Exception {
		this.param = param;
		this.tab.setParam(this.param);
		boxLine.put(String.valueOf(1), "");
		DbRecord rec = null;
		String value, nameField, keyBoxLine = "", tmp1 = "";
		String cmd = this.getValue("cmd");
		this.tab.setParam(this.param);
		if((!cmd.equals(""))&&(!cmd.equalsIgnoreCase("null"))){
		if (cmd.equalsIgnoreCase("addChild")) {
				rec = this.tab.getNewRecord();
				//rec.setParam(this.param);
				rec.set(this.tab.getMinorKey(), this.getValue("minorkey"));
				this.tab.putNewRecord(rec);
		}
		for (Iterator e = param.keySet().iterator(); e.hasNext();) {
			nameField = (String) e.next();
			value = this.getValue(nameField.substring(2));
			if (nameField.indexOf("$") > 0) {
				this.setValue(nameField.substring(2), value);
			}
			if (!value.equals("")) {
				if (cmd.equalsIgnoreCase("DelChild")) {
					if ((nameField.indexOf(":") > 0)) {
						if (this.findByMinorKey(value)) {
							this.tab.deleteRecord();
						}
						this.boxLine.remove(nameField.substring(2));
					}
					cscDate = new CscCalendar();
					this.clsLineBox();
				} else {
					if (keyBoxLine.indexOf(nameField.substring(2)) >= 0) {
						for (StringTokenizer token = new StringTokenizer(keyBoxLine, ","); token.hasMoreTokens();) {
							tmp1 = token.nextToken();
							if (tmp1.equalsIgnoreCase(nameField.substring(2)))
								this.setCheck(tmp1, value);
						} // for
					} // if
				} // end if
			} // if
		} // for
		}
		
	}
	// ball edit
	private boolean findByMinorKey(String minorKey) {
		boolean found = false;
		try {
			this.tab.goRec(1, false);
			for (int i= 1; !this.tab.eof();) {
				if (this.tab.getStringHTML(this.tab.getMinorKey()).equalsIgnoreCase(minorKey)) {
					found = true;
					break;
				}
				 this.tab.goRec(++i, false);
			}
		} catch (Exception ex) {
			MyLog.error(this, this.rec.getUProfile(), ex);
		}
		return found;
	}
	public void goFirst() {
		try {
			this.tab.first();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getValue(String nameField) throws Exception {
		String temp = "";
		if (((String) this.param.get(this.sign + nameField) != null) && (((String) this.param.get(this.sign + nameField)).length() > 0)) {
			temp = this.charCode("point5", this.param.get(this.sign + nameField).toString());
		}
		if (temp.length() > 0)
			temp = temp.trim();
		return temp;
	} // end getValue

	public void setLabelBox(String labelBox) {
		this.laBox = labelBox;
	}

	public void setCheck(String name, String check) {
		/*checkbox chBox;

		  chBox = (checkbox)boxLine.get(name);
		  chBox.setChecked(check);
		  boxLine.put(chBox.name,chBox);*/

	}

	public void clsLineBox() {
		this.boxLine.clear();
	}
	// ball edit
	private String getCheckBox(String minorKey) {
		String checkb = "";
		try {
			if (boxLine.containsKey(this.tab.getTableName() + ":" + minorKey)) {
				checkb = (String) boxLine.get(this.tab.getTableName() + ":" + minorKey);
			} else {
				checkb =
					"<input type=\"" + "checkbox" + "\" name=\"__" + this.tab.getTableName() + ":" + minorKey + "\" value=\"" + minorKey + "\"   >";
				boxLine.put(this.tab.getTableName().trim() + ":" + minorKey.trim(), checkb);
			} // if
		} catch (Exception e) {
			MyLog.error(this, this.rec.getUProfile(), e);
		}
		return checkb;
	}
	// ball edit
	public String getInputCheckBox() {
		try {
			return this.getCheckBox(this.tab.getStringHTML(this.tab.getMinorKey()));
		} catch (Exception e) {
			MyLog.error(this, this.rec.getUProfile(), e);
		}
		return "";
	}

        private String  checkReadonly(String readonly){
          if(readonly.toLowerCase().indexOf("readonly")== -1){
            if (readonly.toLowerCase().indexOf("<input") != -1) {
              readonly = readonly.substring(0,"<input ".length()) +" READONLY " + readonly.substring("<input ".length(),readonly.length());
            }else if (readonly.toLowerCase().indexOf("<textarea ") != -1) {
               readonly = readonly.substring(0,"<textarea ".length()) +" READONLY " + readonly.substring("<textarea ".length(),readonly.length());
             }else if (readonly.toLowerCase().indexOf("<select ") != -1) {
                readonly = readonly.substring(0,"<select ".length()) +" DISABLED " + readonly.substring("<select ".length(),readonly.length());
             }
          }
          return readonly;
        }

	//ball edit 18-09-03
	public String getInput(String tableName, String field) {
		TagManager tag =null;
		try {
		ComponentManager comM = this.getField(tableName, field);
		Component com = new Component();
		com.process(comM);
			tag = com.getTag();

			tag.setName(tableName + "$" + field + "$" + this.tab.getString(this.tab.getMinorKey()));
			tag.process();
		} catch (Exception ex) {
			MyLog.error(this, this.rec.getUProfile(), ex);
			return "";
		}

		return tag.getInput();
	}

    /*  public String getInput(String tableName, String field){
        String reGetInput="";
        try {
          if (this.getValue("singledisabled").equalsIgnoreCase("true")) {
            reGetInput=this.getData(tableName, field);
          }
          else if (this.getValue("singlereadonly").equalsIgnoreCase("true")) {
            ComponentManager comM = this.getField(tableName, field);
            Component com = new Component();
            com.setFont(new MyFont(), new MyFont());
            com.process(comM);
            TagManager tag = com.getTag();
            try {
              tag.setName(tableName + "$" + field + "$" +
                          this.tab.getString(this.tab.getMinorKey()));

            }
            catch (Exception ex) {
              ex.printStackTrace();
            }
            tag.process();
            reGetInput= this.checkReadonly(tag.getInput());
          }
          else {
            ComponentManager comM = this.getField(tableName, field);
            Component com = new Component();
            com.setFont(new MyFont(), new MyFont());
            com.process(comM);
            TagManager tag = com.getTag();
            try {
              tag.setName(tableName + "$" + field + "$" +
                          this.tab.getString(this.tab.getMinorKey()));

            }
            catch (Exception ex) {
              ex.printStackTrace();
            }
            tag.process();
        reGetInput= tag.getInput();
          }
        }
        catch (Exception ex1) {
         return "";
        }
        return reGetInput;
      }
     */
	//ball edit 18-90-03
	private void setValue(String field, String data) {
		String tableName = "", fieldName = "", minorKey = "";
		StringTokenizer token = new StringTokenizer(field, "$");		
		if (token.hasMoreTokens())
			tableName = token.nextToken();
		if (token.hasMoreTokens())
			fieldName = token.nextToken();
		if (token.hasMoreTokens())
			minorKey = token.nextToken();
		if (this.findByMinorKey(minorKey)) {
			try {
				this.tab.set(fieldName, data);
			} catch (Exception ex) {
				MyLog.error(this, this.rec.getUProfile(), ex);
			}
		}
	}
	public String getLabelCheckBox() {
		return this.laBox;
	}

	public void next() {
		try {
			tab.next();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public boolean eof() {
		try {
			return tab.eof();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

private ComponentManager getField(String tableName, String FieldName) {
		DbRecord rectemp;
		try {
			/**** ball edit 23-09-03 ****/
			if ((tableName != null) && (!tableName.equals("")) && (!this.tab.getTableName().equalsIgnoreCase(tableName))) {
				/*****************************/
                                if( this.tab.getChild(tableName) instanceof DbRecord){
                                  rectemp = (DbRecord)this.tab.getChild(tableName);
                                }else{
                                  if (this.tab.getChild(tableName) instanceof DbInquiry){
                                    rectemp = ((DbInquiry)this.tab.getChild(tableName)).getCurrentDbRecord();
                                  }else{
                                    rectemp = ((DbTable)this.tab.getChild(tableName)).getCurrentRecordManager();
                                  }
                                }

				return (ComponentManager) rectemp.getField(FieldName);
			} else {
				return (ComponentManager) this.tab.getCurrentRecordManager().getField(FieldName);
			} // end if
		} catch (Exception e) {
			MyLog.error(this, this.rec.getUProfile(), e);
			return null;
		}
	}

	private String genLabel(String tableName, String FieldName) {
		ComponentManager comM = this.getField(tableName, FieldName);
		Component com = new Component();
		com.process(comM);
		TagManager tag = com.getTag();
		try {
			tag.setName(tableName + "$" + FieldName + "$" + this.tab.getStringHTML(this.tab.getMinorKey()));

		} catch (Exception ex) {
			MyLog.error(this, this.rec.getUProfile(), ex);
		}
		tag.process();
		return tag.getLabel();
		
	}

	public String getLabel(String FieldName) {
		return this.genLabel("", FieldName);
	}

	public String getLabel(String tableName, String FieldName) {

		return this.genLabel(tableName, FieldName);
	}

	public String getData(String FieldName) {
		return this.charCode("point6", this.getField("", FieldName).getStringHTML());
	}

	public String getData(String tableName, String FieldName) {
		try {
			return this.charCode("point6", this.getField(tableName, FieldName).getStringHTML());
		} catch (RuntimeException e) {
			MyLog.error(this, this.rec.getUProfile(), "getData========table name:"+tableName+" FieldName ==: "+ FieldName);
			MyLog.error(this, this.rec.getUProfile(), e);
			return null;
		}
	}

	public String getDataLabel(String FieldName) {
//		return this.getField("", FieldName).getString();
		return this.getField("", FieldName).getStringHTML();
	}

	public String getDataLabel(String tableName, String FieldName) {
//		return this.getField(tableName, FieldName).getString();
		return this.getField(tableName, FieldName).getStringHTML();
	}

	public String getDateLabel(String FieldName) {
		return ((FieldManager)this.getField("", FieldName)).getcscCalendar().getString();
	}

	public String getDateLabel(String tableName, String FieldName) {
		return ((FieldManager)this.getField(tableName, FieldName)).getcscCalendar().getString();
	}

	public String getScript(String method, String Label) {
		try {
			return "<A HREF=\"javascript:" + method + "('" +this.tab.getString(this.tab.getMinorKey()) + "');\">" + Label + "</A>";
		} catch (Exception e) {
			MyLog.error(this, this.rec.getUProfile(), e);
		}
		return null;
	}

//	public String printTableHTML(String method, String fieldScript, String fieldList) {
//		DbRecord recordM;
//		String tableHTML = "", tmp1;
//		Label laCheckBox = new Label();
//		laCheckBox.setLabelFont(this.lFont);
//		laCheckBox.setLabel(this.getLabelCheckBox());
//
//		tableHTML = "<table width=\"0%\" border=\"0%\" cellspacing=\"3\" cellpadding=\"1\" align=\"center\">";
//		tableHTML = tableHTML + "<tr>";
//		tableHTML = tableHTML + "<td>";
//		tableHTML = tableHTML + laCheckBox.process();
//		tableHTML = tableHTML + "</td>";
//		// this.goFirst();
//		for (StringTokenizer token = new StringTokenizer(fieldList, ","); token.hasMoreTokens();) {
//			tmp1 = token.nextToken();
//			tableHTML = tableHTML + "<td>";
//			tableHTML = tableHTML + this.getLabel(tmp1);
//			tableHTML = tableHTML + "</td>";
//		} // for
//		tableHTML = tableHTML + "</tr>";
//		this.goFirst();
//		for (; !this.eof();) {
//			tableHTML = tableHTML + "<tr>";
//			tableHTML = tableHTML + "<td>";
//			tableHTML = tableHTML + this.getInputCheckBox();
//			tableHTML = tableHTML + "</td>";
//			for (StringTokenizer token = new StringTokenizer(fieldList, ","); token.hasMoreTokens();) {
//				tmp1 = token.nextToken();
//				tableHTML = tableHTML + "<td>";
//				if (fieldScript.equalsIgnoreCase(tmp1))
//					tableHTML = tableHTML + this.getScript(method, this.getDataLabel(tmp1));
//				else
//					tableHTML = tableHTML + this.getDataLabel(tmp1);
//				tableHTML = tableHTML + "</td>";
//			} //for
//			tableHTML = tableHTML + "</tr>";
//			this.next();
//		} // for
//		tableHTML = tableHTML + "</table>";
//		// this.logger.info("tableHTML = "+tableHTML);
//		return tableHTML;
//	}
	public String printTableHTML(String method, String fieldScript, String fieldList) {
		DbRecord recordM;
		String tableHTML = "", tmp1;

		tableHTML = "<table width=\"0%\" border=\"0%\" cellspacing=\"3\" cellpadding=\"1\" align=\"center\">";
		tableHTML = tableHTML + "<tr>";
		tableHTML = tableHTML + "<td>";
		tableHTML = tableHTML + this.getLabelCheckBox();
		tableHTML = tableHTML + "</td>";
		// this.goFirst();
		for (StringTokenizer token = new StringTokenizer(fieldList, ","); token.hasMoreTokens();) {
			tmp1 = token.nextToken();
			tableHTML = tableHTML + "<td>";
			tableHTML = tableHTML + this.getLabel(tmp1);
			tableHTML = tableHTML + "</td>";
		} // for
		tableHTML = tableHTML + "</tr>";
		this.goFirst();
		for (; !this.eof();) {
			tableHTML = tableHTML + "<tr>";
			tableHTML = tableHTML + "<td>";
			tableHTML = tableHTML + this.getInputCheckBox();
			tableHTML = tableHTML + "</td>";
			for (StringTokenizer token = new StringTokenizer(fieldList, ","); token.hasMoreTokens();) {
				tmp1 = token.nextToken();
				tableHTML = tableHTML + "<td>";
				if (fieldScript.equalsIgnoreCase(tmp1))
					tableHTML = tableHTML + this.getScript(method, this.getDataLabel(tmp1));
				else
					tableHTML = tableHTML + this.getDataLabel(tmp1);
				tableHTML = tableHTML + "</td>";
			} //for
			tableHTML = tableHTML + "</tr>";
			this.next();
		} // for
		tableHTML = tableHTML + "</table>";
		return tableHTML;
	}



	public DbTable getTable() {
		return this.tab;
	}

	public String charCode(String point, String dataCon) {
		String convert = dataCon;
		if (point.equals("point5")) {
			ThaiUtilities thaicode = new ThaiUtilities();
			convert = thaicode.ASCII2Unicode(dataCon);
		}
		return convert;
	}
	
	/**
	 * getRequire use to get lists of require field for multiline
	 * @return list of require field
	 */
	public String getRequire() {
        StringBuilder data = new StringBuilder();
        try {
        	String[] tmp = this.getTable().getCurrentRecordManager().listField("require").split(",");
        	for(int i=0; i< tmp.length; i++) {
        		data.append( this.tab.getTableName()).append("$").append(tmp[i]).append("$").append(",");
        	}
        } catch (Exception e) {
			MyLog.error(this, this.tab.getUProfile(), e);
        }
        return data.toString();
    }

}
