package com.csc.library.entry;

import java.rmi.RemoteException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.components.Component;
import com.csc.library.components.Label;
import com.csc.library.components.ListBox;
import com.csc.library.components.Text;
import com.csc.library.database.ChildManager;
import com.csc.library.database.FieldDate;
import com.csc.library.database.Relation;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.ConvertHTML;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyFont;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ThaiUtilities;
import com.csc.library.utilities.UProfile;
public class MyEntry {
	transient CscCalendar startActive, lastActive;
	HashMap param;
	public UProfile user=null;
	String cmd, type;
	String parentName;
	public String mess = "";
	DbRecord myRec=null;
	DbTable myTab;
	final String sign = "__";
	Component com = new Component();
	MultiLine multi;
	InitialEnvironment env;
	protected String fixCon;
	public String valueSearch;
	public String searchBy;
	public String conSearch;
	protected String childFilter = "";
	public DbInquiry inq;
    String keyConfirm = "3";
    protected boolean isSim=false;


	public MyEntry() {}

	public MultiLine getMultiLine(String nametable) {
		return multi;
	}

	private String genLabel(String data) {
		Label label1 = new Label();
		label1.setLabel(data);
		return this.charCode("point6", label1.process());
	}
//15/03/04
/*
	public String getDataLabel(String FieldName) {
		String data = "";
		try {
			data = this.genLabel(this.myRec.getString(FieldName));
		} catch (Exception e) {
			e.printStackTrace();
		}
		return data;
	}*/
   public String getDateLabel(String nameField) {
	String data = "";
	try {
		data = this.charCode("ponit6", this.myRec.getField(nameField).getcscCalendar().getString());
	} catch (Exception e) {
		MyLog.error(this, this.getUProfile(), e);
	}
	return data;
}

public String getDateLabel(String tableName, String nameField) {
	String data = "";
	try {
		try {
			DbRecord db = (DbRecord) this.myRec.getChild(tableName.toLowerCase());
			data = this.charCode("ponit6", db.getString(nameField));
		} catch (ClassCastException e) {
			DbInquiry di = (DbInquiry) this.myRec.getChild(tableName.toLowerCase());
			data = this.charCode("ponit6", di.getCurrentDbRecord().getField(nameField).getcscCalendar().getString());
		}
	} catch (Exception e) {
		MyLog.error(this, this.getUProfile(), e);
	}
	return data;
}
	/*public DbRecord getRecord(String name) {
		DbRecord rec = null;
		try {
			if (myRec.getTableName().equalsIgnoreCase(name)) {
				rec = myRec;
			} else {
				rec = (DbRecord)myRec.getChild(name);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return rec;
	}*/
	public DbRecord getRecord(String name) {
		DbRecord rec = null;
		Object ch;
		try {
			if (myRec.getTableName().equalsIgnoreCase(name)) {
				rec = myRec;
			} else {
				ch=myRec.getChild(name);
				if(ch instanceof DbRecord)
					rec=(DbRecord)ch;
				else if(ch instanceof DbInquiry)	
					rec=((DbInquiry)ch).getCurrentDbRecord();
				else if(ch instanceof DbTable)	
					rec=((DbTable)ch).getCurrentRecordManager();
			}
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
		return rec;
	}

	public DbRecord getRecord() {
		return this.myRec;
	}

	public DbTable getTable(String name) {
		DbTable tm = null;
		try {
			tm = (DbTable) myRec.getChild(name);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return tm;
	}

	public void setTable(DbTable tab) {
		this.myTab = tab;
	}

	/*	public String getButtonSave() {
			Button butt = new Button();
			butt.setType("button");
			butt.setName("SAVE");
			butt.setValue("SAVE");
			try {
				butt.setInputFont(this.user.getInputFont());
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			butt.setonClick("javascript:save();");
			return butt.process();
		}
	
		public String getButtonSearch() {
			Button butt = new Button();
			butt.setType("button");
			butt.setName("search");
			butt.setValue("SEARCH");
			butt.setonClick("javascript:sarch();");
			try {
				butt.setInputFont(this.user.getInputFont());
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			return butt.process();
		}
	
		public String getButtonDelete() {
			Button butt = new Button();
			butt.setType("button");
			butt.setName("Delete");
			butt.setValue("Delete");
			try {
				butt.setInputFont(this.user.getInputFont());
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			butt.setonClick("javascript:edelete();");
			return butt.process();
		}
	*/
	public void setLastActive() {
		this.lastActive = new CscCalendar();
	}

	public void setStartActive() {
		this.startActive = new CscCalendar();
	}

	public String getType() {
		return this.type;
	}

	public void setUserProfile(UProfile pUser) {
		this.user = pUser;
	}

	public java.util.Date getStartActive() {
		return this.startActive.getSqlDate();
	}

	public CscCalendar getLastActive() {
		return this.lastActive;
	}

	public MyFont getLabelFont() {
		try {
			return this.user.getLabelFont();
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
			return null;
		}
	}

	public MyFont getInputFont() {
		try {
			return this.user.getInputFont();
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
			return null;
		}
	}

	public String getUserName() {
		try {
			return this.user.getUserName();
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
			return null;
		}
	}

	public String getValue(String nameField) {
		String temp = "";
		try {
			temp = this.charCode("5", (String) this.param.get(this.sign + nameField));
			if (temp == null)
				return "";
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(),"Parameter " + nameField + " param is empty in MyEntry:getValue() " + e.getMessage());
			MyLog.error(this, this.getUProfile(), e);
			return "";
		}
		return temp;
	}

	public String getShowValue(String nameField) throws Exception {
		String temp = "";
		if (((String) param.get(this.sign + nameField) != null) && (((String) param.get(this.sign + nameField)).length() > 0)) {
			temp = this.recharCode(env.getValue("charcode-point5"), (String) param.get(this.sign + nameField));
		}
		return temp;
	}

	protected String recharCode(String point, String dataCon) {
		String convert = dataCon;
		ThaiUtilities thaicode = new ThaiUtilities();
		convert = thaicode.ASCII2Unicode(dataCon);
		return convert;
	}

	public void setChannel(HashMap param) {
//		this.param=(HashMap)param.clone();
		this.param=param;
		//this.logger.info("Set Channel in Entry " + this.type);
		//this.getAndset();
	}

	public void getAndset() {}

	public UProfile getUProfile() {
		return this.user;
	}

	public String getMessage() {
		return this.mess;
	}

	public void setMessage(String message) {
		this.mess = message;
	}

	public void setParentName(String name) {
		this.parentName = name;
	}
	public String getParentName() {
		return this.parentName;
	}

	private String id() {
		try {
			return env.getValue("host-address");
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
			return null;
		}
	}

	private String port() {
		try {
			return ":" + env.getValue("host-port");
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
			return null;
		}
	}

	public String getURL() {
		return this.id() + this.port();

	}
	public String getIP() {
		return this.id();
	}

	private void initEnv() {
		try {
			//env = new InitialEnvironment(this.getValue("dbname")).getmyEnv();
			env = new InitialEnvironment("GLOBAL");
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
	}

	public String charCode(String point, String dataCon) {
		String convert = dataCon;
		if (point.equals("5")) {
			ThaiUtilities thaicode = new ThaiUtilities();
			convert = thaicode.ASCII2Unicode(dataCon);
		} else if (point.equals("6")) {
			ThaiUtilities thaicode = new ThaiUtilities();
			convert = thaicode.Unicode2ASCII(dataCon);
		} else if (point.equals("0")) {
			ThaiUtilities thaicode = new ThaiUtilities();
			convert = dataCon;
		} else {
			convert = dataCon;
		}
		return convert;
	}

	public String getInputDate(String status, String fieldname) {
		if (status.equalsIgnoreCase("D")) {
			Text txt = new Text();
			try {
				txt.setName(fieldname + "DD");
				txt.setLabel("Date ");
				txt.setValue(myRec.getCscCalendar(fieldname).getDD());
				txt.setMax("2");
				txt.setSize("2");
				txt.process();
			} catch (Exception e) {
				MyLog.error(this, this.getUProfile(), e);
			}
			return txt.getInput();
		} else if (status.equalsIgnoreCase("M")) {
			ListBox lst = new ListBox();
			try {
				lst.setName(fieldname + "MM");
				lst.setLabel("Month ");
				lst.setValidCode("monthcode");
				lst.setChecked(myRec.getCscCalendar(fieldname).getMM());
				lst.process();
			} catch (Exception e) {
				MyLog.error(this, this.getUProfile(), e);
			}
			return lst.getInput();
		} else {
			Text txt = new Text();
			try {
				txt.setName(fieldname + "YY");
				txt.setLabel("Year ");
				txt.setValue(myRec.getCscCalendar(fieldname).getEngYYYY());
				txt.setMax("4");
				txt.setSize("4");
				txt.process();
			} catch (Exception e) {
				MyLog.error(this, this.getUProfile(), e);
			}
			return txt.getInput();
		}
	}

	public void setFieldDate(String fieldname) throws Exception {
		String s = this.getValue(fieldname + "DD");
		s += "-" + this.getValue(fieldname + "MM");
		s += "-" + this.getValue(fieldname + "YY");
		myRec.set(fieldname, s);
	}
	
	 public void setSearch() {
	        try {
	        	ChildManager cmobj = null;
	        	if (this.myRec != null) {
	        		cmobj = (ChildManager) myRec;
	        	} else if (this.inq != null) {
	        		cmobj = (ChildManager) inq;
	        	} else if (this.myTab != null) {
	        		cmobj = (ChildManager) myTab;
	        	}
	        	MyLog.debug(this, this.getUProfile(), " ********  Debug Child Manager : " + cmobj);
	            String listCon = "";
	            Object obj = null;
	            if ((this.fixCon != null) && (!this.fixCon.equals("")) && (!this.fixCon.equals("null"))) {
	                listCon = fixCon;
	            }
	            if ((!this.valueSearch.equals("")) && (!this.searchBy.equals("")) && (!this.valueSearch.equals("null"))) {
	                if (this.searchBy.substring(0,this.searchBy.indexOf(".")).equalsIgnoreCase(cmobj.getTableName())) {
	                	if (cmobj instanceof DbRecord) {
	                		obj = (DbRecord)cmobj;
	                	} else if (cmobj instanceof DbInquiry) {
	                		obj = (DbRecord)this.inq.getCurrentDbRecord();
	                	} else if (cmobj instanceof DbTable) {
	                		obj = (DbRecord)this.myTab.getCurrentRecordManager();
	                	} 
	                	String valuesearch=this.valueSearch;
	                	String searchby=this.searchBy.substring(this.searchBy.indexOf(".") + 1);
	                	if(((DbRecord)obj).getField(searchby) instanceof FieldDate){
	                		CscCalendar cs=new CscCalendar(valuesearch);
	                		valuesearch=cs.getYYYYMMDD();
	                	}
	                    if ((listCon != null) && (!listCon.equals(""))) {
	                        if (this.conSearch.equals("like")) {
	                            listCon = "(" + listCon + ") and " + searchby + " " + this.conSearch + " '%" + valuesearch + "%'";
	                        } else {
	                            listCon = "(" + listCon + ") and " + searchby + " " + this.conSearch + " '" + valuesearch + "'";
	                        }
	                    } else {
	                        if (this.conSearch.equals("like")) {
	                            listCon = searchby + "  " + this.conSearch + " '%" + valuesearch + "%'";
	                        } else {
	                            listCon = searchby + "  " + this.conSearch + " '" + valuesearch + "'";
	                        }
	                    }
	                } else {
	                	if (cmobj instanceof DbRecord) {
	                		obj = cmobj.getChild(this.searchBy.substring(0, this.searchBy.indexOf(".")));
	                        if (this.conSearch.equals("like")) {
	                            ((DbRecord) obj).setFilter(this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '%" + this.valueSearch + "%'");
	                        } else {
	                            ((DbRecord) obj).setFilter(this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '" + this.valueSearch + "'");
	                        }
	                	} else if (cmobj instanceof DbInquiry) {
	                		obj = this.inq.getCurrentDbRecord().getChild(this.searchBy.substring(0, this.searchBy.indexOf(".")));
	                		String subQuery="";
	                		Relation rela=null;
	                		try{ 
	                			if(obj!=null){
	               				rela= ((DbInquiry) obj).getRelation(inq.getTableName());
	               				Vector vrela=rela.getVFieldListParent();
	                			Vector vparent=inq.getCurrentDbRecord().getAllFieldName();
	                			for(int i=0;i<vrela.size();i++){
	                				if(vparent.contains((String)vrela.get(i))){
	                					subQuery=(String)vrela.get(i)+" in (select "+(String)rela.getVFieldtListChild().get(i)+" from "+((DbInquiry)obj).getTableName()+" where ";
	                					break;
	                				}
	                			}
	                		  }
	                		}catch(Exception ex){
	                			MyLog.warn(this,this.getUProfile(),ex);
	                		}                		
	                        if (this.conSearch.equals("like")) {
	                            inq.setFilter(subQuery+" "+this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '%" + this.valueSearch + "%' "+((subQuery.length()>0)?")":""));
	                        } else {
	                            inq.setFilter(subQuery+" "+this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '" + this.valueSearch + "' "+((subQuery.length()>0)?")":""));
	                        }
	                	} else if (cmobj instanceof DbTable) {
	                		obj = this.myTab.getCurrentRecordManager().getChild(this.searchBy.substring(0, this.searchBy.indexOf(".")));
	                	}
	                }
	            }
	            if ((this.childFilter != null) && (!this.childFilter.equals("")) && (!this.childFilter.equals("null"))) {
	                for (StringTokenizer token = new StringTokenizer(this.childFilter, ";"); token.hasMoreTokens();) {
	                    for (StringTokenizer sub_token = new StringTokenizer(token.nextToken(), ":"); sub_token.hasMoreTokens();) {
	                    	if (cmobj instanceof DbRecord) {
	                        	obj = this.myRec.getChild(sub_token.nextToken());
	                        } else if (cmobj instanceof DbInquiry) {
	                        	obj = this.inq.getCurrentDbRecord().getChild(sub_token.nextToken());
	                        } else if (cmobj instanceof DbTable) {
	                        	obj = this.myTab.getCurrentRecordManager().getChild(sub_token.nextToken());
	                        }
	                    	
	                        if (obj instanceof DbRecord) {
	                            ((DbRecord) obj).setFilter(sub_token.nextToken());
	                        } else {
	                            if (obj instanceof DbInquiry) {
	                                ((DbInquiry) obj).setFilter(sub_token.nextToken());
	                            } else if (obj instanceof DbTable) {
	                            	((DbTable) obj).setFilter(sub_token.nextToken());
	                            }
	                        }
	                    }
	                }
	            }
	            if ((listCon != null) && (!listCon.equals("")) && (!listCon.equals("null"))) {
	            	if(cmobj instanceof DbInquiry ){
	            		if(((DbInquiry)cmobj).getFilter().trim().length()>0){
	            			cmobj.setFilter(((DbInquiry)cmobj).getFilter()+" and "+listCon);
	            		}else{
	            			cmobj.setFilter(listCon);
	            		}
	            	}
	            }
	        } catch (Exception e) {
				MyLog.error(this, this.getUProfile(), e);
	        }
	    }
	 
	 public String InitialVariable() {
	 	String data = "<input type=\"hidden\" name=\"__server_date\" value=\""+new CscCalendar().getYYYYMMDD()+"\">";
	 	String tablelist="";
	 	try {
	 		if(this.myRec!=null){
	 			tablelist = this.myRec.getTableName();
	 		}
	 		if(tablelist.length()>0){
	 			tablelist +=",";
	 		}
	 		if(this.myTab!=null){
	 			tablelist +=this.myRec.getTableName();
	 		}
		} catch (Exception e) {
		}
	 	data += "<input type=\"hidden\" name=\"__env_table\" value=\""+tablelist+"\">";
/*	 	ConvertHTML con = new ConvertHTML();
	 	data += "<input type=\"hidden\" name=\"__systemstatus\" value=\""+this.getUProfile().getSystemStatus()+"\">\n";
	 	if (this.getUProfile().isErrorStatus()) {
//	 		data += "<input type=\"hidden\" name=\"__systemmessage\" value=\""+con.convert(this.getUProfile().getMessage())+"\">\n"; 
	 		data += "<input type=\"hidden\" name=\"__shortmessage\" value=\""+con.convert(this.getUProfile().getShortMessage())+"\">\n"; 
	 	} else {
//	 		data += "<input type=\"hidden\" name=\"__systemmessage\" value=\"\">\n"; 
	 		data += "<input type=\"hidden\" name=\"__shortmessage\" value=\"\">\n"; 
	 	}
//	 	this.getUProfile().clearSystemStatus(""); */
	 	return data; 
	 }
	 
	 public String getTagConfirm() {
		 	StringBuilder data = new StringBuilder();
		 	
		 	data.append("<input type=\"hidden\" name=\"__systemstatus\" value=\"");
		 	data.append(this.getUProfile().getSystemStatus()).append("\">\n");
		 	
		 	if (this.getUProfile().isErrorStatus()) { 
		 		data.append("<input type=\"hidden\" name=\"__shortmessage\" value=\"");
		 		data.append(ConvertHTML.convert(this.getUProfile().getShortMessage())).append("\">\n"); 
		 	} else {
		 		data.append("<input type=\"hidden\" name=\"__shortmessage\" value=\"\">\n"); 
		 	}
		 	data.append("<input type=\"hidden\" name=\"__confirm\" value=\"");
		 	data.append(this.keyConfirm).append("\">");
		 	data.append("<script language=\"JavaScript\">window.setTimeout(showMess,0);</script>");
		 	data.append("<input type=\"hidden\" name=\"__actioned\" value=\"\">\n");
		 	
		 	return data.toString();	    	
	     
	    }
	 public String endJSP() {
		StringBuilder data = new StringBuilder(this.getTagConfirm());
	 	data.append("<script language=\"javascript\">window.setTimeout(checkConfirm,0);</script>\n");
	 	
	 	return data.toString();
	 }	 
	 
	 public void clean(){}
	 
	 public void refreshData(DbRecord rec) throws RemoteException {
     	Hashtable childTable = rec.getChildTable();
    	String chName;
    	ChildManager ch;
		try {
			for (Enumeration enumeration = childTable.keys(); enumeration
					.hasMoreElements();) {
				chName = (String) enumeration.nextElement();
				ch = (ChildManager)childTable.get(chName);

				if(!((ch instanceof DbTable)||(ch instanceof DbRecord)))	       
					this.myRec.refreshChild(chName);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		} 
	 }
	public void setInputType(String fieldName,String inputType){
		try{
			this.myRec.getField(fieldName).setComType(inputType);
		}catch(Exception ex){
			MyLog.error(this," Can't set input type of "+fieldName);
		}
	};
	public void setProperties(String fieldName,String propName,String value){
		try{
			this.myRec.getField(fieldName).setProperty(propName,value);
		}catch(Exception ex){
			MyLog.error(this," Can't set properties type of "+fieldName);
		}
	};
	
	public void isSim(boolean isSim){
		this.isSim=isSim;
	}
	
	public boolean getIsSim(){
		return this.isSim;
	}	
	 
} // end class
