package com.csc.library.entry;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;

import com.csc.library.components.Component;
import com.csc.library.components.ComponentManager;
import com.csc.library.database.FieldManager;
import com.csc.library.database.MyField;
import com.csc.library.database.Relation;
import com.csc.library.database.SystemCode;
import com.csc.library.report.GenCondition;
import com.csc.library.report.ReportComponent;
import com.csc.library.service.GenProcessQuque;
import com.csc.library.service.ReportService;
import com.csc.library.service.WriteLogProcess;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReportXml;
import com.csc.library.utilities.ThaiUtilities;
import com.csc.library.utilities.UProfile;

public class ReportEntry extends MyEntry implements ScreenManager {
	
	private String fileName = "";
	String listTypeField = "";
	String listSysField = "";	
	//private HashMap hMap;
	private HashMap data;
	private HashMap condition;
	private HashMap con;
	private InitialEnvironment	env;
	private DbInquiry			di;
	private ReportXml reportXml;
	
	public ReportEntry() {
		this.type = "reportEntry";
	}
	
	public void dataManager(String objName, HashMap param) {
		this.param = param;
		MyLog.info(this, this.getUProfile(), "objName " + objName);
		reportXml = new ReportXml(objName, this.user.getDbName(),this.user);
		//reportXml.setUProfile(this.user);
	}
	
	public ComponentManager getComponent(String namefield) {
		ComponentManager cm = null;
		return cm;
	}
	
	public String process() {
		String cmd = "";
		cmd = this.getValue("cmd");
		this.getValue("");
		MyLog.info(this, this.getUProfile(), "Print Report CMD : " + cmd);
		if (cmd.equalsIgnoreCase("save")) {
			MyLog.info(this, this.getUProfile(), "Printing start............... ");
			this.createQuque();
//			this.print();
			//this.export();
		} else if (cmd.equalsIgnoreCase("savecon")) {
			this.saveConRecord();
		} else if (cmd.equalsIgnoreCase("delcon")) {
			this.deleteConRecord();
		}
		return "";
	}
	
	/*
	 private void export() {
	 	DbInquiry dbInq = new InitialInquiry(user).getDbInquiry("Memployee", true);
	 	this.setReportData();
	 	this.setInquiry();
	 	MyExport myexp = new MyExport(this.con, this.di);
	 	myexp.process();
	 }
	*/
	
	/*
	private void setInquiry() {
		try {
			String dbXml = null;
			dbXml = (String) con.get("SCREEN");
			DbXml db = new DbXml(this.user, dbXml, this.user.getComCode(), this.user.getUserId(), this.user.getPassword(), this.con);
			di = db.getInquiry();
			this.setInquiryCondition();
			di.refresh();
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
	*/
	
	/*
	private void setInquiryCondition() {
		Properties filter = (Properties) con.get("FILTER");
		try {
			if (filter != null) {
				String operator = (String) filter.get("operator");
				this.setInquiryOperator(operator);
				this.setInquiryFilter(filter);
			}
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
	*/
	
	/*
	private void setInquiryOperator(String operator) throws Exception {
		MyLog.debug(this, this.getUProfile(), "Operator for inquiry " + operator);
		if (operator != null && operator.trim().equals("AND")) {
			di.setAllRequiredFound(true);
			MyLog.debug(this, this.getUProfile(), "Set All RequireFound true");
		} else {
			di.setAllRequiredFound(false);
			MyLog.debug(this, this.getUProfile(), "Set All RequireFound false");
		}
	}
	*/
	
	/*
	private void setInquiryFilter(Properties filter) throws Exception {
		Hashtable h = di.getChildTable();
		Enumeration em = h.keys();
		DbInquiry inq = null;
		String tableName = di.getTableName();
		String fixpFilter = "", rFilter = "";
		if (filter.get(tableName) != null || this.con.get("FIXFILTER" + tableName.toUpperCase()) != null) {
			fixpFilter = (String) this.con.get("FIXFILTER" + tableName.toUpperCase());
			if (fixpFilter != null && !fixpFilter.equals("")) {
				rFilter += fixpFilter;
				if (filter.get(tableName) != null && !filter.get(tableName).equals(""))
					rFilter += "  AND  " + (String) filter.get(tableName);
			} else
				rFilter = (String) filter.get(tableName);
			di.setFilter(rFilter);
		}
		while (em.hasMoreElements()) {
			tableName = (String) em.nextElement();
			try {
				inq = (DbInquiry) di.getChild(tableName);
			} catch (ClassCastException e) {
				MyLog.warn(this, this.getUProfile(), "Object not instance Inquiry Can not set Filter");
			}
			if (filter.get(tableName) != null || this.con.get("FIXFILTER" + tableName.toUpperCase()) != null) {
				fixpFilter = (String) this.con.get("FIXFILTER" + tableName.toUpperCase());
				if (fixpFilter != null && !fixpFilter.equals("")) {
					rFilter += fixpFilter;
					if (filter.get(tableName) != null && !filter.get(tableName).equals(""))
						rFilter += "  AND  " + (String) filter.get(tableName);
				} else
					rFilter = (String) filter.get(tableName);
				inq.setFilter(rFilter);
			}
		}
	}
	*/
	
	private void setOrderList() {
		String orderList = this.getValue("groupText");
		//		System.out.println("OrderList " + orderList);
		int orderCount = 1;
		java.util.StringTokenizer st = new java.util.StringTokenizer(orderList);
		while (st.hasMoreTokens()) {
			con.put("ORDERBY" + orderCount++, st.nextToken());
		}
	}
	
	private void setUprofile() {
		UProfile uf = (UProfile) this.user.clone();
		String lang = this.getValue("language");
		uf.set("lang", lang);
		if (lang.equals("THA")) {
			uf.setCompanyName(this.param.get("com_tname").toString());
		} else {
			uf.setCompanyName(this.param.get("com_ename").toString());
		}
		con.put("UPROFILE", uf);
	}
	
	public void setReportData() {
		try {
			ThaiUtilities th = new ThaiUtilities();
			con = new HashMap();
			this.data = new HashMap();
			this.setOrderList();
			this.setUprofile();
			Properties filterCon = new GenCondition(th.ASCII2Unicode(this.getValue("filtercon"))).getCondition();
			con.put("COMPANY", ((UProfile) con.get("UPROFILE")).getCompanyName());
			con.put("FILTER", filterCon);
			con.put("OLDFILTER",this.getValue("filtercon"));
			Iterator it = this.param.keySet().iterator();
			String keyName, value;
			while (it.hasNext()) {
				keyName = (String) it.next();
				if (keyName.indexOf(this.sign) != -1) {
					value = (String) this.param.get(keyName);
					con.put(keyName.substring(2, keyName.length()).toUpperCase(), value);
				}
			}
			String template = this.getValue("template");
			con.put("TEMPLATE", template.substring(0, template.indexOf("$")));
			con.put("SIZE", template.substring(template.indexOf("$") + 1, template.length()));
			data.put("REPORTNAME", this.getValue("reportname"));
			data.put("CONDITION", con);
			data.put("CLASSNAME", this.getValue("classname"));
			data.put("__export_type",  this.param.get("__export_type"));
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
	
	public HashMap getReportData() {
		return this.data;
	}
	
	public void createQuque() {
		try {
	/*		
			 R : Report
			 I : Import
			 E : Export
			 M : MailMerge
	*/
			this.setReportData();
			String pg = (String) this.param.get("__export_type");
			String process_group="";
			pg = pg.toUpperCase().trim();
			if (pg.equalsIgnoreCase("MAILMERGE")) {
				process_group="M";
			} else if ((pg.equalsIgnoreCase("EXPORT")) || (pg.equalsIgnoreCase("EXPORTFILE"))) {
				process_group="E";
			} else if (pg.equalsIgnoreCase("IMPORT")) {
				process_group="I";
			} else {
				process_group="R";
			}

			GenProcessQuque gp = new GenProcessQuque();
			gp.createQuque(this.getUProfile(), this.getValue("reportname"),this.getValue("reportname"), (String)this.param.get("__classname"), (String) this.param.get("__screen"), this.getValue("remark"),  "9", this.data,(String) this.param.get("__export_type"),process_group,"N","");
		
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}

	}
	
//	public String saveCondition() {
//		String process_id = new GenId(this.getUProfile()).getId(this.path)+ ".ser";
//		String FileName = this.path + process_id ;
//		try {
//			FileOutputStream fu = new FileOutputStream(FileName);
//			ObjectOutputStream ou = new ObjectOutputStream(fu);
//			ou.writeObject(this.data);
//			ou.close();
//			return process_id;
//		} catch (IOException ex) {
//			MyLog.error(this, this.getUProfile(), ex);
//		}
//		return "";
//	}

	public void print() {
		this.setReportData();
		WriteLogProcess w = new WriteLogProcess();
		try {
			w.set("name", this.getValue("reportname"));
			w.set("screen_name", (String) this.param.get("__screen"));
			w.set("export_type", (String) this.param.get("__export_type"));
			w.set("file_type", (String) this.param.get("__file_type"));
			w.set("class_name", (String) this.param.get("__classname"));
			w.set("process", "lreport_log");
			w.set("conpath", new InitialEnvironment("GLOBAL").getValue("temp-dir") + "reports/condition/");
			w.setCondition(this.data);
			w.setUProfile(this.user);
			this.fileName = w.saveLog("reportid");
			this.runService();
			
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
	private void runService() {
		ReportService service = new ReportService();
		service.setProcessID(this.fileName);
		service.setCondition(this.data);
		service.setUProfile(this.user);
		service.setClassName((String) this.param.get("__classname"));
		service.setExportType((String) this.param.get("__export_type"));
		service.start();
	}
	
	public String getTagConfirm() {
		return "";
	}
	
	public String getLabel(String nameField) {
		String str="";
		ComponentManager mcom;
		Component com;
		Vector conditionList = reportXml.getConditionPropList();
		int i = 0;
		for (i = 0; i < conditionList.size(); i++) {			
			Properties prop = (Properties) conditionList.elementAt(i);
			if(prop.getProperty("name").equalsIgnoreCase(nameField)){
					mcom = new ReportComponent(this.user, prop);
					com = new Component();
					com.process(mcom);
					str=com.getLabel();
			}
		}
		return str;
	}
	
	public String getInput(String nameField) {
			String str="";
			ComponentManager mcom;
			Component com;
			Vector conditionList = reportXml.getConditionPropList();
			int i = 0;
			for (i = 0; i < conditionList.size(); i++) {			
				Properties prop = (Properties) conditionList.elementAt(i);
				if(prop.getProperty("name").equalsIgnoreCase(nameField)){
						mcom = new ReportComponent(this.user, prop);
						com = new Component();
						com.process(mcom);
						str=com.getInput();
				}
			}
			return str;
	}
	
	public String getUI(String nameField) {
		return "";
	}
	
	public String getLabel(String nameChild, String nameField) {
		return this.getLabel(nameField);
	}
	
	public String getLinkTable() {
		StringBuffer link = new StringBuffer();
		Vector list = reportXml.getLinkTableList();
		try {
			for (int i = 0; i < list.size(); i++) {
				link.append("[&nbsp;<a href=\"javascript:;\" onClick=\"changeTable('");
				link.append( list.elementAt(i)).append("','").append(this.reportXml.getHelp((String) list.elementAt(i)) );
				link.append("');\">").append(list.elementAt(i) ).append("</a>&nbsp;]");
			}
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
		return link.toString();
	}
	
	public String getFieldTable(String table) {
		StringBuffer field = new StringBuffer();
		Vector fieldList = new Vector();
		String fieldName="", fieldDesc="", helpName = "", tTable = null, linkName = null;
		try {
			DbRecord db = this.getDbRecord(table);
			fieldList = reportXml.getFielddTable(table);
			field.append("<table class=\"inner2\" width=\"450\">");
			field.append("<tr><td width=\"225\" class=\"row1\">Field Name</td><td width=\"225\" class=\"row1\">Description</td></tr>");
			for (int i = 0; i < fieldList.size(); i++) {
				helpName="";
				fieldName = fieldList.elementAt(i).toString();
				fieldDesc = db.getField(fieldName).getDescription();
				FieldManager fm = db.getField(fieldName);
				tTable = fm.getRelation();
				if (tTable != null && !tTable.equalsIgnoreCase("")) {
					linkName = this.getRfieldName(table, tTable, fieldName);
				} else
					linkName = fieldName;
				if(tTable.length()==0)
					helpName = fm.getHelp();
				else if(helpName.length()==0&&tTable.length()>0)
					helpName=tTable+"HELP";
				
				if(reportXml.isLinkField()) {
					field.append("<tr><td><a href=\"javascript:;\" onClick=\"adddata('").append( table.toLowerCase() );
					field.append( "." ).append( fieldName.toLowerCase() ).append( "','" ).append( linkName.toLowerCase() );
					field.append("','" ).append( helpName ).append( "');\">" ).append( fieldName ).append( "</a></td>");
					
				} else {
					field.append("<tr><td>").append( fieldName ).append( "</td>");
				}
				field.append("<td>" ).append( fieldDesc ).append( "</td></tr>");
				this.listTypeField+=fm.getName()+":"+fm.getType()+"#";
				if(!fm.getValidCode().equalsIgnoreCase("")){
					this.listSysField+=fm.getName()+":"+fm.getValidCode()+"#";
				}				
			}
		} catch (Exception ex) {
			MyLog.error(this,this.getUProfile(),table+"."+fieldName+" is null please check in protablexml");
		}
		field.append("</table>");
		return   this.getListSysField()+"   "+this.getListTypeField()+"   "+field.toString();
	}
	
	private String getRfieldName(String table, String rTable, String fieldName) {
		Hashtable re = null;
		Vector pList, cList;
		try {
			DbRecord db = this.getDbRecord(rTable);
			table=this.getDbRecord(table).getTableName();
			re = (Hashtable) db.getRelationInfo().clone();
			if (re == null) {
				db = this.getDbRecord(table);
				re = (Hashtable) db.getRelationInfo().clone();
			}
			Relation relation = (Relation) re.get(table.toLowerCase());
			if(relation==null){
				db = this.getDbRecord(table);
				relation= db.getRelation(rTable.toLowerCase());
				cList = relation.getVFieldListParent();
				pList = relation.getVFieldtListChild();
				for (int i = 0; i < pList.size(); i++) {
					String temp = (String) pList.elementAt(i);
					if (temp.equalsIgnoreCase(fieldName))
						return (String) cList.elementAt(i);
				}				
				
			}else{
				if(relation !=null){
					pList = relation.getVFieldListParent();
					cList = relation.getVFieldtListChild();
					for (int i = 0; i < pList.size(); i++) {
						String temp = (String) pList.elementAt(i);
						if (temp.equalsIgnoreCase(fieldName))
							return (String) cList.elementAt(i);
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(),"Table  :  " + table + "  Rtable  " + rTable + "  FieldName    " + fieldName);
			MyLog.error(this, this.getUProfile(), e);
			return fieldName;
		}
		return fieldName;
	}
	private String getTag(String name, String id, String script, String text, String type) {
		StringBuffer str = new StringBuffer();
		String field, desc = "";
		String table = "";
		Vector orderList = null;
		if (type.equalsIgnoreCase("order"))
			orderList = reportXml.getOrderByList();
		else
			orderList = reportXml.getGroupByList();
		DbRecord db = null;
		str.append("<select name=\"" ).append( name ).append( "\" id=\"" ).append( id ).append( "\" onChange=\"" ).append( script ).append( "();\">\n");
		str.append("<option value=\"0\" selected>..</option>\n");
		try {
			String[][] aa = new String[orderList.size()][2];
            String methodlang = this.getUProfile().get("lang");
            String mltmp = SystemCode.getValue("DESCENDING","DESCENDING");
            if (methodlang.equalsIgnoreCase("THA")) 
            	methodlang = " " + mltmp.substring(mltmp.indexOf(",")+1);
            else 
            	methodlang = " " + mltmp.substring(0,mltmp.indexOf(","));
			for (int i = 0; i < orderList.size(); i++) {
				field = (String) orderList.elementAt(i);
				if (field.indexOf(".") != -1){
					table=field.substring(0,field.indexOf("."));
					db = this.getDbRecord(table);
					String fname = field.substring(field.indexOf(".") + 1, field.length());
					if (fname.indexOf(" ") > -1)
						fname = fname.substring(0,fname.indexOf(" "));
					desc = db.getField(fname).getDescription();
				}else{
					table=reportXml.getMainTable();
					db = this.getDbRecord(table);
					if (field.indexOf(" ") > -1)
						field = field.substring(0,field.indexOf(" "));
					desc = db.getField(field).getDescription();
				}	
				aa[i][0] = field + " desc";
				aa[i][1] = desc + methodlang;
				str.append("<option value=\"" ).append( field + "\" >" ).append( desc ).append( "</option>\n");
			}
			for (int i=0;i<aa.length;i++) {
				str.append("<option value=\"" ).append( aa[i][0] + "\" >" ).append( aa[i][1] ).append( "</option>\n");
			}
		} catch (RemoteException ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
		str.append("</select> <input name=\"" ).append( text ).append( "\" type=\"text\" readonly=\"true\" id=\"desc3\" size=\"30\">\n");
		return str.toString();
	}
	private DbRecord getDbRecord(String table) {
		DbRecord db = null;
		try {
			String status = this.reportXml.getTableStatus(table);
			if ((status != null) && (status.equalsIgnoreCase("center"))) {
				UProfile uprofileCenter = (UProfile) this.user.clone();
				db = new InitialRecord(uprofileCenter).getDbRecord(table);
			} else {
				db = new InitialRecord(this.user).getDbRecord(table, 'i');
			}
			db.setProperties(true);
		} catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
		}
		return db;
	}
	public String getTagOrderBy() {
		return this.getTag("__orderby", "orderby", "insertOrderBy", "__orderText", "order");
	}
	public String getTagGroupBy() {
		return this.getTag("__groupby", "groupby", "insertGroupBy", "__groupText", "group");
	}
	public String getTagTemplate() {
		ThaiUtilities th = new ThaiUtilities();
		StringBuffer str = new StringBuffer();
		Vector templateList = reportXml.getTemplate();
		HashMap h = null;
		str.append("<select name=\"__template\" id=\"__template\">\n");
		String desc;
		String size = "";
		for (int i = 0; i < templateList.size(); i++) {
			h = (HashMap) templateList.elementAt(i);
			if (this.user.get("lang").equalsIgnoreCase("ENG")) {
				desc = (String) h.get("edesc");
			} else {
				desc = (String) h.get("tdesc");
			}
			size = (String) h.get("size");
			if (size == null) {
				size = "";
			}
			str.append("<option value=\"" ).append( (String) h.get("name") ).append( "$" ).append( size );
			str.append( "\" lang=\"" ).append( (String)h.get("lang") ).append( "\">" ).append( th.ASCII2Unicode(desc) ).append( "</option>\n");
		}
		str.append("</select> \n");
		return str.toString();
	}
	public String getMainTable() {
		return this.reportXml.getMainTable();
	}
	public String getMainHelp() {
		try {
			DbRecord db = this.getDbRecord(this.getMainTable());
			return db.getMainHelp().toString();
		} catch (RemoteException e) {
			return null;
		}
	}
	public String getTagComponent(String className) {
		StringBuffer str = new StringBuffer();
		ComponentManager mcom;
		Component com;
		Vector conditionList = reportXml.getConditionPropList();
		Vector componentList = reportXml.getComponentList();
		String temp, label, input;
		int i = 0;
		for (i = 0; i < conditionList.size(); i++) {
			Properties prop = (Properties) conditionList.elementAt(i);
			com = new Component();
			String table = prop.getProperty("dl-table");
			if (table == null) {
				mcom = new ReportComponent(this.user, prop);
				com.process(mcom);
				if(prop.getProperty("COMTYPE")!=null && !prop.getProperty("COMTYPE").equalsIgnoreCase("hidden")){
					str.append(" <tr><td  class=\"" ).append( className ).append( "\">" ).append( com.getLabel() ).append( "&nbsp;</td>");
					str.append("<td >" ).append( com.getInput() ).append( "</td></tr>");
				}else{
					str.append(com.getInput());
				}
			} else {
				String field = prop.getProperty("dl-field");
				String filter = prop.getProperty("dl-filter");
				String orderby = prop.getProperty("dl-orderby");
				String addcompid = prop.getProperty("dl-addcompanyid");
				DbInquiry ditmp = new InitialInquiry(this.user).getDbInquiry(table);
				try {
					Vector keys = ditmp.getAllKey();
					String allkey = "";
					for (int ikeys=0;ikeys<keys.size();ikeys++) {
						allkey = allkey + "," + (String) keys.get(ikeys);
					}
					if (allkey.indexOf(field) < 0) {
						allkey = field + allkey;
					} else {
						if (allkey != null && !allkey.equals("")) 
							allkey = allkey.substring(1);
						else
							allkey = field;
					}
					if (addcompid != null && addcompid.equals("on")) {
						if (filter.equals("")) {
							filter = "companyid='"+this.user.get("companyid")+"'";
						} else {
							filter = filter + " and companyid='" + this.user.get("companyid")+"'";
						}
					}
					ditmp.setColumn(allkey);
					ditmp.setFilter(filter);
					ditmp.setFetchAll(true);
					ditmp.setOrderBy(orderby);
					ditmp.refresh();
					if (ditmp.next()) {
						MyField mf = (MyField) ditmp.getCurrentDbRecord().getField(field);
						mf.setComType(prop.getProperty("COMTYPE"));
						mf.setName(prop.getProperty("name"));
						mf.setDescription(prop.getProperty("desc"));
						com.process(mf);
						if(prop.getProperty("COMTYPE")!=null && !prop.getProperty("COMTYPE").equalsIgnoreCase("hidden")){
							str.append(" <tr><td  class=\"" ).append( className ).append( "\">" ).append( com.getLabel() ).append( "&nbsp;</td>");
							str.append("<td >" ).append( com.getInput() ).append( "</td></tr>");
						}else{
							str.append(com.getInput());
						}
					}
				} catch (Exception e) {
					MyLog.error(this, this.getUProfile(), e);
				}finally{
					if(ditmp!=null){
						ditmp.closeConnection();
					}
				}
			}
		}
		return str.toString();
	}
	public boolean hasComponent() {
		return reportXml.hasComponent();
	}
	public String getTagComponentHidden() {
		StringBuffer str = new StringBuffer();
		ComponentManager mcom;
		Component com;
		Vector conditionList = reportXml.getConditionPropList();
		int i = 0;
		for (i = 0; i < conditionList.size(); i++) {
			Properties prop = (Properties) conditionList.elementAt(i);
			prop.setProperty("COMTYPE", "hidden");
			mcom = new ReportComponent(this.user, prop);
			com = new Component();
		
			com.process(mcom);
			str.append("\n" ).append( com.getInput());
		}
		return str.toString();
	}
	
	public String getTagReportXML(){
		return "<input type=\"hidden\" name=\"__REPORT_XML\" value=\"" + this.reportXml.getDataManager() + "\">";
		
	}
	
	public String getTagFixFilterHidden() {
		StringBuffer str = new StringBuffer();
		str.append(this.getTagReportXML());
		Vector list = this.reportXml.getFixFilter();
		String tableName, value;
		HashMap filter = new HashMap();
		for (int i = 0; i < list.size(); i++) {
			filter = (HashMap) list.elementAt(i);
			tableName = (String) filter.get("tablename");
			value = (String) filter.get("value");
			str.append("<input type=\"hidden\" name=\"__fixfilter" ).append( tableName ).append( "\" value=\"" ).append( value ).append( "\">");
		}
		return str.toString();
	}
	public String getTagChildChkHidden() {
		String data = "<input type=\"hidden\" name=\"__childchk\" value=\"" + this.reportXml.getChildChk() + "\">";
		return data;
	}
	public String getTagReportHeaderValue() {
		HashMap h = reportXml.getReportHeader();
		if (this.user.get("lang").equalsIgnoreCase("ENG")) {
			return (String) h.get("edesc");
		} else {
			return (String) h.get("tdesc");
		}
	}
	public String getTagLanguage() {
		String engSelected = "", thaiSelected = "";
		if (this.user.get("lang").equalsIgnoreCase("ENG")) {
			engSelected = "selected";
		} else {
			thaiSelected = "selected";
		}
		StringBuilder data = new StringBuilder();
		data.append("<select name=\"__language\" id=\"__language\" onChange=\"changeHeader()\">");
		data.append("<option id=\"lang$e\" value=\"ENG\" ").append(engSelected).append(" >Eng</option>");
		data.append("<option id=\"lang$t\" value=\"THA\" ").append(thaiSelected).append(">Thai</option></select>");
		return data.toString();
	}
	public String getThaiHeaderValue() {
		ThaiUtilities th = new ThaiUtilities();
		HashMap h = reportXml.getReportHeader();
		return th.ASCII2Unicode((String) h.get("tdesc"));
	}
	
	public String getEngHeaderValue() {
		ThaiUtilities th = new ThaiUtilities();
		HashMap h = reportXml.getReportHeader();
		return th.ASCII2Unicode((String) h.get("edesc"));
	}
	
	public String getReportPath() {
		try {
			this.initEnv();
			return env.getValue("report-path");
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
			return null;
		}
	}
	
	public void setRecordInfo() {
	}
	
	public void setCmd(String cmd) {
		this.cmd = cmd;
	}
	
	public DbTable getTable() {
		return null;
	}
	
	private void initEnv() {
		env = new InitialEnvironment("GLOBAL");
	}
	
	// Method for get Condition for comapny
	public String getCondition(String key) {
		this.initConInq();
		try {
			String retrunValue = "", fieldName;
			Vector fieldList;
			DbRecord db = (DbRecord) this.condition.get(key);
			if(db!=null){
				fieldList = db.getArrayFieldList();
				for(int i=0;i<fieldList.size();i++){
					fieldName = (String)fieldList.get(i);
					retrunValue += fieldName + "#" + db.getStringHTML(fieldName) + "$";
				}
			
				retrunValue += "newpageby_value#" + db.getStringHTML("newpageby_value");
			}
			return retrunValue;
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
			return "";
		}
	}
	
	public String getConditionHidden(int count) {
		StringBuilder retrunValue = new StringBuilder();
		for (int i = 1; i <= count; i++) {
			retrunValue.append("\n<input type=\"hidden\" name=\"con").append(i);
			retrunValue.append("\" value=\"").append(this.getCondition(String.valueOf(i))).append("\" >");
		}
		return retrunValue.toString();
	}
	
	private void initConInq() {
		DbInquiry conInq = null;
		try {
			this.condition = new HashMap();
			UProfile uCenter = (UProfile) this.user.clone();
//			uCenter.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
//			uCenter.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
			String filter = " reportid='" + this.reportXml.getDataManager() + "'";
			filter += " and companyid='" + this.user.get("companyid") + "'";
			filter += " and create_by='" + this.user.get("employeeid") + "'";
			conInq = new InitialInquiry(uCenter).getDbInquiry();
			conInq.initMyTable("Lreport_condition", "", "");
			conInq.setFetchAll(true);
			conInq.setFilter(filter);
			conInq.setOrderBy("conditionid");
			conInq.setColumn("*");
			conInq.refresh();
			while (conInq.next()) {
				this.condition.put(conInq.getStringHTML("conditionid"), conInq.getCurrentDbRecord().cloneRecord(true));
			}
		} catch (Exception e) {
			try {
				MyLog.error(this, this.getUProfile(), e);
				conInq.closeConnection();
			} catch (Exception ex) {
				MyLog.error(this, this.getUProfile(), ex);
			}
		}finally{
			if(conInq!=null){
				conInq.closeConnection();
			}
		}
	}
	
	private void saveConRecord() {
		UProfile uCenter = (UProfile) this.user.clone();
		DbRecord db = new InitialRecord(uCenter).getDbRecord("Lreport_condition");
		try {
			db.set("reportid", this.reportXml.getDataManager());
			db.set("companyid", (String) this.user.get("companyid"));
			db.set("conditionid", this.getValue("conditionid"));
			db.set("create_by", (String) this.user.get("employeeid"));
			//db.search();
			db.set("condition_value", this.getValue("data"));
			db.set("condition_desc", this.getValue("condesc"));
			db.set("reportheader", this.getValue("reportHeader"));
			db.set("orderby_value", this.getValue("orderText"));
			db.set("groupby_value", this.getValue("groupText"));
			db.set("newpageby_value", this.getValue("onnewpage"));
			db.set("report_language", this.getValue("language"));
			db.set("screen_name", this.getValue("screen"));
			db.save();
		} catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
	
	private void deleteConRecord() {
		UProfile uCenter = (UProfile) this.user.clone();
		DbRecord db = new InitialRecord(uCenter).getDbRecord("Lreport_condition");
		try {
			db.set("reportid", this.reportXml.getDataManager());
			db.set("companyid", (String) this.user.get("companyid"));
			db.set("conditionid", this.getValue("conditionid"));
			db.set("create_by", (String) this.user.get("employeeid"));
			db.delete();
		} catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
	
	public String getComponentPage(String defaultPage) {
		if (this.reportXml.getComponentPage() == null) {
			return defaultPage;
		} else
			return this.reportXml.getComponentPage();
	}
	
	public boolean  isUseCondition() {
		String condition=this.reportXml.getConditon();
		if(condition==null){
			return true;
		}else{
			return Boolean.valueOf(condition).booleanValue();
		}		
	}
	
	public String getOptionRequire() {
		String data = this.reportXml.getOptionRequire();
		if (data != null && !data.equals("") && 
				data.substring(0,data.indexOf("::")).equalsIgnoreCase("true")) {
			String data2 = data.substring(data.indexOf("::")+2);
			return data2;
		} else {
			return "";
		}
	}
	
	public String getTagGroupDB(){
		return "<input type=\"hidden\" name=\"__groupdb\" value=\"" + this.reportXml.getGroupDB()+ "\">";
	}
	
    protected String getListTypeField(){    	
    	return "<input type=\"hidden\" name=\"__listtypefield\" value=\""+this.listTypeField+"\">";
    }
    
    protected String getListSysField(){    	
    	return "<input type=\"hidden\" name=\"__listsysfield\" value=\""+this.listSysField+"\">";
    }
    
    
}
