package com.csc.library.entry;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import java.util.StringTokenizer;

import com.csc.library.components.ComponentManager;
import com.csc.library.components.Label;
import com.csc.library.database.ChildManager;
import com.csc.library.database.FieldManager;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.DbXml;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
public class SingleEntry extends MyEntry implements UIManager,Serializable {
    String help_return, obj;
    boolean searchOn = true;
    int space = 0;
    int duplicateRec;

    String messageError = "";
    String messageWarning = "";
    String refer = "";
    private String objName;   

    private HashMap prop;
    public SingleEntry() {
        this.myRec = null;
        this.type = "singleEntry";
    }
    public void dataManager(String objName, HashMap param) {
        this.objName = objName;
        this.param = param;
        try {
            if (this.myRec == null) {
                DbXml dataControl = new DbXml(this.user, objName, this.user.getComCode(), this.user.getUserName(), this.user.getPassword(), this.param);
                this.myRec = dataControl.getRecord();
                MyLog.debug(this, this.getUProfile(), "myRec : " + this.myRec);
                this.myRec.setPropDB(this.user.getComCode(), this.user.getUserName(), this.user.getPassword());
                this.myRec.setRefreshModel((byte)1);
            }
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
	public void setChannel(HashMap param) {
		if(param.hashCode()!=this.param.hashCode())
			this.param.clear();
		this.param.putAll((Map)param);
	   	try {
			if((this.getValue("isloadparam").equalsIgnoreCase(""))||(this.getValue("isloadparam").equalsIgnoreCase("true"))){
				HashMap h = this.myRec.getParam();
				h.putAll(((Map)this.param));
			}
		} catch (Exception e) {
			e.printStackTrace();
		} 
	}
    public void getAndset() {
    	this.keyConfirm = "0";
        try {

            if (this.getValue("referPage").equalsIgnoreCase("true") && !this.getValue("help").equals("")) {
                UProfile tup = (UProfile) this.user.clone();
                tup.setUserId(this.getValue("editBy"));
                this.myRec.setUProfile(tup);
                this.refreshData(this.myRec);
                //this.myRec.refresh();
                //this.myRec.setVerifyOff();
                //this.myRec.setViewVerifyOff();
                this.help_return = this.getValue("help");
                this.myRec.set("runno", this.help_return.substring(this.help_return.indexOf("$") + 1, this.help_return.length()));
                this.myRec.search("runno");                
            } else if (!this.getValue("runno").equals("")) {
                this.myRec.set("runno", this.getValue("runno"));
                this.myRec.search("runno");
            }else if (!this.getValue("help").equals("")) {
                this.help_return = this.getValue("help");
                if(this.help_return!=null && this.help_return.indexOf("$")!=-1){
                	this.help_return=this.help_return.replace("$", "#");
                }
                this.setHelp();
            }
            help_return = null;
            if(this.myRec instanceof RecordCmp){
            	this.isSim(((RecordCmp)this.myRec).simWorking||this.isSim);
            }else{
            	this.isSim(this.isSim);
            }
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }
    private void setHelp(String fieldKey, boolean search) {
        String helpN="", helpV="";
        StringTokenizer token = new StringTokenizer(fieldKey, "#");
        helpN = token.nextToken();
        if(token.hasMoreTokens())
        	helpV = token.nextToken();
        try {
       
            this.myRec.set(helpN.substring(2), helpV);
            if ((this.searchOn) && (search)) {
                if (this.myRec.getListKey().indexOf(helpN.substring(2)) >= 0) {
                    this.myRec.search();
                }
            }            
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }
    private void setHelp() {
        if (this.help_return.indexOf(";") > 0) {
            for (StringTokenizer token = new StringTokenizer(this.help_return, ";"); token.hasMoreTokens();) {
                this.setHelp(token.nextToken(), false);
            }
            try {
                int searchs=this.myRec.search();
    
                if (searchs == 0) {
					this.clean();
					this.keyConfirm = "-5";
				}else{
					this.keyConfirm = "5";
				}
                this.refer = this.myRec.getRunNo();
            } catch (Exception ex) {
    			MyLog.error(this, this.getUProfile(), ex);
            }
        } else {
            this.setHelp(this.help_return, true);
        }
    }
    public void searchOn() {
        this.searchOn = true;
    }
    public void searchOff() {
        this.searchOn = false;
    }
    //160304 pae
    public ComponentManager getComponent(String nameChild, String nameField) {
        FieldManager fm = null;
        DbRecord rec = null;
        if (nameChild != null) {
            try {
                ChildManager ch = this.myRec.getChild(nameChild);
                if (ch instanceof DbInquiry) {
                    rec = ((DbInquiry) ch).getCurrentDbRecord();
                    rec.setProperties(true);
                } else if (ch instanceof DbRecord) {
                    rec = (DbRecord) this.myRec.getChild(nameChild);
                } else if (ch instanceof DbTable) {
                    rec = ((DbTable) ch).getCurrentRecordManager();
                }
                fm = rec.getField(nameField);
                fm.setProperty("label", fm.getValue());
//              comment by pas 20110421 ͧҡա set require ռŷ notnull ˹ҨͼԴ
//                fm.setProperty("require", "false");
            } catch (Exception e) {
    			MyLog.error(this, this.getUProfile(), e);
            }
            return (ComponentManager) fm;
        } else {
            return getComponent(nameField);
        }
    }
    /*public ComponentManager getComponent(String nameChild, String nameField) {
     FieldManager fm = null;
     DbRecord rec = null;
     if (nameChild != null) {
     try {
     rec = (DbRecord) this.myRec.getChild(nameChild);
     fm = rec.getField(nameField);
     fm.setProperty("label", fm.getProperty("value"));
     } catch (Exception e) {
     e.printStackTrace();
     }
     return (ComponentManager) fm;
     } else {
     return getComponent(nameField);
     }
     }*/
    public ComponentManager getComponent(String nameField) {
        FieldManager fm = null;
        try {
            fm = this.myRec.getField(nameField);
            fm.setProperty("his_table", this.myRec.getTableName());
            fm.setProperty("his_refer", this.refer);
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return (ComponentManager) fm;
    }
    public void setValue() throws Exception {
        String nameField, valueField, fieldList, st;
        FieldManager fm;
        HashMap temp = (HashMap) this.param.clone();
        Iterator e = temp.keySet().iterator();
        while (e.hasNext()) {
            nameField = (String) e.next();
            try {
	            if (nameField.equalsIgnoreCase("__cmd")) {
	                this.cmd = this.getValue("cmd");
	            } else {
	                if (nameField.equalsIgnoreCase("__obj")) {
	                    this.cmd = this.getValue("obj");
	                }
	            }
	            if (nameField.length()>2) {
		            st = nameField.substring(nameField.length() - 2);
		            if (st.equalsIgnoreCase("DD") || st.equalsIgnoreCase("MM") || st.equalsIgnoreCase("YY")) {
		                fm = this.myRec.getField(nameField.substring(2, nameField.length() - 2));
		                if (fm != null && fm.getType().equals("Date") && st.equalsIgnoreCase("DD")) {
		                    this.setFieldDate(nameField.substring(2, nameField.length() - 2));
		                }
		            } else {
		                valueField = this.getValue(nameField.substring(2));
		                this.myRec.set(nameField.substring(2).trim(), valueField);
		            }
	            }
        	} catch (Exception ex) {
        			MyLog.warn(this, ex);
        	}
        }
    }
    /*	public String getFlashParameter() {
     String send = "";
     return send;
     }
     */
    public String getTagError() {
        return "<INPUT TYPE=\"HIDDEN\" NAME=\"__error\" VALUE=\"" + this.messageError + "\">";
    }
    public String getTagWarning() {
        return "<INPUT TYPE=\"HIDDEN\" NAME=\"__warning\" VALUE=\"" + this.messageWarning + "\">";
    }

    public void update() {
        try {
            //			this.logger.info("Update in SingleEntry.");
            if (this.getValue("confirm").equals("2")) {
                this.myRec.setConfirm(true);
                this.myRec.insert();
            }
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    private void setRecordProperties() {
        try {
            prop = new HashMap();
            prop.put("dbscreen", this.objName);
            prop.put("screen_param", this.param);
            prop.put("uprofile", this.user);
            prop.put("db", this.myRec);
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    /*	public void save() {
     this.setRecordProperties();
     try {
     if (this.getValue("confirm").equals("0")) {
     int re = this.singleProcess.insert(this.prop, false);
     if (re == 2) {
     this.keyConfirm = "1";
     } else {
     this.keyConfirm = "3";
     this.myRec=this.singleProcess.getDbRecord();
     }
     } else if (this.getValue("confirm").equals("2")) {
     int re = this.singleProcess.insert(this.prop, true);
     }
     if(this.keyConfirm=="3")
     this.clean();
     } catch (Exception e) {
     e.printStackTrace();
     }
     }
     */
    
    /**
     * @author NoVaViVa 
     *  30/08/2005
     *     confirm save ͧҡͧ message ˹ pages աúѹ֡ record  
     *   ֧繵ͧաreturn keyConfirm ˹Ҩͨʴ١ 
     */
    public void save() {
        this.setRecordProperties();
        int re = 0;
        try {
            if (this.getValue("confirm").equals("0")) {   // insert
                this.myRec.setConfirm(false);                
                re = this.myRec.insert();
            } else if (this.getValue("confirm").equals("2")) { //update
                this.myRec.setConfirm(true);
                re = this.myRec.insert();
            } else if (this.getValue("confirm").equals("s")) {  //insert & update
                re = this.myRec.save();
            } else if (this.getValue("confirm").equals("c")) {  //insert & update
                re =9;
            }
            this.keyConfirm=String.valueOf(re);
            if (re==9 || this.getValue("isclean").equals("1")) {
            	this.clean();
            }else{
            	 this.refreshData(this.myRec);            	
            }                   
/*            if (re>0) {
            	this.clean();
            } else {   
            	this.refreshData(this.myRec);
            }
            */
//            this.refreshData(this.myRec);
       } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public void search() {
        try {
            int search = myRec.search();
            if (search == 0) {
                this.clean();
                this.keyConfirm = "-5";
            }else{
            	this.keyConfirm = "5";
            }
            // ball edit  10-11-03
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    //ball edit  10-11-03
    /*	public void del() {
     this.setRecordProperties();
     try {
     int del = this.singleProcess.delete(this.prop);
     if (del >= 0)
     this.clean();
     else
     this.keyConfirm = "6";
     } catch (Exception e) {
     e.printStackTrace();
     }
     }
     */
    public void del() {
        this.setRecordProperties();
        try {
            int del = this.myRec.delete();
            this.keyConfirm = String.valueOf(del);
            if (del == 4)
                this.clean();
            else if (del == -31) {
            	//this.keyConfirm += "#(FK Integrity)Can't delete!!";
            }
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public void clean() {
        try {
            //this.myRec=this.myRec.cloneRecord(true);
            this.myRec.clearField();
            
            //pae edit 19-09-2005 clear data in child to remove description of child  in screen
            Hashtable hm = (Hashtable) this.myRec.getChildTable();
            Iterator it = hm.keySet().iterator();
            while (it.hasNext()) {
            	String child = (String) it.next();
            	ChildManager ch = this.myRec.getChild(child);
            	if (ch != null) {
					Iterator itChild = ch.getChildTable().keySet().iterator();
					while (itChild.hasNext()) {
						String keyChild = (String) itChild.next();
						ChildManager chChild = (ChildManager) ch.getChildTable().get(keyChild);
						chChild.clearField();
					}				
					ch.clearField();            	
            	}
            }
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public String process() {
        String check = "";
        this.mess = "";
        try {
            this.cmd = this.getValue("cmd");            
            if ((this.cmd != null) && (this.cmd.length() > 0)) {
                if (this.cmd.equalsIgnoreCase("save")) {
                	this.keyConfirm = "3";
                    this.setValue();
                    this.save();
                } else if (this.cmd.equalsIgnoreCase("delete")) {
                	this.keyConfirm = "3";
                    this.setValue();
                    this.del();
                } else if (this.cmd.equalsIgnoreCase("search")) {
                	this.keyConfirm = "3";
                    this.setValue();
                    this.search();
                    this.refer = this.myRec.getRunNo();
                } else if (this.getValue("help") != null && this.getValue("help").equals("")) {
                    this.setValue();
                }
            }else{
            	 if(this.isSim){
                 	this.myRec.configInq();
                 }
            }
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
        return check;
    }
    public String getMessage(String message) {
        try {
            HashMap param = this.myRec.getParam();
            return (String) param.get(message);
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
            return null;
        }
    }
    public void setUI(String nameField) {
        com.process(this.getComponent(nameField));
    }
    public void setUI(String nameChild, String nameField) {
        com.process(this.getComponent(nameChild, nameField));
    }
    public void setSpace(int space) {
        this.space = space;
    }
    
    private String checkReadonly(String readonly, String fieldName) {
        if (readonly.toLowerCase().indexOf("readonly") == -1) {
            if (readonly.toLowerCase().indexOf("<input") != -1) {
                readonly = readonly.substring(0, "<input ".length()) + " READONLY " + readonly.substring("<input ".length(), readonly.length());
            } else if (readonly.toLowerCase().indexOf("<textarea ") != -1) {
                readonly = readonly.substring(0, "<textarea ".length()) + " READONLY " + readonly.substring("<textarea ".length(), readonly.length());
            } else if (readonly.toLowerCase().indexOf("<select ") != -1) {
                readonly = readonly.substring(0, "<select ".length()) + " DISABLED " + readonly.substring("<select ".length(), readonly.length());
            }
        }
        return readonly;
    }
    public String getInput(String nameField) {
        String readonly = "";       
        try {
        	setUI(nameField);
            if (this.getValue("singledisabled").equalsIgnoreCase("true")) {
                return this.getDataLabel(nameField);
            } else if (this.getValue("singlereadonly").equalsIgnoreCase("true")) {
                readonly = this.com.getInput();
                readonly = this.checkReadonly(readonly, nameField);
                return this.charCode("point6", readonly);
            } else {
                return this.charCode("point6", this.com.getInput());
            }
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
			MyLog.error(this, this.getUProfile(),"=================  SingleEntry.getInput() [Namefield : " + nameField + "] ");
            return "";
        }
    }
    /*	public String getUI(String nameField) {
     setUI(nameField);
     this.com.setSpace(space);
     return this.charCode("point6", this.com.getUI());
     }
     */
    public String getLabel(String nameField) {
        try {
            Label label1 = new Label(this.getComponent(nameField));
            return this.charCode("point6", label1.process());
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
            return null;
        }
    }
    public String getLabel(String nameChild, String nameField) {
        try {
 /*         Label label1 = new Label(this.getComponent(nameChild, nameField), this.user.getLabelFont(), this.user.getInputFont());
            return this.charCode("point6", label1.process()); */
        	return  this.getComponent(nameChild, nameField).getDescription();
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
			MyLog.error(this, this.getUProfile(),"=================  SingleEntry.getLabel() [TableName : " + nameChild + " Namefield : " + nameField + "] ");
            return null;
        }
    }
    public String getDataLabel(String nameField) {
        String data = "";
        try {
        	FieldManager fm = this.myRec.getField(nameField);
        	if (fm != null){
        		data = this.charCode("point6", fm.getStringHTML());
        	}else{
        		MyLog.warn(this, this.getUProfile(),"=================  SingleEntry.getDataLabel() [ Namefield : " + nameField + "] ");
        	}
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        	MyLog.error(this, this.getUProfile(),"=================  SingleEntry.getDataLabel() [ Namefield : " + nameField + "] ");
        }
        return data;
    }
    public String getDataLabel(String tableName, String nameField) {
        String data = "";
        try {
        		ChildManager child=this.myRec.getChild(tableName.toLowerCase());
        		FieldManager fm = null;
        		if(child instanceof DbRecord){
        			DbRecord db=(DbRecord)child;
        			fm = db.getField(nameField.toLowerCase());
        		}else if(child instanceof DbInquiry){
        			DbInquiry di=(DbInquiry)child;
        			fm = di.getCurrentDbRecord().getField(nameField);
        		}
        		if(fm!=null){
        			data = this.charCode("point6", fm.getStringHTML());
        		}else{
        			MyLog.error(this, this.getUProfile(), "=================  SingleEntry.getDataLabel() [TableName : " + tableName + " Namefield : " + nameField + "] ");
        		}
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
			MyLog.error(this, this.getUProfile(), "=================  SingleEntry.getDataLabel() [TableName : " + tableName + " Namefield : " + nameField + "] ");
        }
        return data;
    }
    public String getRequire() {
        String data = "";
        try {
            data = this.myRec.listField("require");
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    /**
     * ball edit 16-10-03
     * */
    public void referLangOn() {
        try {
            this.myRec.referLangOn();
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }
    public void referLangOff() {
        try {
            this.myRec.referLangOff();
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }
    /*
     protected void initSingleProcess() {
     this.singleProcess= (Singleable) new InitialEntryProcess().getEntry("SingleProcess");
     }
     */
    public void setRecordInfo() {
    }
    public void setCmd(String cmd) {
        this.cmd = cmd;
    }
    public DbTable getTable() {
        return null;
    }
    public void setRecord(DbRecord db){
    	this.myRec=db;
    }
    
    public String getEditCheck() {
    	StringBuilder html = new StringBuilder();
    	
    	String editBy = this.getDataLabel("edit_by");
    	if( editBy != null && !editBy.trim().equalsIgnoreCase("")) {
    		html.append( editBy ).append("_ : ");
    		html.append( this.getDataLabel("edit_date")).append(" : ");
    		html.append(this.getDataLabel("edit_time"));
    		
    		String approve = this.getDataLabel("approve");
        	if( approve != null && !approve.trim().equalsIgnoreCase("")) {
        		html.append( " :: " ).append( approve );
        	}
    	}
    	return html.toString();
    }

    /****************************/

    
    
}
