package com.csc.library.formula;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import koala.dynamicjava.interpreter.InterpreterException;

import com.csc.library.database.MyHashMap;
import com.csc.library.utilities.DynamicJava;
import com.csc.library.utilities.FileString;
import com.csc.library.utilities.MyLog;
/**
 * @author SoCool
 *
 * MyFormula  Class  extend Ҩҡ Dynamic Java ö
 * ͧͧ Get  Error Message   Get ҵèҡ Environment ͧ Dynamic Java
 * ͡ define ҵ÷ժԴ primitive type
 */
public class MyFormula extends DynamicJava {
	private String error = "";
	private String factory = "fact1";
	private List errRemoveList = new Vector();
	public MyFormula() {
		this.addErrRemoveList("koala.dynamicjava.parser.wrapper.");
		this.addErrRemoveList("koala.dynamicjava.interpreter.error.");
	}
	/**
	 * Returns the error.
	 * @return String
	 */
	public String getError() {
		return error;
	}
    /**
     * ʹ 㹡 run String  Code ͧ Java 㹢 run time
     * @param value  Code  Run
     * @return boolean flag Success
     */	
	public boolean process(String value) {
		try {
			this.error = "";
			super.interpret(value, this.getFactory());
			return true;
		} catch (InterpreterException e) {
			error = this.cutMessageErr(e.getError().toString());
			MyLog.debug(this, value+" /n ERROR /n "+e.getError().toString());
//			MyLog.debug(this, e);
			return false;
		} catch (Exception e) {
//			MyLog.debug(this, e);
			return false;
		}
	}
    /**
     * ʹ㹡 code java ШзӡõѴ error message 
     *  error Դ鹨纤㹵 private String error = "";
     * @param value
     * @return String Ѿҡäӹǹ
     */	
	public String getStringProcess(String value) {
		try {
			this.setError("");
			return super.interpret(value, this.getFactory()).toString();
		} catch (Exception e) {
			MyLog.error(this, value+" /n ERROR /n "+e.getMessage());
			MyLog.error(this, e);
			this.setError(this.cutMessageErr(e.getMessage()));
			return "";
		}
	}
    /**
     * Get ҵ Environment ͧ Dynamicjava
     * @param variable ÷ͧô֧
     * @return  double ͧù
     */	
	public double getDoubleResult(String variable) {
		if (super.getVariable(variable)==null) return 0;
		String tmp = super.getVariable(variable).toString();
		return new Double(tmp).doubleValue();
	}
    /**
     * Get ҵ Environment ͧ Dynamicjava
     * @param variable ÷ͧô֧
     * @return  boolean ͧù 
     */	
	public boolean getBooleanResult(String variable) {
		if (super.getVariable(variable)==null) return false;
		String tmp = super.getVariable(variable).toString();
		return new Boolean(tmp).booleanValue();
	}
    /**
     * Get ҵ Environment ͧ Dynamicjava
     * @param variable ÷ͧô֧
     * @return  String ͧù 
     */	
	public String getStringResult(String variable) {
		if (super.getVariable(variable)==null) return "";
		String tmp = super.getVariable(variable).toString();
		return tmp;
	}
	
	public MyHashMap getHashResult(String variable) {
		if (super.getVariable(variable)==null) return new MyHashMap();;
		MyHashMap tmp = (MyHashMap) super.getVariable(variable);
		return tmp;
	}
    /**
     * 㹡õѴ Error Message ҡ Dynamic Java ͧ ҡ Error Դ Dynamic Java ѡɳФ
     * koala.dynamicjava.parser.wrapper.......... ѹԹ仨֧ͧѴ ͡  Fix ҴԹ 100 ѡ
     * @param errMsg  Error Message
     * @return String Ѿ
     */
	private String cutMessageErr(String errMsg) {
		String cut = "", result = errMsg;
		Iterator it = this.getErrRemoveList().iterator();
		while (it.hasNext()) {
			cut = (String) it.next();
			if (result.indexOf(cut) > -1) {
				FileString fs = new FileString();
				fs.setData(result);
				fs.delString(cut);
				result = fs.getData();
			}
		}
		if ((result.indexOf("Encountered") > -1) && (result.indexOf("<EOF>") > -1))
			return "Does't have end line[ ; ]";
		if (result.length() > 99) {
			return result.substring(0, 99);
		} else {
			return result;
		}
	}
	/**
     *  ʹ run   code java 
     * ¨ return ҼѾ Object Ѻ׹ 
	 * @see com.csc.library.utilities.DynamicJava#interpret(String, String)
     * @param interpretstring  String  run
     * @param fact  factory 㹡кض֧ environment ͧ Dynamicjava ҵͧҹ
     *  Environment ˹ ͧѹ
	 */
	public Object interpret(String interpretstring, String fact) {
		try {
			this.error = "";
			return super.interpret(interpretstring, fact);
		} catch (InterpreterException e) {
			MyLog.error(this, interpretstring);
			MyLog.error(this, e);
			error = this.cutMessageErr(e.getError().toString());
			return null;
		} catch (NullPointerException e) {
			MyLog.error(this, interpretstring);
			MyLog.error(this, e);
			return null;
		} catch (Exception e) {
			MyLog.error(this, interpretstring);
			MyLog.error(this, e);
			return null;
		}
	}
	/**
     *  ʹѹ code java ҡ file
	 * @see com.csc.library.utilities.DynamicJava#interpretFile(String)
     * @return Object Ѿ
	 */
	public Object interpret(String interpretstring) {
		return this.interpret(interpretstring, this.factory);
	}
	/**
	 * @see com.csc.library.utilities.DynamicJava#interpretFile(String)
	 */
	public Object interpretFile(String fname) {
		try {
			this.error = "";
			return super.interpretFile(fname);
		} catch (InterpreterException e) {
			MyLog.error(this, fname);
			MyLog.error(this, e);
			error = this.cutMessageErr(e.getError().toString());
			return null;
		} catch (NullPointerException e) {
			MyLog.error(this, fname);
			MyLog.error(this, e);
			return null;
		} catch (Exception e) {
			MyLog.error(this, fname);
			MyLog.error(this, e);
			return null;
		}
	}
	/**
	 * Returns the factory.
	 * @return String
	 */
	public String getFactory() {
		return factory;
	}
	/**
	 * Sets the factory.
	 * @param factory The factory to set
	 */
	public void setFactory(String factory) {
		this.factory = factory;
	}
	/**
	 * Sets the error.
	 * @param error The error to set
	 */
	public void setError(String error) {
		this.error = error;
	}
	/**
	 * Returns the errRemoveList.
	 * @return List
	 */
	protected List getErrRemoveList() {
		return errRemoveList;
	}
	/**
	 * Sets the errRemoveList.
	 * @param errRemoveList The errRemoveList to set
	 */
	protected void setErrRemoveList(List errRemoveList) {
		this.errRemoveList = errRemoveList;
	}
	/**
	 * Add the errRemoveList.
	 * @param errRemoveList The errRemoveList to set
	 */
	protected void addErrRemoveList(String errMessage) {
		this.getErrRemoveList().add(errMessage);
	}
}