package com.csc.library.mail;

import java.sql.Time;
import java.sql.Timestamp;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * @author SoCool
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MailBox {
	private String dbName = "";
	private String schemaName = "";
	private String tableName = "MyMail";
	private MyHashMap data=new MyHashMap();
	/**
	 * Returns the mailid.
	 * @return String
	 */
	public String getMailid() {
		return this.data.getString("mailid");
	}

	/**
	 * Returns the mAttach.
	 * @return String
	 */
	public String getMAttach() {
		return this.data.getString("mattach");
	}

	/**
	 * Returns the mBCC.
	 * @return String
	 */
	public String getMBCC() {
		return this.data.getString("mbcc");
	}

	/**
	 * Returns the mCC.
	 * @return String
	 */
	public String getMCC() {
		return this.data.getString("mcc");
	}

	/**
	 * Returns the mCondition.
	 * @return String
	 */
	public String getMCondition() {
		return this.data.getString("mcondition");
	}

	/**
	 * Returns the mFormat.
	 * @return String
	 */
	public String getMFormat() {
		return this.data.getString("mformat");
	}

	/**
	 * Returns the mForward.
	 * @return String
	 */
	public String getMForward() {
		return this.data.getString("mforward");
	}

	/**
	 * Returns the mFrom.
	 * @return String
	 */
	public String getMFrom() {
		return this.data.getString("mfrom");
	}

	/**
	 * Returns the mMessage.
	 * @return String
	 */
	public String getMMessage() {
		return this.data.getString("mmessage");
	}

	/**
	 * Returns the mSender.
	 * @return String
	 */
	public String getMSender() {
		return this.data.getString("msender");
	}

	/**
	 * Returns the mSendTo.
	 * @return String
	 */
	public String getMSendTo() {
		return this.data.getString("msendto");
	}

	/**
	 * Returns the mStatus.
	 * @return String
	 */
	public String getMStatus() {
		return this.data.getString("mstatus");
	}

	/**
	 * Returns the mSubject.
	 * @return String
	 */
	public String getMSubject() {
		return this.data.getString("msubject");
	}

	/**
	 * Returns the mTime.
	 * @return Timestamp
	 */
	public Timestamp getMTime() {
		return (Timestamp)this.data.get("mtime");
	}

	/**
	 * Returns the mType.
	 * @return String
	 */
	public String getMType() {
		return this.data.getString("mtype");
	}

	/**
	 * Returns the sendDateTime.
	 * @return Time
	 */
	public Time getSendDateTime() {
		return (Time)this.data.get("senddatetime");
	}

	/**
	 * Sets the mailid.
	 * @param mailid The mailid to set
	 */
	public void setMailid(String mailid) {
		this.data.put("mailid",mailid);
	}

	/**
	 * Sets the mAttach.
	 * @param mAttach The mAttach to set
	 */
	public void setMAttach(String mAttach) {
		this.data.put("mattach",mAttach);
	}

	/**
	 * Sets the mBCC.
	 * @param mBCC The mBCC to set
	 */
	public void setMBCC(String mBCC) {
		this.data.put("mbcc",mBCC);
	}

	/**
	 * Sets the mCC.
	 * @param mCC The mCC to set
	 */
	public void setMCC(String mCC) {
		this.data.put("mcc",mCC);
	}

	/**
	 * Sets the mCondition.
	 * @param mCondition The mCondition to set
	 */
	public void setMCondition(String mCondition) {
		this.data.put("mcondition",mCondition);
	}

	/**
	 * Sets the mFormat.
	 * @param mFormat The mFormat to set
	 */
	public void setMFormat(String mFormat) {
		this.data.put("mformat",mFormat);
	}

	/**
	 * Sets the mForward.
	 * @param mForward The mForward to set
	 */
	public void setMForward(String mForward) {
		this.data.put("mforward",mForward);
	}

	/**
	 * Sets the mFrom.
	 * @param mFrom The mFrom to set
	 */
	public void setMFrom(String mFrom) {
		this.data.put("mfrom",mFrom);
	}

	/**
	 * Sets the mMessage.
	 * @param mMessage The mMessage to set
	 */
	public void setMMessage(String mMessage) {
		this.data.put("mmessage",mMessage);
	}

	/**
	 * Sets the mSender.
	 * @param mSender The mSender to set
	 */
	public void setMSender(String mSender) {
		this.data.put("msender",mSender);
	}

	/**
	 * Sets the mSendTo.
	 * @param mSendTo The mSendTo to set
	 */
	public void setMSendTo(String mSendTo) {
		this.data.put("msendto",mSendTo);
	}

	/**
	 * Sets the mStatus.
	 * @param mStatus The mStatus to set
	 */
	public void setMStatus(String mStatus) {
		this.data.put("mstatus",mStatus);
	}

	/**
	 * Sets the mSubject.
	 * @param mSubject The mSubject to set
	 */
	public void setMSubject(String mSubject) {
		this.data.put("msubject",mSubject);
	}

	/**
	 * Sets the mTime.
	 * @param mTime The mTime to set
	 */
	public void setMTime(Timestamp mTime) {
		this.data.put("mtime",mTime);
	}

	/**
	 * Sets the mType.
	 * @param mType The mType to set
	 */
	public void setMType(String mType) {
		this.data.put("mtype",mType);
	}

	/**
	 * Sets the sendDateTime.
	 * @param sendDateTime The sendDateTime to set
	 */
	public void setSendDateTime(Time sendDateTime) {
		this.data.put("senddatetime",sendDateTime);
	}

	public int save() {
		if (this.dbName == null || this.dbName.equals("")) {
			return -1;
		} else if (this.schemaName == null || this.schemaName.equals("")) {
			return -1;
		} else {
			try {
				UProfile up = new UProfile();
				up.setDbName(this.dbName);
				up.setSchemaName(this.schemaName);
				
				DbRecord mailRec = new InitialRecord(up).getDbRecord(this.tableName);
				Iterator it = this.data.keySet().iterator();
				while(it.hasNext()){
					String field = (String)it.next();
					mailRec.set(field,this.data.getString(field));
				}
				return mailRec.save();
			} catch (Exception e) {
				MyLog.error(this, e);
				return -1;
			}
		}

	}
	/**
	 * Returns the dbName.
	 * @return String
	 */
	public String getDbName() {
		return dbName;
	}

	/**
	 * Returns the schemaName.
	 * @return String
	 */
	public String getSchemaName() {
		return schemaName;
	}

	/**
	 * Sets the dbName.
	 * @param dbName The dbName to set
	 */
	public void setDbName(String dbName) {
		this.dbName = dbName;
	}

	/**
	 * Sets the schemaName.
	 * @param schemaName The schemaName to set
	 */
	public void setSchemaName(String schemaName) {
		this.schemaName = schemaName;
	}
	public void set(String key,String value){
		this.data.put(key,value);
	}
	public void set(String key,Time value){
		this.data.put(key,value);
	}
	public void set(String key,Timestamp value){
		this.data.put(key,value);
	}
	public Object get(String key){
		return this.data.get(key);
	}
	public String getString(String key){
		return (String)this.data.get(key);
	}
	public Time getTime(String key){
		return (Time)this.data.get(key);
	}
	public Timestamp getTimestamp(String key){
		return (Timestamp)this.data.get(key);
	}
	/**
	 * Returns the tableName.
	 * @return String
	 */
	public String getTableName() {
		return tableName;
	}

	/**
	 * Sets the tableName.
	 * @param tableName The tableName to set
	 */
	public void setTableName(String tableName) {
		this.tableName = tableName;
	}
}
