package com.csc.library.mail;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class OutgoingMail {
	
	String outboxid="";
	String companyid="";  
	String employeeid="";
	String usernameid="";
	String sender="";
	String referid="";
	String receiver="";
	String ccreceiver="";
	String subject="";
	String content="";
	String status_Complete="C";
	String status_Error="E";
	String status_Resend="R";
	String status="C";	
	String msgerror="";
	String create_date="";
	String create_time="";
	String create_by="";
	String edit_date="";
	String edit_time="";
	String edit_by="";
	UProfile up=null;
	String scriptMSSQL="CREATE TABLE TOUTBOX(" +
	 		" OUTBOXID    VARCHAR(20)	NOT NULL," +
	 		" COMPANYID   VARCHAR(5)	NOT NULL," +
	 		" REFERID    VARCHAR(20)	 NULL," +	 		
	 		" EMPLOYEEID  VARCHAR(15)		NULL," +
	 		" USERNAMEID	VARCHAR(20)		NULL," +
	 		" SENDER		VARCHAR(500)	NULL," +
	 		" RECEIVER	VARCHAR(2000)	NULL," +
	 		" CCRECEIVER	VARCHAR(2000)	NULL," +
	 		" SUBJECT		VARCHAR(2000)	NULL," +
	 		" CONTENT		VARCHAR(4000)	NULL," +
	 		" STATUS		VARCHAR(1)		NULL," +
	 		" MSGERROR	VARCHAR(4000)		NULL," +
	 		" CREATE_DATE VARCHAR(12)		NULL," +
	 		" CREATE_TIME VARCHAR(12)		NULL," +
	 		" CREATE_BY VARCHAR(12)		NULL," +
	 		" EDIT_DATE VARCHAR(12)		NULL," +
	 		" EDIT_TIME VARCHAR(12)		NULL," +
	 		" EDIT_BY VARCHAR(12)		NULL," +
	 		" RUNNO INT		NULL," +
	 		" PRIMARY KEY(OUTBOXID,COMPANYID)" +
	 		" )";
	
	String scriptORACLE="CREATE TABLE TOUTBOX(" +
	 		" OUTBOXID    VARCHAR2(20)	NOT NULL," +
	 		" COMPANYID   VARCHAR2(5)	NOT NULL," +
	 		" REFERID    VARCHAR2(20)	 NULL," +	 		
	 		" EMPLOYEEID  VARCHAR2(15)		NULL," +
	 		" USERNAMEID	VARCHAR2(20)		NULL," +
	 		" SENDER		VARCHAR2(100)	NULL," +
	 		" RECEIVER	VARCHAR2(2000)	NULL," +
	 		" CCRECEIVER	VARCHAR2(2000)	NULL," +
	 		" SUBJECT		VARCHAR2(2000)	NULL," +
	 		" CONTENT		VARCHAR2(4000)	NULL," +
	 		" STATUS		VARCHAR2(1)		NULL," +
	 		" MSGERROR	VARCHAR2(4000)		NULL," +
	 		" CREATE_DATE VARCHAR2(12)		NULL," +
	 		" CREATE_TIME VARCHAR2(12)		NULL," +
	 		" CREATE_BY VARCHAR2(12)		NULL," +
	 		" EDIT_DATE VARCHAR2(12)		NULL," +
	 		" EDIT_TIME VARCHAR2(12)		NULL," +
	 		" EDIT_BY VARCHAR2(12)		NULL," +
	 		" RUNNO NUMBER(10)		NULL," +
	 		" PRIMARY KEY(OUTBOXID,COMPANYID)" +
	 		" )";	
	
	public OutgoingMail(UProfile up) {
		this.setUProfile(up);
		initTable();
	}
	
	public void setUProfile(UProfile up){
		this.up=up;
	}
	
	public UProfile getUProfile(){
		return this.up;
	}
	
 public String getReferid() {
		return referid;
	}

	public void setReferid(String referid) {
		this.referid = referid;
	}

private void createTable(String DBVendor){
	 String sql=scriptMSSQL;
	 if(DBVendor.equalsIgnoreCase("oracle")){
		 sql=this.scriptORACLE;
	 }
	 Statement stm =null;
	   CscConnection con = null;
	   try {
	   		con = (CscConnection) StaticProperties.myConnection.getConnection(up.getDbName(),up);
	   		con.setClassName("SQLExceptionManager.executeQuery");
	        stm = con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
	        stm.executeUpdate(sql);
	        stm.close();
	   		con.close();
	   } catch (SQLException e) {
		   MyLog.error(this,this.up,sql);
		   MyLog.error(this,this.up,">>>>>>>>>>>>>> Can not create table! <<<<<<<<<<<<<<<");
	   		e.printStackTrace();
	   }finally{
		   try {
			   if(stm!=null)
				   stm.close();
			} catch (SQLException e1) {
			}
		   try {
				con.close();
			} catch (SQLException e1) {
			}
	   }	 
 }

public  String getOutboxid() {
	if(outboxid.equals("0")||outboxid.length()==0){
		outboxid=String.valueOf(System.nanoTime());
	}
	return outboxid;
}

public void setOutboxid(String outboxid) {
	this.outboxid = outboxid;
}

public String getCompanyid() {
	return companyid;
}

public void setCompanyid(String companyid) {
	this.companyid = companyid;
}

public String getEmployeeid() {
	return employeeid;
}

public void setEmployeeid(String employeeid) {
	this.employeeid = employeeid;
}

public String getUsernameid() {
	return usernameid;
}

public void setUsernameid(String usernameid) {
	this.usernameid = usernameid;
}

public String getSender() {
	return sender;
}

public void setSender(String sender) {
	this.sender = sender;
}

public String getReceiver() {
	return receiver;
}

public void setReceiver(String receiver) {
	this.receiver = receiver;
}

public String getCcreceiver() {
	return ccreceiver;
}

public void setCcreceiver(String ccreceiver) {
	this.ccreceiver = ccreceiver;
}

public String getSubject() {
	return subject;
}

public void setSubject(String subject) {
	this.subject = subject;
}

public String getContent() {
	return content;
}

public void setContent(String content) {
	this.content = content;
}

public String getStatus() {
	return status;
}

public void setStatus(String status) {
	this.status = status;
}

public String getMsgerror() {
	return msgerror;
}

public void setMsgerror(String msgerror) {
	this.msgerror = msgerror;
}

public String getCreate_date() {
	return create_date;
}

public void setCreate_date(String create_date) {
	this.create_date = create_date;
}

public String getCreate_time() {
	return create_time;
}

public void setCreate_time(String create_time) {
	this.create_time = create_time;
}

public String getCreate_by() {
	return create_by;
}

public void setCreate_by(String create_by) {
	this.create_by = create_by;
}

public String getEdit_date() {
	return edit_date;
}

public void setEdit_date(String edit_date) {
	this.edit_date = edit_date;
}

public String getEdit_time() {
	return edit_time;
}

public void setEdit_time(String edit_time) {
	this.edit_time = edit_time;
}

public String getEdit_by() {
	return edit_by;
}

public void setEdit_by(String edit_by) {
	this.edit_by = edit_by;
} 



public  void sendComplete(){
	String sql="";
	CscConnection connection = null;
	PreparedStatement statement=null;
	try{
		try {
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.up.getDbName()); 
			sql = "insert into toutbox(outboxid,companyid, employeeid, usernameid, referid, sender, receiver, ccreceiver, subject, content, status, msgerror, create_date, create_time, create_by, edit_date, edit_time, edit_by)" +
					" values(?, ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?)";		
			statement = connection.prepareStatement(sql);
			statement.setString(1,getOutboxid());
			statement.setString(2,getCompanyid());
			statement.setString(3, getEmployeeid());
			statement.setString(4, getUsernameid());
			statement.setString(5, getReferid());			
			statement.setString(6, getSender());
			statement.setString(7, getReceiver());
			statement.setString(8, getCcreceiver());
			statement.setString(9, getSubject());
			statement.setString(10, getContent());
			statement.setString(11, status_Complete);
			statement.setString(12, "Complete");
			statement.setString(13, getCreate_date());
			statement.setString(14, getCreate_time());
			statement.setString(15, getCreate_by());
			statement.setString(16, getEdit_date());
			statement.setString(17, getEdit_time());
			statement.setString(18, getEdit_by());
			statement.executeUpdate();
			connection.commit();
		}catch (Exception e) {
			MyLog.error(this, this.up, e);
		} finally {
			closeConnection(connection, statement);
		}
	}catch(Exception ex){
		ex.printStackTrace();
	}
}

public void reSendItem(String outid){
	String sql="";
	CscConnection connection = null;
	PreparedStatement statement=null;
	try{
		try {
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.up.getDbName()); 
			sql = "update toutbox set status=? where outboxid=?";		
			statement = connection.prepareStatement(sql);
			statement.setString(1, status_Resend);
			statement.setString(2, outid);
			statement.executeUpdate();
			connection.commit();
		}catch (Exception e) {
			MyLog.error(this, this.up, e);
		} finally {
			closeConnection(connection, statement);
		}
	}catch(Exception ex){
		ex.printStackTrace();
	}
}

public void sendError(){
	String sql="";
	CscConnection connection = null;
	PreparedStatement statement=null;
	try{
		try {
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.up.getDbName()); 
			sql = "insert into toutbox(outboxid,companyid, employeeid, usernameid, referid, sender, receiver, ccreceiver, subject, content, status, msgerror, create_date, create_time, create_by, edit_date, edit_time, edit_by)" +
					" values(?, ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?,  ?)";		
			statement = connection.prepareStatement(sql);
			statement.setString(1,getOutboxid());
			statement.setString(2,getCompanyid());
			statement.setString(3, getEmployeeid());
			statement.setString(4, getUsernameid());
			statement.setString(5, getReferid());			
			statement.setString(6, getSender());
			statement.setString(7, getReceiver());
			statement.setString(8, getCcreceiver());
			statement.setString(9, getSubject());
			statement.setString(10, getContent());
			statement.setString(11, status_Error);
			statement.setString(12, getMsgerror());
			statement.setString(13, getCreate_date());
			statement.setString(14, getCreate_time());
			statement.setString(15, getCreate_by());
			statement.setString(16, getEdit_date());
			statement.setString(17, getEdit_time());
			statement.setString(18, getEdit_by());
			statement.executeUpdate();
			connection.commit();
		}catch (Exception e) {
			MyLog.error(this, this.up, e);
		} finally {
			closeConnection(connection, statement);
		}
	}catch(Exception ex){
		ex.printStackTrace();
	}
}

private void initTable(){
	try{
		CscConnection connection = null;
		Statement statement=null;
		try {
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.up.getDbName()); 
			String sql = "select * from toutbox";				
			statement = connection.createStatement();
			statement.executeQuery(sql);
		}catch (SQLException e) {
			MyLog.error(this, this.up, e);
			if(e.getSQLState().equals("42000") ||e.getSQLState().equals("S0002") || e.getSQLState().equals("42S02")) {
				this.createTable(connection.getVendor());
		}			
		} finally {
			closeConnection(connection, statement);
		}
	}catch(Exception ex){
		ex.printStackTrace();
	}
}


private void closeConnection(CscConnection connection, Statement statement) {
	try {
		if(statement!=null){
			statement.close();
		}
	} catch (SQLException e) {}		
	try{
		if(connection!=null){
			connection.close();
		}
	}catch(Exception ex){}
}

public void reSendAll(){
	try{
		CscConnection connection = null;
		Statement statement=null;
		ResultSet rs=null;
		try {
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.up.getDbName()); 
			String sql = "select * from toutbox where status='".concat(this.status_Error).concat("'");				
			statement = connection.createStatement();
			rs=statement.executeQuery(sql);
			SendMail sm=null;
			while(rs.next()){
				sm=new SendMail("",rs.getString("sender"), rs.getString("receiver"), rs.getString("ccreceiver"),rs.getString("subject"),rs.getString("content")) ;
				sm.send();
				reSendItem(rs.getString("outboxid"));
			}
		}catch (SQLException e) {
			MyLog.error(this, this.up, e);
			if(e.getSQLState().equals("42000") ||e.getSQLState().equals("S0002") || e.getSQLState().equals("42S02")) {
				this.createTable(connection.getVendor());
		}			
		} finally {
			closeConnection(connection, statement);
		}
	}catch(Exception ex){
		ex.printStackTrace();
	}
}

public void reSendItems(String outid){
	try{
		if(outid.indexOf(",")>-1){
			String[] outarr=outid.split(",");
			for(int i=0;i<outarr.length;i++){
				this.reSendItem(outarr[i]);
				sendMailbyItems(outarr[i]);
				reSendItem(outarr[i]);
			}
		}
	}catch(Exception ex){
		ex.printStackTrace();
	}
}

public void sendMailbyItems(String outid){
	try{
		CscConnection connection = null;
		Statement statement=null;
		ResultSet rs=null;
		try {
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.up.getDbName()); 
			String sql = "select * from toutbox where outboxid='".concat(outid).concat("'");				
			statement = connection.createStatement();
			rs=statement.executeQuery(sql);
			SendMail sm=null;
			while(rs.next()){
				sm=new SendMail("",rs.getString("sender"), rs.getString("receiver"), rs.getString("ccreceiver"),rs.getString("subject"),rs.getString("content")) ;
				sm.send();
			}
		}catch (SQLException e) {
			MyLog.error(this, this.up, e);
		} finally {
			closeConnection(connection, statement);
		}
	}catch(Exception ex){
		ex.printStackTrace();
	}
}

}
