package com.csc.library.service;

import java.io.File;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Vector;

import org.apache.commons.lang.StringUtils;

import com.csc.entity.CSC_Quque;
import com.csc.library.database.StaticProperties;
import com.csc.library.process.DbProcess;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialProcess;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ThaiUtilities;
import com.csc.library.utilities.UProfile;

/**
 * @author Administrator
 */
public class GenProcessQuque  extends ThreadProcess {
//	private String processID = "";
	private HashMap cond  = new HashMap();
//	private HashMap param = new HashMap();
//	private UProfile upf=null;
	private String proc_msg = "";
	private String path = new InitialEnvironment("GLOBAL").getValue("temp-dir") + "/process/condition/";
	final String sign = "__";
	private int maxlist = 100;
	
	public GenProcessQuque() {
		super();
	}
	
	public void run() {
		try {
			this.genThred();
			Runtime.getRuntime().gc();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
	}

	/**
	 * 2012-04-10  transaction ͺ getProcessList  Connection  processlist  connection  
	 *  
	 */
	
	private Vector getProcessList(){
		String prClass = StringUtils.trimToNull(getValue("prclass"));
		final DbProcess xProcess;
		Vector vc=new Vector();
		try {
			xProcess = new InitialProcess().getProcess(prClass);
			xProcess.setParam(cond);
			xProcess.initData(cond);
			StaticProperties.myConnection.beginTransaction(xProcess.getUProfile(), this);
			this.proc_msg = xProcess.getMessage();
			vc=xProcess.getProcessList();
			StaticProperties.myConnection.endTransaction(	xProcess.getUProfile(), this);
			return vc;
		} catch (Exception e) {
			MyLog.error(this, upf, e);
			return null;
		}
	}
	
//	public void setUProfile(UProfile upf){
//		this.upf = upf;
//
//	}
	
	public String saveCondition(HashMap paramdata, String folder) {
		String process_id = new GenId(upf).getId(path)+ ".ser";
		String FileName = path +folder+"/"+ process_id ;
		File f = new File(path +folder+"/");
		if(!f.exists()){
			f.mkdir();
		}
		try {
			FileOutputStream fu = new FileOutputStream(FileName);
			ObjectOutputStream ou = new ObjectOutputStream(fu);
			if(paramdata == null) {
				ou.writeObject(param);
			} else {
				ou.writeObject(paramdata);
			}
			ou.close();
			return process_id;
			
		} catch (Exception e) {
			MyLog.error(this, upf, e);
		}
		return "";
	}
	
	public String getValue(String nameField) {
		String temp = "";
		try {
			temp = this.charCode("5", (String) this.param.get(this.sign + nameField));
			if (temp == null) {
				return "";
			}
		} catch (Exception e) {
			MyLog.error(this, upf,"Parameter " + nameField + " param is empty in MyEntry:getValue() " + e.getMessage());
			MyLog.error(this, upf, e);
			return "";
		}
		return temp;
	}
	
	private String charCode(String point, String dataCon) {
		String convert = dataCon;
		if (point.equals("5")) {
			ThaiUtilities thaicode = new ThaiUtilities();
			convert = thaicode.ASCII2Unicode(dataCon);
		} else if (point.equals("6")) {
			ThaiUtilities thaicode = new ThaiUtilities();
			convert = thaicode.Unicode2ASCII(dataCon);
		} else if (point.equals("0")) {
			convert = dataCon;
		} else {
			convert = dataCon;
		}
		return convert;
	}

	public void setCondition(HashMap con) {
		this.cond = con;
	}

//	public void setParam(HashMap con) {
//		this.param = con;
//	}


	/**
	 * @return the maxlist
	 */
	public int getMaxlist() {
		try{
			if(param.containsKey("maxlist")){
				maxlist = Integer.parseInt((String)param.get("maxlist"));
			}
		}catch(Exception ex){}				
		return maxlist;
	}

	/**
	 * @param maxlist the maxlist to set
	 */
	public void setMaxlist(int maxlist) {
		this.maxlist = maxlist;
	}
	
	public String genThred() throws Exception{
		DbRecord db = new InitialRecord(upf).getDbRecord("com.csc.entity.CSC_Quque");
		db.setDatabaseName(StaticProperties.serverManager.getDatabaseQuque());
		this.param.put("cond", this.cond);
		CscCalendar d = new CscCalendar();
		Vector processList = this.getProcessList();
		int count = 0;
		String processGroup = "";
		
		String process_type="N";
		if(this.param.containsKey("__process_type")){
			process_type = (String)this.param.get("__process_type");
		}
		String tname=(this.getValue("name").length()==0)?this.getValue("tname"):this.getValue("name");
		Vector newProcessList = new Vector();
		InitialEnvironment inv = new InitialEnvironment("GLOBAL");
		for (int i=0; i<processList.size(); i++) {
			count++;
			newProcessList.add(processList.get(i));
			if (count==this.getMaxlist() || i == (processList.size()-1)) {
				this.param.put("csc_process_list", newProcessList);
				db.clearField();
				db.set("ename",this.getValue("ename"));
				db.set("tname",tname);
				db.set("class_name",this.getValue("prclass"));
				if (!StaticProperties.serverManager.isProduction()) {
						db.set("process_status", "T");
						db.set("server_name", StaticProperties.serverManager.getServerName());
				}else{
					db.set("process_status", "W");
					db.set("server_name", "NONE");					
				}				
				db.set("process_type",process_type);
				db.set("process_group","P");
	            db.set("owner", (String) this.upf.get("appname"));
	            db.set("remote_ip", (String) this.upf.get("remote_ip"));
	            db.set("employeeid", (String) this.upf.getEmployee());
	            db.set("companyid", (String) this.upf.getComCode());
	            db.set("user_name", (String) this.upf.get("username"));
	            db.set("screen_name", (String) this.param.get("__screen"));
	            db.set("next_time", d.getYYYYMMDDHHMMSS());
	            db.set("start_time", "waiting");
	            db.set("end_time", "waiting");
	            db.set("process_msg", "");
				db.set("remark",this.getValue("remark"));
	            db.set("process_priority", "9");
				db.set("condition",this.saveCondition(null,d.getYYYYMMDD()));
				db.set("parentid",processGroup);
				db.set("http_port",inv.getValue("SERVER-port"));
				db.set("provider_url",inv.getValue("SERVER-provider_url"));
				db.set("ptype", this.getValue("ptype"));
				db.set("referkey",this.getValue("referkey"));
				db.save();
				if(StringUtils.isBlank(processGroup)) {
					processGroup = db.getString("ququeid");
				}
				newProcessList.clear();
				count = 0;
			} 
		}
		StaticProperties.serverManager.inviteServerCheckQuque();
		
		return processGroup;
	}
	
	public String createQuque(UProfile upf, String engName, String thaiName, String className, String screenName, String remark,  String priority, HashMap condition) throws Exception {
		return createQuque(upf, engName, thaiName, className, screenName, remark,  priority, condition,"","P","N","cond");
	}
	
	public String createWorkFlowProcess(UProfile upf, HashMap paramdata,String engName, String thaiName, String screenName, String remark,String referkey)  throws RemoteException {
		return this.createImmediateQueue(upf, paramdata, engName, thaiName, screenName, remark, "WorkflowProcess","W",referkey); 
	}
	
	public String approveWorkFlowProcess(UProfile upf, HashMap paramdata,String engName, String thaiName, String screenName, String remark,String referkey)  throws RemoteException {
		paramdata.put("uprofile",upf);
		return this.createImmediateQueue(upf, paramdata, engName, thaiName, screenName, remark, "ApproveWorkflowProcess","W",referkey); 
	}
	
	
	public String createQuque(UProfile upf, String engName, String thaiName, String className, String screenName, String remark,  String priority, HashMap condition,String export_type,String process_group,String process_type,String conName) throws Exception {
		DbRecord db = new InitialRecord(upf).getDbRecord("com.csc.entity.CSC_Quque");
		this.param.put(conName, condition);
		CscCalendar d  = new CscCalendar();
		InitialEnvironment inv= new InitialEnvironment("GLOBAL");
		db.clearField();
		db.setDatabaseName(StaticProperties.serverManager.getDatabaseQuque());
		db.set("ename",engName);
		db.set("tname",thaiName);
		db.set("class_name",className);
		db.set("process_status","W");
		db.set("process_type",process_type);
		db.set("process_group",process_group);
        db.set("owner", (String) upf.get("appname"));
        db.set("remote_ip", (String) upf.get("remote_ip"));
        db.set("employeeid", (String) upf.getEmployee());
        db.set("companyid", (String) upf.getComCode());
        db.set("user_name", (String) upf.get("username"));
        db.set("screen_name", screenName);
        db.set("server_name", "NONE");
        db.set("next_time", d.getYYYYMMDDHHMMSS());
        db.set("start_time", "waiting");
        db.set("end_time", "waiting");
        db.set("result_type",export_type);
		db.set("remark",remark);
        db.set("process_priority", priority);
        
        if(conName.trim().length()>0){
        	db.set("condition",this.saveCondition(null,d.getYYYYMMDD()));
        }else{
        	db.set("condition",this.saveCondition(condition,d.getYYYYMMDD()));
        }
		db.set("http_port",inv.getValue("server-port"));
		db.set("provider_url",inv.getValue("server-provider_url"));
		db.set("parentid","");
		db.save();
		this.processID = db.getString("ququeid");
		StaticProperties.serverManager.inviteServerCheckQuque();
		return this.processID; 
	}

	
	public String createQuquePrintOnline(UProfile upf, String engName, String thaiName, String screenName, String remark)  throws RemoteException {
		DbRecord db = new InitialRecord(upf).getDbRecord("com.csc.entity.CSC_Quque");
		CscCalendar d  = new CscCalendar();
		InitialEnvironment inv= new InitialEnvironment("GLOBAL");
		db.clearField();
		db.setDatabaseName(StaticProperties.serverManager.getDatabaseQuque());
		db.set("ename",engName);
		db.set("tname",thaiName);
		db.set("class_name","PrintingOnline");
		db.set("process_status","R");
		db.set("server_name", StaticProperties.serverManager.getServerName());
		db.set("process_type","O");
		db.set("process_group","R");
        db.set("owner", (String) upf.get("appname"));
        db.set("remote_ip", (String) upf.get("remote_ip"));
        db.set("employeeid", (String) upf.getEmployee());
        db.set("companyid", (String) upf.getComCode());
        db.set("user_name", (String) (upf.get("username")));
        db.set("screen_name", screenName);
		db.set("result_type", "EXPORT_PDF");
        db.set("next_time", d.getYYYYMMDDHHMMSS());
        db.set("start_time", d.getYYYYMMDDHHMMSS());
        db.set("end_time", "waiting");
		db.set("remark",remark);
        db.set("process_priority", "0");
		db.set("http_port",inv.getValue("server-port"));
		db.set("provider_url",inv.getValue("server-provider_url"));        
        this.param.put("UPROFILE",upf);
        this.param.put("CONDITION",this.param);
		db.set("condition",this.saveCondition(null,d.getYYYYMMDD()));
		db.set("parentid","");
		if (db.save()==1) {
			StaticProperties.serverManager.createQuquePrintOnline(db.getString("ququeid"),this);
			this.processID = db.getString("ququeid");
		} 
		return processID; 
	}	

	public String createImmediateQueue(UProfile upf, HashMap paramdata,String engName, String thaiName, String screenName, String remark,String classname,String process_type)  throws RemoteException {
		return this.createImmediateQueue(upf, paramdata, engName, thaiName, screenName, remark, classname, process_type, "");
	}
	
	public String createImmediateQueue(UProfile upf, HashMap paramdata,String engName, String thaiName, String screenName, String remark,String classname,String process_type,String referkey)  throws RemoteException {
		if( this.isDuplicateProcessWorkflow(upf , paramdata , process_type, referkey) ){
			return "";
		}
		DbRecord db = new InitialRecord(upf).getDbRecord("com.csc.entity.CSC_Quque");
		CscCalendar d  = new CscCalendar();
		InitialEnvironment inv= new InitialEnvironment("GLOBAL");
		db.clearField();
		db.setDatabaseName(StaticProperties.serverManager.getDatabaseQuque());
		db.set("ename", engName);
		db.set("tname", thaiName);
		db.set("class_name", classname);
		db.set("process_status", "W");
		db.set("server_name", StaticProperties.serverManager.getServerName());
		db.set("process_type", process_type);
		db.set("process_group", "P");
        db.set("owner", (String) upf.get("appname"));
        db.set("remote_ip", (String) upf.get("remote_ip"));
        db.set("employeeid", (String) upf.getEmployee());
        db.set("companyid", (String) upf.getComCode());
        db.set("user_name", (String) (upf.get("username")));
        db.set("screen_name", screenName);
		db.set("result_type", "EXPORT_TXT");
        db.set("next_time", d.getYYYYMMDDHHMMSS());
        db.set("start_time", d.getYYYYMMDDHHMMSS());
        db.set("end_time", "waiting");
		db.set("remark", remark);
        db.set("process_priority", "0");
		db.set("http_port", inv.getValue("server-port"));
		db.set("provider_url", inv.getValue("server-provider_url"));
		db.set("referkey",referkey);
		paramdata.put("cond", paramdata);
		db.set("condition",this.saveCondition(paramdata,d.getYYYYMMDD()));
		db.set("parentid","");
		if (db.save() == 1) {
			this.processID = db.getString("ququeid");
			StaticProperties.serverManager.initialProcess((CSC_Quque)db);
		} 
		
		return processID; 
	}	
	
	private boolean isDuplicateProcessWorkflow(UProfile up , HashMap param , String processType, String referkey){
		if(processType.equalsIgnoreCase("W")){
			if(param.containsKey("runno") && param.containsKey("step_id")){
				String wf_seq_no = param.get("runno").toString();
				String step_id = param.get("step_id").toString();
				//String referkey = up.getEmployee()+"$"+wf_seq_no+"$"+step_id;
				String filter = "referkey='"+referkey+"'";
				if(param.containsKey("transfer_id")){
					filter = "("+referkey+" or TR"+param.get("transfer_id").toString()+"$"+wf_seq_no+"$"+step_id+")";
				}
				DbInquiry inqQ = null;
				try{
					inqQ = new InitialInquiry(up).getDbInquiry("com.csc.entity.CSC_Quque");
		  			inqQ.setColumn("ququeid,referkey,companyid");
		  			inqQ.setFilter(filter);
		  			
					DbRecord workflow_data = new InitialRecord(up).getDbRecord("Workflow_data_notrigger");
		  			workflow_data.setWFOff();
		  			workflow_data.setColumn(workflow_data.getListKey() + ",q_status");
		  			workflow_data.set("runno", wf_seq_no);
		  			if(workflow_data.search("runno") == 1){
		  				if( (!workflow_data.getString("q_status").equalsIgnoreCase("R") && !workflow_data.getString("q_status").equalsIgnoreCase("W") && !workflow_data.getString("q_status").equalsIgnoreCase("E")) && inqQ.recCount() == 0){// óշ͡  ͡ʶҹоӧҹ   q ѧӧҹ
		  					workflow_data.set("q_status", "W");
  			  				workflow_data.setWFOff();
  			  				if(workflow_data.save() > 0){
  			  					return false;
  			  				}
		  				}else{//  ó͡  ͡ӧҹ    Q ӧҹ
		  					return true;
		  				}
		  			}
				}catch(Exception e){
					MyLog.error(this ,up , e);
				}finally{
					if( inqQ != null ){
						inqQ.closeConnection();
					}
				}
			}
		}else{//  óշ Workflow
			return true;
		}
		return false;
	}
}
