package com.csc.library.service;

import java.lang.reflect.Method;
import java.util.HashMap;

import com.csc.library.cscexport.MyExport;
import com.csc.library.cscimport.MyImport;
import com.csc.library.database.ConnectionPools;
import com.csc.library.database.StaticProperties;
import com.csc.library.process.DbProcess;
import com.csc.library.report.ReportEngine;
import com.csc.library.utilities.MailMerge;
import com.csc.library.utilities.MyLog;

/**
 * @author Administrator
 */
public class GenReport  extends ThreadProcess{
//	private DbReport db;
	private String reportID	= "";
	private String status = "";	
	private String expName = "";
//	private String className = "";
	private String export_type;
//	private HashMap param = new HashMap();
//	private UProfile upf = null;
	
	private boolean newFolder = false;
	
//	public void setUProfile(UProfile upf) {
//		this.upf = upf;
//	}
	
	public void setExportType(String export_type) {
		this.export_type = export_type;
	}
	
	public void setClassName(String className) {
		this.className = className;
	}
	
	public void run() {
		try {
			this.upf.put("processID",this.reportID);
			this.upf.setProcessid(this.reportID);
			this.getReport();
			Runtime.getRuntime().gc();
			
		} catch (Exception ex) {
			Runtime.getRuntime().gc();
			MyLog.error(this, this.upf, ex);
		}
	}
	
//	public void setParam(HashMap param) {
//		this.param = param;
//	}
	
	public void setProcessID(String reportID) {
		this.reportID = reportID;
	}
	
	private void getReport() {

		long starttime = System.currentTimeMillis();
		try {
			MyLog.info(this, this.upf, "[REPORT : " + this.className + "]");
			Object obj = null;
			if (this.export_type.equalsIgnoreCase("MAILMERGE")) {
				if (!this.className.equalsIgnoreCase("MAILMERGE")) {
					obj = Class.forName("com.csc.library.process." + this.className).newInstance();
					Class c = obj.getClass();
					Method m = c.getDeclaredMethod("setCondition", new Class[] { HashMap.class });
					m.invoke(obj, new Object[] { this.param.get("CONDITION") });
					m = c.getDeclaredMethod("process", new Class[] { String.class });
					m.invoke(obj, new Object[] { reportID });
				} else {
					MailMerge mm = new MailMerge();
					mm.setCondition((HashMap)this.param.get("CONDITION"));
					mm.process(reportID);
				}

			} else if ((this.export_type.equalsIgnoreCase("EXPORT")) || (this.export_type.equalsIgnoreCase("EXPORTFILE"))) {
				obj = Class.forName("com.csc.library.cscexport." + this.className).newInstance();
				Class c = MyExport.class;
				Method m = c.getDeclaredMethod("setCondition", new Class[] { HashMap.class });
				m.invoke(obj, new Object[] { this.param.get("CONDITION") });
				m = c.getDeclaredMethod("process", new Class[] { String.class });
				m.invoke(obj, new Object[] { reportID });

			} else if (this.export_type.equalsIgnoreCase("IMPORT")) {
				obj = Class.forName("com.csc.library.cscimport." + this.className).newInstance();
				Class c = MyImport.class;
				Method m = c.getDeclaredMethod("setCondition", new Class[] { HashMap.class });
				m.invoke(obj, new Object[] { this.param.get("CONDITION") });
				m = c.getDeclaredMethod("process", new Class[] { String.class });
				m.invoke(obj, new Object[] { reportID });

			} else {
				obj=new ReportEngine((HashMap) this.param.get("CONDITION"), this.reportID,this.upf);
				((ReportEngine)obj).run();
			}
			long endtime = System.currentTimeMillis();
			StaticProperties.serverManager.completeProcess(this.reportID, "Finished!","",obj);	
			System.out.println("END TIME Thread["+this.getId()+"] [processid="+reportID+"] [STATUS="+this.status+"] Time used=[" +(endtime-starttime)+"]");
		
		} catch (Exception ex) {
			try {
				StaticProperties.serverManager.incompleteProcess(this.reportID, ex.getMessage());
				System.out.println("END TIME Process !!!! IN COMPLETE !!!! Thread["+this.getId()+"] [STATUS="+this.status+"] [processid="+reportID+"]" + System.currentTimeMillis());
			} catch (Exception e) {
				e.printStackTrace();
			}			
			MyLog.error(this, this.upf, ex);
		}finally{
			this.endProcess();
		}
	}
	
//	private DbRecord getReportRecord() {
//		DbRecord db = new InitialRecord(this.upf).getDbRecord("lreport_log");
//		return db;
//	}
	
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	
	public void setProcess(String processid, String index, DbProcess db){
		//used in process
	}
	
	@Override
	public void destroy() {

	}

	public String getExportFileName() {
		return expName;
	}

	public void setExportFileName(String expName) {
		this.expName = expName;
	}

	public boolean isNewFolder() {
		return newFolder;
	}

	public void setNewFolder(boolean isnew) {
		this.newFolder = isnew;
	}
	
	public String getProcessId() {
		return reportID;
	}

	
	private void endProcess(){
	try{
		if(this.reportID!=null &&this.reportID.length()>0){
			ConnectionPools cp = (ConnectionPools) StaticProperties.connectionMap.get(this.getUProfile().getDbName().toLowerCase());
			cp.removeConnectionProcess(this.reportID);
			this.reportID="";
		}
	}catch(Exception ex){
		MyLog.error(this, ex);
	}
		
	}
	
}
