package com.csc.library.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;

import com.csc.library.database.StaticProperties;
import com.csc.library.process.DbProcess;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
;
/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class GenService extends Thread {
	private DbProcess	process;
	private HashMap		param;
	private String		processID	= "", schemaName = "", index = "";
	private UProfile 	upf=null;
	public void setProcess(String processid, String index, DbProcess db) {
		this.process = db;
		this.index = index;
		this.processID = processid;
		this.process.setProcessCode(this.processID+":"+index);
		schemaName = new InitialEnvironment("GLOBAL").getValue("schema-name");
	}
	private void runningState() {
		Connection con = null;
		Statement st = null;
		try {
			con = this.initConnection();
			st = con.createStatement();
			st.executeUpdate("update  lprocess_sub set status='R' where processid='" + this.processID + "' and sub_index='" + this.index + "'");
			//	con.commit();
			con.close();
			st.close();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
			try {
				con.close();
				st.close();
			} catch (SQLException ex1) {
				MyLog.error(this, this.upf, ex1);
			}
		}
	}
	private void errorState() {
		Connection con = null;
		Statement st = null;
		try {
			con = this.initConnection();
			st = con.createStatement();
			st.executeUpdate("update  lprocess_sub set end_time='" + new CscCalendar().getDDMMYYYYHHMMSS() + "',status='F' where processid='" + this.processID + "' and sub_index='" + this.index + "'");
			//con.commit();
			con.close();
			st.close();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
			try {
				con.close();
				st.close();
			} catch (SQLException ex1) {
				MyLog.error(this, this.upf, ex1);
			}
		}
	}
	private void completeState() {
		Connection con = null;
		Statement st = null;
		try {
			con = this.initConnection();
			st = con.createStatement();
			st.executeUpdate("update lprocess_sub set end_time='" + new CscCalendar().getDDMMYYYYHHMMSS() + "',status='C' where processid='" + this.processID + "' and sub_index='" + this.index + "'");
			//	con.commit();
			con.close();
			st.close();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
			try {
				con.close();
				st.close();
			} catch (SQLException ex1) {
				MyLog.error(this, this.upf, ex1);
			}
		}
	}
	private void setMessage() {
		try {
			Connection con = this.initConnection();
			Statement st = con.createStatement();
			st.executeUpdate("update lprocess_sub set end_time='" + new CscCalendar().getTimestamp() + "',process_msg='" + this.process.getMessage() + "' where processid='" + this.processID + "' and sub_index='" + this.index + "'");
			//	con.commit();
			//	con.commit();
			con.close();
			st.close();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
	}
	private Connection initConnection() {
		Connection con = null;
		String dbName = this.upf.getDbName();
		try {
			//		con = new ConnectDB(dbName).getConnection();
			con = StaticProperties.myConnection.getConnection(dbName,upf);
			//CscConnection csccon=(CscConnection)con;
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		//csccon.setInfo(this.getClass().getName());
		return con;
	}
	public void run() {
		try {
			this.upf = (UProfile) this.param.get("UProfile");
			this.runningState();
			this.process.process();			
			this.setMessage();
			String process_stat = this.process.getProcessStatus();
			if(process_stat.equals("C")){
				this.completeState();
			}else if(process_stat.equals("F")){
				this.errorState();
			}
			Runtime.getRuntime().gc();
			System.out.println("END TIME    " + System.currentTimeMillis());
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
			this.errorState();
		}
	}	
	public void setParam(HashMap param) {
		this.param = param;
	}
	public void setUProfile1(UProfile upf) {
		this.upf = upf;
	}
	
}
