package com.csc.library.service;
import java.io.File;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.StaticProperties;
import com.csc.library.process.DbProcess;
import com.csc.library.session.ConnectProcess;
import com.csc.library.session.Connectable;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialProcess;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ProcessService  extends Thread {
	private String pName="",processID = "";
	private HashMap cond;
	private UProfile upf=null;
	private String proc_msg = "";

	public void run() {
		try {
			this.genThred();
			Runtime.getRuntime().gc();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
	}
	public void setProcessID(String processID) {
		this.processID = processID;
	}
	private Connection initConnection() {
		Connection con = null;
		String dbName = this.upf.getDbName();
//		con = new ConnectDB(dbName).getConnection();
		try {
			con = StaticProperties.myConnection.getConnection(dbName,upf);
				//CscConnection csccon=(CscConnection)con;
				//csccon.setInfo(this.getClass().getName());
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}

		return con;
	}

	private Vector getProcessList(){
			DbProcess xProcess = new InitialProcess().getProcess(this.pName.trim());
			try {
				xProcess.setParam(cond);
				xProcess.initData(cond);
				this.proc_msg = xProcess.getMessage();
				return  xProcess.getProcessList();
			} catch (Exception e) {
				MyLog.error(this, this.upf, e);
				return null;
			}
	}
	public void setUProfile(UProfile upf){
		this.upf=upf;

	}
	private void getProcess()  {
		DbProcess xProcess = null;
                Connection con=null;
                Statement st=null;
                ResultSet rs=null;
		try {
			con = this.initConnection();
			st = con.createStatement();
			rs = st.executeQuery("select prclass from  lprocess where processid='" + this.processID + "'");
			rs.next();
			this.pName = rs.getString("prclass");
			this.cond = this.getCondition();
			//con.commit();
			rs.close();
			st.close();
			con.close();
			double end = System.currentTimeMillis();
		} catch (Exception e) {
                  try {
        			MyLog.error(this, this.upf, e);
          			rs.close();
        			st.close();
        			con.close();
                  }
                  catch (SQLException ex) {
        			MyLog.error(this, this.upf, ex);
                  }
		}
	}
	
	public void genThred(){
		this.getProcess();
		Vector processList=this.getProcessList();
//		Vector processList=new Vector();
//		for (int i = 0; i < 111; i++) {
//			processList.add(String.valueOf(i));
//		}
		// edit for divide process to other machine
		// divide by number of manchine
		Vector serverList = this.getServerList();
		Vector ratioList = this.getServerRatioList();
		int slsize = serverList.size();
		int rlsize = ratioList.size();
		int sum = 0;
		if (rlsize == slsize) {
			for (int i=0; i<rlsize; i++) {
				sum += Integer.parseInt((String) ratioList.get(i));
			}
		} else {
			for (int i=0; i<rlsize; i++) {
				ratioList.set(i,"1");
			}
			sum = slsize;
		}
		int size = processList.size();
		// calculate amount of section
		int section = size/sum;
		int restsize = size%sum; 
//		if (size%sum > 0) {
//			section++;
//		}
		int savePoint = 0;
        boolean plist=false;
		for (int i=0; i<slsize; i++) {
			Vector newProcessList = new Vector();
			String serverUrl = (String) serverList.get(i);
			int ratio = Integer.parseInt((String)ratioList.get(i));
			int serversize = ratio * section;
			int more = (int) (restsize * ratio)/sum;
			if ((restsize*ratio)%sum > 0) {
				more++;
			}
			serversize += more;
			int j = 0;
			for (j=savePoint; j<serversize+savePoint; j++) {
				if (j==size) {
                    plist=true;
					break;
				}
				newProcessList.add(processList.get(j));
			}
			savePoint = j;
            if(plist && size<slsize){
                break;
            }
            
			int pPerthred = serversize / StaticProperties.processPerThred;
			int restdivide = serversize % StaticProperties.processPerThred;
//			if (serversize % StaticProperties.processPerThred > 0)
//				pPerthred++;
			if (pPerthred < 1) {
				pPerthred = 1;
			}
			MyLog.info(this, this.upf,"//////////////////////Server       : " + serverUrl);
			MyLog.info(this, this.upf,"//////////////////////Process List : " + serversize);
			MyLog.info(this, this.upf,"//////////////////////Thred Connd  : " + StaticProperties.processPerThred);
			MyLog.info(this, this.upf,"//////////////////////Process per  : " + pPerthred);
			MyLog.info(this, this.upf,"//////////////////////Rest Process : " + restdivide);
//			if (pPerthred < 1)
//				pPerthred = 1;
			// divide by thread in one machine
			this.genProcess(serverUrl,newProcessList,pPerthred,i,restdivide);
		}
	}

	private void genProcess(String serverName,Vector processList,int pPerthred,int serverNo,int restdivide) {
		int index = 1;
//		Vector serverList = this.getServerList();
		int plsize = processList.size();
//		int serverChk = 0;
		//String serverName = "";
		int ppt = StaticProperties.processPerThred;
		if (processList.size() == 0) {
			this.genLprocessMessage();
		} else {
			//serverName = (String) serverList.elementAt(serverChk++);
			for (int i = 0; i < processList.size(); i++) {
				Vector list = new Vector();
//				if (serverList.size() == serverChk) {
//					serverChk = 0;
//				}
				try {
					for (int j = 1; j <= pPerthred; j++) {
						if (i == plsize) break;
						
						if (j == pPerthred) {
							list.addElement(processList.elementAt(i));
							if (restdivide > 0) {
								list.addElement(processList.elementAt(++i));
								restdivide--;
							}
						} else
							list.addElement(processList.elementAt(i++));
						
					}
				} catch (RuntimeException e) {
 //       			MyLog.error(this, this.upf, e);
				}
				
//				System.out.println("Server process  " + serverName + " process " + list.size());
				
				
				try {
                    
                    UProfile uprofile=(UProfile)cond.get("UProfile");
					this.genSubLog(uprofile, this.processID, String.valueOf(index+(ppt*serverNo)));
					Connectable con = new  ConnectProcess().getProcess(serverName);
                    
                    uprofile.set("fsecurity","1");
                    uprofile = (UProfile) uprofile.clone();
                    uprofile.clearFieldConfigTemp();
                    this.cond.put("UProfile",uprofile.clone());

					con.process(this.processID, this.pName, index+(ppt*serverNo), this.cond, list);
					MyLog.info(this, this.upf, "Server process  " + serverName + " process " + list);
					index++;
				} catch (Exception e) {
        			MyLog.error(this, this.upf, ">>> Connect to Other Session Bean Error !!!!"+e.toString());
				}
		
			}
		}
		this.removeConditionFile();
	}

	private HashMap getCondition() {
		HashMap data = new HashMap();
		try {
			String FileName = new InitialEnvironment("GLOBAL").getValue("temp-dir") + "/process/condition/" + this.processID.trim() + ".ser";
			FileInputStream fi = new FileInputStream(FileName);
			ObjectInputStream oi = new ObjectInputStream(fi);
			data = (HashMap) oi.readObject();
			oi.close();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		return data;
	}

	private void removeConditionFile(){
		try {
			String fileName = new InitialEnvironment("GLOBAL").getValue("temp-dir") + "/process/condition/" + this.processID.trim() + ".ser";
			File f=new File(fileName);
			f.delete();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}

	}

//	private void printTime(String pName, String time) {
//		try {
//			this.initMyRecordLog(pName);
//			MyLog.info(this, upf, "TOTAL TIME  ON  PROCESS : " + pName + " :  ****************************************");
//			MyLog.info(this, upf, ":" + time + " min.");
//		} catch (Exception e) {
//			MyLog.error(this, upf, e);
//		}
//	}
//	private void initMyRecordLog(String name) {
//		try {
//			FileAppender pLog = (FileAppender) this.logger.getAppender("PROCESS");
//			pLog.setFile("D:\\logs\\process\\" + name + ".txt");
//			pLog.activateOptions();
//		} catch (Exception e) {
//			MyLog.error(this, this.upf, e);
//		}
//	}
	private void genSubLog(UProfile upf, String processid, String subid) {
		DbRecord db = new InitialRecord(upf).getDbRecord("lprocess_sub");
		CscCalendar now = new CscCalendar();
		try {
			db.set("processid", processid);
			db.set("companyid",upf.get("companyid"));
			db.set("sub_index", subid);
			db.set("lastupdate", now.getYYYYMMDD());
			db.set("start_time", now.getDDMMYYYYHHMMSS());
			db.set("nextupdate", now.getYYYYMMDD());
			db.set("end_time","waiting");
			db.set("status", "A");
			db.save();
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	}
	
	private Vector getServerList() {
		Vector serverList = new Vector();
		String server = new InitialEnvironment("GLOBAL").getValue("SERVER-provider_url");
		if (!server.equals("")) {
			StringTokenizer st = new StringTokenizer(server, ",");
			while (st.hasMoreTokens()) {
				serverList.addElement(st.nextToken());
			}
		} else {
			serverList.add("127.0.0.1");
		}
		return serverList;
	}

	private void genLprocessMessage(){
		DbRecord db = new InitialRecord(upf).getDbRecord("lprocess");
		CscCalendar now = new CscCalendar();
		now.setSign("/");
		try {
			db.setColumn("processid,process_msg,companyid");
			db.set("processid", this.processID);
			db.set("process_msg", this.proc_msg);
			db.set("companyid", upf.get("companyid"));
			db.save();
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	}
	
	private Vector getServerRatioList() {
		Vector ratioList = new Vector();
		String ratio = new InitialEnvironment("GLOBAL").getValue("SERVER-provider_ratio");
		if (!ratio.equals("")) {
			StringTokenizer st = new StringTokenizer(ratio, ":");
			while (st.hasMoreTokens()) {
				ratioList.addElement(st.nextToken());
			}
		} else {
			ratioList.add("1");
		}
		return ratioList;		
	}
}
