package com.csc.library.service;

import java.lang.reflect.Method;
import java.rmi.RemoteException;
import java.util.HashMap;

import com.csc.library.cscexport.MyExport;
import com.csc.library.cscimport.MyImport;
import com.csc.library.process.DbReport;
import com.csc.library.report.ReportEngine;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MailMerge;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ReportService extends Thread {
	DbReport			db;
	private String		reportID	= "", className = "", export_type;
	private HashMap		condition	= new HashMap();
	private UProfile	 upf =null;
	public void setUProfile(UProfile upf) {
		this.upf = upf;
	}
	public void setExportType(String export_type) {
		this.export_type = export_type;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public void run() {
		try {
			this.getReport();
			Runtime.getRuntime().gc();
		} catch (Exception ex) {
			Runtime.getRuntime().gc();
			MyLog.error(this, this.upf, ex);
		}
	}
	public void setCondition(HashMap condition) {
		this.condition = condition;
	}
	public void setProcessID(String reportID) {
		this.reportID = reportID;
	}
	private void getReport() {
		int i = 0;
		String schemaName = this.upf.getSchemaName();
		try {
			MyLog.info(this, this.upf, "[REPORT : " + this.className + "]");
			this.updateLog("R");
			if (this.export_type.equalsIgnoreCase("MAILMERGE")) {
				if (!this.className.equalsIgnoreCase("MAILMERGE")) {
					Object obj = Class.forName("com.csc.library.process." + this.className).newInstance();
					Class c = obj.getClass();
					Method m = c.getDeclaredMethod("setCondition", new Class[] { HashMap.class });
					m.invoke(obj, new Object[] { this.condition.get("CONDITION") });
					m = c.getDeclaredMethod("process", new Class[] { String.class });
					m.invoke(obj, new Object[] { reportID });
				} else {
					MailMerge mm = new MailMerge();
					mm.setCondition((HashMap)this.condition.get("CONDITION"));
					mm.process(reportID);
				}
				this.updateFile("rtf");
				this.updateLog("C");
			} else if ((this.export_type.equalsIgnoreCase("EXPORT")) || (this.export_type.equalsIgnoreCase("EXPORTFILE"))) {
				Object obj = Class.forName("com.csc.library.cscexport." + this.className).newInstance();
				Class c = MyExport.class;
				Method m = c.getDeclaredMethod("setCondition", new Class[] { HashMap.class });
				m.invoke(obj, new Object[] { this.condition.get("CONDITION") });
				m = c.getDeclaredMethod("process", new Class[] { String.class });
				m.invoke(obj, new Object[] { reportID });
				this.updateLog("C");
			} else if (this.export_type.equalsIgnoreCase("IMPORT")) {
				Object obj = Class.forName("com.csc.library.cscimport." + this.className).newInstance();
				Class c = MyImport.class;
				Method m = c.getDeclaredMethod("setCondition", new Class[] { HashMap.class });
				m.invoke(obj, new Object[] { this.condition.get("CONDITION") });
				m = c.getDeclaredMethod("process", new Class[] { String.class });
				m.invoke(obj, new Object[] { reportID });
				this.updateLog("C");
			} else {
				new ReportEngine((HashMap) this.condition.get("CONDITION"), this.reportID,this.upf).run();
				this.updateLog("C");
			}
		} catch (Exception ex) {
			this.updateLog("F");
			MyLog.error(this, this.upf, ex);
		}
	}
	private DbRecord getReportRecord() {
		DbRecord db = new InitialRecord(this.upf).getDbRecord("lreport_log");
		return db;
	}
	private void updateFile(String data) {
		DbRecord db = this.getReportRecord();
		try {
			db.setGroupfield("update_file");
			db.set("reportid", this.reportID);
            //db.set("owner", (String) this.upf.get("appname"));
			db.set("file_type", data);
			db.save();
		} catch (RemoteException e) {
			MyLog.error(this, this.upf, e);
		}
	}
	private void updateLog(String data) {
		CscCalendar now = new CscCalendar();
		now.setSign("/");
		DbRecord db = this.getReportRecord();
		try {
			if (data.equals("C")) {
				db.setGroupfield("update_commit");
				db.set("end_time", now.getDDMMYYYYHHMMSS());
			} else {
				db.setGroupfield("update_running");
			}
			db.set("reportid", this.reportID);
			db.set("status", data);
            db.set("owner", (String) this.upf.get("appname"));
			db.save();
		} catch (RemoteException e) {
			MyLog.error(this, this.upf, e);
		}
	}
}
