package com.csc.library.service;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.HashMap;

import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class WriteLogProcess implements Serializable {

	private static final long serialVersionUID = 1L;
	private HashMap		data		= new HashMap();
	private HashMap		condition	= new HashMap();
	private UProfile	 upf=null;
	private String		process_id;
	public void set(String key, String value) {
		this.data.put(key.toUpperCase(), value);
	}
	public void setCondition(HashMap condition) {
		this.condition = condition;
	}
	public void setUProfile(UProfile upf) {
		this.upf = upf;
	}
	public String genProcess() {
		process_id = new GenId(this.upf).getId((String) this.data.get("CONPATH"));
		this.keepCondition();
		this.saveLog();
		return process_id;
	}
	public void keepCondition() {
		String FileName = (String) this.data.get("CONPATH") + this.process_id + ".ser";
		try {
			FileOutputStream fu = new FileOutputStream(FileName);
			ObjectOutputStream ou = new ObjectOutputStream(fu);
			ou.writeObject(this.condition);
			ou.close();
		} catch (IOException ex) {
			MyLog.error(this, this.upf, ex);
		}
	}
	public String saveLog(String returnField) {
		try {
			CscCalendar now = new CscCalendar();
			UProfile up = (UProfile) this.upf.clone();
			//	up.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
			//	up.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
			DbRecord db = new InitialRecord(up).getDbRecord((String) this.data.get("PROCESS"));
			db.setGroupfield("savelog");
			db.set("processid", "0");
			db.set("prclass", (String) this.data.get("PRCLASS"));
			db.set("proc_join", (String) this.data.get("PROC_JOIN"));
			db.set("ptype", (String) this.data.get("PTYPE"));
			db.set("reportid", "0");
			db.set("event", now.getYYYYMMDD());
			db.set("lastupdate", now.getYYYYMMDD());
			db.set("nextupdate", now.getYYYYMMDD());
			now.setSign("/");
			db.set("remote_ip", this.upf.get("remote_ip"));
			db.set("screen_name", (String) this.data.get("SCREEN_NAME"));
			db.set("export_type", (String) this.data.get("EXPORT_TYPE"));
			db.set("file_type", (String) this.data.get("FILE_TYPE"));
			db.set("class_name", (String) this.data.get("CLASS_NAME"));
			db.set("name", (String) this.data.get("NAME"));
			db.set("start_time", now.getDDMMYYYYHHMMSS());
			db.set("end_time", "waiting");
			db.set("status", "A");
			db.set("companyid", up.get("companyid"));
			try {
				db.set("reportcondition", (String) ((HashMap) this.condition.get("CONDITION")).get("OLDFILTER"));
			} catch (RuntimeException e) {
				MyLog.error(this, this.upf, e);
			}
			db.save();
			return db.getString(returnField);
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
			return null;
		}
	}
	public void saveLog() {
		try {
			CscCalendar now = new CscCalendar();
			DbRecord db = new InitialRecord(this.upf).getDbRecord((String) this.data.get("PROCESS"));
			db.setGroupfield("savelog");
			db.set("processid", this.process_id);
			db.set("prclass", (String) this.data.get("PRCLASS"));
			db.set("proc_join", (String) this.data.get("PROC_JOIN"));
			db.set("ptype", (String) this.data.get("PTYPE"));
			db.set("reportid", this.process_id);
			db.set("event", now.getYYYYMMDD());
			db.set("screen_name", (String) this.data.get("SCREEN_NAME"));
			db.set("export_type", (String) this.data.get("EXPORT_TYPE"));
			db.set("file_type", (String) this.data.get("FILE_TYPE"));
			db.set("class_name", (String) this.data.get("CLASS_NAME"));
			//db.set("name", (String) this.data.get("NAME"));
			db.set("tname", (String) this.data.get("TNAME"));
			db.set("ename", (String) this.data.get("ENAME"));
			db.set("remark", (String) this.data.get("REMARK"));
			db.set("condition", this.process_id + ".ser");
			db.set("lastupdate", now.getYYYYMMDD());
			db.set("start_time", now.getDDMMYYYYHHMMSS());
			db.set("end_time", "waiting");
			db.set("nextupdate", now.getYYYYMMDD());
			db.set("status", "A");
			db.set("companyid", this.upf.get("companyid"));
			db.save();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
	}
	/**
	 * Returns the process_id.
	 * @return String
	 */
	public String getProcess_id() {
		return process_id;
	}
	/**
	 * Sets the process_id.
	 * @param process_id The process_id to set
	 */
	public void setProcess_id(String process_id) {
		this.process_id = process_id;
	}
}
