package com.csc.library.session;
import java.math.BigDecimal;
import java.rmi.RemoteException;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

import com.csc.library.database.ChildManager;
import com.csc.library.database.ConfigMetadata;
import com.csc.library.database.ConnectManager;
import com.csc.library.database.DataSet;
import com.csc.library.database.FieldGroup;
import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.PropertyRec;
import com.csc.library.database.RSecurityManager;
import com.csc.library.database.Relation;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.UProfile;
public interface DbRecord extends com.csc.library.database.ChildManager {
    public int search() throws RemoteException;
    public int search(String key) throws RemoteException;
    public String getRunNo() throws RemoteException;
    public boolean set(String field, String data) throws RemoteException;
    public boolean set(String tableName, String field, String data) throws RemoteException;
    public boolean set(String fieldName, boolean data) throws RemoteException;
    public boolean set(String fieldName, byte data) throws RemoteException;
    public boolean set(String fieldName, char data[]) throws RemoteException;
    public boolean set(String fieldName, char data) throws RemoteException;
    public boolean set(String fieldName, short data) throws RemoteException;
    public boolean set(String fieldName, int data) throws RemoteException;
    public boolean set(String fieldName, long data) throws RemoteException;
    public boolean set(String fieldName, float data) throws RemoteException;
    public boolean set(String fieldName, double data) throws RemoteException;
    public boolean set(String fieldName, Timestamp data) throws RemoteException;
    public boolean set(String fieldName, java.sql.Date data) throws RemoteException;
    public boolean set(String fieldName, BigDecimal data) throws RemoteException;
    public boolean set(String fieldName, Time data) throws RemoteException;
    public boolean set(String fieldName, CscCalendar data) throws RemoteException;
    public String getString(String field) throws RemoteException;
    public void restore() throws RemoteException;
    public void restore(String fieldName) throws RemoteException;
    public String getNameKey(String No) throws RemoteException;
    public int save() throws RemoteException;
    public FieldManager getField(String fieldName) throws RemoteException;
    public String getTableName() throws RemoteException;
    public String getFieldList() throws RemoteException;
    public void setAllRequiredFound(boolean require) throws RemoteException;
    public void setRequiredFound(boolean require) throws RemoteException;
    public boolean getRequiredFound() throws RemoteException;
    public boolean setColumn(FieldGroup fg) throws RemoteException;
    public DbRecord getRecordManager(String childName) throws RemoteException;
    public ChildManager getChild(String childName) throws RemoteException;
    public CscCalendar getCscCalendar(String fieldName) throws RemoteException;
    public void clearField() throws RemoteException;
    public int delete() throws RemoteException;
    public int deleteForMyTable() throws RemoteException;
    public boolean setColumn(String columnList) throws RemoteException;
    public boolean setColumn(Vector columnList) throws RemoteException;
    public void setPropDB(String comp, String user, String pwd) throws RemoteException;
    public String getListKey() throws RemoteException;
    public void refreshChild() throws RemoteException;
    public void refreshChild(String childName) throws RemoteException;
    public void setRelationInfo(Hashtable hashRelation) throws RemoteException;
    public void setChildTable(Hashtable hashChild) throws RemoteException;
    public void setFilter(String condition) throws RemoteException;
    public String getDescription() throws RemoteException;
    public String getActualName() throws RemoteException;
    public int assignField(DataSet ds) throws RemoteException;
    public void setFoundData(boolean found) throws RemoteException;
    public void print() throws RemoteException;
    public void printList() throws RemoteException;
    public boolean getBoolean(String fieldName) throws RemoteException;
    public byte getByte(String fieldName) throws RemoteException;
    public char[] getChars(String fieldName) throws RemoteException;
    public char getChar(String fieldName) throws RemoteException;
    public short getShort(String fieldName) throws RemoteException;
    public int getInt(String fieldName) throws RemoteException;
    public long getLong(String fieldName) throws RemoteException;
    public float getFloat(String fieldName) throws RemoteException;
    public double getDouble(String fieldName) throws RemoteException;
    public Timestamp getTimestamp(String fieldName) throws RemoteException;
    public java.sql.Date getDate(String fieldName) throws RemoteException;
    public BigDecimal getBigDecimal(String fieldName) throws RemoteException;
    public Time getTime(String fieldName) throws RemoteException;
    public void setActualName(String name) throws RemoteException;
    public void setTableName(String name) throws RemoteException;
    public Hashtable getRelationInfo() throws RemoteException;
    public Hashtable getEffectTable() throws RemoteException;
    public void setEffectTable(Hashtable hashEffectTable) throws RemoteException;
    public Hashtable getChildTable() throws RemoteException;
    public Relation getRelation(String tableName) throws RemoteException;
    public void putRelation(Relation oRela) throws RemoteException;
    public void removeRelation(String tableName) throws RemoteException;
    public int putChild(ChildManager oChild) throws RemoteException;
    public int putChild(String childName, char type, char usedFor) throws RemoteException;
    public void removeChild(String childName) throws RemoteException;
    public void removeAllChild() throws RemoteException;
    public void putFieldGroup(FieldGroup gf) throws RemoteException;
    public FieldGroup getFieldGroup(String groupCode) throws RemoteException;
    public String getLinkFieldChild(String childName) throws RemoteException;
    public String getLinkFieldParent(String childName) throws RemoteException;
    public Vector getAllFieldGroupName() throws RemoteException;
    public int fieldGroupCount() throws RemoteException;
    public DbTable getTableManager(String childName) throws RemoteException;
    public String listChild() throws RemoteException;
    public boolean foundData() throws RemoteException;
    public void setUsedFor(char usedFor) throws RemoteException;
    public void isChild() throws RemoteException;
    public boolean isReferOn();
    public void setReferOn(boolean referOn);
    public int setCondition(String condition[]) throws RemoteException;
    public void refresh() throws RemoteException;
    public int getSizeKey() throws RemoteException;
    public void setRefreshModel(byte model) throws RemoteException;
    public void setConnectControl(ConnectManager con) throws RemoteException;
    public ConnectManager getConnectControl() throws RemoteException;
    public void appendFrom(DbRecord rec) throws RemoteException;
    public void appendFrom(DbInquiry inq) throws RemoteException;
    public void appendFrom(DbTable tab) throws RemoteException;
    public void setUProfile(UProfile uPro) throws RemoteException;
    public UProfile getUProfile();
    public void setSecurity(RSecurityManager rm) throws RemoteException;
    public int searchForSecurity(String fieldNmae, String value) throws RemoteException;
    public void setErrMess(String mess) throws RemoteException;
    public void setConfirm(boolean confirm) throws RemoteException;
    public int insert() throws RemoteException;
    public void setDatabaseName(String databaseName) throws RemoteException;
    public void setUserId(String uid) throws RemoteException;
    public void setPKObject() throws RemoteException;
    public void setProperties(boolean loadComponent) throws RemoteException;
    public void setProperties() throws RemoteException;
    public void actionLog() throws RemoteException;
    public void setDefaultField(String fieldName) throws RemoteException;
    public void setMessageError(String mess) throws RemoteException;
    public void setMessageWarning(String mess) throws RemoteException;
    public String getMessageError() throws RemoteException;
    public String getMessageWarning() throws RemoteException;
    public Vector listFieldPro(String propertiesName) throws RemoteException;
    public String listField(String propertiesName) throws RemoteException;
    public void setParam(HashMap param) throws RemoteException;
    public HashMap getParam() throws RemoteException;
    public void setParam(String key, String value) throws RemoteException;
    public String getParam(String key) throws RemoteException;
    public void referLangOff() throws RemoteException;
    public void referLangOn() throws RemoteException;
    public String listFieldValue(String prop) throws RemoteException;
    public void setEncryptOn() throws RemoteException;
    public void setEncryptOff() throws RemoteException;
    public String getSystemCode(String field) throws RemoteException;
    public String getSystemCode(String table, String field) throws RemoteException;
    public String getFieldNotSave() throws RemoteException;
    public int save(String keyGroup) throws RemoteException;
    public String getAutoNumber(String field) throws RemoteException;
//    public void setTranSaction(javax.transaction.UserTransaction transaction) throws RemoteException;
    public void setVMetaData(ConfigMetadata vm) throws RemoteException;
    public String getMainHelp() throws RemoteException;
    public String getReferHelp() throws RemoteException;
    public String getMainkey() throws RemoteException;
    public void setGroupfield(String gField) throws RemoteException;
    public HashMap getGroupField() throws RemoteException;
    public DbRecord cloneRecord(boolean isSave) throws RemoteException;
    public RSecurityManager getSecurity() throws RemoteException;
    public Object getObject(String objName) throws RemoteException;
    public boolean wfActive();
    public void setWFOn();
    public void setWFOff();
    public void moveToHis() throws RemoteException;
    public void setFieldList(String fieldlist) throws RemoteException;
    public void formatOn(); 
    public void formatOff();
    public void setFieldFormat(String type);
    public void postInqNext();
    public void preInqNext();
    public void dependOn();
    public void dependOff();
    public void afterLoadConfig();
    public void loadHelp(boolean loadComponent);
    public void searchOriginal();
	public Vector getArrayFieldList();
	public Vector getSystemField();
	public void startUp();
	public void setData(DbRecord r);
	public void setAllDeleteLevel(String delete);
	public String getAllData(); 
//	public void setVerifyOff();
	public String getDataBaseName();
	public String getStringHTML(String fieldName);
	public String getDataFormat(String fieldName);
	public boolean keyOK();
	public String getKeyEmptyList();
	public Vector getAllFieldName();
	public void isSave(boolean isSave);
	public boolean isSave();
	public int getConfirmStatus();
	public boolean isSaveState();
	public MyHashMap getMyHashMap();
	public Vector getConditionOR();
	public Vector getConditionAND();
	public DbRecord clone(UProfile upf);
	public PropertyRec clonePropertyRec(UProfile upf);
	public void setPropertyRec(PropertyRec pr);
	public Vector getColumn_need();
	public PropertyRec getKeyPropertyRec();
	public HashMap getNormalField();
	public Vector getMaindatoryField();
	public HashMap getAliasField();
	public String  getWEkey();
	public ConfigMetadata getConfigMetaData();
	public String getWFactive();
	public String getDocumentno();
	public String getDescThai();
	public String getDescEng();
	public String getDesc();
	public String getEditCheck();
	public  void setProperty(DbRecord motherClass) throws RemoteException;
	public  FieldManager getSearchInfo();
	public PropertyRec getPropertyRec();
	public void setCreateBy(String s);
	public String  getCreateBy();	
	public void setBlankChild();
	public void isSim(boolean isSim);
	public boolean getIsSim();
	public void configInq();
	public String getOriginalValue(String fieldName);
	public String getDbType();
	public Vector getFieldBlob();
	public Vector getFieldUpload();
	
	public String getViewUrl(String field);
	public String getDownloadUrl(String field);
	public String getZipUrl(String field);
	public Vector getAutoNumField();
	public void setTransferRecord(DbRecord dbRecod);
	/**
	 * @author odragonfireo
	 * @param target = table ͧźͧ initial Record зӡ set ͹
	 * @param filter = ͹䢷ͧ¢ 稨зӡź table source 
	 * @param sort = true/false ͻͧѹѭҺѹ֡Դfield ӴѺ field  proçѹµͧӡ sort  column  proçѹ false 
	 *               ҡӹǹ field ҡѹժ field çѹ ͧӡ  setColumn(String) ͧ  
	 */
	public void moveToTable(DbRecord target,String filter,boolean sort);
	/**
	 * @author odragonfireo
	 * @param sql = query 㹡¢
	 * @param deleteSql = query ͧźtable 鹷ҧѧҡ¢º
	 * @see
	 */
	public void moveToTable(String sql,String deleteSql);
	
	/**
	 * create by pas test getField(int)
	 */
//    public boolean set(int index, String data) throws RemoteException;	
//    public boolean set(int index, int data) throws RemoteException;
//    public boolean set(int index, long data) throws RemoteException;
//    public boolean set(int index, float data) throws RemoteException;
//    public boolean set(int index, double data) throws RemoteException;
//    public boolean set(int index, CscCalendar data) throws RemoteException;

//    public FieldManager getField(int index) throws RemoteException;
//	public Vector getmField() ;
//	public String getString(int index) throws RemoteException;
	/**
	 * end create by pas test getField(int)
	 */
	//create by pas  trace object
    public String getObjectTrace();
    
    /* create for transfer workflow*/
    public void setWFTransferOn(String wf_ref_doc);
    public void setWFTransferOff();
	public boolean getWFTransfer();	
	public String getWFRefDoc();
	public String getWorkflowURL();
}
