package com.csc.library.session;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.List;

import javax.naming.Context;
import javax.naming.NamingException;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.database.StaticProperties;
import com.csc.library.utilities.Base64Decoder;
import com.csc.library.utilities.Base64Encoder;
import com.csc.library.utilities.MyEnvironment;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadFile;
import com.csc.library.utilities.WriteFile;
import com.csc.library.utilities.WriteXml;

public class InitialEnvironment{
	private Object				home;
	private String				databaseName;
	private Element				rootElement, dbElement;
	private Context				ctx		= null;
	private MyEnvironment		db		= null;
	//transient private Logger	logger	= Logger.getLogger(InitialEnvironment.class);
    private String configProperties="D:/EnterprisePT/Jboss/properties/config-properties";
    private String configPath="D:/EnterprisePT/Jboss/properties/";
    private String configFile="payrollweb2.xml";
    //private Logger Log = Logger.getLogger(InitialEnvironment.class);
    
	public InitialEnvironment(String databaseName) {
		//String resource = "D:/WebSphere/AppServer/installedApps/PRPEAP.ear/XML/logfile.xml";
		this.databaseName = databaseName;
	}
	public InitialEnvironment() {
		//this.databaseName = new InitialEnvironment("GLOBAL").getValue("db-name");
		this.databaseName = "GLOBAL";
	}
	
	public void setDbName(String dbName){
		this.databaseName=dbName;
	} 
	
	public String getValue(String key) {
		try {
			this.InitialDocument();
			String parent = key.substring(0, key.indexOf("-")).toUpperCase();
			String attribute = key.substring(key.indexOf("-") + 1, key.length()).toLowerCase();
			List list = this.rootElement.getChildren("DATABASE");
			Iterator it = list.iterator();
			while (it.hasNext()) {
				Element obj = (Element) it.next();
				if (obj.getAttributeValue("name").equalsIgnoreCase(this.databaseName)) {
					if (!attribute.equalsIgnoreCase("password")) {
						return obj.getChild(parent).getAttributeValue(attribute);
					} else {
						Element objChild = obj.getChild(parent);
						return this.checkPassword(objChild,obj.getAttributeValue("name"),
								objChild.getAttributeValue(attribute));
					}
				}
			}
		} catch (Exception ex) {
			//ex.printStackTrace();
			return "";
		}
		return "";
	}
	public boolean checkOs() {
		String win = "windows";
//		System.out.println(" SYSTEM.GETPROPERTIES().GET( OS.NAME )"+System.getProperties().get("os.name"));
		if (System.getProperties().get("os.name").toString().toLowerCase().indexOf("windows") != -1) {
			return true;
		} else
			return false;
	}
	    
    public String getPath(){
      return this.configPath;
}

    public String getFileName() {
    	this.configFile=StaticProperties.invBase._configFile;
        return this.configFile;
  }
    
    private String getSystemPath1() {
		String returnValue = "";
		try {
			this.getInitialContext();
			db = (MyEnvironment) this.invokeRemote();
			returnValue = db.getEnv("system-dir");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return returnValue;
	}
	private void getInitialContext() throws NamingException {
		ctx = new MyContext().getInitialContext();
		home = ctx.lookup("StdEnvironment");
	}
	private Object invokeRemote() throws Exception {
		Class c = home.getClass();
		Method mx = c.getDeclaredMethod("create", new Class[] {});
		return mx.invoke(home, new Object[] {});
	}
	
	private String checkPassword(Element element,String dbName,String password) {
		String passw = "";
		String pathfile = this.getPath() + "_tmp" + dbName;
		if(element.getName().equalsIgnoreCase("mapdrive")){
			pathfile = this.getPath() + "_tmp" + dbName+"_"+element.getName();
		}
		File file = new File(pathfile);
		boolean updatefile = false;
		boolean existfile = false;
		boolean samepass = false;
		
		if (file.exists()) {
			existfile = true;
			ReadFile rf = new ReadFile(pathfile);
			String enpass = rf.getString();
			rf.closeFile();
			// check if password not change
			if (password.equals(enpass)) {
				updatefile = false;
			} else {
				Base64Encoder benc = new Base64Encoder(password);
				String encp =  benc.processString();
				if (!encp.equals(enpass)) {
					updatefile = true;
				} else {
					samepass = true;
				}
			}
		} else {
			updatefile = true;
		}
		
		if (updatefile) {
			if (existfile)
				file.delete();
			try {
				file.createNewFile();
			} catch (IOException e) {
				e.printStackTrace();
			}
			passw = password;
			Base64Encoder benc = new Base64Encoder(password);
			String encpass = benc.processString();
			WriteFile wf = new WriteFile(pathfile);
			wf.writeString(encpass);
			wf.closeFile();
			if (element.getAttribute("password") != null)
				element.removeAttribute("password");
			element.addAttribute("password",encpass);
			WriteXml wx = new WriteXml(this.rootElement,this.getPath() + this.getFileName());
			wx.output();
		} else {
			Base64Decoder bdec = new Base64Decoder(password);
			try {
				if (!samepass)
					passw = bdec.processString();
				else {
					passw = password;
					Base64Encoder benc = new Base64Encoder(password);
					String encpass = benc.processString();
					WriteFile wf = new WriteFile(pathfile);
					wf.writeString(encpass);
					wf.closeFile();
					if (element.getAttribute("password") != null)
						element.removeAttribute("password");
					element.addAttribute("password",encpass);
					WriteXml wx = new WriteXml(this.rootElement,this.getPath() + this.getFileName());
					wx.output();					
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return passw;
	}
	
	public Element getRootElement() {
		this.InitialDocument();
		return this.rootElement;
	}
    
    private void InitialDocument() {
		try {
            this.InitialConfig(); 			
			if(!StaticProperties.invBase.isloadDoc){           
				SAXBuilder builder = new SAXBuilder();
	//			this.logger.info("Path Initial : " + this.getPath() + this.getFileName());
				Document stru = builder.build(new File(this.getPath() + this.getFileName()));
				rootElement = stru.getRootElement();
				StaticProperties.invBase._RootElement=rootElement;
				StaticProperties.invBase.isloadDoc=true;
			}else
				rootElement=StaticProperties.invBase._RootElement;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}	
	
    /**
     * @author pas 28092005
     * Ѻ get Ѻ config file
     */
    private Element getRootConfig(String fileName) {
        SAXBuilder builder = new SAXBuilder();
        Document stru = null;
        try {
                stru = builder.build(fileName+".xml");
                return stru.getRootElement();
        } catch (Exception ex) {            
                return null;
        }
 }   
    /**
     * @author pas 28092005
     * Ѻ setѺ config file
     */
    
    private void InitialConfig() {       
        try {
            boolean chkOs=this.checkOs();            
            if(!chkOs) this.configProperties="/EnterprisePT/Jboss/properties/config-properties"; 
            //Log.error("######## OS :>  "+System.getProperties().get("os.name")+" "+chkOs+" configProperties :> "+this.configProperties);
        	if(!StaticProperties.invBase.isconfigDoc){
		            Element conXml=this.getRootConfig(this.configProperties);
		            if(conXml==null){
		                conXml=this.getRootConfig("C:/EnterprisePT/Jboss/properties/config-properties");
		            }            
		            this.configPath=conXml.getChild("CONFIGFILE").getAttributeValue("path");
		            StaticProperties.invBase._configPath=this.configPath;
		            this.configFile=conXml.getChild("CONFIGFILE").getAttributeValue("file");
		            StaticProperties.invBase._configFile=this.configFile;
		            StaticProperties.invBase.isconfigDoc=true;
        	}else{
	                this.configPath=StaticProperties.invBase._configPath;
	                this.configFile=StaticProperties.invBase._configFile;
        	}
        } catch (Exception ex) {
            MyLog.error("######## FILE NOT FOUND :> CONFIG-PROPERTIES "+ex);
        }
    }
        
}
