package com.csc.library.session;

import java.util.HashMap;

import javax.naming.Context;
import javax.naming.NamingException;

import com.csc.library.database.MyInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class InitialInquiry {
	private Context ctx = null;
	private DbInquiry db = null;
	private Object home = null;
	private String uid = "";
	private UProfile user=null;
	private HashMap param = new HashMap();

	public InitialInquiry(UProfile user) {
		this.user = user;
	}

	public InitialInquiry(UProfile user,HashMap param) {
		this.user = user;
		this.param=param;
	}
	
	public DbInquiry getDbInquiry() {
		try {
			db = this.invokeRemote();			
			return this.db;
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
			return null;
		}
	}
	/**
	 *  after get DbInquiry you will set column and refresh before use
	 *  @param table is table name
	 **/
	public DbInquiry getDbInquiry(String table) {
		try {
			db=this.getDbInquiry(table, "", "",false);
//			db = this.invokeRemote();
//			db.setParam(this.param);
//			db.initMyTable(table,"","");
			return this.db;
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
			return null;
		}
	}
	/**
	 *  initValue is boolean for set DbInquiry to setcolum and refresh
	 *  @param table is name of table for get inquiry
	 *  @param initValue is flag for initial value( set column * and refresh data)
	 **/
	public DbInquiry getDbInquiry(String table,boolean initValue) {
		try {
			db=this.getDbInquiry(table, "", "",initValue);
//			db = this.invokeRemote();
//			db.initMyTable(table,"","");
//			if(initValue){
//				db.setColumn("*");
//				db.refresh();
//			}	
			return this.db;
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
			return null;
		}
	}
	/**
	 *  initValue is boolean for set DbInquiry to setcolum and refresh
	 *  @param table is name of table for get inquiry
	 *  @param filter is filter for table
	 * @param initValue is flag for initial value( set column * and refresh data)
	 **/
	public DbInquiry getDbInquiry(String table,String filter,boolean initValue) {
		try {
			db=this.getDbInquiry(table, filter, "",initValue);
//			db = this.invokeRemote();
//			db.initMyTable(table,filter,"");
//			if(initValue){
//				db.setColumn("*");
//				db.refresh();
//			}	
			return this.db;
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
			return null;
		}
	}
	/**
	 *  initValue is boolean for set DbInquiry to setcolum and refresh
	 *  @param table is name of table for get inquiry
	 *  @param filter is filter for table
	 *  @param order is order for table
	 *  @param initValue is flag for initial value( set column * and refresh data)	 
	 **/
	public DbInquiry getDbInquiry(String table,String filter,String order,boolean initValue) {
		try {
			db = this.invokeRemote();
			if(this.param!=null)
				db.setParam(this.param);
			db.initMyTable(table,filter,order);
			if(initValue){
				db.setColumn("*");
				db.refresh();
			}
			return this.db;
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
			return null;
		}
	}

	/*	public DbInquiry getDbInquiry() {
			try {
				//this.uid = uid;
				//		this.getInitialContext();
				db = new MyInquiry(this.user);
				db.setDataSource("jdbc/DS_PRDBS10D");
				db.setSchemaName(this.user.getSchemaName());
			} catch (Exception e) {
				e.printStackTrace();
			}
			return this.db;
		}
	*/
	private void getInitialContext() throws NamingException {
		ctx = new MyContext().getInitialContext();
		home = ctx.lookup("StdDbInquiry");
	}
	
	/*
	private DbInquiry invokeRemote() throws Exception {
		Class c = home.getClass();
		Method mx = c.getDeclaredMethod("create", new Class[] { com.csc.library.utilities.UProfile.class });
		DbInquiry db = (DbInquiry) mx.invoke(home, new Object[] { this.user });
		db.setDataSource(new InitialEnvironment(this.user.getDbName()).getValue("datasource-name"));
		db.setSchemaName(this.user.getSchemaName());
		return db;
	}
	*/
	
	private DbInquiry invokeRemote() throws Exception {
				try {
				//this.uid = uid;
				//		this.getInitialContext();
				db = new MyInquiry(this.user);
				db.setDataSource("jdbc/DS_PRDBS10D");
				db.setSchemaName(this.user.getSchemaName());
			} catch (Exception e) {
				MyLog.error(this, this.user, e);
			}
			return this.db;
	}

	private void invokeInqBean(String bean) {
		try {
		//this.uid = uid;
		//		this.getInitialContext();
		if(bean.indexOf(".")==-1){
			db = (DbInquiry) Class.forName("com.csc.library.inqbean." + this.convertTable(this.convertTable(bean))).newInstance();
		}else{
			db = (DbInquiry) Class.forName(bean).newInstance();
		}
		db.setUProfile(this.user);
		db.setDataSource("jdbc/DS_PRDBS10D");
		db.setSchemaName(this.user.getSchemaName());
	} catch (Exception e) {
		MyLog.error(this, this.user, e);
	}
	
	}	
	private String convertTable(String bean) {
		String tName = bean.toLowerCase();
		return tName.substring(0, 1).toUpperCase() + tName.substring(1, tName.length());
	}	
	/**
	 *  after get DbInquiry you will set column and refresh before use
	 *  @param table is table name
	 **/
	public DbInquiry getInqBean(String bean) {
		try {
			this.invokeInqBean(bean);			
			return this.db;
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
			return null;
		}
	}	
	/**
	 *  initValue is boolean for set DbInquiry to setcolum and refresh
	 *  @param table is name of table for get inquiry
	 *  @param filter is filter for table
	 *  @param order is order for table
	 *  @param initValue is flag for initial value( set column * and refresh data)	 
	 **/
	public DbInquiry getInqBean(String bean,String filter,String order,boolean initValue) {
		try {
			this.invokeInqBean(bean);
			db.setFilter(filter);
			db.setOrderBy(order);			
			if(initValue){
				db.setColumn("*");
				db.refresh();
			}
			return this.db;
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
			return null;
		}
	}	
}