package com.csc.library.session;

import java.lang.reflect.Method;
import java.util.HashMap;
import javax.naming.Context;
import javax.naming.NamingException;
import com.csc.library.database.MyTable;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class InitialTable {

	private String tableName;
	private UProfile user;
	private Context ctx = null;
	private DbTable db = null;
	private Object home = null;
	private HashMap param=new HashMap();

	public InitialTable(UProfile user) {
		this.user = user;
	}

	public InitialTable(UProfile user, HashMap param) {
		this.user = user;
		if(param != null) {
			this.param = (HashMap) param.clone();
		}
	}

	public DbTable getDbTable(String tableName) {
		this.tableName = tableName;
		if(this.param!=null) {
			this.db = new MyTable(this.user, tableName,this.param);
		} else {
			this.db = new MyTable(this.user, tableName);
			try {
				this.db.setParam(this.param);
			} catch (Exception ex) {
				MyLog.error(this, this.user, ex);
			}
		}
		return this.db;
	}


	public DbTable getDbTable(String tableName, boolean loadComponent) {
		this.tableName = tableName;
		if(this.param!=null){
			this.db = new MyTable(this.user, tableName,loadComponent,this.param);
		} else {
			this.db = new MyTable(this.user, tableName,loadComponent);
			try {
					this.db.setParam(this.param);
				} catch (Exception ex) {
					MyLog.error(this, this.user, ex);
				}
		}
		return this.db;
	}

	/*
	 26/12/2547
	 public DbTable getDbTable(String tableName) {
	 this.tableName = tableName;
	 this.db=new MyTable(this.user,tableName);
	 return this.db;
	 }
	 */
	/*
	 old
	 public DbTable getDbTable(String tableName) {
	 this.tableName = tableName;
	 try {
	 this.getInitialContext();
	 db = new MyTable( this.user, this.tableName);
	 db.setUProfile(user);
	 } catch (Exception e) {
	 e.printStackTrace();
	 }
	 return this.db;
	 }
	 */

	private void getInitialContext() throws NamingException {
		ctx = new MyContext().getInitialContext();
		home = ctx.lookup("StdDbTable");
	}

	private DbTable invokeRemote() throws Exception {
		Class c = home.getClass();
		Method mx = c.getDeclaredMethod("create", new Class[] {
				com.csc.library.utilities.UProfile.class,
				java.lang.String.class });
		DbTable db = (DbTable) mx.invoke(home, new Object[] { this.user,
				this.tableName });
		db.setParam(this.param);
		return db;
	}

}
