package com.csc.library.system;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.rmi.RemoteException;
import java.security.Principal;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.lang.StringUtils;

import com.csc.library.database.StaticConfig;
import com.csc.library.database.StaticProperties;
import com.csc.library.entry.ScreenManager;
import com.csc.library.security.ActionLogImp;
import com.csc.library.security.Authorizable;
import com.csc.library.security.JspFileAuthen;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialActionLog;
import com.csc.library.session.InitialAuthorize;
import com.csc.library.session.InitialEntry;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.util.session.SessionListener;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;
public class Task {
	
    protected HttpServletRequest req;
    protected HttpServletResponse res;
    protected HttpSession session;

    protected boolean multiPage = false;
    protected boolean isSim = false;

    protected double start, end;
    
    protected int max=5;
    protected int sessionTimeout=900;
    

    protected String modulePath="";
    protected String classAuthen="";
    protected String scrName = "";
    protected final String sign = "__";
    protected String entery, objName;
    protected String complog = "";
    protected String dblog = "";
    protected String lastEntry="";
    protected String lastObject="";
    protected String appname="";
    protected String rootPage="";

    protected HashMap param;
    protected HashMap screenHash;
    protected Vector oldValueList;
    
    protected InitialEnvironment env;
    protected UProfile user = null;
    protected ScreenManager activeScr = null;
    protected JspFileAuthen jspauthen=new JspFileAuthen();
    protected ActionLogImp al;
    protected CheckNull chk=null;
        
    private boolean redirect=true;
    private boolean keepCache=true;
    
    
    public void setChannel(HttpServletRequest req, HttpServletResponse res) throws Exception {
        this.req = req;
        this.res = res; 
        start = System.currentTimeMillis();
        Enumeration key = req.getParameterNames();
        param = new HashMap();
//        Runtime.getRuntime().gc(); 	//comment by pas 	ͧ͡ҡ garbage ԹҨԴ Thread_locked
        while (key.hasMoreElements()) {
            String pName = (String) key.nextElement();
            param.put(pName, req.getParameter(pName));
        }
        if ((param.get(this.sign + "dbcomp") != null) && (param.get(this.sign + "dbcomp").toString().trim().length() > 0)) {
            this.setDblogin(param.get(this.sign + "dbcomp").toString());
        }
        /**
         * create by pas
         *
         * create date 30-01-2005
         * user check permission of virtual employee in time limit;
         * UProfile isvirtualemp = 1  equals virtual employee
         *
         */
        if ((this.user != null) && (this.user.get("isvirtualemp") != null) && (this.user.get("isvirtualemp").equals("1"))) {
            this.isVirtualUsed();
        }
        this.setAppName();
    }
    
    /**
     * create by pas
     *
     * create date 30-01-2005
     * user check permission of virtual employee in time limit;
     *
     */
    private void isVirtualUsed() {
        CscCalendar current = new CscCalendar();
        CscCalendar startdate = null;
        CscCalendar enddate = null;
        String stdate = "1900-01-01", endate = "1900-01-01";
        try {            
            stdate = this.user.get("vstartdate");
            endate = this.user.get("venddate");                        
            startdate = new CscCalendar(stdate);
            enddate = new CscCalendar(endate);
            if ((current.beforeEquals(startdate)) || (current.afterEquals(enddate))) {
                MyLog.warn(this, this.user, " LOGIN FALSE USERNAME IS EXPIRSE......");
                session.setAttribute("userprofile", null);
            }
        } catch (Exception ex) {
			MyLog.error(this, user, ex);
        }
    }
    
    
    public String getValue(String nameField) {
        String temp = "";
        if ((this.req.getParameter(this.sign + nameField) != null) && (this.req.getParameter(this.sign + nameField).length() > 0)) {
            temp = this.req.getParameter(this.sign + nameField);
        }
        return temp;
    }
    private void setDblogin(String valueField) {
        try {
            this.dblog = valueField.substring(0, valueField.indexOf("-"));
            this.complog = valueField.substring(valueField.indexOf("-") + 1, valueField.length());
        } catch (Exception ex) {
        }
    }
    public void checkProfile() {
        try {        	
        	if(this.session==null){
        		this.session = req.getSession();
        		if(this.session.isNew()){
        			session.invalidate();
        			this.session = req.getSession(true);
            		this.initEnv();
            		this.sessionTimeout=this.getSessionTimeOut();
            		this.session.setMaxInactiveInterval(this.sessionTimeout);
        		}
        	}    		
            if ((this.session.getAttribute("userprofile") == null) || (this.getValue("cmd").equalsIgnoreCase("login")) || (this.getValue("guest").equalsIgnoreCase("true"))){            	
                if(this.getValue("guest").equalsIgnoreCase("true")){
                    if(this.user==null)
                        this.user = this.setGuest();                    
                }else{
                    this.user = this.checkPermission();    
                }
                
                String atm=(user==null)?"":"0";                                
                String accountActive=(atm.length()>0)?((this.user.containsKey("accountactive"))?this.user.get("accountactive").toString():""):"";
                
                if(!accountActive.equalsIgnoreCase("true")) this.user=null;                
                
                if (user == null) {
                   if(accountActive.equalsIgnoreCase("false")){
                       this.sendRedirect("PWDEXPIRE.jsp");
                       return;
                   }else if(accountActive.equals("waiting")){
                      this.sendRedirect("LOGINFAIL.jsp");
                      return;
                  }else{
                	  	 String pageName = this.req.getServletPath();
                	  	 if(pageName.lastIndexOf("/")>1){
                	  		this.sendRedirect("../AUTHORIZEERROR.jsp");
                	  	 }else{
                	  		 this.sendRedirect("./AUTHORIZEERROR.jsp");
                	  	 }
                         return;
                  }                    
                } else {
                    session.setAttribute("userprofile", this.user);
                    session.setAttribute("remote_id",req.getRemoteAddr());
                    if((!this.getValue("guest").equalsIgnoreCase("true"))&&(session.getAttribute("SessionListener")==null)){
                        session.setAttribute("SessionListener",new SessionListener(this.user));
                    }
                    this.param.put("__fixCon", this.user.get("company"));
                      if(this.user.get("firstlogin")!=null && this.user.get("firstlogin").toString().equalsIgnoreCase("true")){ // first Login to changePassword                     
                        this.user.set("appname","empview");
                        this.sendRedirect("./EMPVIEW/PI_PASSWORD.jsp");
                        this.setRedirect(false);
                        return;
                    }else if(this.getValue("return").length()>0){
                    	if(this.getValue("return").indexOf("/")>-1){
                    		this.user.set("appname",this.getValue("return").substring(0,this.getValue("return").indexOf("/")));
                    	}
                        this.sendRedirect("./"+this.getValue("return"));
                        this.setRedirect(false);
                        return;
                    }                     
                }
            
            }else {
            	//check session time out
            	//this.checkSessionTimeout();
                this.user = (UProfile) this.session.getAttribute("userprofile");
            }
            this.authenJspFile();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
        
    private void killScreen(){
    	String key = null;
    	MyTreeMap tree  = new MyTreeMap();
    	long longTime=0;
    	if(!this.screenHash.isEmpty()){
    		Iterator it = this.screenHash.keySet().iterator();
    		while(it.hasNext()){
    			key =(String)it.next();
    			if(this.screenHash.get(key)   instanceof ScreenManager){
    			  try {
    					longTime=((ScreenManager)this.screenHash.get(key)).getLastActive().getTimeInMillis();
					} catch (Exception e) {
						longTime=0;
					}    				
    				tree.put(String.valueOf(longTime),key);
    			}    		
    		}    		
    		if(tree.size()>this.max){
    			Iterator it_K = tree.keySet().iterator();    
    			String curr=null,temp=null;
    			while(it_K.hasNext()){
    				temp=(String)it_K.next();
    				if(curr==null)curr=temp;
    				if(Long.parseLong(curr)>Long.parseLong(temp))curr=temp;
    			}
    			this.screenHash.remove(tree.get(curr));
    		}
    	}
    }
    
    private void setScreenObj(){
    	if(this.screenHash==null){
    		if(this.session.getAttribute("screenhash")==null){
    			this.screenHash  = new HashMap();
    			this.session.setAttribute("screenhash", this.screenHash);    		
    		}else{
    			this.screenHash =(HashMap)this.session.getAttribute("screenhash");
    		}
    	}else{
    		this.session.setAttribute("screenhash", this.screenHash);    		
    	}
    }
    private boolean isClean(String objName, String entry){
    	boolean check=true;
    	
    	if((this.lastEntry.equalsIgnoreCase("ChildEntry"))||(this.lastObject.equalsIgnoreCase(objName))||this.getValue("clean").equalsIgnoreCase("1")){
    		check=false;
    	}
    	return check;
    }
    public Object process(String entry, String objName) {
        try{
        	this.checkProfile();
        	if(this.getUProfile()!=null){
	        	this.getUProfile().clearSystemStatus("");
	        	if(this.user.containsKey("lastEntry")){
	        		this.lastEntry =this.user.get("lastEntry");
	        	}
	        	if(this.user.containsKey("lastObject")){
	        		this.lastObject =this.user.get("lastObject");
	        	}	           
	            this.setScreenObj();
	            String appname = (this.getValue("appname").length()>0)?this.getValue("appname"):this.getAppname();
	            if (appname != null && !appname.equals("")) {
	            	this.user.set("appname",appname);
	            }
	            this.entery = entry;
	            this.objName = objName;
	            if (entry.equalsIgnoreCase("SingleEntry") && this.getValue("cmd") != null) {
	                this.singleProcess(objName);
	            } else if (entry.equalsIgnoreCase("ChildEntry") && this.getValue("cmd") != null) {
	                this.childProcess(objName);
	            } else if (entry.equalsIgnoreCase("MultiEntry") && this.getValue("cmd") != null) {
	                this.multiProcess(objName, "MultiEntry");
	            } else if (entry.equalsIgnoreCase("MultiNoRecEntry") && this.getValue("cmd") != null) {
	                this.multiNoRecProcess(objName, "MultiNoRecEntry");
	            } else {
	                this.actScreenProcess(entry, objName);
	            }
	            this.end = System.currentTimeMillis();
	            //this.printTime(String.valueOf((end-start)/1000));
	            
	            this.setScreenObj();	            
	            this.killScreen();
	            if(!entry.equalsIgnoreCase("helpentry")){
	                this.user.put("lastEntry",entry);
	                this.user.put("lastObject",objName);
	            }
	            if(al==null){	            	
	            	al=(ActionLogImp)this.getUProfile().getObject("actionlogid");
	            	if(al==null){
	            		  al=new InitialActionLog(this.user,String.valueOf(System.nanoTime()),this.req.getSession().getId(),this.req.getRemoteAddr()).getActionLog();         
	            	}
	            	al.setJspOnline(al.getLogid(), this.req.getServletPath(), (String)this.getUProfile().get("appname"), StaticProperties.serverManager.getServerName());
	            }
        	}else {       	  
        	 return null;
        	}
        } catch (Exception e) {
            MyLog.error(this, this.user, e);
        }
        return this.activeScr;
    }
    public Object process(String entry, String objName, boolean multiPage) {
        this.multiPage = multiPage;
        return this.process(entry, objName);
    }
    
    public Object process(String entry, String objName, boolean multiPage,boolean isSim) {
        this.multiPage = multiPage;
        this.isSim=isSim;
        return this.process(entry, objName);
    }
    
    private void singleProcess(String objName) throws Exception {
        	if(((ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+objName))!=null){
        		this.activeScr = (ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+objName);
        		 MyLog.debug(this, this.user, "++++++This single Screen  get from session (cmd=search) "+objName);
        		this.activeScr.setStartActive();
        		this.activeScr.setChannel(this.param); 
        		if(!this.getValue("clean").equalsIgnoreCase("1"))   		
        			this.activeScr.clean();
        		this.activeScr.isSim(this.isSim);
        		this.activeScr.getAndset();
        		this.activeScr.process();
        	}else{       	
    	
        		this.activeScr = (ScreenManager) new InitialEntry().getEntry("SingleEntry");
        		this.activeScr.setStartActive();
        		this.activeScr.setUserProfile(this.user);
        		MyLog.debug(this, this.user, "Task Datamanager : " + objName);
        		this.activeScr.dataManager(objName, this.param);
        		this.activeScr.setChannel(this.param);
        		this.activeScr.isSim(this.isSim);
        		this.activeScr.getAndset();
           		if (this.getValue("cmd").equalsIgnoreCase("search")) 
           			this.activeScr.process();
        		}
        this.activeScr.setLastActive();
        if(this.keepCache){
        	this.screenHash.put(this.getUProfile().get("appname")+"-"+objName, this.activeScr);
        }
    }
    
    private void childProcess(String objName) throws Exception {
        this.activeScr = (ScreenManager) new InitialEntry().getEntry("ChildEntry");
        this.activeScr.setStartActive();
        this.activeScr.setUserProfile(this.user);
        String obj = this.getValue("headMulti");
        ScreenManager multi = (ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+obj);
        if (objName.indexOf(".") > 0) {
            this.activeScr.setTable(multi.getTable(objName.substring(objName.indexOf(".") + 1, objName.length())));
        } else {
            this.activeScr.setTable(multi.getTable(objName));
        }
        this.activeScr.dataManager(objName, this.param);
        this.activeScr.setChannel(this.param);
        this.activeScr.getAndset();
        this.activeScr.process();
        multi.setTable(this.activeScr.getTable(objName));
        multi.setLastActive();
    }
    private boolean isParentCmd(String cmd) {
        return cmd.equalsIgnoreCase("") || cmd.equalsIgnoreCase("save") || cmd.equalsIgnoreCase("search") || cmd.equalsIgnoreCase("delete");
    }
    private void multiProcess(String objName, String entry) throws Exception {
        String message = "", errorMsg = "";
        if (!(this.getValue("cmd").equals("") || this.getValue("cmd").equalsIgnoreCase("search")) || this.multiPage) {
            this.activeScr = (ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+objName);
            MyLog.debug(this, this.user, "++++++This Screen multi get from session (have cmd) "+objName);
            if(this.activeScr==null){
        		this.activeScr = (ScreenManager) new InitialEntry().getEntry(entry);
        		this.activeScr.setStartActive();
        		this.activeScr.setUserProfile(this.user);
        		this.activeScr.dataManager(objName, this.param);
            }
            this.activeScr.setChannel(this.param);
            if(this.isClean(objName, entry))
            	this.activeScr.clean();
            this.activeScr.getAndset();
            this.activeScr.process();
            errorMsg = (String) this.activeScr.getRecord().getParam().get("error_msg");
            this.param.put("error_msg", errorMsg);
        }else 
        if (this.isParentCmd(this.getValue("cmd")) && !this.multiPage ) {
        	if(((ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+objName))!=null){
        		this.activeScr = (ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+objName);
        		MyLog.debug(this, this.user, "This Screen get from session (cmd=search) "+objName);
        		this.activeScr.setStartActive();
        		this.activeScr.setChannel(this.param);        		
                if(this.isClean(objName, entry))
                	this.activeScr.clean();
        		this.activeScr.getAndset();
        		if (this.getValue("cmd").equalsIgnoreCase("search"))
        			this.activeScr.process();
        	}else{
        		this.activeScr = (ScreenManager) new InitialEntry().getEntry(entry);
        		this.activeScr.setStartActive();
        		this.activeScr.setUserProfile(this.user);
        		this.activeScr.dataManager(objName, this.param);
        		this.activeScr.setChannel(this.param);
        		this.activeScr.getAndset();
        		if (this.getValue("cmd").equalsIgnoreCase("search"))
        			this.activeScr.process();
        	}
            this.activeScr.setLastActive();
        }
        if(this.keepCache){
        	this.screenHash.put(this.getUProfile().get("appname")+"-"+objName, this.activeScr);
        }
    }
    private void multiNoRecProcess(String objName, String entry) throws Exception {       	
    	if(((ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+objName))!=null){
        		this.activeScr = (ScreenManager) this.screenHash.get(this.getUProfile().get("appname")+"-"+objName);
        		MyLog.debug(this, this.user, "++++++This multi Screen get from session (cmd=search)   "+objName);
        		this.activeScr.setStartActive();
        		this.activeScr.setChannel(this.param);  
                if(this.isClean(objName, entry))
                	this.activeScr.clean();
        		this.activeScr.getAndset();
        		this.activeScr.process();
        	}else{       	
        		this.activeScr = (ScreenManager) new InitialEntry().getEntry(entry);
        		this.activeScr.setStartActive();
        		this.activeScr.setUserProfile(this.user);
        		this.activeScr.dataManager(objName, this.param);
    			this.activeScr.setChannel(this.param);
    			this.activeScr.getAndset();
    			if ((this.getValue("cmd").equalsIgnoreCase("search")) || (this.getValue("cmd").equalsIgnoreCase("multiSearch")))
    				this.activeScr.process();
        	}

        this.activeScr.setLastActive();
        if(this.keepCache){
        	this.screenHash.put(this.getUProfile().get("appname")+"-"+objName, this.activeScr);
        }    
    }
    private void actScreenProcess(String entry, String objName) throws Exception {
        if ((objName != null) && (!objName.equals(""))) {
            if ((this.activeScr == null) && (!entry.equals(""))) {
                this.activeScr = (ScreenManager) new InitialEntry().getEntry(entry);
                this.activeScr.setStartActive();
                this.activeScr.setUserProfile(this.user);
                if (entry.equalsIgnoreCase("ChildEntry")) {
                    ScreenManager multi = (ScreenManager) session.getAttribute(this.getValue("headMulti"));
                    if (objName.indexOf(".") > 0) {
                        this.activeScr.setTable(multi.getTable(objName.substring(objName.indexOf(".") + 1, objName.length())));
                    } else {
                        this.activeScr.setTable(multi.getTable(objName));
                    }
                }
                this.activeScr.dataManager(objName, this.param);
                this.activeScr.setChannel(this.param);
                this.activeScr.getAndset();
                this.activeScr.setLastActive();
            } else {
                if ((this.activeScr.getType() != null) && (this.activeScr.getType().equalsIgnoreCase("ChildEntry"))) {
                    this.activeScr.setChannel(this.param);
                    this.activeScr.getAndset();
                }
            }
        }
        if (entry.equalsIgnoreCase("MultiEntry"))
            session.setAttribute(objName, this.activeScr);
        if (this.getValue("logout").equals("ok"))
            session.invalidate();
        this.scrName = this.getValue("screen");
    }
    public UProfile checkPermission() throws Exception {
        String sUser = null;
        UProfile up =null;
        boolean authen=false;
        try{
        Principal p = req.getUserPrincipal();
        if (req.getRemoteUser() != null)
            sUser = req.getRemoteUser();
        else
            sUser = this.getValue("user");
        ;
        MyLog.debug(this, this.user, "=============== Login by :::" + sUser);
        String com_profile = req.getParameter("com_profile");
        if (com_profile == null)
            com_profile = new com.csc.library.session.InitialEnvironment("GLOBAL").getValue("db-name");
        Authorizable autho = new InitialAuthorize(sUser, this.getValue("password"), com_profile).getAuthorize();
        if ((this.getValue("isagent") != null) && (this.getValue("isagent").equals("1"))) {
            autho.setAgency(this.getValue("agencyname"));
            autho.setAgencyID(this.getValue("agencyid"));
        }
        autho.setRemoteIP(this.req.getRemoteAddr());
        autho.setSessionID(this.session.getId()); 
        String ulang=(req.getParameter("__lang")!=null)?req.getParameter("__lang"):"";
        if ((this.dblog.length() > 0) && (this.complog.length() > 0)&& ulang.length()>0)
        	authen=autho.checkAuthorize(this.dblog, this.complog,ulang);
        else if ((this.dblog.length() > 0) && (this.complog.length() > 0))
        	authen=autho.checkAuthorize(this.dblog, this.complog);
        else if (this.dblog.length() > 0)
        	authen=autho.checkAuthorize(this.dblog);
        else
        	authen=autho.checkAuthorize();
        if(authen)
        	up = autho.getUProfile();
        }catch(Exception ex){
            MyLog.error(this, this.user, ex);
        }
        return up;
    }
    private void initEnv() {
        try {
            env = new InitialEnvironment("GLOBAL");
        } catch (Exception ex) {
            MyLog.error(this, this.user, ex);
        }
    }
    public void setUProfile(UProfile user) {
        this.user = user;
    }
    public UProfile getUProfile() {
        try {
            return (UProfile) session.getAttribute("userprofile"); 
        } catch (Exception ex) {
            MyLog.debug(this, this.user, "UProfile is null in Task.getUProfile().");
            return null;
        }
    }
    private void printTime(String time) {
           MyLog.info(this, this.user, "TOTAL TIME  ON  ENTRY : " + this.entery + " NAME : " + this.objName + " CMD  " + this.getValue("cmd") + "   : ****************************************");
           MyLog.info(this, this.user, ":" + time + " sec.");
    }
    
    private UProfile setGuest(){
        UProfile g=new UProfile();
        g.set("employeename", "Guest");
        g.set("fullname", "Guest");
        g.set("lang", "THA");
        String dbName = new InitialEnvironment("GLOBAL").getValue(this.dblog+"-name");
        g.setDbName(dbName);
        g.setSchemaName(new InitialEnvironment(dbName).getValue("schema-name"));
        
        g.set("user_level","guest");
        g.set("companyid",this.complog);
        g.set("accountactive", "true");
        g.set("firstlogin","false");
        g.set("user","guest");
        String regional=StaticConfig.getConfigCompany(g, "SM1006");
        String regionallty="";
        if(regional.equals("0")){
        	regionallty=g.get("lang").toString();
        }else{
        	regionallty=regional;
        }
        g.set("regional",regional);
        g.set("formatdate",StaticConfig.getConfigCompany(g, "SM1005")+":"+regional);        
        return g;
    }
    
    private boolean saveAttemp(UProfile up,String attemp) {
         boolean chkLogin=true; 
        try {
            String dbName="";
            InitialEnvironment inv = new InitialEnvironment("GLOBAL");
            if (this.dblog.length() > 0)
                dbName=inv.getValue(dblog+"-name");
            else
                dbName=inv.getValue("db-name");
           
            inv=new InitialEnvironment(dbName);
            
            UProfile uf =null;
            
            if(up==null){    
                uf=new UProfile();
                uf.setDbName(dbName);    
                uf.setUserName(this.getValue("user")); 
                uf.set("username",this.getValue("user"));
                uf.set("lang", "ENG");
            }else{
                uf=up;
            }
            
            DbRecord db = new InitialRecord(uf).getDbRecord("Muser");  
            db.setColumn("usernameid,attemp,status");   
            db.set("usernameid", uf.get("username"));
            if(db.getField("attemp")!=null){
            if(db.search()==1){
                int feq=db.getInt("attemp")+1;
                if(attemp.length()==0)                   
                    db.set("attemp",feq);
                    else
                    db.set("attemp",attemp);         
                    
                    db.set("status","1");
               
                  if(feq>3 && !attemp.equalsIgnoreCase("0")){
                    chkLogin=false;
                    db.set("status","0");
                }
                  db.save();
            }
           }
        } catch (Exception e) {
            MyLog.error(this, this.user, e);
        }
        return chkLogin;
    }

	/**
	 * @return the appname
	 */
	public String getAppname() {
		return appname;
	}

	/**
	 * @param appname the appname to set
	 */
	public void setAppname(String appname) {
		this.appname = appname.toUpperCase();
	}
	

	public String getRootpage() {
		return rootPage;
	}

	public void setRootpage(String rootPage) {
		this.rootPage = rootPage;
	}	

//	private void authenJspFile(){
//		try{
//				if(this.user!=null){
////					System.out.println("START TIME "+System.currentTimeMillis());
//					String pageName=this.req.getServletPath();
//					if(pageName.indexOf(".jsp")>-1){
//						String appname="";
//						if(pageName.lastIndexOf("/")>1)
//							appname=pageName.substring(1,pageName.lastIndexOf("/"));
//						pageName=pageName.substring(pageName.lastIndexOf("/")+1,pageName.lastIndexOf(".jsp"));
//						if(StaticProperties.jspAuthen.isPrivate(appname+"/"+pageName)&&StaticProperties.jspAuthen.isPrivate(pageName)){							
//							if(!StaticProperties.jspAuthen.privilegeAuthen(this.getUProfile(), appname+"_"+pageName)){
//								if(this.getClassauthen().length()==0){
//									sendError(appname);
//								}else if(!StaticProperties.jspAuthen.checkAuthen(this.getClassauthen(),this.getUProfile(),this.param)){
//									sendError(appname);
//								}
//							}
//						}
//					}
////					System.out.println(System.currentTimeMillis());
//				}
//		}catch(Exception ex){
//			MyLog.error(this,"Can't access jsp");
//		}
//	}
	
	private void authenJspFile() {
		
		try {
			if (this.user != null) {
//				System.out.println("START TIME "+System.currentTimeMillis());
				String authenFail="/AUTHENFAIL.jsp";
				String pageName = this.req.getServletPath();
				if (pageName.indexOf(".jsp") > -1) {
					String appname = "";
					if (pageName.lastIndexOf("/") > 1) {
						appname = pageName.substring(1, pageName.lastIndexOf("/"));
					}
					pageName = pageName.substring(pageName.lastIndexOf("/")+1,pageName.lastIndexOf(".jsp"));
					
					if(appname.length()>0){
						authenFail=".."+authenFail;
					}
					
					if (StaticProperties.jspAuthen.isPrivate(appname, pageName)) {
						
						if (!StaticProperties.jspAuthen.checkPrivilegePage(this.getUProfile(), appname, pageName)) {
							if (StringUtils.isBlank(getClassauthen())) {								
								forward(authenFail);
							} else if (!StaticProperties.jspAuthen.checkAuthen(getClassauthen(), getUProfile(), param)) {
								forward(authenFail);
							}
						}
					}
				}
//				System.out.println(System.currentTimeMillis());
			}
		} catch (Exception e) {
			if (this.user != null) {
				MyLog.error(this,this.user, "Can't access jsp "+this.req.getServletPath());
			}
		}
	}
//
//	private void sendError(String appname){
//		try{
//			if(appname.length()>0){
//				this.res.sendRedirect("../AUTHENFAIL.jsp");
//			} else {
//				this.res.sendRedirect("AUTHENFAIL.jsp");
//			}
//			System.out.println("END TIME "+System.currentTimeMillis());
//			return;
//		}catch(Exception ex){}
//	}
	
	public void forward(String location) throws IOException {
		if (isRedirect()) {
			RequestDispatcher disp = req.getRequestDispatcher(location);
			try {
				disp.forward(req, res);
				setRedirect(false);
			}catch(IllegalStateException ex){
				/** Դ IllegalStateException ͧ **/
			} catch (Exception e) {
				req.setAttribute("javax.servlet.error.exception", e);
				res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR,"Could not forward to." + location);
			}
		}
    }
	
	public void sendRedirect(String location){
		try {
			if(isRedirect()){
				this.res.sendRedirect(location);
				setRedirect(false);
			}
		} catch (IOException e) {
			MyLog.error(this,"Can't sendRedirect to "+location);
		}
	}
	
	public String getClassauthen() {
		return classAuthen;
	}

	public void setClassauthen(String classAuthen) {
		this.classAuthen = classAuthen;
	}

//	private boolean captChaValidate(){
//    	Boolean isResponseCorrect =Boolean.FALSE;
//        //remenber that we need an id to validate!
//        String captchaId = session.getId();
//        //retrieve the response
//        String response = req.getParameter("j_captcha_response");
//        // Call the Service method
//         try {
//             isResponseCorrect = CaptchaServiceSingleton.getInstance().validateResponseForID(captchaId,response);
//         } catch (CaptchaServiceException e) {
//              //should not happen, may be thrown if the id is not valid
//         }
//
//         //do something according to the result!
//         return isResponseCorrect.booleanValue();
//	}
	
	private void setAppName(){
		if(this.req.getServletPath().lastIndexOf("/")>-1&&(this.req.getServletPath().indexOf("/")!=this.req.getServletPath().lastIndexOf("/")))
			appname=this.req.getServletPath().substring(1,this.req.getServletPath().lastIndexOf("/"));
		if(session==null && this.req.getSession().getAttribute("userprofile")!=null){
			session=this.req.getSession();
			this.user=(UProfile) session.getAttribute("userprofile");
			if(this.getAppname().trim().length()>0&&!this.getAppname().equalsIgnoreCase(this.user.get("appname"))){
				this.user.set("appname", appname.toUpperCase());
			}
		}		
	}

	public boolean isRedirect() {
		return redirect;
	}

	public void setRedirect(boolean isredirect) {
		this.redirect = isredirect;
	}
	
	public boolean isKeepCache() {
		return keepCache;
	}

	public void setKeepCache(boolean keepCache) {
		this.keepCache = keepCache;
	}
	
	public int getSessionTimeOut(){
		if(this.env==null){
			this.initEnv();
		}
		return Integer.parseInt(this.chkCheckNullString(this.env.getValue("session-timeout"),String.valueOf(this.sessionTimeout)));
	}
	
	public String chkCheckNullString(String str){
		return this.chk.chkNullString(str,"");
	}
	
	public String chkCheckNullString(String str,String strdefault){
		if(this.chk==null){
			this.chk=new CheckNull();
		}
		return this.chk.chkNullString(str,strdefault);
	}
	
	public void checkSessionTimeout(){
		if(this.session!=null){
			long createSession=this.session.getCreationTime();
			long lastSession=this.session.getLastAccessedTime();
			if((lastSession-createSession)>(this.getSessionTimeOut()*1000)){
				this.session.invalidate();
				sendErrorPage();		
			}
		}else{
			   sendErrorPage();           
		}
	}
	
	private void sendErrorPage(){
		 String pageName = this.req.getServletPath();
	  	 if(pageName.lastIndexOf("/")>1){
	  		this.sendRedirect("../AUTHORIZEERROR.jsp");
	  	 }else{
	  		 this.sendRedirect("./AUTHORIZEERROR.jsp");
	  	 }
	  	 this.setRedirect(false);
        return;		
	}	
}
