package com.csc.library.utilities;

import java.text.DecimalFormat;

public class CurrencyToThai {
	private String				curStr;
	private StringBuffer		outputStr	= new StringBuffer();
	private String[]			NumRead		= { "ٹ", "˹", "ͧ", "", "", "", "ˡ", "", "Ỵ", "" };
	private String[]			PositionStr	= { "", "Ժ", "", "ѹ", "", "ʹ", "ҹ" };
	private String[]			currency	= { "ҷ", "ʵҧ" };
	
	public CurrencyToThai() {
		super();
	}
	public CurrencyToThai(int amount) {
		curStr = (new Integer(amount)).toString();
		process();
	}
	public CurrencyToThai(String amount) {
		curStr = amount;
		process();
	}
	public CurrencyToThai(double amount) {
		curStr = (new Double(amount)).toString();
		process();
	}
	protected void process() {
		this.process(this.outputStr);
	}
	/**
	 * <PRE>
	 * ʹѡ㹡 parse Ţӹǹ
	 *  parse Ţȹ
	 * </PRE>
	 * @param outputStr
	 * @return
	 */
	protected String process(StringBuffer outputStr) {
		if (curStr.indexOf(".") != -1 && (curStr.length() - curStr.indexOf(".")) < 3)
			curStr += "0";
		String money = (curStr.indexOf(".")==-1)?curStr:curStr.substring(0, curStr.indexOf("."));
		String fract = (curStr.indexOf(".")==-1)?"0":curStr.substring(curStr.indexOf(".") + 1, curStr.length());
//		 nuball edit 03-09-48
		fract = String.valueOf(Integer.parseInt(fract));
		/***/

		
		if (money.length() > 11) {
			money = this.processMoney(money);
		} else {
			money = this.parse(money);
		}
	/*	fract = this.processFraction(fract);
		System.out.println(money + " " + currency[0] + " " + fract + " " + currency[1]);
		//Nu  ball edit 2-09-48
		return money + " " + currency[0] + " " + fract + " " + currency[1];
		/***************/
		
		/***
		03-09-48
		Nu ball edit ͧҢͧ Boy Դç شȹ ͡ .70   ٹ ʵҧ , 00  ٹٹ ʵҧ
	*/
		fract = this.parse(fract);

//		System.out.println("gen String commit");
		
		if(Integer.parseInt( curStr.substring(curStr.indexOf(".") + 1, curStr.length()))>0)
			return money + " " + currency[0] + " " + fract + " " + currency[1];
		else
			return money + " " + currency[0];	
	}
	/**
	 * <PRE>
	 * 㹡 Parse ŢѡԹ 18 ѡ
	 *  100,000,000,000 Ţ  ˹觾ѹҹ ѹԹ
	 * Թ  1,000,000,000,000  ˹ҹҹ  
	 * </PRE>
	 * @param money Ţзӡŧ
	 * @return String Ѿҡŧ
	 */
	private String processMoney(String money) {
		int len = money.length(), mod = len % 6;
		int count = len / 6, cur_pos = 0, end_pos = 0;
		String str = "", result = "";
		boolean first = true;
		for (int i = 1; i < count + 1; i++) {
			cur_pos = (i - 1) * 6;
			end_pos = (6 * i);
			if (first && mod != 0) {
				str = money.substring(cur_pos, end_pos + mod);
				str = this.parse(str);
				first = false;
			} else {
				str = money.substring(cur_pos + mod, end_pos + mod);
				str = this.parse(str);
			}
			result += str + "ҹ";
		}		
		return result.substring(0, result.length() - 4);
	}
	/**
	 * 㹡 ŧŢ繷ȹͧ
	 * @param fraction  Ţзӡŧ
	 * @return String Ѿҡŧ
	 */
	private String processFraction(String fraction) {
		int fract = 0;
		String result = "";
		for (int i = 0; i < fraction.length(); i++) {
			fract = Integer.parseInt(String.valueOf(fraction.charAt(i)));
			result += this.getThaiNumber(fract);
		}
		return result;
	}
	/**
	 * 㹡 Parse ŢӹǹѡԹ 18 ѡ
	 * @param data
	 * @return
	 */
	private String parse(String data) {
		String tempStr = "", strNum = "", result = "";
		int count = 0;
		boolean first_digit = true;
		for (int i = data.length(); i >= 1; i--) {
			tempStr = "" + data.charAt(count);
			strNum = "";
			int currentNumber = Integer.parseInt(tempStr);
			if (currentNumber != 0) {
				strNum = this.getThaiNumber(first_digit, i - 1, currentNumber, data);
				//System.out.println(strNum);
			}
			first_digit = false;
			result += strNum;
			count++;
		}
		return result;
	}
	/**
	 * <PRE>
	 * ֧ҵŢ աõǨͺ͹䢷¨͹ ͧŢ
	 *  10 Ţ Ժ ѡҹ ˹ҹ  10,000,001,000,000
	 * ͨ Ժҹҹ 
	 * </PRE> 
	 * @param position
	 * @param number
	 * @return
	 */
	protected String getThaiNumber(boolean first, int position, int number, String data) {
		boolean over_million = false;
		int digit = 0;
		if (position >= 6) {
			digit = position % 6;
			over_million = true;
		}
		if ((number == 2) && (digit == 1 || position == 1)) {// check condition for position 2
			if (over_million)
				return "" + PositionStr[digit];
			else
				return "" + PositionStr[position];
		} else if (((digit == 1) || (digit == 0 && position == 1)) && number == 1) {
			return "Ժ";
		} else if (digit == 0 && number == 1 && over_million) {
			if ((position == 6 && data.length() > 7)) {
				return "" + PositionStr[position];
			} else {
				if (position == 6 && data.length() == 7) {
					return "˹" + PositionStr[position];
				} else if (first) {
					return NumRead[number] + PositionStr[digit] + PositionStr[6];
				} else {
					return "";
				}
			}
		} else {
	/*		if (over_million) {
				if ((position > 6) && (first))
					return NumRead[number] + PositionStr[digit] + PositionStr[6];
				else if (position == 6)
					return NumRead[number] + PositionStr[position];
				else
					return NumRead[number] + PositionStr[digit];
			} else {
				if (number == 1 && position == 0)
					return "";
				else
					return NumRead[number] + PositionStr[position];
			}
		}*/
			/** Nu ball edit 03-09-48 **/
			if (over_million) {
				if ((position > 6) && (first))
					return NumRead[number] + PositionStr[digit] ;
				else if (position == 6)
					return NumRead[number] + PositionStr[position];
				else
					return NumRead[number] + PositionStr[digit];
			} else {
				if (number == 1 && position == 0 && (data.length()>1)){
					return "";
				}else
					return NumRead[number] + PositionStr[position];
			}
		}
		/********/		
			
	}
	/**
	 * ֧Ţ ҡ array 
	 * @param number Ţзӡŧ
	 * @return String Ѿҡŧ
	 */
	protected String getThaiNumber(int number) {
		return NumRead[number];
	}
	public String getString() {
		return this.outputStr.toString();
	}
	public String getString(int amount) {
		return this.getString(String.valueOf(amount));
	}
	public String getString(double amount) {
		return this.getString(String.valueOf(amount));
	}
	
	/**
	 * 100 ˹ºҷǹ
	 * @param amount
	 * @param format
	 * @return
	 */
	public String getStringAvancedDesc(double amount, String format)
    {
        if(amount > 0){
        	DecimalFormat nformat = new DecimalFormat(format);
            curStr = String.valueOf(nformat.format(amount));
            return processAavanchedDesc(new StringBuffer());
        }else{
        	return "";
        }
		
    }
	
	
	protected String processAavanchedDesc(StringBuffer outputStr)
    {
        String net_word = "ǹ";
        if(curStr.indexOf(".") != -1 && curStr.length() - curStr.indexOf(".") < 3)
            curStr += "0";
        String money = curStr.indexOf(".") != -1 ? curStr.substring(0, curStr.indexOf(".")) : curStr;
        String fract = curStr.indexOf(".") != -1 ? curStr.substring(curStr.indexOf(".") + 1, curStr.length()) : "0";
        fract = String.valueOf(Integer.parseInt(fract));
        if(money.length() > 11)
            money = processMoney(money);
        else
            money = parse(money);
        fract = parse(fract);
        if(Integer.parseInt(curStr.substring(curStr.indexOf(".") + 1, curStr.length())) > 0)
            return money + currency[0] + fract + currency[1];
        else
            return money + currency[0] + net_word;
    }

	
	
	/**
	 * <PRE>
	 * 	ʹѺŧŢŢ double 
	 * 㹡óշŢ double դ 4.18422635E6 
	 * ͷӡäӹǹзԴ errror  ͧաèѴ format
	 * Ţ͹һż ֧ҧ method ӹ¤дǡ
	 * </PRE>
	 * @param amount  ӹǹзӡäӹǹ  2545646.11 , 4.18422635E6
	 * @param format  ٻẺͧŢ͹令ӹǹ ###.00 ԴŢȹ ###
	 * @return Ţ  ͧԺҺҷ
	 */
	public String getString(double amount, String format) {
		DecimalFormat nformat = new DecimalFormat(format);
		return this.getString(nformat.format(amount));
	}
	/**
	 * Base Method 㹡äӹǹ
	 * @param amount
	 * @return
	 */
	public String getString(String amount) {
		curStr = amount;
		return process(new StringBuffer());
	}

	public static void main(String args[]){
		CurrencyToThai ct = new CurrencyToThai();
		System.out.println(ct.getString(5000.00));
	}

}