package com.csc.library.utilities;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.database.ChildManager;
import com.csc.library.database.ConfigMetadata;
import com.csc.library.database.MyInqReport;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;
public class DbXml {
	DbRecord myRec, rec;
	DbTable myTab, tab;
	DbInquiry myInq = null;
	Element str, table;
	String Obj, typeGet, filterT, filterI;
	String comcode, user, password, requiredFound = null;
	private InitialEnvironment env;
	private HashMap param;
	private UProfile upf=null;
	private String orderby = "";
	private boolean isjoin=false;
	public DbXml(UProfile upf, String objName, String comcode, String user, String password) {
		this.upf = upf;
		this.user = user;
		this.comcode = comcode;
		this.password = password;
		this.myRec = this.rec = null;
		this.initEnv();
		try {
			SAXBuilder builder = new SAXBuilder();
			String pathName="";			
			String appName=this.getAppName(objName);
//			String cssite=this.upf.get("cssite");
			if(appName !=null && !appName.equals("") && !appName.equals("null")){
					pathName=env.getValue("xmlpath-dbxml")+appName+"/"+ objName.toUpperCase() + ".xml";
				File file=new File(pathName);
				if(!file.exists()){
					pathName=env.getValue("xmlpath-dbxml") +objName.toUpperCase() + ".xml";
				}
			}else{
				pathName=env.getValue("xmlpath-dbxml")+ objName.toUpperCase() + ".xml";
			}
			Document stru = builder.build(new File(pathName));
			//this.logger.info(er.info("DBXML : " + env.getValue("xmlpath-dbxml"));
			str = stru.getRootElement();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		this.process();
	}
	public DbXml(UProfile upf, String objName, String comcode, String user, String password, HashMap param) {
		this.param = param;
		this.upf = upf;
		this.user = user;
		this.comcode = comcode;
		this.password = password;
		this.myRec = this.rec = null;
		this.initEnv();
		try {
			SAXBuilder builder = new SAXBuilder();
			String pathName="";
			String appName=this.getAppName(objName);
//			String cssite=this.upf.get("cssite");
			if(appName !=null && !appName.equals("") && !appName.equals("null")){
				pathName=env.getValue("xmlpath-dbxml")+appName+"/"+ objName.toUpperCase() + ".xml";
				File file=new File(pathName);
				if(!file.exists()){
					pathName=env.getValue("xmlpath-dbxml") + objName.toUpperCase() + ".xml";
				}
			}else{
				pathName=env.getValue("xmlpath-dbxml") +objName.toUpperCase() + ".xml";
			}
			 Document stru = builder.build(new File(pathName));
			str = stru.getRootElement();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		this.process();
	}
	public DbXml(String s, String comcode, String user, String password, boolean b) {
		this.user = user;
		this.comcode = comcode;
		this.password = password;
		this.myRec = this.rec = null;
		this.initEnv();
		try {
			SAXBuilder builder = new SAXBuilder();
			Document stru = builder.build(new ByteArrayInputStream(s.getBytes()));
			str = stru.getRootElement();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		this.process();
	}
	protected void processXml() {
		try {
			DbTable s_Table;
			DbRecord s_Record;
			DbInquiry s_Inquiry;
			ChildManager center = null, prv = null;
			Element XTable;
			Integer temp;
			String backOut = "", prvOut;
			List list = str.getChildren();
			Iterator it = list.iterator();
			int i = 1;
			while (it.hasNext()) {
				XTable = (Element) it.next();
				if (!XTable.getName().equalsIgnoreCase("sim")&&!XTable.getName().equalsIgnoreCase("groupby")&&!XTable.getName().equalsIgnoreCase("orderby")&&!XTable.getName().equalsIgnoreCase("filter")) {					String outType = XTable.getAttributeValue("out");
					String dbtype = this.str.getAttributeValue("type");
					if (dbtype != null && !dbtype.equals("") && dbtype.equalsIgnoreCase("inqreport"))
						outType = "record";
					if (outType.equalsIgnoreCase("inquiry")) {
						s_Inquiry = this.setInquiry(XTable);
						if (i == 1) {
							this.myInq = s_Inquiry;
						}
						if ((i > 1)
								&& (XTable.getAttributeValue("central")
										.equalsIgnoreCase("false"))) {
							if (backOut.equalsIgnoreCase("inquiry")) {
								center = (ChildManager) myInq;
							}
							if (backOut.equalsIgnoreCase("table")) {
								center = (ChildManager) myTab;
							}
							if (backOut.equalsIgnoreCase("record")) {
								center = (ChildManager) myRec;
							}
							center.putChild((ChildManager) s_Inquiry);
						} else {
							if ((i > 1)
									&& (!XTable.getAttributeValue("central")
											.equalsIgnoreCase("false"))) {
								prv = this.getPrv(XTable
										.getAttributeValue("central"), center);
								if (prv != null) {
									prv.putChild((ChildManager) s_Inquiry);
								}
							}
						}
					} // if
					if (outType.equalsIgnoreCase("table")) {
						s_Table = this.setTable(XTable);
						if (i == 1) {
							this.myTab = s_Table;
						}
						if ((i > 1)
								&& (XTable.getAttributeValue("central")
										.equalsIgnoreCase("false"))) {
							if (backOut.equalsIgnoreCase("inquiry")) {
								center = (ChildManager) myInq;
							}
							if (backOut.equalsIgnoreCase("table")) {
								center = (ChildManager) myTab;
							}
							if (backOut.equalsIgnoreCase("record")) {
								center = (ChildManager) myRec;
							}
							center.putChild((ChildManager) s_Table);
						} else {
							if ((i > 1)
									&& (!XTable.getAttributeValue("central")
											.equalsIgnoreCase("false"))) {
								prv = this.getPrv(XTable
										.getAttributeValue("central"), center);
								if (prv != null) {
									prv.putChild((ChildManager) s_Table);
								}
							}
						}
					}
					if (outType.equalsIgnoreCase("record")) {
						boolean issave=true;
						if(XTable.getAttributeValue("issave")!=null){
							issave=(XTable.getAttributeValue("issave").equalsIgnoreCase("false"))?false:true;
						}
						s_Record = this.setRecord(XTable,issave);
						if (i == 1) {
							this.myRec = s_Record;
							this.myRec.loadHelp(true);
						}
						if ((i > 1)
								&& (XTable.getAttributeValue("central")
										.equalsIgnoreCase("false"))) {
							//this.logger.info(s_Record);
							if (backOut.equalsIgnoreCase("inquiry")) {
								center = (ChildManager) myInq;
							}
							if (backOut.equalsIgnoreCase("table")) {
								center = (ChildManager) myTab;
							}
							if (backOut.equalsIgnoreCase("record")) {
								center = (ChildManager) myRec;
							}
							center.putChild((ChildManager) s_Record);
						} else {
							if ((i > 1)
									&& (!XTable.getAttributeValue("central")
											.equalsIgnoreCase("false"))) {
								prv = this.getPrv(XTable
										.getAttributeValue("central"), center);
								if (prv != null) {
									prv.putChild((ChildManager) s_Record);
								}
							}
						} // end  if
					} // if
					if (XTable.getAttributeValue("central").equalsIgnoreCase(
							"true")) {
						backOut = outType;
					}
				}
				i++;
			} // end for
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	} //process
	
	
	/**
	 * GET data From Main Table
	 * @param nameTable
	 * @param child
	 * @return
	 */
	protected ChildManager getPrv(String nameTable, ChildManager child) {
		ChildManager childM = null;
		try {
			if (child != null) {
				childM = (ChildManager) child.getChild(nameTable);
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return childM;
	}
	public DbRecord getRecord() {
		//	try {
		//		this.myRec.setTranSaction(new InitialTransaction().getUserTransaction());
		//	} catch (RemoteException e) {
		//	}
//		this.myRec.formatOn();
		return this.myRec;
	} // getRecord
	protected void iniRecord(String rname, String center) {
          center="";
		try {
			if ((center != null) && (center.equalsIgnoreCase("center"))) {
				UProfile upCenter = (UProfile) this.upf.clone();
				upCenter.set("lang", this.upf.get("lang"));
				upCenter.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
				upCenter.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
				upCenter.setCompanyName("CBASE");
				upCenter.setFullName(this.upf.getFullName());
				this.rec = new InitialRecord(upCenter, this.param).getDbRecord(rname);
			} else {
				this.rec = new InitialRecord(this.upf, this.param).getDbRecord(rname);
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	}
	protected void iniSpecialRecord(String rname) {
		try {
			this.rec = (DbRecord) Class.forName("pataya.database." + rname).newInstance();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, "initRecord Exception: " + ex);
		}
	}
	protected DbRecord setRecord(Element recXML) {
		return setRecord(recXML,true);
	}
	
	protected DbRecord setRecord(Element recXML,boolean isSave) {
		try {
			String condi, columnlist;
			condi = columnlist = "";
			if ((recXML.getAttributeValue("special") == null) || (recXML.getAttributeValue("special").equals(""))) {
				this.iniRecord(recXML.getAttributeValue("name"), recXML.getAttributeValue("status"));
			} else {
				this.iniSpecialRecord(recXML.getAttributeValue("special"));
			}
			columnlist = this.getDataList(recXML);
			rec.isSave(isSave);
			if (columnlist.trim().length() < 1) {
				columnlist = "";
			} else {
				columnlist = columnlist.substring(0, columnlist.length() - 1);
			}
			if (columnlist.length() > 0) {
				rec.setColumn(columnlist);
			}
			rec.setParam(this.param);
//			if (((String) StaticProperties.myConfig.get("recordstatus")).equalsIgnoreCase("on")) {
//				ConfigMetadata vm = new ConfigMetadata(this.upf);
//				vm.process();
//				rec.setVMetaData(vm);
//			}
			if (recXML.getAttributeValue("join_type") != null && 
					!recXML.getAttributeValue("join_type").equals("")) {
				rec.setParam("join_type",recXML.getAttributeValue("join_type"));
			} else {
				rec.setParam("join_type","");
			}
			String orderby = this.getDataList(recXML.getChild("ORDER"));
			if (orderby != null && !orderby.equals("")) {
				String aname = this.rec.getActualName();
				String name = recXML.getAttributeValue("name");
				String vname = recXML.getAttributeValue("vname");
				String rname = recXML.getAttributeValue("rname");
				if (aname.equalsIgnoreCase(name)) {
					name = aname;
				} else if (vname != null && !vname.equals("")) {
					if (this.orderby.indexOf(vname) < 0)
						name = vname;
				} else if (rname != null && !rname.equals("")) {
					if (this.orderby.indexOf(rname) < 0)
						name = rname;
				}
				StringTokenizer stn = new StringTokenizer(orderby,",");
				orderby = "";
				while (stn.hasMoreTokens()) {
					String fnameTemp = stn.nextToken();
					orderby = orderby + "," + name + "." + fnameTemp;
				}
				orderby = orderby.substring(1);
				if (this.orderby.length()>0) {
					this.orderby = this.orderby + "," + orderby;
				} else {
					this.orderby = orderby;
				}
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return rec;
	} //setRecord
	public DbTable getTable() {
		try {
			tab.setFilter(filterT);
			
			//	this.myTab.setTranSaction(new InitialTransaction().getUserTransaction());
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
//		this.myTab.formatOn();
		return this.myTab;
	} //getTable
	// ball edit 29-09-03
	protected void iniTable(String tname, String center) {
          //fix for non dbcenter
          center="";
		try {

			if ((center != null) && (center.equalsIgnoreCase("center"))) {
				UProfile uprofileCenter = (UProfile) this.upf.clone();
				uprofileCenter.set("lang", this.upf.get("lang"));
				uprofileCenter.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
				uprofileCenter.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
				this.tab = new InitialTable(uprofileCenter, this.param).getDbTable(tname,true);
			} else {
				this.tab = new InitialTable(this.upf, this.param).getDbTable(tname,true);
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	} // iniTable
	/**************************/
	protected DbTable setTable(Element tableXML) {
		try {
			Element order = tableXML.getChild("ORDER");
			if ((tableXML.getAttributeValue("special") == null)
					|| (tableXML.getAttributeValue("special").equals(""))) {
				this.iniTable(tableXML.getAttributeValue("name"), tableXML
						.getAttributeValue("status"));
			} else {
				this.iniTable(tableXML.getAttributeValue("special"), tableXML
						.getAttributeValue("status"));
			}
			String minorkey = "";
			minorkey = tableXML.getAttributeValue("minorkey");
			String RefreshModel = "";
			RefreshModel = tableXML.getAttributeValue("refreshmodel");
			String blankrecord;
			blankrecord = tableXML.getAttributeValue("blankrecord");
			if (blankrecord == null)
				blankrecord = "";
			int amt = 0;
			if (blankrecord.trim().length() > 0)
				amt = Integer.parseInt(blankrecord);
			if (amt > 0)
				tab.setBlankRecord(amt);
			String condi, columnlist, orderlist;
			Integer temp;
			byte byteRefresh = 1;
			condi = columnlist = orderlist = "";
			columnlist = this.getDataList(tableXML);
			orderlist = this.getDataList(order);
			if (columnlist.trim().length() < 2) {
				columnlist = "";
			} else {
				columnlist = columnlist.substring(0, columnlist.length() - 1);
			}
			if (orderlist.trim().length() < 2) {
				orderlist = "";
			} else {
				orderlist = orderlist.substring(0, orderlist.length() - 1);
			}
			if ((minorkey != null) && (minorkey != "")) {
				tab.setMinorKey(minorkey);
			}
			if ((RefreshModel != null) && (RefreshModel != "")) {
				tab.setRefreshModel(byteRefresh);
			}
			tab.setColumn(columnlist);
			tab.setOrderBy(orderlist);
			ConfigMetadata vm = new ConfigMetadata(this.upf);
			vm.process();
			tab.setVMetaData(vm);
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return tab;
	} // setTable
	public DbInquiry getInquiry() {
		MyInqReport di = null;
		String type = this.str.getAttributeValue("type");
		if (type != null && !type.equals("") && type.equals("inqreport")) {
			di = new MyInqReport(this.upf);
			di.setRecReport(this.myRec);
			String distinct = this.str.getAttributeValue("distinct");
			if (distinct != null && !distinct.equals(""))
				di.appendSql("distinct",distinct);
			Element simElement = this.str.getChild("SIM");
			Iterator child = simElement.getChildren().iterator();
			while (child.hasNext()) {
				Element ele = (Element) child.next();
				di.setSimColumn(ele.getText(),
					ele.getAttributeValue("tablename"),
					ele.getAttributeValue("simname"),
					ele.getAttributeValue("groupby"),
					ele.getAttributeValue("having"),
					ele.getAttributeValue("tablerelate"),
					ele.getAttributeValue("where"));
			}
			Element groupbyElement = this.str.getChild("GROUPBY");
			child = groupbyElement.getChildren().iterator();
			String groupby = new String("");
			while (child.hasNext()) {
				Element ele = (Element) child.next();
				groupby = groupby + " ," + ele.getText();
			}
			try {
				if (!groupby.equalsIgnoreCase("")) {
					di.appendSql("groupby",groupby.substring(2));
					di.appendSql("having",groupbyElement.getAttributeValue("having"));
				}
			} catch (Exception e) {
				MyLog.error(this, this.upf, e);
			}
			di.appendSql("orderby",this.orderby);
			di.setOrderBy(this.orderby);
			return di;
		}
//		this.myInq.formatOn();
		return this.myInq;
	}
	protected DbInquiry iniSpecialInquiry(String iname) {
		////////////////In the future//////////////////
		DbInquiry inq = null;
		try {
			inq = (DbInquiry) Class.forName("pataya.database." + iname).newInstance();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		return inq;
	}
	protected String getDataList(Element dElement) {
		List list = dElement.getChildren();
		Iterator it = list.iterator();
		String data = "";
		while (it.hasNext()) {
			Element obj = (Element) it.next();
			data = data + obj.getText() + ",";
		}
		return data;
	}
	protected DbInquiry iniInquiry(UProfile uprofile,String obj){
		DbInquiry inq = null;
		if(!obj.equalsIgnoreCase("inquiry")){
			inq = new InitialInquiry(uprofile).getInqBean(obj);
		}else{
			inq = new InitialInquiry(uprofile).getDbInquiry();
		}
		return inq;
	}
	protected DbInquiry setInquiry(Element inquiryXML) {
		DbInquiry inq = null;
		String requiredFound = null;
		Element order = inquiryXML.getChild("ORDER");
		String obj="inquiry";
		try {
			// ball edit 29-09-03
                       //String status=inquiryXML.getAttributeValue("status");
                       //fix for non DbCenter
			if((inquiryXML.getAttributeValue("inqbean")!=null)&&(!inquiryXML.getAttributeValue("inqbean").equals(""))){
				obj=inquiryXML.getAttributeValue("inqbean").trim();
			}
            String status="";
			if ((status!= null) && (status.equalsIgnoreCase("center"))) {
				UProfile uprofileCenter = (UProfile) this.upf.clone();
				uprofileCenter.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
				uprofileCenter.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
				inq = iniInquiry(uprofileCenter,obj);
				inq.setParam(this.param);
			} else {
				inq =iniInquiry(this.upf,obj); 
				inq.setParam(this.param);
			}
			if ((inquiryXML.getAttributeValue("special") == null) || (inquiryXML.getAttributeValue("special").equals(""))) {
				inq.initMyTable(inquiryXML.getAttributeValue("name"), "", "");
			} else {
				inq = this.iniSpecialInquiry(inquiryXML.getAttributeValue("special"));
			}
			if((inquiryXML.getAttributeValue("inqbean")!=null)&&(!inquiryXML.getAttributeValue("inqbean").equals(""))){
				if (inquiryXML.getChild("GROUP")!=null) {
					Element group = inquiryXML.getChild("GROUP");
					String grouplist =this.getDataList(group);
					inq.setGroupBy(grouplist);
				}
				
				Element sum = inquiryXML.getChild("SUM");
				if(sum !=null) inq.setSumColumn(sum.getTextTrim());
				
				Element avg = inquiryXML.getChild("AVG");
				if(avg !=null) inq.setAVGColumn(avg.getTextTrim());

				Element min = inquiryXML.getChild("MIN");
				if(min !=null) inq.setMinColumn(min.getTextTrim());
				
				Element max = inquiryXML.getChild("MAX");
				if(max !=null) inq.setMaxColumn(max.getTextTrim());
				
				Element udf = inquiryXML.getChild("UDF");
				if(udf !=null) inq.setUDFColumn(udf.getTextTrim());		
				
			
			}
			/******************************/
		
			if (this.param != null) {
				String resultSet = (String) this.param.get("__resultSet");
				if (resultSet == null) {
					resultSet = (String) this.param.get("RESULTSET");
				}
				if (resultSet != null && !resultSet.equalsIgnoreCase("")) {
					inq.setResultSet(resultSet);
				}
				{
					resultSet = inquiryXML.getAttributeValue("resultset");
					if (resultSet != null && !resultSet.equals("")) {
						inq.setResultSet(resultSet);
					}
				}
			}
			/**** setFetchAll ***/
			if (inquiryXML.getAttributeValue("fetchall") != null && inquiryXML.getAttributeValue("fetchall").equals("true")) {
				inq.setFetchAll(true);
			}
			/****************/
			this.requiredFound = inquiryXML.getAttributeValue("requiredfound");
			String condi, columnlist, orderlist;
			//      Integer temp,I;
			condi = columnlist = orderlist = "";
			columnlist = this.getDataList(inquiryXML);
			orderlist = this.getDataList(order);
			/*      if(condi.trim().length()< 4)condi = "";
			      else condi= condi.substring(0,condi.length()-4);*/
			if (columnlist.trim().length() < 2) {
				columnlist = "";
			} else {
				columnlist = columnlist.substring(0, columnlist.length() - 1);
			}
			if (orderlist.trim().length() < 2) {
				orderlist = "";
			} else {
				orderlist = orderlist.substring(0, orderlist.length() - 1);
			}
			inq.setColumn(columnlist);
			inq.setOrderBy(orderlist);
			//      filterI =condi;
			// Inq.setPropDB(this.comcode,this.user,this.password);
			if ((this.requiredFound != null) && (this.requiredFound.equalsIgnoreCase("true"))) {
				inq.setAllRequiredFound(true);
			}
			//			ConfigMetadata vm=new  ConfigMetadata(this.upf);
			//			vm.process();
//			if (((String) StaticProperties.myConfig.get("inquirystatus")).equalsIgnoreCase("on")) {
//				inq.setVerifyOn();
//				inq.setViewVerifyInsertOn();
				//inq.setViewVerifyUpdateOn();
//			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return inq;
	}
	private void initEnv() {
		env = new InitialEnvironment("GLOBAL");
	}
	protected void process() {
		isjoin=(this.str.getAttributeValue("isjoin")!=null && this.str.getAttributeValue("isjoin").equalsIgnoreCase("true"))?true:false;
		if(isjoin)
			this.joinTableXml();
		else
			this.processXml();
	}
	
	private void joinTableXml(){
		try {
			DbTable s_Table;
			DbRecord s_Record;
			DbInquiry s_Inquiry;
			ChildManager center = null, prv = null;
			Element XTable;
			Integer temp;
			String backOut = "", prvOut;
			List list = str.getChildren();
			Iterator it = list.iterator();
			int i = 1;
			while (it.hasNext()) {
				XTable = (Element) it.next();
				if (!XTable.getName().equalsIgnoreCase("sim")&&!XTable.getName().equalsIgnoreCase("groupby")&&!XTable.getName().equalsIgnoreCase("orderby")&&!XTable.getName().equalsIgnoreCase("filter")) {
					String outType = XTable.getAttributeValue("out");
					String dbtype = this.str.getAttributeValue("type");
					String aliasname=XTable.getAttributeValue("aliasname");					
					if (dbtype != null && !dbtype.equals("") && dbtype.equalsIgnoreCase("inqreport"))
						outType = "record";
					if (outType.equalsIgnoreCase("inquiry")) {
						s_Inquiry = this.setInquiry(XTable);
						s_Inquiry.setAliasName(aliasname);
						if (i == 1) {
							this.myInq = s_Inquiry;
							this.myInq.isJoinTable(true);
							String orderby = this.getOrderby();
							String groupby = this.getGroupby();
							String filter  = this.getFilter();			
							this.myInq.setOrderJoin(orderby);
							this.myInq.setGroupJoin(groupby);
							this.myInq.setFilterJoin(filter);
						}
						if ((i > 1)	&& (XTable.getAttributeValue("central")	.equalsIgnoreCase("false"))) {
							if (backOut.equalsIgnoreCase("inquiry")) {
								center = (ChildManager) myInq;
							}
							if (backOut.equalsIgnoreCase("table")) {
								center = (ChildManager) myTab;
							}
							if (backOut.equalsIgnoreCase("record")) {
								center = (ChildManager) myRec;
							}
							center.putChild((ChildManager) s_Inquiry);
						} else {
							if ((i > 1)&& (!XTable.getAttributeValue("central").equalsIgnoreCase("false"))) {
								prv = this.getPrv(XTable.getAttributeValue("central"), center);
								if (prv != null) {
									prv.putChild((ChildManager) s_Inquiry);
								}
							}
						}
					} // if
					if (outType.equalsIgnoreCase("table")) {
						s_Table = this.setTable(XTable);
						s_Table.setAliasName(aliasname);
						if (i == 1) {
							this.myTab = s_Table;
						}
						if ((i > 1)
								&& (XTable.getAttributeValue("central")
										.equalsIgnoreCase("false"))) {
							if (backOut.equalsIgnoreCase("inquiry")) {
								center = (ChildManager) myInq;
							}
							if (backOut.equalsIgnoreCase("table")) {
								center = (ChildManager) myTab;
							}
							if (backOut.equalsIgnoreCase("record")) {
								center = (ChildManager) myRec;
							}
							center.putChild((ChildManager) s_Table);
						} else {
							if ((i > 1)
									&& (!XTable.getAttributeValue("central")
											.equalsIgnoreCase("false"))) {
								prv = this.getPrv(XTable
										.getAttributeValue("central"), center);
								if (prv != null) {
									prv.putChild((ChildManager) s_Table);
								}
							}
						}
					}
					if (outType.equalsIgnoreCase("record")) {
						boolean issave=true;
						if(XTable.getAttributeValue("issave")!=null){
							issave=(XTable.getAttributeValue("issave").equalsIgnoreCase("false"))?false:true;
						}
						s_Record = this.setRecord(XTable,issave);
						s_Record.setAliasName(aliasname);
						if (i == 1) {
							this.myRec = s_Record;
							this.myRec.loadHelp(true);
						}
						if ((i > 1)
								&& (XTable.getAttributeValue("central")
										.equalsIgnoreCase("false"))) {
							//this.logger.info(s_Record);
							if (backOut.equalsIgnoreCase("inquiry")) {
								center = (ChildManager) myInq;
							}
							if (backOut.equalsIgnoreCase("table")) {
								center = (ChildManager) myTab;
							}
							if (backOut.equalsIgnoreCase("record")) {
								center = (ChildManager) myRec;
							}
							center.putChild((ChildManager) s_Record);
						} else {
							if ((i > 1)
									&& (!XTable.getAttributeValue("central")
											.equalsIgnoreCase("false"))) {
								prv = this.getPrv(XTable
										.getAttributeValue("central"), center);
								if (prv != null) {
									prv.putChild((ChildManager) s_Record);
								}
							}
						} // end  if
					} // if
					if (XTable.getAttributeValue("central").equalsIgnoreCase(
							"true")) {
						backOut = outType;
					}
				}
				i++;
			} // end for
			
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		
	}
	private String getOrderby(){
		String orderby="";
		if(str.getChild("ORDERBY")!=null){
			 List list=str.getChild("ORDERBY").getChildren();
			 if(list!=null){
			 Element em=null;
			 String ordername="";
			 	for(int i=0;i<list.size();i++){
			 		em=(Element) list.get(i);
			 		ordername=em.getAttributeValue("table")+"."+em.getTextTrim();		 		
			 		orderby+=ordername.toLowerCase();
			 		if(i!=list.size()-1)
			 			orderby+=",";
			 	}
			 }
		}
		 return orderby;
	}

	private String getGroupby(){
		String groupby="";
		if(str.getChild("GROUPBY")!=null){		
		 List list=str.getChild("GROUPBY").getChildren();
		 if(list!=null){
		 Element em=null;
		 String groupname="";
		 	for(int i=0;i<list.size();i++){
		 		em=(Element) list.get(i);
		 		groupname=em.getAttributeValue("table")+"."+em.getTextTrim();
 				groupby+=groupname.toLowerCase();
		 		if(i!=list.size()-1)
		 			groupby+=",";
		 	}
		 }
		}
		 return groupby;
	}
	
	private String getFilter(){
		 String filter="";		
		 if(str.getChild("FILTER")!=null){
			 List list=str.getChild("FILTER").getChildren();
			 if(list!=null){
			 Element em=null;
			 String keyname="";
			 String svalue="";
			 	for(int i=0;i<list.size();i++){
			 		em=(Element) list.get(i);
			 		keyname=em.getAttributeValue("table")+"."+em.getTextTrim();
			 		svalue=em.getAttributeValue("value");
					filter+=keyname.toLowerCase()+"='"+svalue+"'";
			 		if(i!=list.size()-1)
			 			filter+=" and ";
					
			 	}
			 }
		 }
		 return filter;
	}
	
	private String getAppName(String xmlfile){
		String appName=this.upf.get("appname");	
		if(xmlfile.indexOf("/")>-1)
			appName="";
		return appName;
	}
}
