package com.csc.library.utilities;
import java.io.IOException;
import java.io.StringReader;
import java.util.Map;

import koala.dynamicjava.parser.wrapper.JavaCCParserFactory;
/**
 *  Class for interpret java file during Runtime
 **/
public class DynamicJava extends koala.dynamicjava.interpreter.TreeInterpreter {
	private CscCalendar calendar;
	public DynamicJava() {
		super(new JavaCCParserFactory());
		calendar = new CscCalendar();
	}
	public CscCalendar getCalendar() {
		return calendar;
	}
	/**
	 *  Get variable from environment in dynamic java
	 * */
	public Map getConstant() {
		return this.evalVisitorContext.getConstants();
	}
	/**
	 *  Interpret String
	 *  @param interpretstring is String for interpret
	 *  @param fact is factory (same factory is same environment)
	 * */
	public Object interpret(String interpretstring, String fact) {
		if (interpretstring == null || interpretstring.equals("")) {
			MyLog.warn(this, "!!!!!!!!!!!!!!String for interpret is null or blank value!!!!!!!!!!!!!!");
			return null;
		} else {
			Object result =null;
			try{
					result= super.interpret(new StringReader(interpretstring), fact);
			}catch(Exception ex){
				MyLog.error(this,ex);
			}
			if (result != null)
				MyLog.debug(this, "Result is:" + result.toString());
			return result;
		}
	}
	/**
	 *  Interpret File
	 *  @param fname is name of file to interpret
	 *  @return Object after interpret
	 * */
	public Object interpretFile(String fname) {
		try {
			return super.interpret(fname);
		} catch (IOException ex) {
			MyLog.error(this,  ex);
			return null;
		}
	}
}