package com.csc.library.utilities;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.StringTokenizer;
import java.util.Vector;

public class FileString {
	private String				data;
	private String				fileName;
	private Vector				lazyString	= new Vector();
	private boolean				lazy		= false;
	public FileString() {
		super();
	}
	public void setFileName(String str) { // set filename to class
		this.fileName = str;
	}
	public String toString() {
		return this.getData();
	}
	public Vector subString(String a, String dim) {
		Vector tmpData = new Vector();
		while (a.length() > 0) {
			if (a.indexOf(dim) != -1) {
				tmpData.addElement(a.substring(0, a.indexOf(dim)));
				a = a.substring(a.indexOf(dim) + 4, a.length());
			} else {
				tmpData.addElement(a);
				a = "";
			}
		}
		return tmpData;
	}
	private void fecthStringToVector(char delim, String tokenString, Vector result) {
		StringTokenizer sz = new StringTokenizer(this.getData(), String.valueOf(delim));
		while (sz.hasMoreTokens()) {
			this.addLazyString(sz.nextToken());
		}
	}
	public String getToken(int index, char delim) {
		if (this.isLazy()) {
			if (index == 0) {
				if (this.getLazyString().isEmpty() && (this.getData().indexOf(delim) > -1)) {
					this.fecthStringToVector(delim, this.getData(), this.getLazyString());
				}
				return this.getLazyString(0);
			} else {
				return (String) this.getLazyString(index);
			}
		} else {
			StringTokenizer sz = new StringTokenizer(this.getData(), String.valueOf(delim));
			String result = "";
			for (int i = 0; i <= index; i++) {
				if (sz.hasMoreTokens()) {
					result = sz.nextToken();
				}
			}
			return result;
		}
	}
	public String getStringFL(int begin, int end) {
		int count = 0;
		String tmpStr = "";
		boolean chk = true;
		while (chk) {
			if (count >= begin) {
				if (count > end) {
					return tmpStr;
				} else
					tmpStr += this.data.charAt(count);
			}
			count++;
		}
		return tmpStr;
	}
	public void clearData() {
		this.data = "";
		this.setLazy(false);
	}
	public boolean setData(int newData) { // set data(String) to class
		this.data = String.valueOf(newData);
		this.setLazy(false);
		return true;
	}
	public boolean setData(double newData) { // set data(String) to class
		this.data = String.valueOf(newData);
		this.setLazy(false);
		return true;
	}
	public boolean setData(String str) { // set data(String) to class
		if (str == null || str.equals("")) {
			return false;
		} else {
			this.data = str;
			this.setLazy(false);
			return true;
		}
	}
	public void addData(String addStr) {
		this.data += addStr;
		this.setLazy(false);
	}
	public boolean setDataFile(String fName) { // set data(file) to class
		if (fName == null || fName.equals("")) {
			return false;
		} else {
			try {
				FileReader fin = new FileReader(fName);
				BufferedReader bin = new BufferedReader(fin);
				StringBuffer strBuf = new StringBuffer();
				while (bin.ready()) {
					strBuf.append((char) bin.read());
				}
				this.data = strBuf.toString();
				this.setLazy(false);
			} catch (IOException ex) {
				MyLog.error(this, ex);
				return false;
			}
			return true;
		}
	}
	public String getData() {
		return this.data;
	}
	public String addBlank(int digit, String blank, int newData) {
		Integer tmpInt = new Integer(newData);
		return this.addBlank(digit, blank, tmpInt.toString());
	}
	public String addBlank(int digit, String blank, double newData) {
		Double tmpDbl = new Double(newData);
		return this.addBlank(digit, blank, tmpDbl.toString());
	}
	public String addBlank(int digit, String blank, String newData) {
		//this.logger.info(newData);
		String tmpBlank = this.repeat(blank, digit);
		String output = (tmpBlank) + newData;
		return output.substring(output.length() - digit, output.length());
	}
	public String addBlank(int digit, String blank, String align, int newData) {
		this.setData(new Integer(newData).toString());
		return this.addBlankData(digit, blank, align);
	}
	public String addBlank(int digit, String blank, String align, double newData) {
		this.setData(new Double(newData).toString());
		return this.addBlankData(digit, blank, align);
	}
	public String addBlank(int digit, String blank, String align, String newData) {
		this.setData(newData);
		return this.addBlankData(digit, blank, align);
	}
	public String addBlankData(int digit, String blank, String align) {
		String tmpBlank = "", tmpData = "";
		tmpData = this.data;
		for (int i = 0; i < digit; i++) {
			tmpBlank += blank;
		}
		if (align.equalsIgnoreCase("left")) {
			tmpData = tmpData + tmpBlank;
			this.data = tmpData.substring(0, digit);
		} else if (align.equalsIgnoreCase("right")) {
			tmpData = tmpBlank + tmpData;
			this.data = tmpData.substring(tmpData.length() - digit, tmpData.length());
		} else {
			MyLog.error(this, "ERROR: No such alignment");
		}
		return this.data;
	}
	public String replaceAll(String cut, String strRplc) {
		String tmp2 = "", tmp3 = "", tmpStr = "";
		int count = 0, index = 0;
		Vector v = new Vector();
		boolean chk = true;
		try {
			for (int i = 0; i < this.data.length() - cut.length(); i++) {
				tmp2 = this.data.substring(i, i + cut.length());
				if (tmp2.equals(cut)) { //begin start tag
					this.data = this.cutAndReplc(i, cut.length(), strRplc);
				}
			}
			return this.getData();
		} catch (Exception e) {
			MyLog.error(this, e);
			return null;
		}
	}
	public String replaceAllIgnoreCase(String cut, String strRplc) {
		String tmp2 = "", tmp3 = "", tmpStr = "";
		int count = 0, index = 0;
		Vector v = new Vector();
		boolean chk = true;
		try {
			for (int i = 0; i < this.data.length() - cut.length(); i++) {
				tmp2 = this.data.substring(i, i + cut.length());
				if (tmp2.equalsIgnoreCase(cut)) { //begin start tag
					this.data = this.cutAndReplc(i, cut.length(), strRplc);
				}
			}
			return this.getData();
		} catch (Exception e) {
			MyLog.error(this, e);
			return null;
		}
	}
	public void replaceString(String cut, String strRplc) {
		String newData = "";
		if (cut != null || !cut.equals("")) {
			int startCut = this.data.indexOf(cut);
			if (startCut > -1) { // have string cut in data
				String head = "", tail = "", body = "";
				head = this.data.substring(0, startCut);
				tail = this.data.substring(startCut + cut.length(), this.data.length());
				this.data = head + strRplc + tail;
			}
		}
	}
	public String cutAndReplc(int start, int cut, String replcStr) {
		String tmpStr = "", head = "", tail = "";
		if (this.data == null || this.data.equals("")) {
			return null;
		} else {
			head = this.data.substring(0, start);
			tail = this.data.substring((start + cut), this.data.length());
			tmpStr = head + replcStr + tail;
			return tmpStr;
		}
	}
	public void delString(String str) {
		int i = findAddrStr(str);
		this.data = cutAndReplc(i, str.length(), "");
	}
	public void delAllString(String strDel, String replc) {
		String tmp2 = "";
		int index = -1;
		try {
			//System.out.println("length of data:"+data.length());
			index = findAddrStr(strDel);
			while (index > -1) {
				this.data = this.cutAndReplc(index, strDel.length(), replc);
				index = findAddrStr(strDel);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	public String getInTag(String beginTag, String endTag) {
		String tmp = this.getTag(beginTag, endTag);
		return tmp.substring(beginTag.length(), tmp.length() - endTag.length());
	}
	public Vector getInTagGroup(String beginTag, String endTag) {
		Vector getGroup = this.getTagGroup(beginTag, endTag);
		Vector tmp = new Vector();
		String tmpStr = "";
		for (int i = 0; i < getGroup.size(); i++) {
			tmpStr = (String) getGroup.get(i);
			tmp.add(tmpStr.substring(beginTag.length(), tmpStr.length() - endTag.length()));
		}
		return tmp;
	}
	public String getStrBefore(String mark) {
		if (this.getData().indexOf(mark) > -1) {
			int markPoint = this.getAddrStr(mark);
			if (markPoint > -1) {
				return this.data.substring(0, markPoint);
			} else {
				return "";
			}
		} else {
			return "";
		}
	}
	public String getStrBefore(String mark, String newData) {
		String data = this.getData();
		this.setData(newData);
		String result = this.getStrBefore(mark);
		this.setData(data);
		return result;
	}
	public String getStrBefore(String mark, double newData) {
		String data = this.getData();
		this.setData(newData);
		String result = this.getStrBefore(mark);
		this.setData(data);
		return result;
	}
	public String getStrAfter(String mark) {
		if (this.getData().indexOf(mark) > -1) {
			int markPoint = this.getAddrStr(mark);
			if (markPoint > -1) {
				return this.getData().substring(markPoint + mark.length(), this.getData().length());
			} else {
				return "";
			}
		} else {
			return "";
		}
	}
	public String getStrAfter(String mark, String newData) {
		String data = this.getData();
		this.setData(newData);
		String result = this.getStrAfter(mark);
		this.setData(data);
		return result;
	}
	public String getStrAfter(String mark, double newData) {
		String data = this.getData();
		this.setData(newData);
		String result = this.getStrAfter(mark);
		this.setData(data);
		return result;
	}
	public String getTag(String beginTag, String endTag) {
		String tmp2 = "", tmp3 = "", tmpStr = "";
		int count = 0, index = 0;
		boolean chk = true;
		try {
			for (int i = 0; i < this.data.length() - beginTag.length(); i++) {
				if (chk == false) {
					break;
				} else {
					tmp2 = this.data.substring(i, i + beginTag.length());
					if (tmp2.equals(beginTag)) { //begin start tag
						chk = true;
						count = i + beginTag.length();
						tmp3 = beginTag;
						while (chk) {
							tmp3 += this.data.charAt(count);
							tmpStr = this.data.substring(count, count + endTag.length());
							if (tmpStr.equals(endTag) || count > this.data.length()) {
								chk = false;
							}
							count++;
						}
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
			return null;
		}
		tmpStr = tmp3.substring(0, tmp3.length() - 1);
		return tmpStr + endTag;
	}
	public Vector getTagGroup(String beginTag, String endTag) {
		String tmp2 = "", tmp3 = "", tmpStr = "";
		int count = 0, index = 0;
		Vector v = new Vector();
		boolean chk = true;
		try {
			for (int i = 0; i < this.data.length() - beginTag.length(); i++) {
				tmp2 = this.data.substring(i, i + beginTag.length());
				if (tmp2.equals(beginTag)) { //begin start tag
					chk = true;
					count = i + beginTag.length();
					tmp3 = beginTag;
					while (chk) {
						tmp3 += this.data.charAt(count);
						tmpStr = this.data.substring(count, count + endTag.length());
						if (tmpStr.equals(endTag) || count > this.data.length()) {
							v.add(tmp3);
							chk = false;
						}
						count++;
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
			return null;
		}
		return v;
	}
	public Vector getAddrStrGroup(String findStr) {
		String tmp2 = "";
		Vector v = new Vector();
		try {
			for (int i = 0; i < this.data.length() - findStr.length(); i++) {
				tmp2 = this.data.substring(i, i + findStr.length());
				if (tmp2.equals(findStr)) {
					v.add(new Integer(i));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return v;
	}
	public int findAddrStr(String findStr) {
		String tmp2 = "";
		try {
			//System.out.println("length of data:"+data.length());
			for (int i = 0; i <= this.data.length() - findStr.length(); i++) {
				tmp2 = this.data.substring(i, i + findStr.length());
				if (tmp2.equals(findStr)) {
					return i;
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return -1;
	}
	public int getAddrStr(String findStr) {
		String tmp2 = "";
		int index = -1, tmpint = 0;
		try {
			//System.out.println("length of data:"+data.length());
			for (int i = 0; i <= this.data.length() - findStr.length(); i++) {
				tmp2 = this.data.substring(i, i + findStr.length());
				tmpint = i + findStr.length();
				if (tmp2.equals(findStr)) {
					return i;
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return -1;
	}
	public boolean outFile(String fName) {
		try {
			//OUTPUT FILE
			byte b[] = null;
			FileOutputStream fileOut = new FileOutputStream(fName);
			b = this.data.toString().getBytes();
			fileOut.write(b);
			fileOut.close();
			return true;
		} catch (IOException ex) {
			MyLog.error(this,  ex);
			return false;
		}
	}
	public boolean outFile(String fName, boolean clearData) {
		boolean result = this.outFile(fName);
		if (clearData)
			this.data = "";
		return result;
	}
	public boolean outFile(String newData, String fName, boolean clearData) {
		this.data = newData;
		boolean result = this.outFile(fName);
		if (clearData)
			this.data = "";
		return result;
	}
	public String blank(String newData, int count) {
		if (count == 1) {
			return newData;
		} else {
			return this.blank(newData, count - 1) + newData;
		}
	}
	public String removeString(String strRemove) {
		this.delString(strRemove);
		return this.getData();
	}
	public String removeString(String newData, String strRemove) {
		String data = this.getData();
		this.setData(newData);
		this.delString(strRemove);
		String result = this.getData();
		this.setData(data);
		return result;
	}
	public String repeat(String str, int numberOf) {
		if (numberOf > 0) {
			StringBuffer sb = new StringBuffer(str);
			for (int i = 1; i < numberOf; i++) {
				sb.append(str);
			}
			return sb.toString();
		} else {
			return " ";
		}
	}
	public Vector getVectorToken(String delim) {
		Vector result = new Vector();
		StringTokenizer sz = new StringTokenizer(this.data, delim);
		while (sz.hasMoreTokens()) {
			String tmp = sz.nextToken();
			result.add(tmp);
		}
		return result;
	}
	/**
	 *  @param newData ٻẺ String1,String2,String3 Ex "aa,bb,cc,dd"
	 *  @param delim  ҷ¡ String
	 *  @return Vector =[aa,bb,cc,dd]
	 * */
	public Vector getVectorToken(String newData, String delim) {
		Vector result = new Vector();
		StringTokenizer sz = new StringTokenizer(newData, delim);
		while (sz.hasMoreTokens()) {
			String tmp = sz.nextToken();
			result.add(tmp);
		}
		return result;
	}
	public String cutData(String text, String delim, int count) {
		String a = "", a1 = "", a2 = "", a21 = "";
		StringTokenizer st, st1;
		st = new StringTokenizer(text, delim);
		for (int i = 0; i <= count; i++) {
			if (st.hasMoreTokens()) {
				a = st.nextToken().toString();
			}
		}
		return a;
	}
	public int countRec(char delim) {
		StringTokenizer sz = new StringTokenizer(this.getData(), String.valueOf(delim));
		int c = 0;
		while (sz.hasMoreTokens()) {
			c++;
		}
		return c;
	}
	public String addData(String st, String ad, int num, String bb) {
		if (bb.equals("0")) {
			while (st.length() < num) {
				st = ad + st;
			}
		} else {
			while (st.length() < num) {
				st += ad;
			}
		}
		return st;
	}
	public String cutTime(String tm) {
		int i = 0;
		String tm3 = "";
		StringTokenizer tm1 = new StringTokenizer(tm, ":");
		while (i < 2) {
			tm3 += tm1.nextToken().toString();
			if (i < 1) {
				tm3 += ".";
			}
			i++;
		}
		//c=Double.valueOf(tm3).doubleValue();
		//System.out.println("tm--->"+c);
		return tm3;
	}
	public String setDate(String data) {
		String yy = 25 + data.substring(0, 2);
		String mm = data.substring(2, 4);
		String dd = data.substring(4, 6);
		int yy1 = Integer.parseInt(yy) - 543;
		String date = yy1 + "-" + mm + "-" + dd;
		return date;
	}
	public String setHour(String hr) {
		String hh = "0";
		String mm = "0";
		if (hr.length()==4) {
			hh = hr.substring(0, 2);
			mm = hr.substring(2, 4);
		} else if (hr.length()==5) {
			hh = hr.substring(0, 2);
			mm = hr.substring(3, 5);
		}
		return hh + "." + mm;
	}
	public boolean isLazy() {
		return lazy;
	}
	public void setLazy(boolean lazy) {
		this.lazy = lazy;
	}
	protected String getLazyString(int index) {
		String lazyStr="";
		try{
			lazyStr=(String) this.getLazyString().get(index);
		}catch(Exception ex){}
		return lazyStr;
	}
	protected Vector getLazyString() {
		return lazyString;
	}
	protected void addLazyString(String lazyString) {
		this.getLazyString().add(lazyString);
	}
	

    //㹡 return ͡ FORMAT HHMMSS
    //Exam  8.3 return 0830
    public String getTimeFormat(double time, String format) {    	
    	DecimalFormat df = new DecimalFormat("00.00");
		String t = df.format(time);
		StrReplace str = new StrReplace();
    	if (format.equalsIgnoreCase("HHMM")) {
    		return str.replace(t,".","");
    	} else if (format.equalsIgnoreCase("HHMMSS")) {
    		return str.replace(t,".","")+"00";
    	} else return str.replace(t,".","");
    }
    
	public String getNextToken(int index, char delim) {
			if (index == 0) {
				lazyString=new Vector();
				if (this.getData().indexOf(delim) > -1) {
					this.fecthStringToVector(delim, this.getData(), this.getLazyString());
				}
				return this.getLazyString(0);
			} else {
				return (String) this.getLazyString(index);
			}
	}    
    
	public static void main(String[] args) {
		FileString fs = new FileString();
//		System.out.println("hour -->> " + fs.setHour("1212"));
		//System.out.println("Data-->" + fs.addData("12", "0", 3, "0"));
		fs.setData("dd	1	2	3	++6958");
		System.out.println(fs.getToken(0,'\t'));
		System.out.println(fs.getToken(1,'\t'));
		System.out.println(fs.getToken(2,'\t'));
		System.out.println(fs.getToken(3,'\t'));		
		System.out.println(fs.getToken(4,'\t'));
		//System.out.println(fs.replaceAll(","," AND "));
		//System.out.println(fs.getData());
		//String str = "2";
		//System.out.println((str.equalsIgnoreCase(""))?"1":"2");
		//System.out.println(fs.addBlank(10,"0","left","E100"));
		//n32FileSystem wf = new Win32FileSystem();
	}
}
