package com.csc.library.utilities;

import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;

public class HelpXml {
	Element str, table;
	DbXml db;
	public String showList = "", orderList = "", returnList = "", searchList = "";
	private InitialEnvironment env;
	private String user;
	private UProfile upf=null;
	private HashMap param=new HashMap();

	public HelpXml(UProfile upf, String objName, String comcode, String user, String password) {
		this.user = user;
		this.upf = upf;
		this.initEnv();
		try {
			SAXBuilder builder = new SAXBuilder();
			String pathName="";
			String appName=this.upf.get("appname");
//			String cssite=this.upf.get("cssite");
			if(appName !=null && !appName.equals("")){
				pathName=env.getValue("xmlpath-helpxml")+appName+"/"+ objName.toUpperCase() + ".xml";
				File file=new File(pathName);
				if(!file.exists()){
					pathName=env.getValue("xmlpath-helpxml") + objName.toUpperCase() + ".xml";
				}
			}else{
				pathName=env.getValue("xmlpath-helpxml") + objName.toUpperCase() + ".xml";
			}
			Document stru = builder.build(new File(pathName));
			str = stru.getRootElement();
			db = new DbXml(upf, str.getChild("DATAMANAGER").getText(), comcode, user, password);
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		this.process();
	}

public HelpXml(UProfile upf, String objName, String comcode, String user, String password,HashMap param) {
		this.user = user;
		this.upf = upf;
		this.initEnv();
                this.param=param;
		try {
			SAXBuilder builder = new SAXBuilder();
			String pathName="";
			String appName=this.upf.get("appname");
//			String cssite=this.upf.get("cssite");
			if(appName !=null && !appName.equals("")){
				pathName=env.getValue("xmlpath-helpxml")+appName+"/"+ objName.toUpperCase() + ".xml";
				File file=new File(pathName);
				if(!file.exists()){
					pathName=env.getValue("xmlpath-helpxml") + objName.toUpperCase() + ".xml";
				}
			}else{
				pathName=env.getValue("xmlpath-helpxml") + objName.toUpperCase() + ".xml";
			}
			Document stru = builder.build(new File(pathName));
			str = stru.getRootElement();
			db = new DbXml(upf, str.getChild("DATAMANAGER").getText(), comcode, user, password,this.param);
			//  searchList = str.getChild("SEARCH").getText();
			//returnValue = str.getChild("RETURN").getText();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		this.process();
	}


	private void process() {
		this.setOrder(str.getChild("ORDER"));
		this.setShow(str.getChild("SHOWN"));
		this.setSearch(str.getChild("SEARCH"));
		this.setReturn(str.getChild("RETURN"));
	}

	private void setOrder(Element orderxml) {
		this.orderList = this.getDataList(orderxml);
	}

	private void setSearch(Element searchxml) {
		this.searchList = this.getDataList(searchxml);
	}

	private void setShow(Element showxml) {
		this.showList = this.getDataList(showxml);
	}

	private void setReturn(Element returnxml) {
		this.returnList = this.getDataList(returnxml);
	}

	protected String getDataList(Element dElement) {
		List list = dElement.getChildren();
		Iterator it = list.iterator();
		String data = "";
		while (it.hasNext()) {
			Element obj = (Element) it.next();
			data = data + obj.getText() + ",";
		}
		return data;
	}

	public DbInquiry getInquiry() {
		return db.getInquiry();
	}

	public DbTable getTable() {
		return db.getTable();
	}

	public DbRecord getRecord() {
		return db.getRecord();
	}

	public String checkTypeDB() {
		return db.typeGet;
	}

	private void initEnv() {
		env = new InitialEnvironment("GLOBAL");
	}
}
