package com.csc.library.utilities;
import java.io.File;
import java.io.FileFilter;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import org.jdom.Attribute;
import org.jdom.Element;

import com.csc.library.config.LoadConfig;
import com.csc.library.config.LoadQueue;
import com.csc.library.database.ConfigMetadata;
import com.csc.library.database.ConnectionPools;
import com.csc.library.database.LoadProTable;
import com.csc.library.database.LoadProTableV2;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.Relation;
import com.csc.library.database.StaticProperties;
import com.csc.library.drive.BaseMapDrive;
import com.csc.library.drive.DriveImpl;
import com.csc.library.process.ServerManager;
import com.csc.library.security.ActionLogImp;
import com.csc.library.security.LoadTemplate;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
public class LoadStaticProperties {
    private boolean setConnection =true;
    private boolean configLogger = false;
    private boolean loadSchedule = false;
    private HashMap aliasname=new HashMap();
    public void process() {
    	DriveImpl mapDrive=new BaseMapDrive();
    	try {
			mapDrive.init();
			BaseMapDrive.mapDrive.scanDrive();
		} catch (Exception e) {
			MyLog.error(this,e);
		}
    	this.genFieldTypeMaping();
    	if (this.configLogger){
    		this.configLogger();
    	}
        this.getPath();
        this.setGlobalTable();
        this.setSystemField();
//        this.setWFTransferField();
        this.setFieldConfig();       
        StaticProperties.relationPools.clear();
        StaticProperties.blobField=new Vector();
        //TODO load field label config
        StaticProperties.FIELD_LABEL_CONFIG.load();
        this.setProTable();
    	InitialRecord.TempolaryCacheRecord = new Hashtable();
    	InitialRecord.PermanentCacheRecord = new Hashtable();
    	InitialRecord.CacheIndexName = new Hashtable();
    	InitialRecord.CacheIndexTime = new Hashtable();
    	ReadXml read=new ReadXml(); 
    	read.loadWorkflowXmlOnMemory();
        this.setConfig();
        if(this.setConnection){
        	this.setConnectionPools();
            this.checkConfig();
        	this.setProcessData();
        }
        this.getFieldConfigXml();
        // Start LoadSchedule
        if (this.loadSchedule) {
        	this.loadSchedule();
        	this.setLoadSchedule(false);
        }
        //End LoadSchedule  
        this.loadMessage();
        if(StaticProperties.serverManager==null){
        	StaticProperties.serverManager = new ServerManager();
        }
        this.checkQueue();
        StaticProperties.jspAuthen.loadProperties();
        if(!StaticProperties.isClearActionLog){
        	clearActionlog();
        }
        //this.loadDbUser();        
    }
    
    public void genFieldTypeMaping() {
    	MyHashMap  oracleType = new MyHashMap(true);
    	oracleType.put("String","VARCHAR2") ;
    	oracleType.put("Autonumber","VARCHAR2(15)") ;
    	oracleType.put("Long","NUMBER(18)") ;
    	oracleType.put("DATE","VARCHAR2(10)") ;
    	oracleType.put("DATETIME","VARCHAR2(10)") ;
    	oracleType.put("TimeStamp","VARCHAR2(10)") ;
    	oracleType.put("BigDecimal","NUMBER(18,2)") ;
    	oracleType.put("Decimal","NUMBER(15,2)") ;
    	oracleType.put("Float","NUMBER(10,2)") ;
    	oracleType.put("Double","NUMBER(15,2)") ;
    	oracleType.put("Integer","NUMBER(12)") ;
    	oracleType.put("Bob","BLOB") ;
    	StaticProperties.fieldType.put("ORACLE", oracleType);
    	
    	MyHashMap  sqlserverType = new MyHashMap(true);
    	sqlserverType.put("String","VARCHAR") ;
    	sqlserverType.put("Autonumber","VARCHAR(30)") ;
    	sqlserverType.put("Long","DECIMAL(18)") ;
    	sqlserverType.put("DATE","VARCHAR(10)") ;
    	sqlserverType.put("DATETIME","VARCHAR(10)") ;
    	sqlserverType.put("TimeStamp","VARCHAR(10)") ;
    	sqlserverType.put("BigDecimal","DECIMAL(18,2)") ;
    	sqlserverType.put("Decimal","DECIMAL(15,2)") ;
    	sqlserverType.put("Float","DECIMAL(10,2)") ;
    	sqlserverType.put("Double","DECIMAL(15,2)") ;
    	sqlserverType.put("Integer","INT") ;
    	sqlserverType.put("Bob","TEXT") ;
    	StaticProperties.fieldType.put("MSSQL", sqlserverType);
    	
    	MyHashMap  PostgreSQLType = new MyHashMap(true);
    	PostgreSQLType.put("String","VARCHAR") ;
    	PostgreSQLType.put("Autonumber","VARCHAR(15)") ;
    	PostgreSQLType.put("Long","NUMERIC(18)") ;
    	PostgreSQLType.put("DATE","VARCHAR(10)") ;
    	PostgreSQLType.put("DATETIME","VARCHAR(10)") ;
    	PostgreSQLType.put("TimeStamp","VARCHAR(10)") ;
    	PostgreSQLType.put("BigDecimal","NUMERIC(18,2)") ;
    	PostgreSQLType.put("Decimal","NUMERIC(15,2)") ;
    	PostgreSQLType.put("Float","NUMERIC(10,2)") ;
    	PostgreSQLType.put("Double","NUMERIC(15,2)") ;
    	PostgreSQLType.put("Integer","INTEGER") ;
    	PostgreSQLType.put("Bob","OID") ;
    	StaticProperties.fieldType.put("PostgreSQL", PostgreSQLType);
    	
    	MyHashMap  mySQLType = new MyHashMap(true);
    	mySQLType.put("String","VARCHAR") ;
    	mySQLType.put("Autonumber","VARCHAR(15)") ;
    	mySQLType.put("Long","INTEGER(18)") ;
    	mySQLType.put("DATE","VARCHAR(10)") ;
    	mySQLType.put("DATETIME","VARCHAR(10)") ;
    	mySQLType.put("TimeStamp","VARCHAR(10)") ;
    	mySQLType.put("BigDecimal","DECIMAL(18,2)") ;
    	mySQLType.put("Decimal","DECIMAL(15,2)") ;
    	mySQLType.put("Float","DECIMAL(10,2)") ;
    	mySQLType.put("Double","DECIMAL(15,2)") ;
    	mySQLType.put("Integer","INTEGER(10)") ;
    	mySQLType.put("Bob","BLOB") ;
    	StaticProperties.fieldType.put("mySQL", mySQLType);
    	
    	MyHashMap  DB2Type = new MyHashMap(true);
    	DB2Type.put("String","VARCHAR") ;
    	DB2Type.put("Autonumber","VARCHAR(15)") ;
    	DB2Type.put("Long","INTEGER(18)") ;
    	DB2Type.put("DATE","VARCHAR(10)") ;
    	DB2Type.put("DATETIME","VARCHAR(10)") ;
    	DB2Type.put("TimeStamp","VARCHAR(10)") ;
    	DB2Type.put("BigDecimal","DECIMAL(18,2)") ;
    	DB2Type.put("Decimal","DECIMAL(15,2)") ;
    	DB2Type.put("Float","DECIMAL(10,2)") ;
    	DB2Type.put("Double","DECIMAL(15,2)") ;
    	DB2Type.put("Integer","INTEGER(10)") ;
    	DB2Type.put("Bob","VARBINARY") ;
    	StaticProperties.fieldType.put("DB2", DB2Type);
    }
    
    public void setConnectionPools() {
        StaticProperties.connectionMap = new HashMap();
        String dbList = new InitialEnvironment("GLOBAL").getValue("dblist-name");
        StringTokenizer st = new StringTokenizer(dbList, ",");
        while (st.hasMoreTokens()) {
            String dbName = st.nextToken();
            String url = new InitialEnvironment(dbName).getValue("datasource-url");
            ConnectionPools con = new ConnectionPools(dbName);
            StaticProperties.connectionMap.put(dbName.toLowerCase(), con);
        }
        System.out.println("Commit Set Connection   " + StaticProperties.connectionMap);
    }
    public void setIsSetConnection(boolean set){
    	this.setConnection=set;
    }
    private String getConfigPath(String path) {
        return new InitialEnvironment("GLOBAL").getValue(path);
    }
    private void loadDbUser() {
        LoadTemplate load = new LoadTemplate();
        load.process();
    }
    private void getPath() {
        StaticProperties.systemPath = System.getProperty("payroll_config");
    }
    private String getProtablePath(String path) {
        return new InitialEnvironment("GLOBAL").getValue(path);
    }
    private void setGlobalTable() {
        ReadXml read = new ReadXml(this.getConfigPath("config-dir") + "config");
        Element em = read.getChildElement("GLOBAL");
        java.util.Iterator it = em.getChildren().iterator();
        while (it.hasNext()) {
            Element ch = (Element) it.next();
            String table = ch.getText();
            StaticProperties.gloBalTable.add(table.toLowerCase().trim());
        }
        System.out.println("GLOBAL OUT :: " + StaticProperties.gloBalTable);
        System.out.println("commited set globaltable !! ");
    }
    private void setConfig() {
        UProfile uf = new UProfile(true);
        uf.set("lang", "tha");
        uf.setDbName("GLOBAL");
        ConfigMetadata vm = new ConfigMetadata(uf);
        vm.process();
//no used        
//        StaticProperties.myConfig.put("fieldmulticompany", vm.getFieldMultiCompany());
//        StaticProperties.myConfig.put("inquirystatus", vm.getInquiryStatus());
//        StaticProperties.myConfig.put("vfieldstatus", vm.getVfieldStatus());
//        StaticProperties.myConfig.put("multicompanystatus", vm.getMultiCompanyStatus());
//        StaticProperties.myConfig.put("recordstatus", vm.getRecordStatus());
//        StaticProperties.myConfig.put("inquirystatus", vm.getInquiryStatus());
//        StaticProperties.myConfig.put("insertstatus", vm.getInsertStatus());
//        StaticProperties.myConfig.put("deletestatus", vm.getDeleteStatus());
//        StaticProperties.myConfig.put("updatestatus", vm.getUpdateStatus());
//no used        
        StaticProperties.myConfig.put("rule_foreingekey", vm.getDependLevel());
        ReadXml read = new ReadXml(this.getConfigPath("config-dir") + "config");
        String useSchema = read.getChildElement("DATABASE").getChild("USE_SCHEMA").getText();
        StaticProperties.usesSchema = Boolean.valueOf(useSchema).booleanValue();
        String processPerThred = read.getChildElement("SERVICE").getChild("PROCESS_PERTHRED").getText();
        StaticProperties.processPerThred = Integer.parseInt(processPerThred);
        String iLevel = read.getChildElement("RELATION").getChild("INSERT_LEVEL").getText();
        StaticProperties.defaultInsertRelatoinLevel = iLevel;
        String dLevel = read.getChildElement("RELATION").getChild("DELETE_LEVEL").getText();
        StaticProperties.defaultDeleteRelatoinLevel = dLevel;
       // StaticProperties.moduleList=read.getChildElement("MODULE").getAttributeValue("name");
        
        //Start  check Index Table
        StaticProperties.checkIndextable=vm.checkIndexTable();
        MyLog.Debug = vm.getDebugStatus();
        MyLog.Production = vm.getProductionStatus();
        MyLog.Info = vm.getInfoStatus();
        MyLog.Warning=vm.getWarningStatus();
        MyLog.Display = vm.getDisplayStatus();
       //End check Index Table
        
        //set permamnent table
        StaticProperties.PermanentTable=vm.getPermanentTable();
        StaticProperties.maxtemporary=vm.getMaxTemporary();
        StaticProperties.ClearSize=vm.getClearSize();
        boolean encryptOn=(read.getChildElement("ENCRYPT_MODE")!=null &&read.getChildElement("ENCRYPT_MODE").getText().equalsIgnoreCase("off"))?false:true;
        StaticProperties.encryptOn=encryptOn;
        boolean routing_config=(read.getChildElement("ROUTING_CONFIG")!=null &&read.getChildElement("ROUTING_CONFIG").getText().equalsIgnoreCase("true"))?true:false;
        StaticProperties.routing_config=routing_config;
        
    }
    private void setProTable(){
    	File f = new File(this.getConfigPath("xmlpath-protable"));
    	this.setProTableV2(f,"");
    	StaticProperties.relationPools.MoveRelation2Master();
        MyLog.info(this, "PROTABLE OUT :: SUEESESSES ");
        MyLog.info(this, "commited set protable !! ");
//        this.logger.info("protable "+StaticProperties.proTable.keySet());
    }
    private void setProTable(File f,String appName) {    	
        String file[] = f.list();
        for (int i = 0; i < file.length; i++) {
            try {
                String fileName = file[i];
				if(fileName.equals("CVS"))
					continue;
                File  nFile=new File(this.getConfigPath("xmlpath-protable")+"/"+fileName+"/");
                if(nFile.isDirectory()){
                	this.setProTable(nFile,fileName);
					continue;
                }
                if(!appName.equals("")){
                	fileName=appName+"/"+fileName;
                }
                int dotPoint = fileName.lastIndexOf(".xml");
                if (dotPoint > 0) {
                    fileName = fileName.substring(0, fileName.lastIndexOf(".xml")).toLowerCase();
                } else {
                    MyLog.warn(this, "Can't sub string file name >>" + fileName + "<< Skip process this file");
                    continue;
                }
                LoadProTable pro = new LoadProTable();
                pro.setTableName(fileName.toUpperCase());
                pro.setLoadComponent(true);
                pro.process();
                MyHashMap data = new MyHashMap();
                data.put("desceng", pro.getDescEng());
                data.put("security", pro.getSecurity());
                data.put("descthai", pro.getDescThai());
                data.put("editcheck", pro.getEditCheck());
                data.put("mainhelp", pro.getMainHelp());
                data.put("mainkey", pro.getMainkey());
                data.put("properties", pro.getProperties());
                data.put("referhelp", pro.getReferHelp());
                data.put("relation", pro.getRelation());
                data.put("verify", pro.getVerify());
                data.put("verifygroup", pro.getVerifyGroup());
                data.put("fieldgroup", pro.getFieldGroup());
                data.put("wfactive", pro.getWfActive());
                data.put("wfkey", pro.getWfKey());
                data.put("documentno", pro.getDocumentno());
                data.put("systemfield", pro.getSystemField());
                StaticProperties.proTable.put(fileName.toLowerCase(), data);
            } catch (Exception e) {
    			MyLog.error(this, e);
            }
        }
        MyLog.info(this, "Load Complete : " + appName);
    }
    
    private void setProTableV2(File f,String appName) {
        File file[] = f.listFiles((FileFilter)new ProtableFileFilter());
        for (int i = 0; i < file.length; i++) {
            try {
                String fileName = file[i].getName();
                if(file[i].isDirectory()){
                	this.setProTableV2(file[i],fileName);
					continue;
                }else{

                	if(!appName.equals("")){
                		fileName=appName+"/"+fileName;
                	}
                	fileName = fileName.substring(0, fileName.lastIndexOf(".xml")).toLowerCase();
                }
                LoadProTableV2 pro = new LoadProTableV2();
                pro.setTableName(fileName.toUpperCase());
                pro.setLoadComponent(true);
                pro.processDiff();
                MyHashMap data = new MyHashMap();
                data.put("desceng", pro.getDescEng());
                data.put("security", pro.getSecurity());
                data.put("descthai", pro.getDescThai());
                data.put("editcheck", pro.getEditCheck());
                data.put("mainhelp", pro.getMainHelp());
                data.put("mainkey", pro.getMainkey());
                data.put("properties", pro.getProperties());
                data.put("referhelp", pro.getReferHelp());
                data.put("relation", pro.getRelation());
                data.put("verify", pro.getVerify());
                data.put("verifygroup", pro.getVerifyGroup());
                data.put("fieldgroup", pro.getFieldGroup());
                data.put("wfactive", pro.getWfActive());
                data.put("wfkey", pro.getWfKey());
                data.put("documentno", pro.getDocumentno());
                data.put("systemfield", pro.getSystemField());
                data.put("deleteflag",pro.getDeleteFlag());
                data.put("fieldconfig",pro.getConfigName());
                data.put("maindatoryfield",pro.getMaindatoryField());
                data.put("andconditionbeforesave", pro.getAndCondition());
                data.put("orconditionbeforesave", pro.getOrCondition());
                data.put("column_need", pro.getColumnNeed());                
                data.put("fieldupload", pro.getFiledUpload());
                data.put("fieldblob", pro.getFieldBlob());
                data.put("indexkey", pro.getKeyField());
                data.put("allfieldname", pro.getAllFieldName());
                pro.setAliasname((HashMap)this.aliasname.clone());
                data.put("aliasfield", pro.getAliasname());
                if(pro.getConfigName().length()>0){
                	String []cflist=pro.getConfigName().split(",");
                	StaticProperties.FieldConfigTable.put(fileName.toUpperCase(),cflist);
                }
                StaticProperties.proTable.put(fileName.toLowerCase(), data);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        MyLog.info(this, "Load Complete : " + appName);
    }    
    
    public void setProcessData() {
    	MyHashMap tlhm = new MyHashMap();
        UProfile uf = new UProfile(true);
        uf.set("lang", "tha");
        uf.setDbName("GLOBAL");
        ConfigMetadata vm = new ConfigMetadata(uf);
        vm.process();
        Vector tpdatas = vm.getProcessDataConfig();
        String tlkey = null;
        String dblist = new InitialEnvironment("GLOBAL").getValue("dblist-name");
        MyLog.info(this, "Load in List : " + dblist);
    	Element payrollroot = new InitialEnvironment().getRootElement();
    	Iterator iter = payrollroot.getChildren().iterator();
    	while (iter.hasNext()) {
    		Element dbconfig = (Element) iter.next();
    		String dbname = dbconfig.getAttributeValue("name");
    		tlkey = dbname;
    		MyLog.info(this, " === load Database : " + dbname + ".....");
    		if (!dbname.equalsIgnoreCase("GLOBAL") && !dbname.equalsIgnoreCase("hrconfig") &&	dblist.indexOf(dbname) > -1) {
	    	    ConnectionPools con = (ConnectionPools)  StaticProperties.connectionMap.get(dbname.toLowerCase());
	    		if (con.isWorking()) { 
	    			String schema = dbconfig.getChild("SCHEMA").getAttributeValue("name");
	    			DbInquiry dicomps = this.initDbInquiry(dbname, schema,"mcompany", "companyid", "", "");
	    			MyHashMap dbdata = new MyHashMap();
	    			try {
						while (dicomps.next()) {
							String tlkey_comp = new String(tlkey);
							String compid = dicomps.getString("companyid"); 
							tlkey_comp += "-" + compid;
							MyHashMap compdata = new MyHashMap();
							for (int i=0; i<tpdatas.size(); i++) {
								String tlkey_table = new String(tlkey_comp);
								String tablename = (String) tpdatas.get(i);
								tlkey_table += "-" + tablename.substring(tablename.indexOf("/")+1);
								String appname = "";
								if (tablename.indexOf("/") > 0) {
									appname = tablename.substring(0,tablename.indexOf("/"));
									tablename = tablename.substring(tablename.indexOf("/")+1);
								}
								DbInquiry ditable = this.initDbInquiry(dbname,schema,tablename,"*","companyid='"+compid+"'",appname);
								MyHashMap datatable = new MyHashMap();
								while (ditable.next()) {
									Vector veckey = ditable.getAllKey();
									String datakey = "";
									for (int j=0; j<veckey.size(); j++) {
										String key = (String) veckey.get(j);
										if (!key.equalsIgnoreCase("companyid")) {
											if (datakey.indexOf(",") > 0) 
												datakey += "_";
											datakey += ditable.getString(key);
										}
									}
									String allfield = ditable.getCurrentDbRecord().getFieldList();
									StringTokenizer stn = new StringTokenizer(allfield,",");
									MyHashMap recorddata = new MyHashMap();
									while (stn.hasMoreTokens()) {
										String fieldname = stn.nextToken();
										recorddata.put(fieldname,ditable.getString(fieldname));
									}
									datatable.put(datakey,recorddata);
								}
								compdata.put(tablename,datatable);
								tlhm.put(tlkey_table.toLowerCase(),String.valueOf(new CscCalendar().getTime()));
							}
							dbdata.put(compid,compdata);
						}
					} catch (RemoteException e) {
						e.printStackTrace();
					}
					if (StaticProperties.processData == null) {
						StaticProperties.processData = new MyHashMap();
					}
					StaticProperties.processData.put(dbname,dbdata);
					
					
			    	StaticProperties.timeLoadPData = (MyHashMap) tlhm.clone();
			    	for (int i = 0; i < tpdatas.size(); i++) {
						String tablename = (String) tpdatas.get(i);
						String appname = "";
						if (tablename.indexOf("/") > 0) {
							appname = tablename.substring(0, tablename.indexOf("/"));
							tablename = tablename.substring(tablename.indexOf("/") + 1);
						}
//						DbInquiry ditable = this.initDbInquiry(new InitialEnvironment("GLOBAL").getValue("DB-name"), new InitialEnvironment("GLOBAL").getValue("schema-name"), tablename, "*", "",appname); comment by pas  Inquiry ҷԴ hold connection 
						DbRecord dbtable =this.initDbRecord(new InitialEnvironment("GLOBAL").getValue("DB-name"), new InitialEnvironment("GLOBAL").getValue("schema-name"), tablename, "*", "",appname);
						try {
//							DbRecord dbtable = ditable.getCurrentDbRecord();
							dbtable.afterLoadConfig();
						} catch (Exception e) {
							e.printStackTrace();
						}
					}
			    	
	    		}
	    	}
    	}
    }
    
	private DbInquiry initDbInquiry(String dbName, String schema, String tableName, String fields, String filter, String appname) {
		DbInquiry dbInq = null;
		try {
			UProfile up = new UProfile(true);
			up.setDbName(dbName);
			up.setSchemaName(schema);
			up.set("lang", "eng");
			up.set("appname",appname);
			dbInq = new InitialInquiry(up).getDbInquiry();
			dbInq.setSchemaName(up.getSchemaName());
			dbInq.initMyTable(tableName, filter, "");
			dbInq.setColumn(fields);
			dbInq.refresh();
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}
		return dbInq;
	}
	
	private DbRecord initDbRecord(String dbName, String schema, String tableName, String fields, String filter, String appname) {
		DbRecord dbInq = null;
		try {
			UProfile up = new UProfile(true);
			up.setDbName(dbName);
			up.setSchemaName(schema);
			up.set("lang", "eng");
			up.set("appname",appname);
			dbInq = new InitialRecord(up).getDbRecord(tableName);
			dbInq.setColumn(fields);			
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}
		return dbInq;
	}	
    
	public void setLoadLogger(boolean load) {
		this.configLogger = load;
	}
	
	private void configLogger() {
//		String logcfgpath = new InitialEnvironment().getValue("CONFIG-dir") + "logcfg.xml" ;
//		File file = new File(logcfgpath);
//		if (file.exists()) {
//			DOMConfigurator.configure(logcfgpath);
//		}
    	String lpath = new InitialEnvironment("GLOBAL").getValue("LOG-uldir");
    	if (lpath != null && lpath.equals(""))
    		lpath = "D:/EnterprisePT/Jboss/server/default/deploy/HRPEAP.ear/LOG/";
    	StaticProperties.userlogpath = lpath;
	}
	
	private void setSystemField() {
		String configfield = new InitialEnvironment("GLOBAL").getValue("config-dir")+"FIELD_SYSTEM.xml";
		StaticProperties.systemField.put("systemfield",readXMLField(configfield));
	}

//	private void setWFTransferField() {
//		String configfield = new InitialEnvironment("GLOBAL").getValue("config-dir")+"WFTRANSFER_FIELD.xml";
//		StaticProperties.systemField.put("wftransferfield",readXMLField(configfield));
//	}

	
	private MyHashMap readXMLField(String file) {
		ReadXml rx = new ReadXml(file);
		Element feles = rx.getRootElement().getChild("FIELDS");
		Vector vecfield = new Vector(feles.getChildren());
		MyHashMap sysfield=new MyHashMap();  
		for (int i=0;i<vecfield.size();i++) {
			Element field = (Element) vecfield.get(i);
			HashMap hm = new HashMap();
			HashMap ashm = null;
			String fieldName = field.getName().trim().toLowerCase();
			hm.put("NAME",fieldName);
			Iterator itattr = field.getAttributes().iterator();
			while (itattr.hasNext()) {
				Attribute attr = (Attribute) itattr.next();
				hm.put(attr.getName().toUpperCase(),attr.getValue());
			}
			Iterator itelems = field.getChildren().iterator();
			while (itelems.hasNext()) {
				Element elem = (Element) itelems.next();
				hm.put(elem.getName().trim().toUpperCase(),elem.getText());
			}
			if(field.getChild("ALIASNAME")!=null){
				ashm=new HashMap();
				String [] aliasname=field.getChild("ALIASNAME").getText().split(",");
				for(int as=0;as<aliasname.length;as++){
					ashm.put(aliasname[as], fieldName);
					this.aliasname.put(aliasname[as].toLowerCase(),fieldName.toLowerCase());
				}
			}			
			Element component = field.getChild("COMPONENT");
			hm.put("COMTYPE",component.getAttributeValue("type").trim());
			Iterator itcomp = component.getChildren().iterator();
			while (itcomp.hasNext()) {
				Element elem = (Element) itcomp.next();
				hm.put(elem.getName().trim().toUpperCase(),elem.getText());
			}
			hm.put("ALIASNAME", ashm);
			sysfield.put(fieldName,hm);
		}
		return sysfield;
	}
	

	public Vector getConfigList(String configpath) {
		Vector vconfig=null;
		ReadXml read = new ReadXml(configpath + "config");
		Element config = read.getChildElement("FIELDCONFIG");
		if(config!=null){
			vconfig=new Vector();
			Iterator it = config.getChildren().iterator();
			while (it.hasNext()) {
				Element ch = (Element) it.next();
				String data = ch.getText();
				vconfig.addElement(data);
			}
		}
		return vconfig;
	}
	
	private void setFieldConfig() {
		String configpath = new InitialEnvironment("GLOBAL").getValue("config-dir");
		String configfield="",configfile="";
		
		Vector vfield=this.getConfigList(configpath);
		if(vfield.size()>0){
			MyHashMap configField=new MyHashMap();
			for(int f=0;f<vfield.size();f++){
				configfile=vfield.get(f).toString();
				configfield =configpath+configfile+".xml";
				ReadXml rx = new ReadXml(configfield);
				Element feles = rx.getRootElement().getChild("FIELDS");
				Vector vecfield = new Vector(feles.getChildren());
				MyHashMap sysfield=new MyHashMap();
				Vector fieldList=new Vector();
				for (int i=0;i<vecfield.size();i++) {
					Element field = (Element) vecfield.get(i);
					HashMap hm = new HashMap();
					HashMap ashm = null;
					String fieldName = field.getName().trim().toLowerCase();
					hm.put("NAME",fieldName);
					fieldList.addElement(fieldName);
					Iterator itattr = field.getAttributes().iterator();
					while (itattr.hasNext()) {
						Attribute attr = (Attribute) itattr.next();
						hm.put(attr.getName().toUpperCase(),attr.getValue());
					}
					Iterator itelems = field.getChildren().iterator();
					while (itelems.hasNext()) {
						Element elem = (Element) itelems.next();
						hm.put(elem.getName().trim().toUpperCase(),elem.getText());
					}
					if(field.getChild("ALIASNAME")!=null){
						ashm=new HashMap();
						String [] aliasname=field.getChild("ALIASNAME").getText().split(",");
						for(int as=0;as<aliasname.length;as++){
							ashm.put(aliasname[as], fieldName);
							this.aliasname.put(aliasname[as].toLowerCase(),fieldName.toLowerCase());
						}
					}
					
					Element component = field.getChild("COMPONENT");
					hm.put("COMTYPE",component.getAttributeValue("type").trim());
					Iterator itcomp = component.getChildren().iterator();
					while (itcomp.hasNext()) {
						Element elem = (Element) itcomp.next();
						hm.put(elem.getName().trim().toUpperCase(),elem.getText());
					}
					hm.put("ALIASNAME", ashm);
					sysfield.put(fieldName,hm);
				}
				configField.put(configfile.toUpperCase(),sysfield);
				configField.put(configfile.toUpperCase()+"FL",fieldList);
			}				
			StaticProperties.systemField.put("fieldconfig",configField);
		}else
			StaticProperties.systemField.put("fieldconfig",null);
	}
	
	public void setLoadSchedule(boolean load) {
		this.loadSchedule = load;
	}
	
	private void loadSchedule() {
		TimerSchedule ts = new TimerSchedule();
		ts.initialTimer(true,true);
	}

	private void checkRelationFieldConfig(){
		try{			
		MyHashMap hM=(MyHashMap)StaticProperties.FieldConfigTable.clone();
		MyHashMap hF=null;
		Iterator fit=hM.getKeySortIterator();
        UProfile up = new UProfile();
        up.setDbName("GLOBAL");
        up.set("lang", "ENG");
		DbRecord rec=null;		
		Relation r=null; 	
		Vector v=null;
		Vector removeH=new Vector();
		while(fit.hasNext()){
			v=new Vector();
			hF=new MyHashMap();
			String tablename=(String)fit.next();
			String []configValue=(String [])hM.get(tablename);
			Class ct=null;
			try{
				ct = Class.forName("com.csc.library.databean."+convertTable(tablename));
			}catch(Exception ex){
				MyLog.error(this, ex.getMessage());
				if(!removeH.contains(tablename))
					removeH.add(tablename);
				continue;
			}
			for(int c=0;c<configValue.length;c++){
					String childName=configValue[c].substring(0,configValue[c].indexOf("_CONFIG"));
					Class ct2=null;
					try{
						ct = Class.forName("com.csc.library.databean."+convertTable(childName));
					}catch(Exception ex){
						MyLog.error(this, ex.getMessage());
							if(!removeH.contains(childName))
								removeH.add(childName);
						continue;
					}
							try{
								rec=new InitialRecord(up).getDbRecord(tablename.toLowerCase());
							}catch(Exception ex){
								MyLog.error(this, ex.getMessage());								
							}
							if(rec!=null){
								r=rec.getRelation(childName.toLowerCase());
								if (r == null) {
					                rec = new InitialRecord(up).getDbRecord(childName.toLowerCase());
					                r = rec.getRelation(tablename.toLowerCase());
					            }
				                String fname = "";
				                if (r != null)
				                    for (int i = 0; i < r.parentField.size(); i++) {
				                            fname = r.childField.elementAt(i).toString()+","+r.parentField.elementAt(i).toString();
				                            v.add(fname);
				                    }
				                if(v.size()==0)
				                	if(!removeH.contains(tablename))
										removeH.add(tablename);
				                hF.put(configValue[c],v);
						}  
			            	StaticProperties.FieldConfigTable.put(tablename,hF);
				}
			}	
		removeConfigfield(removeH);
		createFieldConfigTable();
		}catch(Exception ex){
			MyLog.error(this, ex.getMessage());
		}
	}
	
	private String convertTable(String tableName) {
		String tName = tableName.toLowerCase();
		return tName.substring(0, 1).toUpperCase() + tName.substring(1, tName.length());
	}
	
	public void removeConfigfield(Vector vec){
		String configname="";
		for(int v=0;v<vec.size();v++){
			configname=(String)vec.get(v);
			StaticProperties.FieldConfigTable.remove(configname);
		}
	}
	
	private void createFieldConfigTable(){
		Element em=new Element("FIELDCONFIGTABLE");
		em.addContent("\n\t");
		MyHashMap hM=(MyHashMap)StaticProperties.FieldConfigTable.clone();
		MyHashMap configH=null;
		Iterator it2=null;
		Iterator it=StaticProperties.FieldConfigTable.getKeySortIterator();
		Vector v;
		while(it.hasNext()){
			String tablename=(String)it.next();			
			em.addContent(new Element(tablename));
			em.getChild(tablename).addContent("\n\t\t");
				configH=(MyHashMap)hM.get(tablename);
				it2=configH.getKeySortIterator();
				while(it2.hasNext()){
					String configname=(String)it2.next();
					em.getChild(tablename).addContent(new Element(configname));
					em.getChild(tablename).getChild(configname).addContent("\n\t\t\t");
					v=(Vector)configH.get(configname);					
					for(int b=0;b<v.size();b++){
						String relname=(String)v.get(b);
						Element fm=new Element("FIELD");
						fm.setText(relname);
						em.getChild(tablename).getChild(configname).addContent(fm);
						em.getChild(tablename).getChild(configname).addContent("\n\t\t\t");						
					}
				}
		}
			String path=new InitialEnvironment("GLOBAL").getValue("config-dir");
	        WriteXml wx = new WriteXml(em,path+"FIELDCONFIGTABLE");
	        wx.output();
	}
	
	private void getFieldConfigXml(){
		String configpath = new InitialEnvironment("GLOBAL").getValue("config-dir");
		configpath+="FIELDCONFIGTABLE";
		File file=new File(configpath+".xml");
		if(!file.exists()){
			checkRelationFieldConfig();
		}else{
				ReadXml read = new ReadXml(configpath);
				Element root = read.getRootElement();
				Vector vecfield = new Vector(root.getChildren());
				Vector vtable,vfield,vconfig;
				MyHashMap configname=null;
				for (int i=0;i<vecfield.size();i++) {
					configname=new MyHashMap();
					Element tablename=(Element)vecfield.get(i);
					vtable=new Vector(tablename.getChildren());
					for(int c=0;c<vtable.size();c++){
						Element cf=(Element)vtable.get(c);
						vfield=new Vector(cf.getChildren());
						vconfig=new Vector();
						  for(int n=0;n<vfield.size();n++){
							  Element field=(Element)vfield.get(n);
							  vconfig.add(field.getText());
						  }
						  configname.put(cf.getName(), vconfig);
					}
					StaticProperties.FieldConfigTable.put(tablename.getName(), configname);
				}
		}
	}
	
	private void loadMessage(){
		StaticProperties.messagePools.loadMessage();
	}
	
	private void checkConfig(){
		LoadConfig lc=new LoadConfig();
	}
	
	private void checkQueue(){
		LoadQueue lq=new LoadQueue();
	}
	
    public static void main(String args[]){
    	LoadStaticProperties l=new LoadStaticProperties();
    	l.getFieldConfigXml();
    	//l.process();
    }  
    
    public void clearActionlog(){
    	try{
			Class c=Class.forName("com.csc.library.authorize.ActionLog");
			ActionLogImp ac=(ActionLogImp)c.newInstance();
			ac.clearActionlog();
			StaticProperties.isClearActionLog=true;
    	}catch(Exception ex){
    		ex.printStackTrace();
    		StaticProperties.isClearActionLog=false;
    	}
    }
}
