package com.csc.library.utilities;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.TreeMap;

import org.jdom.Attribute;
import org.jdom.Element;

/**
 * <PRE>
 * Cls 红 xml ͧ MailMerge
 *  Cls MailMerge ¡ҹдǡ
 * </PRE>
 * @author @SoCooL@
 */
public class MailMergeXml {
	private String	mmXmlInit	= "";
	private Element	root		= null;
	private TreeMap	xmlData		= new TreeMap();
	/**
	 * <PRE>
	 * Constructor 㹡ҹҨҡ xml 
	 * 絤ҵ Cls ҹ
	 * </PRE>
	 * @param xmlName  xml ͧ MailMerge
	 */
	public MailMergeXml(String xmlName) {
		ReadXml r = new ReadXml(xmlName);
		this.root = r.getRootElement();
		List l = this.root.getChild("VARIABLE").getChildren();
		Iterator it = l.iterator();
		this.mmXmlInit = this.root.getChild("INIT").getText();
		while (it.hasNext()) {
			Element var = (Element) it.next();
			HashMap hResult = new HashMap();
			hResult.put("xmlvalue", var.getText());
			List atbList = var.getAttributes();
			Iterator atbIt = atbList.iterator();
			HashMap hTmpAtb = new HashMap();
			while (atbIt.hasNext()) {
				Attribute atbKey = (Attribute) atbIt.next();
				hTmpAtb.put(atbKey.getName(), atbKey.getValue());
			}
			hResult.put("attribute", hTmpAtb);
			this.xmlData.put(var.getName(), hResult);
		}
	}
	/**
	 * <PRE>
	 * Ǩͺ node xml  node data 
	 *  attribute ͧ
	 * </PRE>
	 * @param key  node ͧõǨͺ
	 * @param attribute  attibute ͧõǨͺ
	 * @return boolean  true  , false 
	 */
	public boolean containAttribute(String key, String attribute) {
		if (this.xmlData.containsKey(key)) {
			HashMap atb = (HashMap) ((HashMap) this.xmlData.get(key)).get("attribute");
			if (atb.containsKey(attribute)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	/**
	 * ֧ attribute ͧ Root Xml
	 * @param attribute   attibute ͧ
	 * @return Ңͧ attribute  ը觤ҧѺ׹
	 */
	public String getRootAttibute(String attribute) {
		Attribute atb = this.getRoot().getAttribute(attribute);
		if (atb != null) {
			return atb.getValue();
		} else {
			MyLog.warn(this, ">>>>>>> Not Found Attribute"+attribute+" in Root Element <<<<<<");
			return "";
		}
	}
	/**
	 * 觤 Root ͧ Mailmerge Xml Ѻ
	 * @return Element  root element
	 */
	protected Element getRoot() {
		return this.root;
	}
	/**
	 * ֧ String attribute ͧ Root Xml
	 * @param key   node ͧ tag data ͧ
	 * @param attribute   attribute ͧ
	 * @return String  Ңͧ attribute ͧ¼Ѿ String
	 */
	public String getStringAttribute(String key, String attribute) {
		HashMap atb = (HashMap) ((HashMap) this.xmlData.get(key)).get("attribute");
		return atb.get(attribute).toString();
	}
	/**
	 * ֧ Integer attribute ͧ Root Xml
	 * @param key   node ͧ tag data ͧ
	 * @param attribute   attribute ͧ
	 * @return String  Ңͧ attribute ͧ¼Ѿ Integer
	 */
	public int getIntegerAttribute(String key, String attribute) {
		HashMap atb = (HashMap) ((HashMap) this.xmlData.get(key)).get("attribute");
		return new Integer(atb.get(attribute).toString()).intValue();
	}
	/**
	 * ֧ Double attribute ͧ Root Xml
	 * @param key   node ͧ tag data ͧ
	 * @param attribute   attribute ͧ
	 * @return String  Ңͧ attribute ͧ¼Ѿ Double
	 */
	public double getDoubleAttribute(String key, String attribute) {
		HashMap atb = (HashMap) ((HashMap) this.xmlData.get(key)).get("attribute");
		return new Integer(atb.get(attribute).toString()).doubleValue();
	}
	/**
	 * Ǩͺ tag data  tag 
	 * @param key  tag ͧõǨͺ
	 * @return boolean  Ѿ  
	 */
	public boolean containKey(Object key) {
		return this.xmlData.containsKey(key);
	}
	/**
	 * ֧ Property ͧ tag data 
	 * @param key  ͧ
	 * @return HashMap  Property ͧ tag 
	 */
	public HashMap getProperty(String key) {
		return ((HashMap) this.xmlData.get(key));
	}
	/**
	 *  get Iterator ͧ tag Data
	 * @return Iterator
	 */
	public Iterator getKeyIterator() {
		return this.xmlData.keySet().iterator();
	}
	/**
	 *  get  Init tag  MailMerge Xml
	 * @return String  tag init
	 */
	public String getInitTag() {
		return this.mmXmlInit;
	}
	/**
	 * ֧ Text Ţͧ tag data
	 * @param key  tag data ͧ
	 * @return String  Ѿ String ͧ tag 
	 */
	public String getText(String key) {
		return ((HashMap) this.xmlData.get(key)).get("xmlvalue").toString();
	}
	/**
	 * ֧ Property ͧ tag data á
	 * @return HashMap  Property ͧ tag á
	 */
	public HashMap getFirstProperty() {
		return ((HashMap) this.xmlData.get(this.xmlData.firstKey().toString()));
	}
	/**
	 * ֧ Property ͧ tag data ش
	 * @return HashMap  Property ͧ tag ش
	 */
	public HashMap getLastProperty() {
		return ((HashMap) this.xmlData.get(this.xmlData.lastKey().toString()));
	}
	public static void main(String[] args) {
		MailMergeXml mXml = new MailMergeXml("c:/MM.xml");
		//System.out.println(mXml.xmlData);
		System.out.println(mXml.getRootAttibute("fetchall"));
	}
}
