package com.csc.library.utilities;
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.session.InitialEnvironment;
public class ReadXml {
	private  Element xmlObj;
	private  String dataManager;
	private  boolean keepOnMemory = false;
	public static HashMap<String, Element> xmlOnMemory = new HashMap<String,Element>();  

	public ReadXml() {
	}
		
	/**
	 * @param objName
	 * @param keppOnMemory
	 * @author odragonfireo
	 * <PRE>  
	 *      
	 * </PRE>
	 */
	public ReadXml(String objName,boolean keppOnMemory) {
		this.init(objName, keppOnMemory);
	}

	public ReadXml(String objName) {
		init(objName,false);
	}
	
	/**
	 * 
	 * @param objName = xml 
	 * @param keep = true Ŵ xml  memory false ӡ纤
	 * 
	 */	
	private void init(String objName, boolean keep) {
		this.setKeepOnMemory(keep);
        String pathStr=objName.substring(0,objName.lastIndexOf("/")+1);
        String fileStr=objName.substring(objName.lastIndexOf("/")+1,objName.length());
		if(objName.endsWith(".xml")){
             fileStr = fileStr.substring(0,fileStr.lastIndexOf(".xml"));
		}
		this.dataManager = pathStr+fileStr.toUpperCase() + ".xml";
			if(xmlOnMemory.containsKey(objName.toLowerCase())){ 
				this.xmlObj=xmlOnMemory.get(objName.toLowerCase());
			}else{
				this.xmlObj=this.connectXml(0,this.dataManager);
				if(this.isKeepOnMemory()){
					xmlOnMemory.put(objName.toLowerCase(),(Element)this.xmlObj.clone());
				}
			}
	}

	private Element connectXml(int count, String fileName) {		
		File file=null;
		SAXBuilder builder = new SAXBuilder();
		Document stru = null;
		Element em=null;
		try{
			file=new File(fileName);
			if(file.exists()){/** Ǩͺԧ֧ҹ  **/
				try{
					stru = builder.build(file);
					em=stru.getRootElement();/** ҹ saxbuilder  **/
				}catch(Exception ex){
					MyLog.error(this, ex);
				}
			}
			if(em==null&&count<3){/** ҡӫԹ 3 ͺ   exception  ش͡**/
				count++;
				wait(200);/** ӡ 0.2 Թҷ价ӡҹաͺ **/
				return this.connectXml(count,fileName);
			}else{
				if(this.isKeepOnMemory()){
					if(em!=null){
						MyLog.debug(this," Read transfer xml file "+fileName+" readed="+count+" Complete (-_-)");
					}else{
						MyLog.error(this," Read transfer xml file "+fileName+" readed="+count+" Incomplete (-_-')");
					}
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
		return em;		
	}
	public String getDataManager() {
		return this.dataManager;
	}

	public void setDataManager(String data) {
		/** comment by pas 
		 * 20110506  method init᷹
        
        String pathStr=data.substring(0,data.lastIndexOf("/")+1);
        String fileStr=data.substring(data.lastIndexOf("/")+1,data.length());
		if (data.indexOf(".xml") > -1)
                  fileStr = fileStr.substring(0,fileStr.lastIndexOf(".xml"));
                  dataManager = pathStr+fileStr.toUpperCase() + ".xml";
		this.connectXml();
		**/
		init(data, false);
	}

	public void setDataManager(String data,boolean keep) {
		init(data,keepOnMemory);
	}
	
	/**
	 *  get atrribute of element
	 *  @return Vector
	 * */
	public Vector getVecAttr(Element element) {
		return this.listTovec(element.getAttributes());
	}
	/**
	 *  get atrribute of element
	 *  @return List
	 * */
	public List getListAttr(Element element) {
		return element.getAttributes();
	}
	/**
	 *  get atrribute of element
	 *  @return HashMap
	 * */
	public HashMap<String, String> getHashMapAttr(Element element) {
		Iterator it = element.getAttributes().iterator();
		HashMap<String, String> hm = new HashMap<String, String>();
		while (it.hasNext()) {
			Attribute attr = (Attribute) it.next();
			hm.put(attr.getName(), attr.getValue());
		}
		return hm;
	}
	public String getAttrValue(Element e, String attrName) {
		return e.getAttributeValue(attrName);
	}
	public Vector<String> getAttrValueGroup(Element e, String attrName) {
		Vector<String> vec = new Vector<String>();
		List list = e.getChildren();
		Iterator it = list.iterator();
		while (it.hasNext()) {
			Element obj = (Element) it.next();
			if ((obj.getAttributeValue(attrName) != null) && (!obj.getAttributeValue(attrName).equals("")))
				vec.add(obj.getAttributeValue(attrName));
		}
		return vec;
	}
	
	private Vector<String> processField(Vector<List> vField) {
		Vector<String> vec = new Vector<String>();
		Element obj = null;
		List list = vField.elementAt(0);
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getText().trim().length() > 0)
				vec.addElement(obj.getText());
		}
		return vec;
	}
	
	public String getString(String name) {
		return xmlObj.getChild(name).getTextTrim();
	}
	
	public Vector<String> getChildField(String tableName, String eleName, String attrName) {
		Vector<List> vec = new Vector<List>();
		Element obj = null;
		String dbTableName = "";
		List list = xmlObj.getChildren();
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getName().startsWith(eleName)) {
				dbTableName = obj.getAttributeValue(attrName);
				if (dbTableName.equals(tableName)) {
					vec.add(obj.getChildren());
					break;
				}
			}
		}
		return this.processField(vec);
	}
	
	public Vector listTovec(List list) {
		Vector vec = new Vector();
		Iterator it = list.iterator();
		while (it.hasNext())
			vec.add(it.next());
		return vec;
	}
	public Vector<Element> getStartWithElement(Element e, String name) {
		Vector<Element> vec = new Vector<Element>();
		Element obj = null;
		List list = e.getChildren();
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getName().startsWith(name))
				vec.add(obj);
		}
		return vec;
	}
	public Element getRootElement() {
		return this.xmlObj;
	}
	public Element getChildElement(String name) {
		return xmlObj.getChild(name);
	}
	
	public boolean isKeepOnMemory() {
		return keepOnMemory;
	}

	public void setKeepOnMemory(boolean keepOnMemory) {
		this.keepOnMemory = keepOnMemory;
	}

	public static void clearXmlOnMemory(){
		if(xmlOnMemory!=null){
			xmlOnMemory.clear();
		}
	}
	
	/**
	 * @author odragonfireo
	 *<PRE>ѺŢŢͧ xml transfer ͧ workflow  memory Ŵѭͧͧ transfer 
	 *     ѭҷǹ˭繻ѭҷ read xml  ¨СҴҹ folder 
	 *</PRE>
	 */
	public  void loadWorkflowXmlOnMemory(){
		if(xmlOnMemory!=null){
				xmlOnMemory.clear();
			}else{
				xmlOnMemory=new HashMap<String,Element>();
		}
		String xmlpath="";
		String xmlName="";
		try{
			InitialEnvironment env=new InitialEnvironment("GLOBAL");
			xmlpath=env.getValue("DIRWF_TRANSFER-dir");
			File folder=new File(xmlpath);
			File files[]=folder.listFiles();
			File file=null;
			Element xmlObj=null;
			for(int i=0;i<files.length;i++){
				file=files[i];
				xmlName=file.getName();
				try{
				if(file.isFile()&&xmlName.endsWith(".xml")){
					if(!xmlOnMemory.containsKey(xmlName.toLowerCase())){
						xmlObj=connectXml(0,xmlpath+xmlName);
						xmlOnMemory.put(xmlName.toLowerCase(),(Element)xmlObj.clone());
					}
				}
				}catch(Exception ex){
					MyLog.error("Cannot get File "+xmlName+" on Memory");
				}
			}
		}catch(Exception ex){
			MyLog.error("Cannot load transfer xml workflow on memory = "+xmlOnMemory);
		}
	}
	
	public static void main(String[] args) {
		ReadXml rm = new ReadXml("d:/AUTOALERT.xml",true);
		
		Element child = null;
		List childs = rm.getRootElement().getChildren();
		for( int i = 0 ; i < childs.size() ; i++ ){
			child = (Element)childs.get(i);
			if( child.getName().equalsIgnoreCase("app_name") ){
				System.out.println(child.getText());
			}else if( child.getName().equalsIgnoreCase("source_table") ){
				System.out.println(child.getChildren());
			}else if( child.getName().equalsIgnoreCase("destination_table") ){
				System.out.println(child.getChildren());
			}else if( child.getName().equalsIgnoreCase("attach_file") ){
				if( child.getAttributeValue("transfer").equalsIgnoreCase("true") ){
					System.out.println(child.getChildren());
				}
			}
		}
	}
}
