package com.csc.library.utilities;

import java.rmi.RemoteException;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.FieldManager;
import com.csc.library.database.MyDB;
import com.csc.library.database.MyInquiry;
import com.csc.library.database.MyTable;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;

public class TransformSQL {
	
	UProfile uf = null;
	String dbtype = "";
	
	
	public TransformSQL(UProfile uf) {
		this.uf = uf;
		dbtype = new InitialEnvironment(this.uf.getDbName()).getValue("datasource-dbtype");
	}
	
	public String tfSql(MyDB mdb,String s) {
		String sr = "";
		if (s != null) sr = new String(s);		
		if (dbtype != null && dbtype.equalsIgnoreCase("oracle")) {
			int spindex = sr.indexOf("''");
			while (sr.indexOf("''") > spindex){				
				if (sr.indexOf("=",spindex-4)>0) {
					int opindex = sr.indexOf("=",spindex-4);
					sr = sr.substring(0,opindex) + " is null" + sr.substring(spindex+2);
				} else if (sr.indexOf("<>",spindex-4)>0) {
					int opindex = sr.indexOf("<>",spindex-4);
					sr = sr.substring(0,opindex) + " is not null" + sr.substring(spindex+2);
				} else if (sr.indexOf("like") > 0) {
					int opindex = sr.indexOf("like",spindex-6);
					sr = sr.substring(0,opindex) + " is null" + sr.substring(spindex+2);
				}
				if(spindex<sr.length())
					spindex = sr.indexOf("''",spindex+1);
				else 
					break;
			}
		}
		return sr;
	}
	
	private FieldManager getFieldDB(MyDB mdb,String fieldName) {
		DbInquiry di = null;
		DbTable dt = null;
		try {
			if (mdb instanceof MyInquiry) {
				di = (DbInquiry) mdb;
				return di.getCurrentDbRecord().getField(fieldName);
			} else if (mdb instanceof MyTable) {
				dt = (DbTable) mdb;
				return dt.getRecordManager().getField(fieldName);
			}
		} catch (RemoteException e) {
			MyLog.error(this, this.uf, e);
		} 
		return null;
	}
	
	public String reformFieldDate(MyDB mdb,String sql) {
		String sqltmp = new String(sql);
		if (sql.length() > 0) {
			String fname = this.getFieldDate(sqltmp);
			if (fname != null) {
				int a = sqltmp.indexOf(fname);
				int b = sqltmp.indexOf(" ",a);
				if (b == -1) b=sqltmp.length();
				b = (b == -1)?sqltmp.length():b;
				int c = sqltmp.indexOf(" ",b+1);
				c = (c == -1)?sqltmp.length():++c;
				String tmp1 = sqltmp.substring(a,b);
				String tmpres = sqltmp.substring(0,c);
//				FieldManager fm = this.getFieldDB(mdb,fname);
//				if (fm != null && fm.getType().equalsIgnoreCase("DATE")) {
					tmpres = tmpres.replaceFirst(tmp1,
							tmp1.substring(0,tmp1.indexOf("'"))+
							this.tfDate(tmp1.substring(tmp1.indexOf("'"))));
//				}
				String tmprest = sqltmp.substring(c);
				if (tmprest.length() > 0) {
					tmprest = this.reformFieldDate(mdb,tmprest);
				}
				sqltmp = tmpres + tmprest;
			}
		}
		return sqltmp;
	}
	
	public String getFieldDate(String sql) {
		String sqltmp = new String(sql);
		int andpos = sqltmp.indexOf(" and ");
		int orpos = sqltmp.indexOf(" or ");
		int signpos = sqltmp.indexOf("-");
		int betweenpos = sqltmp.indexOf("between");
		if (andpos > orpos && orpos > 0 && signpos > 0) {
			if (signpos < orpos) {
				if (betweenpos < 0)
					return sqltmp.substring(0,sqltmp.indexOf("="));
				else
					return sqltmp.substring(0,betweenpos-1);
			} else {
				String tmpfield = this.getFieldDate(sqltmp.substring(orpos+4));
				if (tmpfield != null)
					return tmpfield;
				else 
					if (betweenpos < 0)
						return sqltmp.substring(orpos+4,sqltmp.indexOf("=",orpos));
					else
						return sqltmp.substring(0,betweenpos-1);
			}
		} else if (andpos > 0 && signpos > 0) { 
			if (signpos < andpos) {
				if (betweenpos < 0)
					return sqltmp.substring(0,sqltmp.indexOf("="));
				else
					return sqltmp.substring(0,betweenpos-1);
			} else {
				String tmpfield = this.getFieldDate(sqltmp.substring(andpos+5));
				if (tmpfield != null)
					return tmpfield;
				else
					if (betweenpos < 0)
						return sqltmp.substring(andpos+5,sqltmp.indexOf("=",andpos));
					else
						return sqltmp.substring(0,betweenpos-1);
			}
		} else if (signpos > 0) {
			return sqltmp.substring(0,sqltmp.indexOf("="));
		}
		return null;
	}
		
	public String tfDate(String date) {
		return this.tfDate(date,"YYYY MM DD");
	}
	
	public String tfDate(String date,String format) {
		String tfdate = date;
		if (dbtype.equalsIgnoreCase("oracle"))
			tfdate = "TO_DATE(" + date + ",'" + format + "')";
		return tfdate;
	}
	
	public Vector regenSql(MyDB mdb,String sql) {
		Vector vec = new Vector();
		Vector vecname = new Vector();
		Vector vectype = new Vector();
		Vector vecvalue = new Vector();
		String psql = "";
		
		if (sql.length() > 0) {
			Vector vectmp = this.subSql(sql);
			String restsql = (String) vectmp.get(0);
			String subsql = (String) vectmp.get(1);
			String conj = (String) vectmp.get(2);
			String transql = "";
			
			if (subsql.indexOf("select") > -1 || subsql.indexOf("SELECT") > -1) {
				transql = subsql.substring(0,subsql.indexOf("where")+6);
				String brancket = "";
				if (subsql.lastIndexOf(")") > -1) {
					brancket = subsql.substring(subsql.lastIndexOf(")"));
					subsql = subsql.substring(subsql.indexOf("where")+6,subsql.lastIndexOf(")"));
				} else {
					subsql = subsql.substring(subsql.indexOf("where")+6);
				}
				vectmp = this.regenSql(mdb,subsql);
				transql = transql + (String) vectmp.get(0) + brancket;
			} else if (subsql.indexOf(".") > 0) {
				vectmp = null;
				transql = transql + subsql;
			} else {
				vectmp = this.sepSql(mdb,subsql);
				transql = (String) vectmp.get(0);
			}
			if (vectmp != null) {
				vecname.addAll((Vector) vectmp.get(1));
				vectype.addAll((Vector) vectmp.get(2));
				vecvalue.addAll((Vector) vectmp.get(3));
			}
			psql = psql + transql + conj;
			
			if (restsql.length() > 0) {
				Vector vectmp2 = this.regenSql(mdb,restsql);
				String psql2 = (String) vectmp2.get(0);
				vecname.addAll((Vector) vectmp2.get(1));
				vectype.addAll((Vector) vectmp2.get(2));
				vecvalue.addAll((Vector) vectmp2.get(3));
				psql = psql + psql2;
			} 
		} 
		
		vec.add(psql);
		vec.add(vecname);
		vec.add(vectype);
		vec.add(vecvalue);
		return vec;
	}
	
	public Vector subSql(String sql) {
		int apos = this.checkOperPosSubQ(" and ",sql,0);
		int Apos = this.checkOperPosSubQ(" AND ",sql,0);
		if (Apos > 0 && (apos == -1 || (apos > -1 && Apos < apos))) apos = Apos;
		int opos = this.checkOperPosSubQ(" or ",sql,0);
		int Opos = this.checkOperPosSubQ(" OR ",sql,0);
		if (Opos > 0 && (opos == -1 || (opos > -1 && Opos < opos))) opos = Opos;
		int bpos = sql.indexOf(" between ");
		int Bpos = sql.indexOf(" BETWEEN ");
		if (Bpos > 0 && (bpos == -1 || (bpos > -1 && Bpos < bpos))) bpos = Bpos;
		String conj = "";
		String tsql = new String(sql);
		String stsql = "";
		if (opos > 0 && (apos == -1 || apos > opos)) {
			stsql = tsql.substring(0,opos);
			conj = " or ";
			tsql =  tsql.substring(opos+4);
		} else if (apos > 0 && (opos == -1 || opos > apos)) {
			conj = " and ";
			if (apos > 0 && (apos < bpos || bpos == -1)) {
				stsql = tsql.substring(0,apos);
				tsql = tsql.substring(apos+5);
			} else {
				int tapos = tsql.indexOf(" and ",apos+5);
				int tApos = tsql.indexOf(" AND ",apos+5);
				if (tApos > 0 && (tapos == -1 || (tapos > -1 && tApos < tapos))) tapos = tApos;
				if (tapos > 0) {
					stsql = tsql.substring(0,tapos);
					tsql = tsql.substring(tapos+5);
				} else {
					stsql = tsql;
					tsql = "";
					conj = "";
				}
			}
		} else {
			stsql = tsql;
			conj = "";
			tsql = "";
		}
		Vector vec = new Vector();
		vec.add(tsql); // rest sql
		vec.add(stsql); // sub sql
		vec.add(conj); // conjunction (and,or)
		return vec;
	}
	
	public Vector sepSql(MyDB mdb,String sql) {
		String[] oper = {">=","<=","!=","=","<>",">","<"," like "," between "," in "};
		int[] ioper = {2,2,2,1,2,1,1,6,9,4};
		String fname = "";
		String value = "";
		String tsql = new String(sql);
		Vector output = new Vector();
		Vector vname = new Vector();
		Vector vtype = new Vector();
		Vector vvalue = new Vector();
		for (int i=0;i<oper.length;i++) {
			int operpos = tsql.indexOf(oper[i]);
            	if(tsql.indexOf("'") < tsql.indexOf(oper[3]))
            		operpos=-1;			
			if (operpos > 0) {
				if (tsql.trim().indexOf("(") != 0)
					fname = tsql.substring(0,operpos).trim();
				else 
					fname = tsql.substring(1,operpos).trim();
				FieldManager fm = this.getFieldDB(mdb,fname);
				String ftype = "STRING";
				if (fm != null) {
					ftype = fm.getType();
					if (fm.isEncrypt()) {
						ftype = "STRING";
					} else if (ftype.equalsIgnoreCase("AUTONUMBER")) {
						ftype = "STRING";
					}
				} else {
					MyLog.error(this, this.uf, "========TRANSFORMSQL==========");
					MyLog.error(this, this.uf, "Can't get Field : " + fname);
				}
				if (i != 9 && i!= 8) {
					if (tsql.indexOf(")") < 0)
						value = tsql.substring(operpos+ioper[i]).trim();
					else {
						value = tsql.substring(operpos+ioper[i],tsql.indexOf(")")).trim();
					}
					tsql = tsql.replaceFirst(value,"?");
					value = value.replaceAll("'","");
					vname.add(fname);
					vtype.add(ftype);
					vvalue.add(value);
				} else if (i == 8) {
					int apos = tsql.indexOf(" and ");
					int Apos = sql.indexOf(" AND ");
					if (Apos > 0 && (apos == -1 || (apos > -1 && Apos < apos))) apos = Apos;
					value = tsql.substring(operpos+ioper[i],apos).trim();
					tsql = tsql.replaceFirst(value,"?");
					value = value.replaceAll("'","");
					vname.add(fname);
					vtype.add(ftype);
					vvalue.add(value);
					apos = tsql.indexOf(" and ");
					Apos = sql.indexOf(" AND ");
					if (Apos > 0 && (apos == -1 || (apos > -1 && Apos < apos))) apos = Apos;
					   int lastSym=tsql.indexOf(")");
						if(lastSym>-1)
							value = tsql.substring(apos+5,lastSym).trim();
						else
							value = tsql.substring(apos+5).trim();
					tsql = tsql.replaceFirst(value,"?");
					value = value.replaceAll("'","");
					vname.add(fname);
					vtype.add(ftype);
					vvalue.add(value);
				} else if (i == 9) {
					StringTokenizer stn = new StringTokenizer(tsql.substring(tsql.indexOf("(")+1,tsql.indexOf(")")),",");
					while (stn.hasMoreTokens()) {
						value = stn.nextToken();
						tsql = tsql.replaceFirst(value,"?");
						value = value.replaceAll("'","");
						vname.add(fname);
						vtype.add(ftype);
						vvalue.add(value);
					}
				}
				break;
			} 
		}
		output.add(0,tsql); // transform sql
		output.add(1,vname); // field name 
		output.add(2,vtype); // field type
		output.add(3,vvalue); // field value
		return output;
	}
	
	public int checkOperPosSubQ(String oper,String strbase,int startpos) {
		int operpos = strbase.indexOf(oper,startpos);
		int inpos = strbase.indexOf(" in ",startpos);
		int INpos = strbase.indexOf(" IN ",startpos);
		if (inpos < 0 && INpos > -1) inpos = INpos;
		int spos = strbase.indexOf("(",inpos);
		int epos = strbase.indexOf(")",inpos);
		if (spos > 0 && epos > 0) {
			if (operpos > spos && operpos < epos) {
				return this.checkOperPosSubQ(oper,strbase,epos);
			} else if (operpos > epos) {
				return operpos;
			} else if (operpos < spos) {
				return operpos;
			}
		} else return operpos;
		return -1;
	}
}
