package com.csc.library.utilities;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
public class WriteFile {
	private String data="";
	private String fileName="";
	private String pathName="";
	private File outputFile;
	private FileOutputStream fos;
    private OutputStreamWriter osw;  
    private BufferedWriter bw ;
    private String CharSet="UTF-8";
	/**
	 *  Write File Step 
	 *  Before write file you must set data to variable 
	 *  by method setData , setPathName,setFileName
	 */
	public WriteFile() {
	}
	/**
	 *  Constructor with two parameter one is name of file and two is data
	 *  this constructor will write file to specify path and close file
	 */
	public WriteFile(String fileName, String content) {
		try {
			this.fileName = fileName;
			this.checkDir(fileName);
			this.data = content;
			//Declare fileName as file
			if(fileName.indexOf(":/")>-1 || fileName.indexOf(":\\")>-1)// have path
				this.initFileOutputStream(fileName);
			else	//doesn't have path default is c:/
				this.initFileOutputStream("c:/"+fileName);
			//Change the content into bytecode
//			byte[] b = content.getBytes();
			//Write content in bytecode
			this.bw.write(content);
            this.bw.close();
            this.osw.close();
			this.fos.close();
		} catch (FileNotFoundException e) {
			MyLog.error(this,  e);
		} catch (IOException e) {
			MyLog.error(this,  e);
		}
	}
	/**
	 *  Constructor recieve file name
	 *  and open file waiting for write data from method writeString
	 *  you will must close file by yourself
	 */
	public WriteFile(String Name) {
		try {
			this.fileName = Name;
			this.checkDir(Name);
			this.initFileOutputStream(this.fileName);
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	private void initFileOutputStream(String file) {
		try {
			if (this.fos == null) {
				this.outputFile = new File(file);
				this.fos = new FileOutputStream(this.outputFile);               
				if(!this.CharSet.equals("UTF-8")){
					osw=new OutputStreamWriter(fos,this.CharSet);
				}else{
					osw=new OutputStreamWriter(fos);
				}
                bw = new BufferedWriter(osw);                
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
	public boolean writeString(String strWrite) {
		return this.write(strWrite);
	}
	public boolean write(String strWrite) {
		try {
			if (strWrite == null || strWrite.equalsIgnoreCase("")) {
				return true;
			}
			this.initFileOutputStream(this.getPathName() + this.getFileName());
            bw.write(strWrite);
//			char[]  ch = strWrite.toCharArray();
//			this.write(ch, 0, ch.length);
			return true;
		} catch (Exception e) {
			MyLog.error(this, e);
			return false;
		}
	}
	
	public boolean writeStringBuffer(StringBuffer strWrite) {
		try {
			if (strWrite == null ) {
				return true;
			}
			this.initFileOutputStream(this.getPathName() + this.getFileName());
//            bw.write(strWrite);
			char[]  ch = new char[strWrite.length()];
			strWrite.getChars(0, strWrite.length(), ch, 0);
			this.write(ch, 0, ch.length);
			return true;
		} catch (Exception e) {
			MyLog.error(this, e);
			return false;
		}
	}	

	public boolean write(char[] cbuff) {
		try {
			if (cbuff == null || cbuff.length==0) {
				return true;
			}
			this.initFileOutputStream(this.getPathName() + this.getFileName());
			bw.write(cbuff);
			return true;
		} catch (Exception e) {
			MyLog.error(this, e);
			return false;
		}
	}
	
	public boolean write(char[] cbuff, int off, int len) {
		try {
			if (cbuff == null || cbuff.length==0) {
				return true;
			}
			this.initFileOutputStream(this.getPathName() + this.getFileName());
			bw.write(cbuff, off, len);
			return true;
		} catch (Exception e) {
			MyLog.error(this, e);
			return false;
		}
	}
	
	public boolean write(String cbuff, int off, int len) {
		try {
			if (cbuff == null || cbuff.length()==0) {
				return true;
			}
			this.initFileOutputStream(this.getPathName() + this.getFileName());
			bw.write(cbuff, off, len);
			return true;
		} catch (Exception e) {
			MyLog.error(this, e);
			return false;
		}
	}	
	
	public boolean write(int c) {
		try {
			this.initFileOutputStream(this.getPathName() + this.getFileName());
			bw.write(c);
			return true;
		} catch (Exception e) {
			MyLog.error(this, e);
			return false;
		}
	}

	public void closeFile() {
		try {
            this.bw.close();
            this.osw.close();
            this.fos.close();
		} catch (Exception e) {
			MyLog.error(this,  e);
		}
	}
	/**
	 * Returns the fileName.
	 * @return String
	 */
	public String getFileName() {
		return fileName;
	}
	/**
	 * Returns the pathName.
	 * @return String
	 */
	public String getPathName() {
		return pathName;
	}
	/**
	 * Sets the fileName.
	 * @param fileName The fileName to set
	 */
	public void setFileName(String fileName) {
		this.fileName = fileName;
	}
	/**
	 * Sets the pathName.
	 * @param pathName The pathName to set
	 */
	public boolean setPathName(String pathName) {
		if (pathName == null || pathName.equalsIgnoreCase("")) {
			return false;
		} else if (pathName.indexOf(":/") > 0) {
			this.checkDir(pathName);
			this.pathName = pathName;
			return true;
		} else if (pathName.indexOf(":") > 0) {
			this.checkDir(pathName);
			this.pathName = pathName + "/";
			return true;
		} else {
			this.checkDir(pathName);
			this.pathName = pathName + ":/";
			return true;
		}
	}
	public boolean mkDirAndWriteFile() {
		try {
			if (this.chkValue()) {
				outputFile = new File(this.pathName + this.fileName);
				File createPath = new File(this.pathName);
				createPath.mkdir();
				fos = new FileOutputStream(outputFile);
                osw=new OutputStreamWriter(fos,this.CharSet);  
                bw = new BufferedWriter(osw);             
//				byte[] b = this.data.getBytes();
				//Write content in bytecode
//				fos.write(b);
                bw.write(this.data);
                bw.close();
                osw.close();
				fos.close();
				MyLog.info(this, "Write File Successful");
				return true;
			} else
				return false;
		} catch (Exception e) {
			MyLog.error(this, e);
			return false;
		}
	}
	private boolean chkValue() {
		if (this.pathName == null || this.pathName.equals("")) {
			MyLog.warn(this, "Not Found Path");
			return false;
		} else if (this.fileName == null || this.fileName.equals("")) {
			MyLog.warn(this, "Not Found File Name");
			return false;
		} else if (this.data == null || this.data.equals("")) {
			MyLog.warn(this, "No Data");
			return true;
		} else {
			return true;
		}
	}
	/**
	 * Returns the data.
	 * @return String
	 */
	public String getData() {
		return data;
	}
	/**
	 * Sets the data.
	 * @param data The data to set
	 */
	public void setData(String data) {
		this.data = data;
	}
    public String getCharSet() {
        return CharSet;
    }
    public void setCharSet(String charSet) {
        CharSet = charSet;
    }

    private void checkDir(String pathname){
    	pathname=pathname.replaceAll("\\\\","//");
    	String path=pathname.substring(0,pathname.lastIndexOf("/"));
    	File f=new File(path);
    	if(!f.exists()){
    		f.mkdirs();
    	}
    }
    
}
