package com.csc.library.utilities.compare;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.List;
import java.util.Properties;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

public class CheckProDb {

  public CheckProDb() {

  }
        private String protable, error = "ERROR !! ", warn = "WARN !! ", info = "INFO ";
        private StringBuffer msg = new StringBuffer();
        private Element rootElement=null;
        private String log="d:/testxml/log/db-pro1.txt";
        private HashMap tableProp;
        private String  DRIVER="com.microsoft.jdbc.sqlserver.SQLServerDriver";
        private String USER="MYHRADMIN";
        private String PASSWORD="SYSTEMADMIN";
        private String URL="jdbc:microsoft:sqlserver://192.100.1.111:1433;DatabaseName=EASTWATER";
        private String PROPATH="D:/testxml/source/PROTABLEXML/";
        private String OUTPATH="d:/testxml/out/PROTABLEXML/";
        private String CONFIGPATH="D:/EnterprisePT/compare/config/config";
        private void initEnv(){
          Element conXml=this.getRootElement(this.CONFIGPATH);
          this.DRIVER=conXml.getChild("DATABASE").getAttributeValue("driver");
          this.URL=conXml.getChild("DATABASE").getAttributeValue("url");
          this.USER=conXml.getChild("DATABASE").getAttributeValue("user");
          this.PASSWORD=conXml.getChild("DATABASE").getAttributeValue("password");
         this.PROPATH=conXml.getChild("SOURCEDIR").getText();
         this.OUTPATH=conXml.getChild("RESULTDIR").getText();
         this.log=conXml.getChild("LOGFILE").getText();
         System.out.println("DBURL :" + this.URL);
         System.out.println("DBUSER :"+ this.USER);
         System.out.println("DB PASSWORD :"+this.PASSWORD);
         System.out.println("protable path : "+this.PROPATH);
         System.out.println("out Path : "+ this.OUTPATH);
         System.out.println("log file : "+ this.log);
        }
        private void initProtable() {
                try {
                        File file1 = new File(this.getProtablePath()+"/");
                        String fileList[] = file1.list();
                        msg.append(this.info + "---- START LIST PROTABLE ----\n");
                        for (int i = 0; i < fileList.length; i++) {
                                String fName = fileList[i];
                                fName=fName.substring(0,fName.indexOf("."));
                                 System.out.println("Process table ************:"+(i+1)+" :"+fName);
                               this.prepareData(fName);
                              }
                } catch (Exception e) {
                        e.printStackTrace();
                }
        }
        private Element getRootElement(String path, String fileName) {
                SAXBuilder builder = new SAXBuilder();
                Document stru = null;
                try {
                        stru = builder.build(path+"/" + fileName+".xml");
                        return stru.getRootElement();
                } catch (Exception ex) {
                        return null;
                }
        }
        private Element getRootElement(String fileName) {
               SAXBuilder builder = new SAXBuilder();
               Document stru = null;
               try {
                       stru = builder.build(fileName+".xml");
                       return stru.getRootElement();
               } catch (Exception ex) {
                       return null;
               }
       }

        private void prepareData(String tablename){

             this.rootElement=this.getRootElement(this.getProtablePath(),tablename);
             this.getConnection();
             this.setTableProp(tablename,this.getMetaData(tablename,"",this.getConnection()));
             this.startCompare(tablename,this.rootElement);
        }
        private void startCompare(String tablename,Element em){
               this.listFieldElement(em);
             this.writeXmlFile(tablename,em);
        }
        private void setTableProp(String tableName,ResultSetMetaData rm){
         if(rm!=null){
         this.tableProp=new HashMap();
         this.tableProp.put("tableName",tableName);
        try {
          for (int i = 1; i <= rm.getColumnCount(); i++) {
            this.tableProp.put(rm.getColumnName(i),
                               new FieldProp(rm.getColumnName(i),
                                             rm.getColumnTypeName(i),
                                             rm.getPrecision(i)));
          }
        }
        catch (SQLException ex) {
          ex.printStackTrace();
        }
         }else{
            this.msg.append("\n ERROR +++ can not find table "+tableName+" in database \n");
         }
        }
        private void listFieldElement(Element em){
             List fieldlist= em.getChild("FIELD").getChildren();
             for(int i=0;i<fieldlist.size();i++){
             Element e= (Element)fieldlist.get(i);
             this.compareField(e);
          /*   System.out.println(" field name:"+e.getName()+"   "+e.getChild("WIDTH").getText()+
                                " component : "+ e.getChild("COMPONENT").getAttributeValue("type")+
                                " component size : "+ e.getChild("COMPONENT").getChildText("SIZE")+
                                " component max size : "+ e.getChild("COMPONENT").getChildText("MAXSIZE")
                                );*/
             }
        }
        private void compareField(Element e){
          String componentType=e.getChild("COMPONENT").getAttributeValue("type");
          try {
            FieldProp field =(FieldProp) this.tableProp.get(e.getName());
            if(field!=null){
              int fieldsize = Integer.parseInt(e.getChild("WIDTH").getText());
            //  System.out.println(e.getName() + " - " + fieldsize + " +++++++++ " +
             //                    field.getFieldSize());
              if (fieldsize != field.getFieldSize()) {
                e.getChild("WIDTH").setText(Integer.toString(field.getFieldSize()));
              }
              if (componentType.equalsIgnoreCase("text")) {
                this.checkComponentText(e);
              }
              else if (componentType.equalsIgnoreCase("textarea")) {
                this.checkComponentTextArea(e);
              }
            }else{
                 this.msg.append("\n FIELD :"+e.getName()+" doesn't not exist in table TABLE :"+this.tableProp.get("tableName"));
            }
          }
          catch (NumberFormatException ex) {
            ex.printStackTrace();
          }
        }
        private void checkComponentText(Element e){
            try {
              int fieldSize = Integer.parseInt(e.getChildText("WIDTH"));
              int comSize = Integer.parseInt(e.getChild("COMPONENT").
                                             getChildText("SIZE"));
              int comMaxSize = Integer.parseInt(e.getChild("COMPONENT").
                                                getChildText("MAXSIZE"));
              e.getChild("COMPONENT").getChild("MAXSIZE").setText(Integer.
                  toString(fieldSize));
              if (fieldSize > 70) {
                e.getChild("COMPONENT").getChild("SIZE").setText("70");
              }
              else if (fieldSize <= 70) {
                if (comSize > fieldSize) {
                  e.getChild("COMPONENT").getChild("SIZE").setText(Integer.
                      toString(fieldSize));
                }
              }
            }
            catch (NumberFormatException ex) {
              msg.append("\n"+this.tableProp.get("tableName")+ " fieldname: "+e.getName()+" field or component size ERROR \n");
            //  System.out.println("fieldName:" +e.getName()+" -----------------KKKKKKKKKKKKKKKKKKKK");
            }
        }
        private void checkComponentTextArea(Element e){
           if(e.getChild("COMPONENT").getChild("SIZE")!=null){
               e.getChild("COMPONENT").removeChild("SIZE");
           }
           if(e.getChild("COMPONENT").getChild("MAXSIZE")!=null){
               e.getChild("COMPONENT").removeChild("MAXSIZE");
           }
           if(e.getChild("COMPONENT").getChild("LINE")!=null){
               e.getChild("COMPONENT").removeChild("LINE");
           }
           if(e.getChild("COMPONENT").getChild("LINES")==null){
             e.getChild("COMPONENT").addContent(new Element("LINES"));
           }
           if(e.getChild("COMPONENT").getChild("SIZECHAR")==null){
                  e.getChild("COMPONENT").addContent(new Element("SIZECHAR"));
           }

           e.getChild("COMPONENT").getChild("LINES").setText("3");
           e.getChild("COMPONENT").getChild("SIZECHAR").setText("60");


        }
        private void setFieldProperties(String tableName,Connection con){

        }
        private ResultSetMetaData getMetaData(String tableName,String schema,Connection con){
                ResultSetMetaData rm=null;
                try {
                        String sql="select * from "+schema+tableName;
                                Statement st=con.createStatement();
                                ResultSet rs=st.executeQuery(sql);
                                rm = rs.getMetaData();
                } catch (Exception e) {
               }
                return rm;
        }
        private Connection getConnection(){
         try {
                        Class.forName(DRIVER);
                        Properties	prop = new Properties();
                        prop.put("user", this.USER);
                        prop.put("password", this.PASSWORD);
                        Connection con=DriverManager.getConnection(this.URL, prop);
                        return con;
                } catch (Exception e) {
                        e.printStackTrace();
                        return null;
                }
        }
     private String getProtablePath(){
      //  String ret="D:/EnterprisePT/Jboss/server/default/deploy/PRPEAP.ear/XML/PROTABLEXML/";
      String ret="D:/testxml/source/PROTABLEXML/";
    //  System.out.println("propath :"+this.PROPATH);
      return this.PROPATH;
     }
     public void process(){
                this.initProtable();

              //  this.msg.append("\n\nCompleted found error " + this.errorCount + " warn " + this.warnCount + "\n");
                this.outLogFile();
              //  System.out.println("\n\nCompleted found error " + this.errorCount + " warn " + this.warnCount + "\n");
                System.out.println("\n Please see log in "+this.log);
        }

     private void outLogFile(){
                try {
                        File f=new File(this.log);
                        FileOutputStream fo=new FileOutputStream(f);
                        byte [] b=this.msg.toString().getBytes();
                        fo.write(b);
                } catch (FileNotFoundException e) {
                } catch (IOException e) {
                }
        }
        public void writeXmlFile(String filename,Element em){
          //String path="d:/testxml/out/PROTABLEXML/";
          com.csc.library.utilities.WriteXml wx = new com.csc.library.utilities.WriteXml(em,OUTPATH+"/"+filename);
    //      wx.setIndent(true);
          wx.output();

}


     public static void main(String[] args) {
       CheckProDb cpro=new CheckProDb();
       System.out.println("starting compare protable and database");
      cpro.initEnv();
      System.out.println("initail environment");
       cpro.process();
  //  com.csc.library.utilities.WriteXml wx = new com.csc.library.utilities.WriteXml(new Element("dd"),"c:/a");
 //      wx.setIndent(true);
  //     wx.output();

     }

}
