package com.csc.library.utilities.compare;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;

import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;
/**
 * @author somsuksri
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class CompareProtable {
	private String protable1, protable2, error = "ERROR !! ", warn = "WARN !! ", info = "INFO ";
	private Vector compare=new Vector();
	private StringBuffer msg = new StringBuffer();
	private int errorCount, warnCount;
	private String currFName;
	boolean invalidElement=false;
	private String log="c:/compare/pro-pro.txt";
	public void process() {
		this.initProtable();
		this.msg.append("\n\nCompleted found error " + this.errorCount + " warn " + this.warnCount + "\n");
		this.outFile();
		System.out.println("\n\nCompleted found error " + this.errorCount + " warn " + this.warnCount + "\n");
		System.out.println("Please see log in "+this.log);	
	}
	
	private void outFile(){
		try {
			File f=new File(this.log);
			FileOutputStream fo=new FileOutputStream(f);
			byte [] b=this.msg.toString().getBytes();
			fo.write(b);
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
	}	
	
	private void initProtable() {
		try {
			File file1 = new File(this.protable1);
			String fileList[] = file1.list();
			msg.append(this.info + "---- START COMPARE PROTALE ----\n");
			msg.append(this.info + "---- PROTABLE 1 " + this.protable1 + "\n");
			msg.append(this.info + "---- PROTABLE 2 " + this.protable2 + "\n");
			for (int i = 0; i < fileList.length; i++) {
				String fName = fileList[i];
				Element root1 = this.getRootElement(this.protable1, fName);
				//this.root=root1;
				Element root2 = this.getRootElement(this.protable2, fName);
				this.compare(root1, root2);
			}
		} catch (RuntimeException e) {
			e.printStackTrace();
		}
	}
	private Element getRootElement(String path, String fileName) {
		SAXBuilder builder = new SAXBuilder();
		Document stru = null;
		try {
			stru = builder.build(path + "/" + fileName);
			return stru.getRootElement();
		} catch (Exception ex) {
			return null;
		}
	}
	private void compare(Element root1, Element root2) {
		if (root2 == null) {
			msg.append(this.warn + "\t\t\t- " + this.protable2+"/"+root1.getName() + " NOT FOUND TABLE !!\n");
			warnCount++;
		} else {
			this.compareElement(root1, root2);
		}
	}
	private void compareAttribute(Element em1, Element em2) {
		if(this.compare.size()==0 ||this.compare.contains(em1.getName())){
		this.currFName = "";
		this.getParent(em1);
		List list = em1.getAttributes();
		Iterator it = list.iterator();
		if (!em1.getText().trim().equals(em2.getText().trim())) {
			msg.append(this.error + "\t\t\t\t- ELEMENT  " + this.currFName + " VALUETEXT MISSMATCH\n");
			msg.append("\t\t\t\t\t\t\t\t-  FOUND -->" + em1.getText() + "<-- AND -->" + em2.getText() + "<-- \n");
			this.errorCount++;
		}
		while (it.hasNext()) {
			Attribute at = (Attribute) it.next();
			String attribute = at.getName();
			String data1 = em1.getAttributeValue(attribute);
			String data2 = em2.getAttributeValue(attribute);
			if (data2 == null)
				data2 = "not specify";
			if (!data1.trim().equals(data2.trim())) {
				msg.append(this.error + "\t\t\t\t- ELEMENT " + this.currFName + " ATTRIBUTE  " + attribute + " MISSMATCH\n");
				msg.append("\t\t\t\t\t\t\t\t-  FOUND -->" + data1 + "<-- AND -->" + data2 + "<--\n");
				errorCount++;
			}
		}}
	}
	private Element getParent(Element em) {
		if (em.getParent() != null) {
			this.getParent(em.getParent());
		}
		this.currFName += "/" + em.getName();
		return em;
	}
	private void compareElement(Element em1, Element em2) {
		try {
			if (!em1.getName().equals(em2.getName())) {
				String path1="",path2="";
				this.currFName = "";
				this.getParent(em1);
				path1=this.currFName;
				this.currFName="";
				this.getParent(em2);
				path2=this.currFName;
				if(!this.invalidElement){
				this.invalidElement=true;
				msg.append(this.error + "\t\t\t\t- ELEMENT INVALID \n");
				msg.append("\t\t\t\t\t\t\t\t- "+path1+"\n");
				msg.append("\t\t\t\t\t\t\t\t- "+path2+"\n");
				this.errorCount++;
				}
				return;
			} else {
				if (em1.getChildren().size() > 0) {
					Iterator it = em1.getChildren().iterator();
					Iterator it2 = em2.getChildren().iterator();
					while (it.hasNext()) {
						this.compareElement((Element) it.next(), (Element) it2.next());
					}
				}
				this.compareAttribute(em1, em2);
			}
		} catch (RuntimeException e) {
			//System.out.println(em1+"   "+em2);
		}
	}
	public void setProtable1(String fileName) {
		this.protable1 = fileName;
	}
	public void setProtable2(String fileName) {
		this.protable2 = fileName;
	}
	public void setCompare(String compare) {
		//this.compare = new Vector();
		StringTokenizer st = new StringTokenizer(compare, ",");
		while (st.hasMoreTokens()) {
			this.compare.addElement(st.nextToken());
		}
	}
}
