package com.csc.library.utilities.compare;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.utilities.WriteXml;
/**
 * @author somsuksri
 *
 */
public class GenProtable {
	private String mainProtable, compareProtable;
	private Vector compare = new Vector(), passingChk;
	private String currFName;
	private boolean invalidElement = false;
	private Element mElement, cElement;
	private String log = "c:/compare/PropTableMissmatch.txt", outFileDir = "c:/compare/output/";
	private String activeTable, activeField;
	private GenProLog gen = new GenProLog();
	public void process() {
		//gen.setTableNotFound(true);
		//gen.setFieldNotFound(true);
		//gen.setPropFieldFixMissmatch(true);
		//gen.setPropFieldDynamicMissMatch(true);
		//gen.setRelationTableMissMatch(true);
		//gen.setRelationFieldMissMatch(true);
		gen.setPropTableMissmatch(true);
		
		this.initProtable();
		gen.genCompleteLog();
		this.outFile();
		System.out.println("\n\nCompleted found error " + gen.getErrorCount() + " warn " + gen.getWarnCount() + " fix "+gen.getFixCount()+"\n");
		System.out.println("Please see log in " + this.log);
	}
	private void outFile() {
		try {
			File f = new File(this.log);
			FileOutputStream fo = new FileOutputStream(f);
			byte[] b = gen.getMsg().toString().getBytes();
			fo.write(b);
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
	}
	private void initProtable() {
		try {
			//gen.genLineLog();
			gen.genStartLog(this.mainProtable, this.compareProtable);
			//gen.genLineLog();
			Vector tableChk = new Vector();
			File file1 = new File(this.mainProtable);
			String fileList[] = file1.list();
			this.chkTable(fileList, tableChk);
			file1 = new File(this.compareProtable);
			fileList = file1.list();
			this.chkTable(fileList, tableChk);
		} catch (RuntimeException e) {
			e.printStackTrace();
		}
	}
	private void chkTable(String fileList[], Vector tableChk) {
		for (int i = 0; i < fileList.length; i++) {
			String fName = fileList[i];
			if (!tableChk.contains(fName)) {
				tableChk.add(fName);
				Element root1 = this.getRootElement(this.mainProtable, fName);
				this.mElement = root1;
				Element root2 = this.getRootElement(this.compareProtable, fName);
				this.cElement = root2;
				this.compare(root1, root2);
			}
		}
	}
	private Element getRootElement(String path, String fileName) {
		SAXBuilder builder = new SAXBuilder();
		Document stru = null;
		try {
			stru = builder.build(path + "/" + fileName);
			return stru.getRootElement();
		} catch (Exception ex) {
			return null;
		}
	}
	private void compare(Element root1, Element root2) {
		if (root2 == null) {
			gen.genMissingTableLog("Compare protable", root1.getName());
			//gen.genLineLog();
			this.writeXML(root1);
		} else if (root1 == null) {
			this.writeXML(root2);
			gen.genMissingTableLog("Main protable", root2.getName());
			//gen.genLineLog();
		} else {
			this.activeTable = root1.getName();
			try {
				HashMap mainData = this.getProtableData(root1);
				HashMap compareData = this.getProtableData(root2);
				this.compareTabelProp((HashMap)mainData.get("proptable"),(HashMap)compareData.get("proptable"));
				this.compareField((HashMap) mainData.get("field"), (HashMap) compareData.get("field"));
				this.compareRelation((HashMap) mainData.get("relation"), (HashMap) compareData.get("relation"));
				this.writeXML(this.mElement);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	private void compareTabelProp(HashMap mainData,HashMap compareData){
		this.chkFixTableData(gen.getWarn(), "wfactive", (String)mainData.get("wfactive"), (String) compareData.get("wfactive"));
		this.chkFixTableData(gen.getWarn(), "desc_thai", (String)mainData.get("desc_thai"), (String) compareData.get("desc_thai"));
		this.chkFixTableData(gen.getWarn(), "desc_eng", (String)mainData.get("desc_eng"), (String) compareData.get("desc_eng"));
		this.chkFixTableData(gen.getWarn(), "verify", (String)mainData.get("verify"), (String) compareData.get("verify"));
		this.chkFixTableData(gen.getWarn(), "editcheck", (String)mainData.get("editcheck"), (String) compareData.get("editcheck"));
		this.chkFixTableData(gen.getWarn(), "verify_type", (String)mainData.get("verify_type"), (String) compareData.get("verify_type"));
		this.chkFixTableData(gen.getWarn(), "mainhelp", (String)mainData.get("mainhelp"), (String) compareData.get("mainhelp"));
		this.chkFixTableData(gen.getWarn(), "referhelp", (String)mainData.get("referhelp"), (String) compareData.get("referhelp"));
		this.chkFixTableData(gen.getWarn(), "mainkey", (String)mainData.get("mainkey"), (String) compareData.get("mainkey"));
	}	
	
	private void chkFixTableData(String type, String key, String value1, String value2) {
		try {
			gen.genChkFixTableLog(type,key,value1,value2,this.activeTable);
			if(value1==null && value2 !=null){
				Attribute att=(Attribute)this.cElement.getAttribute(key).clone();
				this.mElement.addAttribute(att);
			}
		} catch (RuntimeException e) {
			e.printStackTrace();
		//	System.err.print("FIELD ERROR Table "+this.activeTable+" Field "+this.activeField+" Element "+key+" Please Change to UperCase befor Compare \n");
		}
	}

	
	
	private void writeXML(Element em) {
		WriteXml wx = new WriteXml(em, outFileDir + em.getName().toUpperCase());
		wx.output();
		this.mElement=null;
		this.cElement=null;
	}
	private void compareField(HashMap mainField, HashMap compareField) {
		Iterator it = mainField.keySet().iterator();
		Vector fieldChk = new Vector();
		this.chkField(mainField, compareField, it, fieldChk);
		it = compareField.keySet().iterator();
		this.chkField(mainField, compareField, it, fieldChk);
		fieldChk = new Vector();
	}
	private void chkField(HashMap mainField, HashMap compareField, Iterator it, Vector fieldChk) {
		while (it.hasNext()) {
			String fieldName = (String) it.next();
			this.activeField = fieldName;
			if (!fieldChk.contains(fieldName)) {
				if (!compareField.containsKey(fieldName)) {
					gen.genMissingFieldLog("Compare Protable", this.activeTable, this.activeField);
					//gen.genLineLog();
				} else if (!mainField.containsKey(fieldName)) {
					gen.genMissingFieldLog("Main Protable", this.activeTable, this.activeField);
					//gen.genLineLog();
					Element aEm = (Element) this.cElement.getChild("FIELD").getChild(fieldName.toUpperCase()).clone();
					this.mElement.getChild("FIELD").addContent(aEm);
				} else {
					FieldProperties mFp = (FieldProperties) mainField.get(fieldName);
					FieldProperties cFp = (FieldProperties) compareField.get(fieldName);
					fieldChk.add(fieldName);
					this.compareField(mFp, cFp);
				}
			}
		}
	}
	private void compareField(FieldProperties mf, FieldProperties cf) {					
		this.chkFixFieldData(gen.getError(), "type", (String) mf.getFixProp().get("type"), (String) cf.getFixProp().get("type"));
		this.chkFixFieldData(gen.getError(), "width", (String) mf.getDynamicProp().get("width"), (String) cf.getDynamicProp().get("width"));
		this.chkFixFieldData(gen.getWarn(), "desc_eng", (String) mf.getDynamicProp().get("desc_eng"), (String) cf.getDynamicProp().get("desc_eng"));
		this.chkFixFieldData(gen.getWarn(), "desc_thai", (String) mf.getDynamicProp().get("desc_thai"), (String) cf.getDynamicProp().get("desc_thai"));
		passingChk = new Vector();
		Iterator it = mf.getDynamicProp().keySet().iterator();
		this.invokeChkDynamicFieldProp(mf, cf, it);
		it = cf.getDynamicProp().keySet().iterator();
		this.invokeChkDynamicFieldProp(mf, cf, it);
		HashMap comMf = (HashMap) mf.getFixProp().get("component");
		HashMap comCf = (HashMap) cf.getFixProp().get("component");
		it = comMf.keySet().iterator();
		this.invokeChkDynamicFieldComponent(comMf, comCf, it);
		it = comCf.keySet().iterator();
		this.invokeChkDynamicFieldComponent(comMf, comCf, it);
		passingChk = new Vector();
	}
	private void invokeChkDynamicFieldComponent(HashMap mf, HashMap cf, Iterator it) {
		try {
			while (it.hasNext()) {
					String key = (String) it.next();
					Element mainElement = this.mElement.getChild("FIELD").getChild(this.activeField.toUpperCase()).getChild("COMPONENT");
					Element compareElement = this.cElement.getChild("FIELD").getChild(this.activeField.toUpperCase()).getChild("COMPONENT");
					this.chkDynamicFieldData(gen.getWarn(), key, (String) mf.get(key), (String) cf.get(key), mainElement, compareElement);
				}
		} catch (RuntimeException e) {
			System.err.println("ERROR FIELD ELEMENT "+this.activeTable+" "+this.activeField+" PLEASE CHANGE TO UPERCASE BEFOR COMPARE \n");
			//e.printStackTrace();
		}
	}
	private void invokeChkDynamicFieldProp(FieldProperties mf, FieldProperties cf, Iterator it) {
		while (it.hasNext()) {
			String key = (String) it.next();
			if (!(key.equalsIgnoreCase("width") || key.equalsIgnoreCase("desc_eng") || key.equalsIgnoreCase("desc_thai"))) {
				Element mainElement = this.mElement.getChild("FIELD").getChild(this.activeField.toUpperCase());
				Element compareElement = this.cElement.getChild("FIELD").getChild(this.activeField.toUpperCase());
				this.chkDynamicFieldData(gen.getWarn(), key, (String) mf.getDynamicProp().get(key), (String) cf.getDynamicProp().get(key), mainElement, compareElement);
			}
		}
	}
	private void chkFixFieldData(String type, String key, String value1, String value2) {
		try {
			if (!value1.equals(value2)) {
				gen.genChkFixFieldLog(type, key, value1, value2, this.activeTable, this.activeField);
				if (key.equalsIgnoreCase("width") && Integer.parseInt(value2) > Integer.parseInt(value1)) {
					this.mElement.getChild("FIELD").getChild(this.activeField.toUpperCase()).getChild("WIDTH").setText(value2);
				}
				//gen.genLineLog();
			}
		} catch (RuntimeException e) {
			System.err.print("FIELD ERROR Table "+this.activeTable+" Field "+this.activeField+" Element "+key+" Please Change to UperCase befor Compare \n");
		}
	}
	private void chkDynamicFieldData(String type, String key, String value1, String value2, Element mainElement, Element compareElement) {
		try {
			gen.genChkDynamicFieldLog(type, key, value1, value2, this.activeTable, this.activeField, this.passingChk);
			if (value1 == null && value2 != null) {
				if (!key.equalsIgnoreCase("key")) {
					Element aEm = (Element) compareElement.getChild(key.toUpperCase()).clone();
					mainElement.addContent(aEm);
				}
			}
			if (value1 != null && value2 != null && !this.passingChk.contains(key)) {
				this.passingChk.add(key);
				if (!value1.equals(value2)) {
					if (key.equals("maxsize") || key.equals("size")) {
						if (Integer.parseInt(value2) > Integer.parseInt(value1)) {
							mainElement.getChild(key.toUpperCase()).setText(value2);
						}
					}
				}
			}
		} catch (RuntimeException e) {
			e.printStackTrace();
			//System.out.println("Error  " + key + "   " + value1 + "   " + value2);
			System.err.print("FIELD ERROR Table "+this.activeTable+" Field "+this.activeField+" Element "+key+" Please Change to UperCase befor Compare \n");
		}
	}
	private void compareRelation(HashMap mRelation, HashMap cRelation) {
		Vector relationChk = new Vector();
		this.compareRelation(mRelation, cRelation, mRelation.keySet().iterator(), relationChk);
		this.compareRelation(mRelation, cRelation, cRelation.keySet().iterator(), relationChk);
		relationChk = new Vector();
	}
	private void compareRelation(HashMap mRelation, HashMap cRelation, Iterator it, Vector relationChk) {
		while (it.hasNext()) {
			String key = (String) it.next();
			if (!relationChk.contains(key)) {
				relationChk.add(key);
				RelationProperties mReProp = (RelationProperties) mRelation.get(key);
				RelationProperties cReProp = (RelationProperties) cRelation.get(key);
				this.compareRelation(mReProp, cReProp);
			}
		}
	}
	private void compareRelation(RelationProperties mRp, RelationProperties cRp) {
		if (cRp == null) {
			gen.genCompareRelationTableLog(this.activeTable, mRp.getTableName());
		} else if (mRp == null) {
			try {
				gen.genMainRelationTableLog(this.activeTable, cRp.getTableName());
				Element reEm = (Element) this.cElement.getChild("RELATION").getChild(cRp.getTableName().toUpperCase()).clone();
				this.mElement.getChild("RELATION").addContent(reEm);
			} catch (RuntimeException e) {
				System.err.println("RELATION ERROR "+this.activeTable+" Relation to  "+cRp.getTableName()+" PLEASE CHANGE TO UPERCASE BEFOR COMPARE \n");
			}
		} else {
			this.chkRelationField(mRp.getTableName(), "Parent", mRp.getParentList(), cRp.getParentList());
			this.chkRelationField(mRp.getTableName(), "Child", mRp.getChildList(), cRp.getChildList());
		}
	}
	private void chkRelationField(String rTable, String type, Vector mV, Vector cV) {
		for (int i = 0; i < mV.size(); i++) {
			String field = (String) mV.elementAt(i);
			if (!cV.contains(field)) {
				gen.genCompareRelationFieldLog(type, this.activeTable, rTable, field);
			}
		}
		for (int i = 0; i < cV.size(); i++) {
			String field = (String) cV.elementAt(i);
			if (!mV.contains(field)) {
				gen.genMainRelationFieldLog(type, this.activeTable, rTable, field);
				Element em=new Element(type.toUpperCase());
				em.setText(field);
				this.mElement.getChild("RELATION").getChild(rTable.toUpperCase()).addContent(em);
			}
		}
	}
	private HashMap getProtableData(Element em) {
		HashMap data = new HashMap();
		//Set Properties table
		HashMap propTable = new HashMap();
		Iterator it = em.getAttributes().iterator();
		while (it.hasNext()) {
			Attribute at = (Attribute) it.next();
			propTable.put(at.getName().toLowerCase(), at.getValue());
		}
		data.put("proptable", propTable);
		//Set Properties field
		HashMap propField = new HashMap();
		it = em.getChild("FIELD").getChildren().iterator();
		while (it.hasNext()) {
			Element fem = (Element) it.next();
			String fName = fem.getName().toLowerCase();
			FieldProperties fprop = new FieldProperties();
			HashMap hprop = new HashMap();
			this.setAttrFieldProp(hprop, fem);
			hprop.put("component", this.getComponentFieldProp(fem.getChild("COMPONENT")));
			fprop.setFixProp(hprop);
			fprop.setDynamicProp(this.getElementFieldProp(fem));
			propField.put(fName, fprop);
		}
		data.put("field", propField);
		//Set Relation
		HashMap relationField = new HashMap();
		it = em.getChild("RELATION").getChildren().iterator();
		while (it.hasNext()) {
			Element reEm = (Element) it.next();
			RelationProperties rProp = new RelationProperties();
			rProp.setTableName(reEm.getName());
			rProp.setParentList(this.getRelationList("PARENT", reEm));
			rProp.setChildList(this.getRelationList("CHILD", reEm));
			relationField.put(rProp.getTableName(), rProp);
		}
		data.put("relation", relationField);
		return data;
	}
	private Vector getRelationList(String type, Element em) {
		Iterator it = em.getChildren().iterator();
		Vector v = new Vector();
		while (it.hasNext()) {
			Element rEm = (Element) it.next();
			if (rEm.getName().equals(type)) {
				v.addElement(rEm.getText());
			}
		}
		return v;
	}
	private void setAttrFieldProp(HashMap data, Element em) {
		Iterator it = em.getAttributes().iterator();
		while (it.hasNext()) {
			Attribute at = (Attribute) it.next();
			data.put(at.getName().toLowerCase(), at.getValue());
		}
	}
	private HashMap getElementFieldProp(Element em) {
		HashMap data = new HashMap();
		Iterator it = em.getChildren().iterator();
		while (it.hasNext()) {
			Element fem = (Element) it.next();
			if (!fem.getName().equals("COMPONENT"))
				data.put(fem.getName().toLowerCase(), fem.getText());
		}
		return data;
	}
	private HashMap getComponentFieldProp(Element em) {
		HashMap data = new HashMap();
		data.put("type", em.getAttributeValue("type"));
		Iterator it = em.getChildren().iterator();
		while (it.hasNext()) {
			Element cEm = (Element) it.next();
			data.put(cEm.getName().toLowerCase(), cEm.getText());
		}
		return data;
	}
	public void setMainProtable(String fileDir) {
		this.mainProtable = fileDir;
	}
	public void setCompareProtable(String fileDir) {
		this.compareProtable = fileDir;
	}

}
