package com.csc.library.utilities.compare;
import java.io.File;
import java.util.HashMap;
import java.util.StringTokenizer;

import org.jdom.Element;

import com.csc.library.database.ConfigMetadata;
import com.csc.library.database.ConnectionPools;
import com.csc.library.database.LoadProTable;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;
import com.csc.library.security.LoadTemplate;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.ReadXml;
import com.csc.library.utilities.UProfile;
public class StaticTest {
	public void process() {
		this.getPath();
		this.setGlobalTable();
		this.setProTable();
		this.setConfig();
	//	this.setConnectionPools();	
		//this.loadDbUser();
	}
	
	public void setConnectionPools(){
		StaticProperties.connectionMap=new HashMap();	
		String dbList=new InitialEnvironment("GLOBAL").getValue("dblist-name");
		StringTokenizer st=new StringTokenizer(dbList,",");	
		while(st.hasMoreTokens()){
			String dbName=st.nextToken();
			String url=new InitialEnvironment(dbName).getValue("datasource-url");
			ConnectionPools con=new ConnectionPools(dbName);
			StaticProperties.connectionMap.put(url.toLowerCase(),con);
		}	
		System.out.println("Commit set connection "+StaticProperties.connectionMap);
	}	
	
	private String getConfigPath(String path) {
		return new InitialEnvironment("GLOBAL").getValue(path);
	}
	
	private void loadDbUser() {
		LoadTemplate load = new LoadTemplate();
		load.process();
	}
	private void getPath() {
		StaticProperties.systemPath = System.getProperty("payroll_config");
	}
	private String getProtablePath(String path) {
		return new InitialEnvironment("GLOBAL").getValue(path);
	}
	private void setGlobalTable() {
		ReadXml read = new ReadXml(this.getConfigPath("config-dir") + "config");
		Element em = read.getChildElement("GLOBAL");
		java.util.Iterator it = em.getChildren().iterator();
		while (it.hasNext()) {
			Element ch = (Element) it.next();
			String table = ch.getText();
			StaticProperties.gloBalTable.add(table.toLowerCase().trim());
		}
		System.out.println("GLOBAL OUT :: " + StaticProperties.gloBalTable);
		System.out.println("commited set globaltable !! ");
	}
	private void setConfig() {
		UProfile uf = new UProfile();
		uf.set("lang", "tha");
		uf.setDbName("GLOBAL");
		ConfigMetadata vm = new ConfigMetadata(uf);
		vm.process();
//		StaticProperties.myConfig.put("fieldmulticompany", vm.getFieldMultiCompany());
//		StaticProperties.myConfig.put("inquirystatus", vm.getInquiryStatus());
//		StaticProperties.myConfig.put("vfieldstatus", vm.getVfieldStatus());
//		StaticProperties.myConfig.put("multicompanystatus", vm.getMultiCompanyStatus());
//		StaticProperties.myConfig.put("recordstatus", vm.getRecordStatus());
//		StaticProperties.myConfig.put("inquirystatus", vm.getInquiryStatus());
//		StaticProperties.myConfig.put("insertstatus", vm.getInsertStatus());
//		StaticProperties.myConfig.put("deletestatus", vm.getDeleteStatus());
//		StaticProperties.myConfig.put("updatestatus", vm.getUpdateStatus());
		ReadXml read = new ReadXml(this.getConfigPath("config-dir") + "config");
		String useSchema = read.getChildElement("DATABASE").getChild("USE_SCHEMA").getText();
		StaticProperties.usesSchema = Boolean.valueOf(useSchema).booleanValue();
		String processPerThred = read.getChildElement("SERVICE").getChild("PROCESS_PERTHRED").getText();
		StaticProperties.processPerThred = Integer.parseInt(processPerThred);
		String iLevel = read.getChildElement("RELATION").getChild("INSERT_LEVEL").getText();
		StaticProperties.defaultInsertRelatoinLevel = iLevel;
		String dLevel = read.getChildElement("RELATION").getChild("DELETE_LEVEL").getText();
		StaticProperties.defaultDeleteRelatoinLevel = dLevel;
	}
	private void setProTable() {
		File f = new File(this.getConfigPath("xmlpath-protable"));
		String file[] = f.list();
		for (int i = 0; i < file.length; i++) {
			try {
				String fileName = file[i];
				fileName = fileName.substring(0, fileName.indexOf(".")).toLowerCase();
				LoadProTable pro = new LoadProTable();
				pro.setTableName(fileName);
				pro.setLoadComponent(true);
				pro.process();
				MyHashMap data = new MyHashMap();
				data.put("desceng", pro.getDescEng());
				data.put("descthai", pro.getDescThai());
				data.put("editcheck", pro.getEditCheck());
				data.put("mainhelp", pro.getMainHelp());
				data.put("mainkey", pro.getMainkey());
				data.put("properties", pro.getProperties());
				data.put("referhelp", pro.getReferHelp());
				data.put("relation", pro.getRelation());
				data.put("verify", pro.getVerify());
				data.put("verifygroup", pro.getVerifyGroup());
				data.put("fieldgroup", pro.getFieldGroup());
				data.put("wfactive", pro.getWfActive());
				StaticProperties.proTable.put(fileName, data);
				
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		System.out.println("PROTABLE OUT :: SUEESESSES ");
		//System.out.println("commited set protable !! "+StaticProperties.proTable);
	}
}
